C
C
C
      SUBROUTINE BRICXS
C
C     THIS SUBROUTINE READS IN THE INITIAL CONDITION AND GEOMETRY RECORDS
C
      INCLUDE 'dimens.cmn'
      INCLUDE 'comcon.cmn'
      INCLUDE 'lunums.cmn'
      INCLUDE 'dtcomp.cmn'
      INCLUDE 'xsinit.cmn'
      INCLUDE 'xsichr.cmn'
      INCLUDE 'geom.cmn'
      INCLUDE 'ceta.cmn'
      INCLUDE 'branch.cmn'
      INCLUDE 'branam.cmn'
      INCLUDE 'dtypes.cmn'
      INCLUDE 'units.cmn'
      INCLUDE 'logics.cmn'
      INCLUDE 'limits.cmn'
      INCLUDE 'volcom.cmn'
      CHARACTER*10 zijchr, qijchr, tenblk
      CHARACTER msg*90, cdmy*4, fvflg*2
      INTEGER i, ns, ij, j, k, nd, nxs
      REAL qij, cdatum, stg1, stg2
      EXTERNAL CHKSTA, SETAB1, ERRSCR, ERRPAR, ERRPRT, ERRLIN, GETCHR
      REAL ABS
      INTRINSIC ABS
      DATA tenblk/'          '/
C
      Error = .FALSE.
      Xskt(1) = MAXS
      Tabeta = MAXS.EQ.MXTFXS
      Nfvxs = 0
      DO 50 i = 1, Nbch
        j = 0
        READ (Luinit,9015,END=100,ERR=110) Ijf(i), Ijt(i), Nsec(i), 
     &        Brname(i), Ijfen(i), Ijten(i), Prtbch(i), Prtsum(i), 
     &        Ppltbh(i), Pltbch(i), Prtxsg(i)
        IF (Ijf(i).LT.1 .OR. Ijf(i).GT.Njnc) THEN
          WRITE (msg,9070) 'F', Ijf(i), 'SOURCE', i, Njnc
          GOTO 140
        ENDIF
        IF (Ijt(i).LT.1 .OR. Ijt(i).GT.Njnc) THEN
          WRITE (msg,9070) 'T', Ijt(i), 'OUTLET', i, Njnc
          GOTO 140
        ENDIF
        WRITE (*,9005) i, Ijf(i), Ijt(i), Brname(i)
        IF (i.GT.1) Xskt(i) = Xskt(i-1) - Nsec(i-1)
        ns = Nsec(i)
        ij = MAXS - Xskt(i)
        DO 40 j = 1, ns
          ij = ij + 1
          IF (ij.GT.MAXS) THEN
            nxs = MAXS - Xskt(i) + ns
            CALL ERRPAR(1,nxs,2,MAXS,' MAXS ',
     &                 'NUMBER OF CROSS SECTIONS INPUT EXCEEDS MAXIMUM')
          ENDIF
          IF (j.EQ.ns) THEN
            Dx(ij) = 0.0
            READ (Luinit,9030,END=90,ERR=120) Z(ij), Q(ij), Rho(ij), 
     &            zijchr, qijchr
          ELSE
            READ (Luinit,9020,END=90,ERR=120) Z(ij), Q(ij), Rho(ij), 
     &            Dx(ij), T(ij), (Rn(k,ij),k=1,3), zijchr, qijchr
            IF (ABS(Dx(ij)).LT.SMLVL) Dx(ij) = 0.00001
            Rn4(ij) = Rn(1,ij)
            IF (ABS(T(ij)).LT.SMLVL) T(ij) = H2otmp
          ENDIF
C
C---ASSIGN SMALL INITIAL-CONDITION STAGE AND DISCHARGE VALUES IN
C---PLACE OF ZERO VALUES FOR SUBSEQUENT ASSIGNMENT OF UNSPECIFIED
C---INITIAL CONDITIONS
          IF (ABS(Z(ij)).LT.SMLVL .AND. zijchr.NE.tenblk) Z(ij) = 0.0001
          IF (ABS(Q(ij)).LT.SMLVL .AND. qijchr.NE.tenblk) Q(ij) = 0.01
          IF (ABS(Q(ij)).GT.SMLVL) THEN
            qij = ABS(Q(ij)*0.005)
            IF (Qtol.GT.qij) Qtol = qij
          ENDIF
          READ (Luinit,9025,END=90,ERR=120) Orient(ij), Betvel(ij), 
     &          Qlat(ij), Ulat(ij)
          IF (Imodfw.NE.0) THEN
            READ (Luinit,9060,END=90,ERR=120) Istrm(3,ij), Istrm(2,ij), 
     &            Istrm(1,ij), Clk(ij), Zbot(ij)
            IF (Istrm(3,ij).LT.0) Lstruc = .TRUE.
          ENDIF
          IF (Rho(ij).LE.0.0) Rho(ij) = H2oden
          IF (Betvel(ij).LT.1.0 .AND. Istrm(3,ij).GE.0) Betvel(ij)
     &        = Glbeta
C
C---READ GEOMETRY RECORDS
          READ (Lugeom,9035,END=70,ERR=80) Ipt(ij), Xstatn(ij),
     &          Gdatum(ij), fvflg, (Itypeo(k,ij),k=1,4)
          CALL CHKSTA(Xstatn(ij))
          IF (fvflg.EQ.'FV' .OR. fvflg.EQ.'fv') THEN
            Nfvxs = Nfvxs + 1
            Ijvol(Nfvxs) = ij
            Fvol(Nfvxs) = 0.0
            Istapr(Nfvxs) = Xstatn(ij)
          ENDIF
C
C---CHECK STATION NUMBER AND DATA TYPES SPECIFIED FOR TDDB OUTPUT
          IF (Ottddb) THEN
            IF (Xstatn(ij)(15:16).EQ.Iblk) THEN
              IF (Itypeo(1,ij).EQ.Iblk .AND. Itypeo(2,ij).EQ.Iblk .AND. 
     &            Itypeo(3,ij).EQ.Iblk .AND. Itypeo(4,ij).EQ.Iblk)
     &            GOTO 20
              Error = .TRUE.
              msg = 'INVALID STATION NUMBER ('//Xstatn(ij)
     &              //') SPECIFIED'
              CALL ERRSCR(0,i,j,msg)
            ENDIF
            DO 10 k = 1, 4
              Dtype = Itypeo(k,ij)
              IF (Dtype.NE.Iblk .AND. Dtype.NE.Qtype .AND. 
     &            Dtype.NE.Ztype .AND. Dtype.NE.Atype .AND. 
     &            Dtype.NE.Btype) THEN
                Error = .TRUE.
                msg = 'INVALID DATA TYPE ('//Dtype//') SPECIFIED'
                CALL ERRSCR(0,i,j,msg)
              ENDIF
   10       CONTINUE
          ENDIF
C
C---INITIALIZE FIRST FORWARD VALUES
   20     Zp(ij) = Z(ij)
          Qp(ij) = Q(ij)
          nd = Ipt(ij)
          cdatum = Gdatum(ij)
          IF (nd.LT.2 .OR. nd.GT.MXPT) THEN
            WRITE (msg,9050) i, j
            CALL ERRPAR(1,nd,2,MXPT,' MXPT ',msg)
          ENDIF
          IF (Tabeta) THEN
            READ (Lugeom,9040,END=70,ERR=80)
     &            (Za(k,ij),Aa(k,ij),Bb(k,ij),Bs(k,ij),Wp(k,ij),
     &            Eta(k,ij),Qa(k,ij),Ta(k,ij),k=1,nd)
          ELSE
            READ (Lugeom,9045,END=70,ERR=80)
     &            (Za(k,ij),Aa(k,ij),Bb(k,ij),Bs(k,ij),Wp(k,ij),k=1,nd)
          ENDIF
          stg1 = Za(1,ij)
          Storar(1,ij) = 0.0
          DO 25 k = 2, nd
            stg2 = Za(k,ij)
            Storar(k,ij) = Storar(k-1,ij) +
     &                     0.5*(Bs(k,ij)+Bs(k-1,ij))*(stg2-stg1)
            stg1 = stg2
   25     CONTINUE
          IF (Wp(nd,ij).GT.SMLVL) THEN
            Rrflg(ij) = .TRUE.
            IF (Wp(nd,ij).LT.0.1) THEN
              WRITE (Printr,9065) i, j
              WRITE (*,9065) i, j
              CALL GETCHR
     &      (' Enter a carriage return to continue or "Q" to quit',cdmy)
            ENDIF
          ELSE
            Rrflg(ij) = .FALSE.
          ENDIF
          IF (j.GT.1 .AND. (Rrflg(ij).AND..NOT.Rrflg(ij-1).OR.
     &        .NOT.Rrflg(ij).AND.Rrflg(ij-1))) THEN
            msg = 
     &'CANNOT MIX USE OF HYDRAULIC RADIUS AND HYDRAULIC DEPTH WITHIN A B
     &RANCH.'
            GOTO 130
          ENDIF
          Zbot(ij) = Zbot(ij) + cdatum
          Za(1,ij) = Za(1,ij) + cdatum
          DO 30 k = 2, nd
            Za(k,ij) = Za(k,ij) + cdatum
            IF (Za(k-1,ij).GE.Za(k,ij)) THEN
              WRITE (msg,9055) Za(k-1,ij), Za(k,ij)
              GOTO 130
            ENDIF
   30     CONTINUE
          IF (Typeta.NE.1 .AND. Tabeta .AND. ABS(Eta(1,ij)).GT.SMLVL)
     &        THEN
            IF (ABS(Eta(1,ij)).GT.1.0) WRITE (Printr,9010) i, j
            CALL SETAB1(ij)
          ENDIF
          IF (Za(1,ij).LT.Ztmin) Ztmin = Za(1,ij)
          IF (Za(nd,ij).GT.Ztmax) Ztmax = Za(nd,ij)
C
C---CHECK CONSTANT ETA SPECIFIED AND ASSIGN GLOBAL DEFAULT IF GIVEN
          IF (j.NE.ns) THEN
            IF (.NOT.(Typeta.NE.1 .OR. ABS(Rn4(ij)).GT.SMLVL .OR. 
     &          (Tabeta .AND. ABS(Eta(1,ij)).GT.SMLVL))) THEN
              IF (ABS(Gleta).LT.SMLVL) CALL ERRSCR(1,i,j,
     & 'CONSTANT ETA INDICATED, BUT NO GLOBAL OR LOCAL VALUE SPECIFIED')
              Rn4(ij) = Gleta
            ENDIF
          ENDIF
   40   CONTINUE
   50 CONTINUE
      IF (Error) STOP
      DO 60 k = 1, ij
        Sumeta(k) = 0.0
        Sumczq(k) = 0.0
        Sczqsq(k) = 0.0
        Szqeta(k) = 0.0
        Indxs(k) = 2
   60 CONTINUE
      Dtype = Ztype
      Zdatum = (Ztmax+Ztmin)*0.5
      IF (ABS(Qtol-BIGPOS).LT.0.00005) Qtol = 1.0
      IF (Qqtol.LT.SMLVL) Qqtol = Qtol
      WRITE (*,'(/,A)') ' Initial-condition and geometry read end!'
      RETURN
   70 msg = 'END-OF-FILE READING GEOMETRY RECORDS'
      GOTO 130
   80 msg = 'IMPROPER FORMAT READING GEOMETRY RECORDS'
      GOTO 130
   90 msg = 'END-OF-FILE READING INITIAL CONDITIONS'
      GOTO 130
  100 msg = 'END-OF-FILE READING BRANCH IDENTIFICATION RECORD'
      GOTO 130
  110 msg = 'IMPROPER FORMAT READING BRANCH IDENTIFICATION RECORD'
      GOTO 130
  120 msg = 'IMPROPER FORMAT READING INITIAL CONDITION RECORDS'
  130 CALL ERRSCR(1,i,j,msg)
  140 CALL ERRPRT(msg)
      WRITE (msg,'(A,I3)') 'MUST BE GREATER THAN ZERO AND LESS THAN', 
     &                     Njnc+1
      CALL ERRLIN(msg)
      STOP
C
 9005 FORMAT (' BRANCH',I3,' FROM JUNCTION',I3,' TO',I3,' : ',A40)
 9010 FORMAT (/,
     &' *WARNING* POSSIBLE ERROR INVOLVING USE OF TABULAR ETA, ETA VALUE
     & > 1.0 FOUND.',/,11X,'FOR BRANCH',I3,' SECTION',I3,
     &' ETA VALUES SHOULD BE IN COLUMNS 51-60.',/,11X,
     &'NOTE, THE TABULAR ETA FIELD WAS REASSIGNED FOR MODEL VERSIONS',/,
     &11X,'AFTER 09/26/95.')
 9015 FORMAT (3I2,A40,27X,7I1)
 9020 FORMAT (2F10.3,F10.4,2F10.2,3E10.4,T1,2A10)
 9025 FORMAT (2F10.3,2F10.4)
 9030 FORMAT (2F10.3,F10.4,T1,2A10)
 9035 FORMAT (I2,1X,A16,44X,F7.3,5A2)
 9040 FORMAT (5F10.3,E10.4,2F10.3)
 9045 FORMAT (5F10.3)
 9050 FORMAT ('NUMBER OF DATA POINTS FOR CROSS SECTION',I2,', BRANCH',
     &        I3,' EXCEEDS MAXIMUM')
 9055 FORMAT ('DUPLICATE OR OUT-OF-RANGE STAGES IN GEOMETRY TABLE,',
     &        F8.3,'>=',F8.3)
 9060 FORMAT (3I3,2F10.4)
 9065 FORMAT (/,
     &' *WARNING* POSSIBLE ERROR ON GEOMETRY RECORDS, WETTED PERIMETER <
     & 0.1 FOUND.',/,11X,'FOR BRANCH',I3,' SECTION',I3,
     &' WETTED PERIMETER IS READ FROM COLUMNS',/,11X,
     &'41-50 AND ETA VALUES FROM COLUMNS 51-60.  NOTE, INPUT OF WETTED',
     &/,11X,
     &'PERIMETER WAS ADDED AND THE TABULAR ETA FIELD MOVED FOR MODEL'
     &,/,11X,'VERSIONS AFTER 09/26/95.',/)
 9070 FORMAT ('INVALID JUNCTION NUMBER (IJ',A1,' =',I3,
     &        ') SPECIFIED FOR ',A6,' OF POSITIVE FLOW FOR BRANCH',I3,/,
     &        ' MUST BE GREATER THAN ZERO AND LESS THAN',I3)
      END
C
C
C
      SUBROUTINE INCOND
C
C     THIS SUBROUTINE DETERMINES INITIAL CONDITIONS FROM SPECIFIED
C     BOUNDARY-VALUE DATA, SETS UNSPECIFIED INITIAL CONDITIONS USING
C     MEAN VALUES DETERMINED FROM INITIAL BOUNDARY-VALUE DATA
C     OR SPECIFIED GLOBAL-DEFAULT-INPUT INITIAL-CONDITION VALUES,
C     ASSIGNS UNSPECIFIED INITIAL CONDITIONS AT INTERNAL
C     JUNCTIONS ACCORDING TO STAGE COMPATIBILITY AND DISCHARGE
C     CONTINUITY, AND INTERPOLATES INITIAL CONDITIONS AT INTERMEDIATE
C     CROSS SECTIONS WITHIN BRANCHES.
C
      INCLUDE 'dimens.cmn'
      INCLUDE 'branch.cmn'
      INCLUDE 'comcon.cmn'
      INCLUDE 'dtcomp.cmn'
      INCLUDE 'bindex.cmn'
      INCLUDE 'boundy.cmn'
      INCLUDE 'bouchr.cmn'
      INCLUDE 'dtypes.cmn'
      INTEGER i, j, k, l, ij, ij1, ijns, ns, ibch, ktzbc, ktqbc, ictj, 
     &        ictjbc, ictobc
      REAL zbcsum, qbcsum, gzhold, gqhold, qbcavg, zbc
      EXTERNAL SEOBIC, SEXSIC
      REAL ABS
      INTEGER IABS
      INTRINSIC IABS, ABS
C
C     DETERMINE MEAN STAGE AND DISCHARGE FROM INITIAL BOUNDARY-VALUE
C     DATA FOR USE AS GLOBAL INITIAL-CONDITION VALUES IF GLOBAL-DEFAULT
C     VALUES ARE NOT SPECIFIED IN INPUT FILE
C
      ktzbc = 0
      ktqbc = 0
      zbcsum = 0.0
      qbcsum = 0.0
      gzhold = Glicz
      gqhold = Glicq
      IF (ABS(Glicz).LT.SMLVL .OR. ABS(Glicq).LT.SMLVL) THEN
        DO 10 l = 1, Nbnd
          IF (Izqbve(l).EQ.0) THEN
            IF (Itype(l).EQ.Ztype) THEN
              zbcsum = zbcsum + Zq(1,l) + Zdatum
              ktzbc = ktzbc + 1
            ELSEIF (Itype(l).EQ.Qtype) THEN
              qbcsum = qbcsum + Zq(1,l)
              ktqbc = ktqbc + 1
            ENDIF
          ELSEIF (Izqbve(l).EQ.1) THEN
C
C---Include constant stages in average
            IF (Itype(l).EQ.Ztype) THEN
              zbcsum = zbcsum + Zqbvco(1,l)
              ktzbc = ktzbc + 1
C
C---Do no include non-constant discharges equal to 0.0
            ELSEIF (Itype(l).EQ.Qtype .AND. ABS(Zqbvco(1,l)).GT.SMLVL)
     &        THEN
              qbcsum = qbcsum + Zqbvco(1,l)
              ktqbc = ktqbc + 1
            ENDIF
C---Note, does not include SIN, rating table, or equations in average
          ENDIF
   10   CONTINUE
        IF (ktzbc.NE.0 .AND. ABS(Glicz).LT.SMLVL) Glicz = zbcsum/ktzbc
        IF (ktqbc.NE.0 .AND. ABS(Glicq).LT.SMLVL) Glicq = qbcsum/ktqbc
      ENDIF
C
C     ASSIGN UNINITIALIZED STAGE AND DISCHARGE AT OPEN-BOUNDARY JUNCTION OF
C     OPEN-BOUNDARY BRANCH TO THE INITIAL BOUNDARY-VALUE DATA AND ASSIGN
C     UNINITIALIZED STAGE AND DISCHARGE AT NON-OPEN-BOUNDARY JUNCTION TO
C     GLOBAL-DEFAULT-INPUT VALUE OR MEAN VALUE DETERMINED FROM INITIAL
C     BOUNDARY-VALUE DATA
C
      ictobc = 0
      DO 30 i = 1, Nbch
        ns = Nsec(i)
        ij1 = MAXS - Xskt(i) + 1
        ijns = MAXS - Xskt(i) + ns
C
C---ICTOBC IS A COUNT OF THE NUMBER OF OPEN-BOUNDARY BRANCHES
C---IBROBC(NBCH) HOLDS THE BRANCH NUMBERS OF OPEN-BOUNDARY BRANCHES
        DO 20 l = 1, Nbnd
          IF (Ibjnc(l).EQ.Ijf(i) .OR. Ibjnc(l).EQ.Ijt(i)) THEN
C
C---SET INITIAL CONDITIONS AT UPSTREAM JUNCTION OF OPEN-BOUNDARY BRANCH
            IF (Ibjnc(l).EQ.Ijf(i) .AND. 
     &          (ABS(Z(ij1)).GT.SMLVL .OR. ABS(Q(ij1)).GT.SMLVL))
     &          CALL SEOBIC(ij1,l)
C
C---SET INITIAL CONDITIONS AT DOWNSTREAM JUNCTION OF OPEN-BOUNDARY BRANCH
            IF (Ibjnc(l).EQ.Ijt(i) .AND. 
     &          (ABS(Z(ijns)).GT.SMLVL .OR. ABS(Q(ijns)).GT.SMLVL))
     &          CALL SEOBIC(ijns,l)
            ictobc = ictobc + 1
            Ibrobc(ictobc) = i
          ENDIF
   20   CONTINUE
   30 CONTINUE
C
C     ASSIGN UNINITIALIZED STAGE AND DISCHARGE AT NON-OPEN-BOUNDARY
C     JUNCTION AT WHICH A NON-OPEN-BOUNDARY BRANCH CONNECTS WITH AN
C     OPEN-BOUNDARY BRANCH
C
C     IDX(MXJN,MXBH), ICT(MXJN) DEFAULTS: MXJN = 25 MXBH = 25
C     ICT(J) IS A COUNT OF THE TOTAL NUMBER OF BRANCHES CONNECTING
C     AT THE J JUNCTION.
C     IDX(J,1...ICT(J)) HOLDS THE BRANCH NUMBERS OF BRANCHES CONNECTING
C     AT THE J JUNCTION.
C     (IF A BRANCH NUMBER IN IDX IS NEGATIVE, THEN THE BRANCH CONNECTS
C     TO THE JUNCTION AT ITS UPSTREAM END.  IF POSITIVE, THEN THE BRANCH
C     CONNECTS TO THE JUNCTION AT ITS DOWNSTREAM END.)
C
      DO 70 j = 1, Njnc
        IF (Ict(j).NE.1) THEN
          ictj = Ict(j)
C
C---ICTJBC IS A COUNT OF THE NUMBER OF OPEN-BOUNDARY BRANCHES CONNECTING
C---AT THE J JUNCTION
          ictjbc = 0
          qbcsum = 0.0
          zbc = 0.0
          DO 50 k = 1, ictj
            ibch = IABS(Idx(j,k))
            DO 40 l = 1, ictobc
              IF (Ibrobc(l).EQ.ibch) THEN
                ictjbc = ictjbc + 1
                ij = MAXS - Xskt(ibch) + 1
                IF (Idx(j,k).GT.0) ij = ij + Nsec(ibch) - 1
                IF (ABS(zbc).LT.SMLVL .AND. ABS(Z(ij)).GT.SMLVL)
     &              zbc = Z(ij)
                qbcsum = qbcsum + Q(ij)
              ENDIF
   40       CONTINUE
   50     CONTINUE
          qbcavg = 0.0
          IF (ictjbc.NE.0) qbcavg = qbcsum/ictjbc
          DO 60 k = 1, ictj
            ibch = IABS(Idx(j,k))
            ij = MAXS - Xskt(ibch) + 1
            IF (Idx(j,k).GT.0) ij = ij + Nsec(ibch) - 1
            IF (ABS(Z(ij)).LT.SMLVL) THEN
              Z(ij) = zbc
              Zp(ij) = Z(ij)
            ENDIF
            IF (ABS(Q(ij)).LT.SMLVL) THEN
              Q(ij) = qbcavg
              Qp(ij) = Q(ij)
            ENDIF
   60     CONTINUE
        ENDIF
   70 CONTINUE
C
C---ASSIGN UNINITIALIZED STAGE AND DISCHARGE AT REMAINING JUNCTIONS
C---WHICH INVOLVE ONLY NON-OPEN-BOUNDARY BRANCHES
      DO 90 j = 1, Njnc
        IF (Ict(j).NE.1) THEN
          ictj = Ict(j)
          DO 80 k = 1, ictj
            ibch = IABS(Idx(j,k))
            ij = MAXS - Xskt(ibch) + 1
            IF (Idx(j,k).GT.0) ij = ij + Nsec(ibch) - 1
            IF (ABS(Z(ij)).LT.SMLVL) THEN
              Z(ij) = Glicz
              Zp(ij) = Glicz
            ENDIF
            IF (ABS(Q(ij)).LT.SMLVL) THEN
              Q(ij) = Glicq
              Qp(ij) = Glicq
            ENDIF
   80     CONTINUE
        ENDIF
   90 CONTINUE
C
C---INTERPOLATE INITIAL CONDITIONS FOR ANY INTERMEDIATE CROSS
C---SECTIONS WITHIN BRANCHES
      CALL SEXSIC
      Glicz = gzhold
      Glicq = gqhold
      RETURN
      END
C
C
C
      SUBROUTINE SEOBIC(IJ,L)
C
C     THIS SUBROUTINE SETS UNSPECIFIED INITIAL CONDITIONS FOR
C     JUNCTIONS DELIMITING OPEN-BOUNDARY BRANCHES
C
      INCLUDE 'dimens.cmn'
      INCLUDE 'comcon.cmn'
      INCLUDE 'dtcomp.cmn'
      INCLUDE 'boundy.cmn'
      INCLUDE 'bouchr.cmn'
      INCLUDE 'dtypes.cmn'
      INCLUDE 'datime.cmn'
      INTEGER k, L, IJ, knd, kpt, itblbc
      REAL zij, qij, rm
      INTEGER IABS
      REAL ABS
      INTRINSIC ABS, IABS
      SAVE itblbc
      DATA itblbc/0/
C
C---SET I.C.'S FROM SPECIFIED STAGE B.V.D.
      IF (Izqbve(L).EQ.0) THEN
        IF (Itype(L).EQ.Ztype) THEN
          IF (ABS(Z(IJ)).LT.SMLVL) THEN
            Z(IJ) = Zq(1,L) + Zdatum
            Zp(IJ) = Z(IJ)
          ENDIF
          IF (ABS(Q(IJ)).LT.SMLVL) THEN
            Q(IJ) = Glicq
            Qp(IJ) = Glicq
          ENDIF
C
C---SET I.C.'S FROM SPECIFIED DISCHARGE B.V.D.
        ELSEIF (Itype(L).EQ.Qtype) THEN
          IF (ABS(Q(IJ)).LT.SMLVL) THEN
            Q(IJ) = Zq(1,L)
            Qp(IJ) = Q(IJ)
          ENDIF
          IF (ABS(Z(IJ)).LT.SMLVL) THEN
            Z(IJ) = Glicz
            Zp(IJ) = Glicz
          ENDIF
        ENDIF
C
C---SET I.C.'S FROM SPECIFIED Z(Q) EQUATION
      ELSEIF (IABS(Izqbve(L)).EQ.1) THEN
        IF (Itype(L).EQ.Ztype .AND. ABS(Z(IJ)).LT.SMLVL) THEN
          qij = Q(IJ)
          Z(IJ) = Zqbvco(1,L)
     &            + (Zqbvco(2,L)+(Zqbvco(3,L)+Zqbvco(4,L)*qij)*qij)*qij
          Zp(IJ) = Z(IJ)
          IF (ABS(Q(IJ)).LT.SMLVL) THEN
            Q(IJ) = Glicq
            Qp(IJ) = Glicq
          ENDIF
C
C---SET I.C.'S FROM SPECIFIED Q(Z) EQUATION
        ELSEIF (Itype(L).EQ.Qtype .AND. ABS(Q(IJ)).LT.SMLVL) THEN
          zij = Z(IJ)
          Q(IJ) = Zqbvco(1,L)
     &            + (Zqbvco(2,L)+(Zqbvco(3,L)+Zqbvco(4,L)*zij)*zij)*zij
          Qp(IJ) = Q(IJ)
          IF (ABS(Z(IJ)).LT.SMLVL) THEN
            Z(IJ) = Glicz
            Zp(IJ) = Glicz
          ENDIF
        ENDIF
C
C---SET I.C.'S FROM STAGE/DISCHARGE RATING TABLE
      ELSEIF (Izqbve(L).EQ.2) THEN
        itblbc = itblbc + 1
        knd = Izqpt(itblbc) - 1
C
C---SET I.C.'S FROM SPECIFIED Z(Q) TABLE
        IF (Itype(L).EQ.Ztype .AND. ABS(Z(IJ)).LT.SMLVL .AND. ABS(Q(IJ))
     &      .GT.SMLVL) THEN
          DO 10 k = 1, knd
            kpt = k
            IF (Q(IJ).GE.Qt(k,itblbc) .AND. Q(IJ).LE.Qt(k+1,itblbc))
     &          GOTO 20
   10     CONTINUE
   20     rm = (Q(IJ)-Qt(kpt,itblbc))/(Qt(kpt+1,itblbc)-Qt(kpt,itblbc))
          Z(IJ) = Zt(kpt,itblbc) + rm*(Zt(kpt+1,itblbc)-Zt(kpt,itblbc))
          Zp(IJ) = Z(IJ)
C
C---SET I.C.'S FROM SPECIFIED Q(Z) TABLE
        ELSEIF (Itype(L).EQ.Qtype .AND. ABS(Q(IJ)).LT.SMLVL .AND. 
     &          ABS(Z(IJ)).GT.SMLVL) THEN
          DO 30 k = 1, knd
            kpt = k
            IF (Z(IJ).GE.Zt(k,itblbc) .AND. Z(IJ).LE.Zt(k+1,itblbc))
     &          GOTO 40
   30     CONTINUE
   40     rm = (Z(IJ)-Zt(kpt,itblbc))/(Zt(kpt+1,itblbc)-Zt(kpt,itblbc))
          Q(IJ) = Qt(kpt,itblbc) + rm*(Qt(kpt+1,itblbc)-Qt(kpt,itblbc))
          Qp(IJ) = Q(IJ)
        ENDIF
C
C---SET I.C.'S FROM SPECIFIED SIN EQUATION
      ELSEIF (Izqbve(L).EQ.3) THEN
C
C---SET I.C.'S FROM Z(T) TABLE
        IF (Itype(L).EQ.Ztype .AND. ABS(Z(IJ)).LT.SMLVL) THEN
          Z(IJ) = Zqbvco(1,L) + (Zqbvco(2,L)*0.5)*SIN(.01745329*
     &            ((M*Dt/Zqbvco(3,L)*180.0)+Zqbvco(4,L)))
          Zp(IJ) = Z(IJ)
          IF (ABS(Q(IJ)).LT.SMLVL) THEN
            Q(IJ) = Glicq
            Qp(IJ) = Glicq
          ENDIF
C
C---SET I.C.'S FROM Q(T) TABLE
        ELSEIF (Itype(L).EQ.Qtype .AND. ABS(Q(IJ)).LT.SMLVL) THEN
          Q(IJ) = Zqbvco(1,L) + (Zqbvco(2,L)*0.5)*SIN(.01745329*
     &            ((M*Dt/Zqbvco(3,L)*180.0)+Zqbvco(4,L)))
          Qp(IJ) = Q(IJ)
          IF (ABS(Z(IJ)).LT.SMLVL) THEN
            Z(IJ) = Glicz
            Zp(IJ) = Glicz
          ENDIF
        ENDIF
C
C
C---SET I.C.'S FOR SELF-SETTING B.C.'S TO SPECIFIED GLOBAL DEFAULTS
      ELSEIF (Itype(L).EQ.Zptype .OR. Itype(L).EQ.Qptype) THEN
        IF (ABS(Z(IJ)).LT.SMLVL) THEN
          Z(IJ) = Glicz
          Zp(IJ) = Glicz
        ENDIF
        IF (ABS(Q(IJ)).LT.SMLVL) THEN
          Q(IJ) = Glicq
          Qp(IJ) = Glicq
        ENDIF
      ENDIF
      RETURN
      END
C
C
C
      SUBROUTINE SEXSIC
C
C     THIS SUBROUTINE SETS UNSPECIFIED INITIAL CONDITIONS FOR
C     INTERMEDIATE CROSS SECTIONS WITHIN BRANCHES
C
      INCLUDE 'dimens.cmn'
      INCLUDE 'branch.cmn'
      INCLUDE 'comcon.cmn'
      INCLUDE 'dtcomp.cmn'
      INCLUDE 'xsinit.cmn'
      INTEGER i, j, ij, ij1, ijns, ns, nsm1
      REAL zdiff, qdiff, dxtot, dxdiff, ABS
      INTRINSIC ABS
C
      DO 30 i = 1, Nbch
        ns = Nsec(i)
        ij1 = MAXS - Xskt(i) + 1
        ijns = MAXS - Xskt(i) + ns
        zdiff = Z(ijns) - Z(ij1)
        qdiff = Q(ijns) - Q(ij1)
        ij = ij1
        nsm1 = ns - 1
        dxtot = 0.0
        DO 10 j = 1, nsm1
          dxtot = dxtot + Dx(ij)
          ij = ij + 1
   10   CONTINUE
        ij = ij1
        dxdiff = 0.0
        DO 20 j = 2, nsm1
          dxdiff = dxdiff + Dx(ij)
          ij = ij + 1
          IF (ABS(Z(ij)).LT.SMLVL) THEN
            Z(ij) = Z(ij1) + zdiff*dxdiff/dxtot
            Zp(ij) = Z(ij)
          ENDIF
          IF (ABS(Q(ij)).LT.SMLVL) THEN
            Q(ij) = Q(ij1) + qdiff*dxdiff/dxtot
            Qp(ij) = Q(ij)
          ENDIF
   20   CONTINUE
   30 CONTINUE
      RETURN
      END
