      SUBROUTINE BRINIT
C
C     Initialize BRANCH computational variables and arrays
C     Read in all data
C
      INCLUDE 'dimens.cmn'
      INCLUDE 'partim.cmn'
      INCLUDE 'limits.cmn'
      INCLUDE 'units.cmn'
      INCLUDE 'untmes.cmn'
      INCLUDE 'dtcomp.cmn'
      INCLUDE 'geom.cmn'
      INCLUDE 'branch.cmn'
      INCLUDE 'comcon.cmn'
      INCLUDE 'dtypes.cmn'
      INCLUDE 'boundy.cmn'
      INCLUDE 'bouchr.cmn'
      INCLUDE 'mdatas.cmn'
      INCLUDE 'netwrk.cmn'
      INCLUDE 'matrix.cmn'
      INCLUDE 'xsinit.cmn'
      INCLUDE 'ceta.cmn'
      INCLUDE 'cploop.cmn'
      INCLUDE 'usrtbl.cmn'
      INCLUDE 'modbrn.cmn'
      INCLUDE 'zq.cmn'
      INCLUDE 'bindex.cmn'
      INCLUDE 'lunums.cmn'
      INCLUDE 'dadcom.cmn'
      INCLUDE 'logics.cmn'
      INCLUDE 'bctime.cmn'
      INCLUDE 'datime.cmn'
      INCLUDE 'wind.cmn'
      INCLUDE 'nodal.cmn'
      INCLUDE 'brnerr.cmn'
      INCLUDE 'arblog.cmn'
C
      INTEGER i, j, k, l, ij, ns, ibch
      CHARACTER*66 msg
      REAL SETA, SETAB, twocsq
      EXTERNAL TIMER, RDCOMP, BRICXS, RDTRK, NDFINP, BVDINP, WNDINP, 
     &         MEDINP, INCOND, ARBALL, PRTBXS, DAILY, SETA, SETAB, 
     &         ERRCRD, STRINP
      INTEGER MAX0, IABS, MOD
      REAL ABS, FLOAT
      INTRINSIC MAX0, IABS, MOD, ABS, FLOAT
C
C     INITIALIZE CONSTANTS AND OTHER IMPORTANT VARIABLES
C     SUCH AS UNIT NUMBERS FOR ALL FILES
C
C     this string (characters 1-58) is used for labeling printouts.
      Brdate = '@(#)BRANCH - A Model for Simulation of Flow in Singular'
      Brdate = '@(#)BRANCH -        and Interconnected Channels'
      Brdate = 
     &'@(#)BRANCH - USGS TWRI Chapter 3, Book 7, R.W. Schaffranek, et al
     &, 1981'
      Brdate = '@(#)BRANCH - Contact: h2osoft@usgs.gov'
      Brdate = '@(#)BRANCH - Version: 4.3x 1997/06/05'
      msg = 
     & '$Id: brinit.f,v 4.3 1997/06/05 20:06:41 rsregan Exp rsregan $'
      Brdate = 'Branch-Network Dynamic Flow Model, Version: '//
     &         msg(17:31)
      Time0 = 0.0
      CALL TIMER(Time0)
C
      Reader = 55
      Luinit = 56
      Lugeom = 57
      Mastr = 58
      Luscr = 59
      Lucvol = 60
      Luivol = 61
      Luiflo = 62
      Lumap = 63
      Lubltm = 64
      Lupst = 65
      Printr = 66
      Punch = 67
      Ludplt = 68
      Luptrk = 69
      Dsref = 97
      Tddata = 98
      Lustrc = 70
C---Luout is temporary file (*.out) of flow results for post plotting
C---if set to zero this is not generated.
C     Luout = 71
      Luout = 0
C
C---Luterm is temporary file (*.trm) of equation terms for post plotting
C---if set to zero this is not generated.
C     Luterm = 72
      Luterm = 0
C
      Qtol = BIGPOS
      Ztmin = BIGPOS
      Ztmax = BIGNEG
      Dxmin = 5000.0
      Dxmax = 25000.0
      Noconv = .TRUE.
      Error = .FALSE.
      Daopen = .FALSE.
      Modeta = .FALSE.
      Ndpart = 0
      Ndleft = 0
      Nnpart = 0
      Nwpart = 0
      Morebd = .FALSE.
      Morenf = .FALSE.
      Morewd = .FALSE.
      Modflow = .FALSE.
      Lstruc = .FALSE.
      Icount = 0
      Clkp = 0.0
      Clkp1 = 0.0
      Clkpp1 = 0.0
      Clkij = 0.0
      Ntsaq = 1
      Dtype = ' Z'
      Ztype = Dtype
      Qtype = ' Q'
      Qptype = 'QP'
      Atype = ' A'
      Btype = ' B'
      Zptype = 'ZP'
      Dptype = 'DP'
      En = 'EN'
      Me = 'ME'
      Unit = 'FT'
      Mt = ' M'
      Tunit = ' F'
      Dc = ' C'
      Iblk = '  '
      Rtcode = 0
      Strip = -1
C
      DO 10 i = 1, 12
        Dypmo(i) = 31
   10 CONTINUE
      Dypmo(2) = 28
      Dypmo(4) = 30
      Dypmo(6) = 30
      Dypmo(9) = 30
      Dypmo(11) = 30
      DO 20 i = 1, MAXS
        Linprt(i) = .FALSE.
        Zbot(i) = BIGNEG
        Hyrad(i) = 0.0
        Istrm(3,i) = 0
   20 CONTINUE
C
C---READ PROGRAM CONTROL PARAMETERS AND ASSIGN DEFAULTS
      CALL RDCOMP
      IF (Idtm.LT.0) THEN
        Idtsec = IABS(Idtm)
        Idtm = Idtsec/60
        IF (MOD(Idtsec,60).NE.0) Idtm = Idtm + 1
      ELSE
        Idtsec = 0
      ENDIF

C
C---READ BRANCH IDENTIFICATION, INITIAL VALUES, AND GEOMETRY DATA
      CALL BRICXS
C
C---CALCULATE NUMBER OF BRANCHES AT EACH JUNCTION AND ASSIGN INDICES
      DO 40 j = 1, Njnc
        Ict(j) = 0
        DO 30 i = 1, Nbch
          IF (Ijf(i).EQ.j) THEN
            Ict(j) = Ict(j) + 1
            Idx(j,Ict(j)) = -i
          ENDIF
          IF (Ijt(i).EQ.j) THEN
            Ict(j) = Ict(j) + 1
            Idx(j,Ict(j)) = i
          ENDIF
   30   CONTINUE
   40 CONTINUE
C
C---READ PARTICLE INJECTION LOCATIONS
      IF (Ipropt.EQ.9) CALL RDTRK
C
C---READ USER-DEFINED TABLE OF COMPUTED FLOW RESULTS SECTIONS AND TYPES
      IF (Otfile.EQ.5) READ (Reader,'(8(A2,2I5))',ERR=200)
     &                       (Uttyp(j),Utbch(j),Utsec(j),j=1,NUMTBL)
C
C---READ EXTERNAL INFLOW/OUTFLOW AT INTERNAL JUNCTIONS
      CALL NDFINP
C
C---READ BOUNDARY-VALUE DATA FOR EXTERNAL JUNCTIONS
      READ (Reader,'(A80,T1,37X,I2,I8)',ERR=190) Lstcrd, Listb, Lista
      CALL BVDINP
C
C---READ TIME-DEPENDENT NODAL FLOW DATA
      IF (Kttdnf.NE.0) CALL NDFINP
C
C---READ TIME-DEPENDENT WIND SPEED AND DIRECTION
      Nwfirt = 0
      IF (Inwind.NE.0) CALL WNDINP(Prtmsg)
C
C---READ MEASURED DATA; BEGIN DATE, BEGIN TIME, AND DATA FREQUENCY ARE
C---ASSUMED CONSTANT FOR ALL MEASURED DATA SETS INPUT AS SPECIFIED ON
C---FIRST MEASURED-DATA DEFINITION CARD.
      CALL MEDINP
C
C---READ FLOW STRUCTURE FILE IF SPECIFIED
      IF (Lstruc) CALL STRINP
C
C---SET UNSPECIFIED INITIAL CONDITIONS USING MEAN VALUES DETERMINED FROM
C---INITIAL BOUNDARY-VALUE DATA OR SPECIFIED GLOBAL-DEFAULT INPUT VALUES
      IF (Irdic.EQ.0) CALL INCOND
C
C---DETERMINE AREA, WIDTH, AND HYDRAULIC DEPTH AT SPECIFIED STAGE
      CALL ARBALL
C
C---new Idtm input as seconds 3/24/95
      IF (Idtsec.NE.0) THEN
        Dt = FLOAT(Idtsec)
      ELSE
        Dt = FLOAT(Idtm*60)
      ENDIF
C
C---PRINT COMPUTATION-CONTROL PARAMETER TABLE AND XS GEOMETRY DATA
      IF (Iprtdt.EQ.0) Iprtdt = Idtm
      Iprtdt = MAX0(Iprtdt,Idtm)
C
      CALL PRTBXS
C
C---APPLY STAGE COMPUTATION DATUM
      IF (ABS(Zdatum).GT.0.000001) THEN
        DO 70 i = 1, Nbch
          ns = Nsec(i)
          ij = MAXS - Xskt(i)
          DO 60 j = 1, ns
            ij = ij + 1
            Z(ij) = Z(ij) - Zdatum
            Zp(ij) = Z(ij)
            DO 50 k = 1, Ipt(ij)
              Za(k,ij) = Za(k,ij) - Zdatum
   50       CONTINUE
   60     CONTINUE
   70   CONTINUE
      ENDIF
C
C---IDENTIFY CROSS-SECTION LOCATIONS FOR SELF-SETTING BOUNDARY COND.
C
C     IN THIS APPROXIMATION, THE STAGE (OR DISCHARGE) AT THE
C     SPECIFIED EXTERNAL BOUNDARY-CONDITION JUNCTION FOR THE PRESENT
C     TIME STEP WILL BE EQUATED TO THE STAGE (OR DISCHARGE)
C     COMPUTED DURING THE PREVIOUS TIME STEP AT THE NEAREST NEIGHBORING
C     UPSTREAM (IF EXTERNAL JUNCTION ENDS THE BRANCH) OR DOWNSTREAM
C     (IF EXTERNAL JUNCTION BEGINS THE BRANCH) CROSS SECTION.  AS A
C     SPECIAL CASE, A MINIMUM STAGE (OR DISCHARGE) CAN BE
C     SPECIFIED BELOW WHICH THE STAGE (OR DISCHARGE) WILL NOT BE
C     PERMITTED TO DROP, THEREBY SIMULATING A SUBMERGED WIER (OR GATE)
C     CONDITION.
C
      DO 80 l = 1, Nbnd
        IF (Ibjnc(l).NE.0) THEN
          ibch = Idx(Ibjnc(l),1)
          IF (Itype(l).EQ.Zptype .OR. Itype(l).EQ.Dptype) THEN
            IF (ibch.LT.0) THEN
              Ijzpbc = MAXS - Xskt(IABS(ibch)) + 2
            ELSE
              Ijzpbc = MAXS - Xskt(ibch) + Nsec(ibch) - 1
            ENDIF
          ELSEIF (Itype(l).EQ.Qptype) THEN
            IF (ibch.LT.0) THEN
              Ijqpbc = MAXS - Xskt(IABS(ibch)) + 2
            ELSE
              Ijqpbc = MAXS - Xskt(ibch) + Nsec(ibch) - 1
            ENDIF
          ENDIF
        ENDIF
   80 CONTINUE
C
C---INITIIALIZE COMPUTATION LOOP PARAMETERS
      Ktmats = 0
      Nd = 1
      Nnd = 1
      Nwd = 1
      Lastn = 0
      N = 0
      Letime = Ietime
      Kt = 0
      IF (.NOT.Ptplt) Kt = (Inhr*60+Inmn-1)/Idtm
      IF (Kt.NE.0) THEN
        DO 110 i = 1, Nbch
          ns = Nsec(i)
          ij = MAXS - Xskt(i)
          DO 100 j = 1, ns
            ij = ij + 1
            DO 90 l = 1, Kt
              IF (Stages) THEN
                Zqcomp(l,ij) = Z(ij)*Qzconv
              ELSE
                Zqcomp(l,ij) = Q(ij)*Qzconv
              ENDIF
   90       CONTINUE
  100     CONTINUE
  110   CONTINUE
      ENDIF
C
C---Initialize eta values
      DO 130 i = 1, Nbch
        ns = Nsec(i) - 1
        ij = MAXS - Xskt(i)
        DO 120 j = 1, ns
          ij = ij + 1
          IF (Tabeta .AND. ABS(Eta(1,ij)).GT.SMLVL) THEN
            Rn4(ij) = SETAB(ij,Z(ij),Q(ij),A(ij),R(ij))
          ELSE
            IF (Typeta.NE.1) Rn4(ij) = SETA(ij,Z(ij),Q(ij),A(ij),R(ij))
          ENDIF
  120   CONTINUE
  130 CONTINUE
C
      IF (Ounit.EQ.Me) Unit = Mt
      Dypmo(2) = 28 + (4-MOD(Kyr,4))/4
      IF (Daysum) CALL DAILY
C
      WRITE (*,9010)
      IF (Khr.NE.24) WRITE (*,9005) Kyr, Kmo, Kda, Khr, Kmn
      WRITE (Rundat,9015) Kyr, Kmo, Kda, Khr, Kmn
C
C---INITIALIZE COMPUTATION CONSTANTS
      Ksc = Kmn*60
      Idts = Idtm*60
      Idtrat = Iprtdt/Idtm
      IF (Idtsec.NE.0) THEN
        Idts = Idtsec
        Idtrat = (Iprtdt*60)/Idts
      ENDIF
      Lprtdt = .FALSE.
      IF (Iprtdt.EQ.Idtm .AND. Idtsec.EQ.0) Lprtdt = .TRUE.
      IF (Iunit.NE.En) THEN
        Ceta1 = 1.794000
        Ceta2 = 0.0530429
        Ceta3 = .00064286
        Wsfact = 1000./3600.
        twocsq = 2.0
      ELSE
        Ceta1 = 3.165276
        Ceta2 = 0.0454095
        Ceta3 = .00021370
        Wsfact = 5280./3600.
        twocsq = 2.0*1.486*1.486
      ENDIF
      Wspeed = Wspeed*Wsfact
      Twodtn = 1.0/(2.0*Dt)
      Idtpdy = 1440/Idtm
      IF (Idtpdy.EQ.0) Idtpdy = 1
      Ginv = 1.0/G
      Ginv2 = 2.0/G
      H2odi = 1.0/H2oden
      Cwfact = Wsdrag*Airden/(H2oden*G)
      Cw = Wspeed*Wspeed*Cwfact
      Chihf = Chi*0.5
      Dchi = (1.0-Chi)/Chi
      Chi1hf = (1.0-Chi)*0.5
      Thetai = 1.0/Theta
      Theta2i = 1.0/(2.0*Theta)
      Dtheta = (1.0-Theta)/Theta
      Denthi = H2odi/Theta
      Gtheta = 1.0/(Theta*G)
      Dt2gth = Twodtn*Gtheta
      Dt2tha = Twodtn/Theta
      Chi2th = Chi/(Theta*twocsq)
      Dcfm64 = Dcfm/64.0
C
C---INITIALIZE MATRIX ARRAYS AND CONSTANTS
      Ii = 4*Nbch
      Iim1 = Ii - 1
      Ii2 = Ii + Ii
      Ii3 = Ii2 + Ii
      Iim1ii = Iim1*Ii
      Iisq = Ii*Ii
      DO 140 i = 1, Ii
        Row(i) = i
  140 CONTINUE
      DO 150 i = 1, Iisq
        Am(i) = 0.0
  150 CONTINUE
      DO 160 i = 1, MXBH4
        Bmx(i) = 0.0
  160 CONTINUE
C
C---Initialize time step loop counter
      M = 1
C
C---END INITIALIZATION
      RETURN
  190 msg = 'READING THE FOLLOWING LIST-INDEX RECORD'
      GOTO 210
  200 msg = 'READING THE FOLLOWING MODFLOW TYPE RECORD'
  210 CALL ERRCRD(1,Lstcrd,msg)
C
C---OUTPUT FORMAT STATEMENTS
 9005 FORMAT (' SIMULATION TIME = ',2(I2.2,'/'),I2.2,I3.2,':',I2.2)
 9010 FORMAT (/' SIMULATION START!'/)
 9015 FORMAT (2(I2.2,'/'),I2.2,I3.2,':',I2.2)
      END
