      SUBROUTINE DAILY
C
C  SUBROUTINE TO PRINT DAILY SUMMARIES OF FLOW RESULTS (IPROPT=2)
C  OR TO WRITE DIRECT-ACCESS CUMULATIVE FLOW-VOLUME FILE AND PRINT
C  TABLES OF MONTHLY FLOW-VOLUME SUMMARIES (IPROPT=4).
C
      CHARACTER*10 months(12)
      CHARACTER fvname*80, blk16*16
      INTEGER fvyear, i4zero, i, j, k, l, ij, ns, ktline, initfl, 
     &        mxfrmo, kt, lastm, nxs, idtpdy, ios, mo, jdayn, minhr, 
     &        minmn, maxhr, maxmn, nd, jdaynb, jdayne, ista, nr, ifvsum, 
     &        itime, kk, jj, dperm(12), fvdata(12)
      REAL fvfact, qbarij, dmy
      CHARACTER*36 msg
      CHARACTER repeat(8)*1, prform*40, hdform*44, vlform*44
      CHARACTER*2 astk, ipart, fvunit
      LOGICAL ilast, prtday, partdy, empty, prtbrn
      INCLUDE 'dimens.cmn'
      INCLUDE 'lunums.cmn'
      INCLUDE 'branch.cmn'
      INCLUDE 'units.cmn'
      INCLUDE 'netwrk.cmn'
      INCLUDE 'comcon.cmn'
      INCLUDE 'untmes.cmn'
      INCLUDE 'convt.cmn'
      INCLUDE 'zqstat.cmn'
      INCLUDE 'datime.cmn'
      INCLUDE 'volcom.cmn'
      INCLUDE 'bouchr.cmn'
      INCLUDE 'logics.cmn'
      INTEGER idthr(MAXDFR), idtmn(MAXDFR)
      CHARACTER*16 fvstat(31,MXFV), lsta(MXFV)
C     MAXDFR = MAX NUMBER OF FLOW REVERSALS ACCOUNTED FOR IN ONE DAY.
C     NEXT FOUR ARRAYS WERE IN VOLCOM COMMON.
      INTEGER MOD, INT
      REAL SIGN
      INTRINSIC MOD, INT, SIGN
      EXTERNAL ERRSTP
C--End volcom.cmn
      SAVE initfl, nxs, idtpdy, lastm, partdy, ktline
      SAVE prtbrn, fvyear, fvunit, fvname, fvfact, fvdata, dperm
      DATA i4zero/0/, blk16/'                '/
      DATA months/' JANUARY  ', ' FEBRUARY ', '  MARCH   ', 
     &     '  APRIL   ', '   MAY    ', '   JUNE   ', '   JULY   ', 
     &     '  AUGUST  ', 'SEPTEMBER ', ' OCTOBER  ', ' NOVEMBER ', 
     &     ' DECEMBER '/, astk/' *'/
      DATA repeat/'1', '2', '3', '4', '5', '6', '7', '8'/
      DATA prform/'(I6,I10,8('' ('',2I2.2,'')'',I6),T127,I6)'/
      DATA hdform/'(04X,''DAY'',03X,07(''  FLOW (REV.)''),''  FLOW'')'/
      DATA vlform/'(04X,''NO.'',03X,07(''  VOL. (TIME)''),''  VOL.'')'/
      DATA dperm/31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31/, 
     &     initfl/1/
      DATA msg/'WRITING CUMULATIVE FLOW-VOLUME FILE'/
      IF (initfl.EQ.1) THEN
        initfl = 2
        nxs = MAXS - Xskt(Nbch) + Nsec(Nbch)
        idtpdy = 1440/Idtm
        lastm = 0
        partdy = .FALSE.
        prtbrn = .FALSE.
        ktline = 66
        fvfact = 0.0001
        fvyear = 0
        fvunit = '  '
        fvname = blk16
        IF (Ipropt.EQ.4) THEN
          dperm(2) = 28 + (4-MOD(Kyr,4))/4
C
C---CHECK STATUS OF FLOW VOLUME FILE ON UNIT 50.
C---  FILE ATTRIBUTES: RECORD LENGTH = (16+MAXDFR*6)*MXFV
C---                   DIRECT ACCESS, UNFORMATTED
          empty = .TRUE.
          READ (Lucvol,REC=367,IOSTAT=ios) fvname, fvyear, fvdata, 
     &          fvunit, lsta
C
C Add check for end of file of new file, as Lahey sets ios>0 for EOF
C of direct access file and can't use REC= and END= in read of DA file
C 18446=Lahey iostat for "data transfer beyond end of file"
C 18525=Lahey 90 iostat for "data transfer beyond end of file"
C 168=Silicon Graphics Fortran for "data transfer beyond end of file"
C
          IF (ios.GE.0 .AND. ios.NE.18446 .AND. ios.NE.168 .AND.
     &        ios.NE.18525) empty = .FALSE.
          IF (.NOT.empty) THEN
C
C---IF UNIT IS NOT EMPTY MAKE SURE IT IS COMPATIBLE WITH NETWORK
C---AND OUTPUT OPTIONS FOR THIS EXECUTION OF BRANCH.
            IF ((fvname.EQ.Netnam) .AND. (fvunit.EQ.Ounit)) THEN
              DO 15 i = 1, MXFV
                IF (lsta(i).NE.Istapr(i)) GOTO 260
   15         CONTINUE
              IF ((fvyear.EQ.Kyr) .OR. 
     &            (fvyear.EQ.Kyr+1 .AND. Kmo.EQ.12 .AND. Kda.EQ.31))
     &            GOTO 30
            ENDIF
            GOTO 260
          ELSE
C
C---WRITE IDENTITY RECORD TO EMPTY FILE.
            fvname = Netnam
            fvunit = Ounit
            fvyear = Kyr
            IF (Kmo.EQ.12 .AND. Kda.EQ.31) fvyear = fvyear + 1
            DO 10 mo = 1, 12
              fvdata(mo) = 0
   10       CONTINUE
C
C---INITIALIZE NEW DIRECT-ACCESS CUMULATIVE FLOW-VOLUME FILE
            WRITE (Lucvol,REC=367,IOSTAT=ios) fvname, fvyear, fvdata, 
     &             fvunit, Istapr
            DO 20 jdayn = 1, 366
              WRITE (Lucvol,REC=jdayn) (blk16,(i4zero,i4zero,k=1,MAXDFR)
     &                                 ,l=1,MXFV)
   20       CONTINUE
            IF (ios.GT.0) CALL ERRSTP(msg)
          ENDIF
   30     DO 50 l = 1, MXFV
            Ijvkt(l) = 1
            DO 40 k = 1, MAXDFR
              Itvol(k,1,l) = 0
              Ifvol(k,1,l) = 0
   40       CONTINUE
   50     CONTINUE
        ENDIF
C
C---INPUT-OUTPUT UNIT CONVERSION FACTORS
        IF (Ounit.EQ.Me) fvfact = 0.1
        DO 60 k = 1, Nbch
          IF (Gprbch.NE.1 .AND. (Gprbch.EQ.2.OR.Prtsum(k).EQ.0))
     &        prtbrn = .TRUE.
   60   CONTINUE
        GOTO 250
      ENDIF
C
      IF (prtbrn) THEN
        IF (ktline+nxs.GT.65) THEN
          WRITE (Printr,9030) Netnam
          WRITE (Printr,9035)
          WRITE (Printr,9040) Unit, Unit, Unit, Unit, Unit, Unit, Unit, 
     &                        Unit, Unit
          WRITE (Printr,9035)
          ktline = 9
        ENDIF
        IF (.NOT.Oplots) THEN
          WRITE (*,9045)
          WRITE (*,9050) Unit, Unit, Unit, Unit, Unit, Unit, Unit
          WRITE (*,9045)
        ENDIF
      ENDIF
C
      ilast = M.EQ.Nsteps
      ipart = Iblk
      kt = M - lastm
      prtday = .TRUE.
      IF (kt.NE.idtpdy) THEN
        ipart = astk
        partdy = .TRUE.
      ENDIF
C
      DO 80 i = 1, Nbch
        IF (Gprbch.NE.1 .AND. (Gprbch.EQ.2.OR.Prtsum(i).EQ.0)) THEN
          ij = MAXS - Xskt(i)
          ns = Nsec(i)
          DO 70 j = 1, ns
            ij = ij + 1
            IF (Iunit.NE.Ounit) THEN
C
C---CONVERT FROM METRIC TO ENGLISH OR FROM ENGLISH TO METRIC
              Zqmin(ij) = Zqmin(ij)*Zconvt
              Zqmax(ij) = Zqmax(ij)*Zconvt
              Qmin(ij) = Qmin(ij)*Qconvt
              Qsum(ij) = Qsum(ij)*Qconvt
              Qmax(ij) = Qmax(ij)*Qconvt
              Aqmin(ij) = Aqmin(ij)*Aconvt
              Aqmax(ij) = Aqmax(ij)*Aconvt
            ENDIF
C
            qbarij = Qsum(ij)/kt
            minhr = Itqmin(ij)/100
            minmn = Itqmin(ij) - minhr*100
            maxhr = Itqmax(ij)/100
            maxmn = Itqmax(ij) - maxhr*100
            IF (.NOT.prtday) THEN
              WRITE (Printr,9060) minhr, minmn, Zqmin(ij), Qmin(ij)
     &                            /Aqmin(ij), Qmin(ij), Aqmin(ij), i, j, 
     &                            qbarij, maxhr, maxmn, Zqmax(ij), 
     &                            Qmax(ij)/Aqmax(ij), Qmax(ij), 
     &                            Aqmax(ij)
            ELSE
              WRITE (Printr,9055) ipart, Kyr, Kmo, Kda, minhr, minmn, 
     &                            Zqmin(ij), Qmin(ij)/Aqmin(ij), 
     &                            Qmin(ij), Aqmin(ij), i, j, qbarij, 
     &                            maxhr, maxmn, Zqmax(ij), Qmax(ij)
     &                            /Aqmax(ij), Qmax(ij), Aqmax(ij)
              prtday = .FALSE.
            ENDIF
            IF (.NOT.Oplots) WRITE (*,9065) minhr, minmn, Zqmin(ij), 
     &         Qmin(ij)/Aqmin(ij), Qmin(ij), i, j, qbarij, maxhr, maxmn, 
     &         Zqmax(ij), Qmax(ij)/Aqmax(ij), Qmax(ij)
            ktline = ktline + 1
            Qmin(ij) = BIGPOS
            Qmax(ij) = BIGNEG
            Qsum(ij) = 0.0
   70     CONTINUE
        ENDIF
   80 CONTINUE
      lastm = M
      IF (Ipropt.EQ.4) THEN
        IF ((kt.EQ.idtpdy) .AND. 
     &      (fvyear.NE.Kyr+1 .OR. Kmo.NE.12 .OR. Kda.NE.31)) THEN
          IF (fvyear.NE.Kyr) GOTO 260
          jdayn = Kda
          DO 90 k = 1, Kmo-1
            jdayn = jdayn + dperm(k)
   90     CONTINUE
          DO 110 l = 1, Nfvxs
            nd = Ijvkt(l)
            DO 100 k = 1, nd
              dmy = Ifvol(k,1,l)
              Ifvol(k,1,l) = INT(dmy*fvfact*Qconvt+SIGN(0.5,dmy))
  100       CONTINUE
  110     CONTINUE
C
C---DIR ACC WRITE #2
          WRITE (Lucvol,REC=jdayn,IOSTAT=ios)
     &             (Istatn(l),(Itvol(k,1,l),Ifvol(k,1,l),k=1,MAXDFR),
     &             l=1,MXFV)
          IF (ios.GT.0) CALL ERRSTP(msg)
          fvdata(Kmo) = 1
C
C---WRITE IDENTITY RECORD TO DIRECT-ACCESS FLOW VOLUME FILE
C
C---DIR ACC WRITE #3
          WRITE (Lucvol,REC=367,IOSTAT=ios) fvname, fvyear, fvdata, 
     &                                      fvunit, Istapr
          IF (ios.GT.0) CALL ERRSTP(msg)
        ENDIF
C
        DO 130 l = 1, MXFV
          nr = Ijvkt(l)
          Ijvkt(l) = 1
          DO 120 k = 1, nr
            Itvol(k,1,l) = 0
            Ifvol(k,1,l) = 0
  120     CONTINUE
  130   CONTINUE
      ENDIF
      IF (prtbrn .AND. .NOT.Oplots) THEN
        WRITE (*,9045)
        WRITE (*,*)
      ENDIF
      IF (.NOT.ilast .AND. (ktline+nxs.LT.66)) GOTO 250
      IF (prtbrn) WRITE (Printr,9035)
      IF (partdy) THEN
        WRITE (Printr,9070)
        partdy = .FALSE.
      ENDIF
      IF (.NOT.ilast .OR. Ipropt.NE.4) GOTO 250
C
C---PRINT MONTHLY SUMMARIES OF FLOW VOLUMES
      DO 240 mo = 1, 12
        IF (fvdata(mo).EQ.0) GOTO 240
        nd = dperm(mo)
        jdaynb = 1
        DO 140 k = 1, mo-1
          jdaynb = jdaynb + dperm(k)
  140   CONTINUE
        jdayne = jdaynb + dperm(mo) - 1
        k = 1
C
C---READ FLOW VOLUMES FROM DIRECT-ACCESS FILE
        DO 150 jdayn = jdaynb, jdayne
          READ (Lucvol,REC=jdayn) (fvstat(k,l),(Itvol(j,k,l),
     &                            Ifvol(j,k,l),j=1,MAXDFR),l=1,MXFV)
          k = k + 1
  150   CONTINUE
C
C---LOCATE NEXT FLOW VOLUME DATA STATION TO BE PRINTED
C---Determine the number of the station within the FV file
        ista = 0
        DO 230 l = 1, Nfvxs
          DO 160 j = 1, MXFV
            IF (fvstat(1,j).EQ.Istapr(l)) THEN
              ista = j
              GOTO 170
            ENDIF
  160     CONTINUE
          ista = ista + 1
C
C---Determine maximum number of flow reversals for the month
  170     mxfrmo = 0
          jj = 1
          DO 190 kk = 1, nd
            IF (fvstat(kk,ista).NE.blk16) THEN
              DO 180 j = jj, MAXDFR
                IF (Itvol(j,kk,ista).NE.0) THEN
                  jj = j
                  mxfrmo = j
                ENDIF
  180         CONTINUE
            ENDIF
  190     CONTINUE
C
C---PRINT MONTHLY FLOW VOLUME SUMMARY FOR STATION ISTPRO
          IF (Ounit.NE.En) THEN
            WRITE (Printr,9015) months(mo), Kyr, Istapr(ista)
          ELSE
            WRITE (Printr,9010) months(mo), Kyr, Istapr(ista)
          ENDIF
          IF (mxfrmo.EQ.0) THEN
            WRITE (Printr,9020)
          ELSE
            hdform(17:17) = repeat(mxfrmo)
            vlform(17:17) = repeat(mxfrmo)
            WRITE (Printr,hdform)
            WRITE (Printr,vlform)
            WRITE (Printr,9025)
          ENDIF
C
          DO 220 kk = 1, nd
            IF (fvstat(kk,ista).NE.blk16) THEN
              ifvsum = Ifvol(1,kk,ista)
              IF (mxfrmo.EQ.0) THEN
                WRITE (Printr,9025) kk, Ifvol(1,kk,ista)
              ELSE
                jj = mxfrmo
                DO 200 j = 1, mxfrmo
                  itime = Itvol(j,kk,ista)
                  IF (itime.EQ.0) GOTO 210
                  idthr(j) = itime/100
                  idtmn(j) = itime - idthr(j)*100
                  ifvsum = ifvsum + Ifvol(j+1,kk,ista)
                  jj = j
  200           CONTINUE
  210           prform(9:9) = repeat(jj)
                WRITE (Printr,prform) kk, Ifvol(1,kk,ista), 
     &                    (idthr(j),idtmn(j),Ifvol(j+1,kk,ista),j=1,
     &                    jj), ifvsum
              ENDIF
            ENDIF
  220     CONTINUE
  230   CONTINUE
  240 CONTINUE
  250 RETURN
  260 WRITE (Printr,9005) fvyear, fvunit, fvname, Kyr, Ounit, Netnam,
     &                    Istapr
      IF (.NOT.Oplots) WRITE (*,9005) fvyear, fvunit, fvname, Kyr,
     &                                Ounit, Netnam, Istapr
      STOP
C
C---OUTPUT FORMAT STATEMENTS
 9005 FORMAT (/
     &' EXECUTION TERMINATED DUE TO INCORRECT ATTEMPT TO UPDATE CUMULATI
     &VE FLOW-VOLUME FILE',/,' FILE IS',I3,1X,A2,' DATA FOR NETWORK: ',
     &A80,/,'  RUN IS',I3,A3,' DATA FOR NETWORK: ',A80,/,' STATIONS: ',
     &10A20)
 9010 FORMAT ('1',A10,'19',I2.2,
     &        ' FLOW IN MILLIONS OF CUBIC FEET AT STATION ',A16/)
 9015 FORMAT ('1',A10,'19',I2.2,
     &        ' FLOW IN THOUSANDS OF CUBIC METERS AT STATION ',A16/)
 9020 FORMAT (4X,'DAY     FLOW',/,4X,'NO.     VOL.'/)
 9025 FORMAT (I6,I10)
 9030 FORMAT ('1',T34,'FLOW RESULTS FOR ',A80/)
 9035 FORMAT ('  ---',3('-------+'),'--------+--',2('-------+'),
     &        '--------------+--',3('-------+'),'--------+--',
     &        2('-------+'))
 9040 FORMAT (12X,'|',26X,'MINIMUM',9X,'|',18X,'MEAN',2X,'|',26X,
     &        'MAXIMUM',9X,'|',/,5X,
     &'DATE   |  TIME   STAGE  VELOCITY DISCHARGE   AREA |BRANCH SECTION
     & DISCHARGE|  TIME   STAGE  VELOCITY DISCHARGE   AREA |'/
     &'  (YR/MO/DY)|(HR:MN)   (',A2,')   (',A2,'/S)  (',A2,'**3/S) (',
     &A2,'**2)|',15X,'(',A2,'**3/S)|(HR:MN)   (',A2,')   (',A2,'/S)  (',
     &A2,'**3/S) (',A2,'**2)|')
 9045 FORMAT (' -----+',2('------+'),'---',2('-------+'),'---------+',
     &        '-----+',2('------+'),'----------')
 9050 FORMAT (2X,
     &'TIME  STAGE   VEL   MINIMUM Q|BRN SEC   MEAN Q | TIME  STAGE   VE
     &L   MAXIMUM Q',/,' HR:MN   (',A2,') (',A2,'/S)  (',A2,'**3/S)|',
     &8X,'(',A2,'**3/S)|HR:MN   (',A2,') (',A2,'/S)  (',A2,'**3/S)')
 9055 FORMAT (1X,A2,2(I2.2,'/'),I2.2,' |',I3.2,':',I2.2,2F8.2,F11.1,F9.1
     &        ,'|',I4,I8,F11.1,' |',I3.2,':',I2.2,2F8.2,F11.1,2F9.1,'|')
 9060 FORMAT (12X,'|',I3.2,':',I2.2,F8.2,F8.2,F11.1,F9.1,'|',I4,I8,
     &        F11.1,' |',I3.2,':',I2.2,2X,F6.2,F8.2,F11.1,F9.1,'|')
 9065 FORMAT (I3.2,':',I2.2,2F7.2,F11.1,'|',I3,I4,F10.1,'|',I2.2,':',
     &        I2.2,2F7.2,F11.1)
 9070 FORMAT ('  * IDENTIFIES A PARTIAL DAY OF RECORD')
      END
C
C
C
      SUBROUTINE DTMAP
C
C  THIS SUBROUTINE OUTPUTS FLOW COMPUTATION RESULTS AS SNAP SHOT
C  IN TIME TO OUTPUT FILE IN TABULAR FORM
C
      REAL zij, qij, aij, bij, bsij
      INTEGER i, ns, ij, j
      INCLUDE 'dimens.cmn'
      INCLUDE 'dtcomp.cmn'
      INCLUDE 'datime.cmn'
      INCLUDE 'branch.cmn'
      INCLUDE 'comcon.cmn'
      INCLUDE 'untmes.cmn'
      INCLUDE 'convt.cmn'
      INCLUDE 'lunums.cmn'
C
C---OUTPUT FLOW RESULTS AT EACH TIME STEP
      WRITE (Lumap,9005) Kyr, Kmo, Kda, Khr, Kmn
C
      DO 20 i = 1, Nbch
        ns = Nsec(i)
        ij = MAXS - Xskt(i)
        DO 10 j = 1, ns
          ij = ij + 1
C
          zij = Z(ij) + Zdatum
          qij = Q(ij)
          aij = A(ij)
          bij = B(ij)
          bsij = Bt(ij) - B(ij)
          IF (Iunit.NE.Ounit) THEN
C
C---CONVERT FROM ENGLISH TO METRIC OR FROM METRIC TO ENGLISH
            zij = zij*Zconvt
            qij = qij*Qconvt
            aij = aij*Aconvt
            bij = bij*Zconvt
            bsij = bsij*Zconvt
          ENDIF
          WRITE (Lumap,9010) i, j, zij, qij, aij, bij, bsij
   10   CONTINUE
   20 CONTINUE
      RETURN
C
C---OUTPUT FORMAT STATEMENTS
 9005 FORMAT (I3.2,'/',I2.2,'/',I2.2,I3.2,':',I2.2)
 9010 FORMAT (I7,I4,5F10.2)
      END
C
C
C
      SUBROUTINE PINCO
C
C     SUBROUTINE TO PUNCH INITIAL CONDITIONS AT END OF RUN
C
      INCLUDE 'dimens.cmn'
      INCLUDE 'xsinit.cmn'
      INCLUDE 'lunums.cmn'
      INCLUDE 'branch.cmn'
      INCLUDE 'branam.cmn'
      INCLUDE 'dtcomp.cmn'
      INCLUDE 'comcon.cmn'
      INCLUDE 'logics.cmn'
      INTEGER i, ij, ns, j
      DO 20 i = 1, Nbch
        WRITE (Punch,9015) Ijf(i), Ijt(i), Nsec(i), Brname(i), Ijfen(i), 
     &                     Ijten(i), Prtbch(i), Prtsum(i), Ppltbh(i), 
     &                     Pltbch(i), Prtxsg(i)
        ij = MAXS - Xskt(i)
        ns = Nsec(i)
        DO 10 j = 1, ns
          ij = ij + 1
          IF (j.NE.ns) THEN
            WRITE (Punch,9005) Z(ij) + Zdatum, Q(ij), Rho(ij), Dx(ij), 
     &                         T(ij), Rn(1,ij), Rn(2,ij), Rn(3,ij)
          ELSE
            WRITE (Punch,9005) Z(ij) + Zdatum, Q(ij), Rho(ij)
          ENDIF
          WRITE (Punch,9010) Orient(ij), Betvel(ij), Qlat(ij), Ulat(ij)
          IF (Imodfw.NE.0) WRITE (Punch,9020) Istrm(1,ij), Istrm(2,ij), 
     &                        Istrm(3,ij), Clk(ij), Zbot(ij)
   10   CONTINUE
   20 CONTINUE
      RETURN
C
C---OUTPUT FORMAT STATEMENTS
 9005 FORMAT (F10.3,F10.2,F10.4,2F10.2,3E10.4)
 9010 FORMAT (2F10.3,2F10.4)
 9015 FORMAT (3I2,A40,27X,7I1)
 9020 FORMAT (3I5,2F10.4)
      END
C
C
C
      SUBROUTINE PRTPLT
C
C  THIS SUBROUTINE PRODUCES A LINE-PRINTER PLOT OF STAGE OR
C  DISCHARGE DATA COMPUTED BY THE BRANCH FLOW MODEL. THE MAXIMUM
C  NUMBER OF POINTS PLOTTED PER PAGE OF OUTPUT IS SPECIFIABLE.
C  LINE-PRINTER PLOTS OF COMPUTED-VERSUS-MEASURED DATA CAN ALSO BE
C  PRODUCED BY THIS SUBROUTINE. ONLY ONE SET OF MEASURED DATA CAN
C  BE INPUT PER BRANCH OF THE NETWORK. ALL SETS OF MEASURED DATA
C  MUST BEGIN AND END AT A COMMON DATE AND TIME WITHIN THE TIME
C  SPAN OF THE SIMULATION AS SPECIFIED ON THE FIRST MEASURED DATA-
C  DEFINITION RECORD INPUT TO BRANCH. THE BEGIN TIME OF MEASURED
C  DATA MUST BE AN INTEGRAL MULTIPLE OF THE COMPUTATION TIME-STEP
C  FREQUENCY OF THE MODEL. IN ADDITION, ALL SETS OF MEASURED DATA
C  MUST HAVE A COMMON FREQUENCY; AGAIN AS SPECIFIED ON THE INITIAL
C  DATA-DEFINITION INPUT RECORD. MEASURED DATA CAN, HOWEVER, BE
C  INPUT AT A TIME-STEP FREQUENCY OTHER THAN THE COMPUTATION TIME-
C  STEP FREQUENCY.
C
C  VERSION UPDATED 9JUN88 - RWS
C  VERSION UPDATED 26SEP88 - RSR TIMING BUG FOR MEASURED DATA OF
C                            GREATER FREQUENCY THAN TIME STEP
C  VERSION UPDATED 01JAN89 - INCREASE SYMBOL ARRAY TO ALLOW FOR 12
C                            CROSS SECTIONS PER BRANCH
C  VERSION UPDATED 01JUN89 - 16-DIGIT STATION NUMBERS
C
C  THIS SUBROUTINE VERSION ACCOUNTS FOR A MAXIMUM OF 6 SUCCESSIVE
C  ALTERNATING-DIRECTION FLOWS, DEFINED BY 5 FLOW REVERSALS, FOR
C  CALCULATING VOLUME TOTALS AND ERROR STATISTICS FOR COMPARISON
C  OF COMPUTED VERSUS MEASURED VOLUME FLUXES AND DISCHARGES.
C
      INTEGER n, kk, locb, loca, nminit, nhour, kbeg, ipage, nwrt, 
     &        ktdev, npage
      INCLUDE 'dimens.cmn'
      INCLUDE 'datime.cmn'
      INCLUDE 'boundy.cmn'
      INCLUDE 'bouchr.cmn'
      INCLUDE 'logics.cmn'
      INCLUDE 'units.cmn'
      INCLUDE 'lunums.cmn'
      INCLUDE 'bctime.cmn'
      INCLUDE 'netwrk.cmn'
      INCLUDE 'comcon.cmn'
      INCLUDE 'untmes.cmn'
      INCLUDE 'mdatas.cmn'
      INCLUDE 'zq.cmn'
      INCLUDE 'branch.cmn'
      INCLUDE 'branam.cmn'
      INTEGER ctvol(MXFRPT), mtvol(MXFRPT), nhrrev(MXFRPT), mbeg, jend, 
     &        nmnrev(MXFRPT), yr, mo, da, hr, mn, pagesz, mid, jbeg
      INTEGER id, md, lastm, initfl, i, kt, midm1, idm, mnd, k, mm, 
     &        mend, ns, ij, nplots, iplot, ijp1, isec, ijk, ipower, 
     &        kend, ktcvol, ktmvol, mdfirst
      CHARACTER*2 header(9), vbar, astk, oh, symbol(12), symbeg, symend, 
     &            chara, charb, b(101), d(101), zunit(5), qunit(5)
      CHARACTER*12 ztitle, qtitle
      CHARACTER cstano*16, msg*55
      LOGICAL meplot, lrevrs
      REAL sreal(11), zqmin, zqmax, zqijk, ystep, zqrem, yorgin, yupper, 
     &     fac, hstep, ystepi, cqlast, zqlast, devtot, devsum, devsqe, 
     &     cfvsum, devsqt, zqmp, th, cqsign, dtzero, dev, zqsign, 
     &     devbar(MXFRPT), devmse(MXFRPT), devrms(MXFRPT), ddt, zqm, 
     &     zqstep, devabs, devabe(MXFRPT), devabt
      REAL cfvol(MXFRPT), mfvol(MXFRPT), fvdiff(MXFRPT), mfvsum, dtm
      INTEGER MOD, IFIX
      REAL ABS, ALOG10, AMOD, SIGN, SQRT
      INTRINSIC MOD, ABS, IFIX, ALOG10, AMOD, SIGN, SQRT
      EXTERNAL ERRPRT
      SAVE yr, mo, da, hr, mn, meplot, dtm, id, mid, lastm, md, zqm, 
     &     ijp1
      DATA lrevrs/.FALSE./, ijp1/2/
C     INITIALIZE PAGE SIZE FOR THE NUMBER OF DATA PLOTTED PER PAGE
      DATA pagesz/48/, astk/'* '/, vbar/'| '/, oh/'O '/
      DATA ztitle/'    STAGE   '/, qtitle/'  DISCHARGE '/
      DATA b/'| ', 9*'  ', '| ', 9*'  ', '| ', 9*'  ', '| ', 9*'  ', 
     &     '| ', 9*'  ', '| ', 9*'  ', '| ', 9*'  ', '| ', 9*'  ', '| ', 
     &     9*'  ', '| ', 9*'  ', '| '/
      DATA d/'+ ', 9*'- ', '+ ', 9*'- ', '+ ', 9*'- ', '+ ', 9*'- ', 
     &     '+ ', 9*'- ', '+ ', 9*'- ', '+ ', 9*'- ', '+ ', 9*'- ', '+ ', 
     &     9*'- ', '+ ', 9*'- ', '+ '/
      DATA zunit/'  ', ' (', 'FT', ') ', '  '/
      DATA qunit/' (', 'FT', '**', '3/', 'S)'/
      DATA header/'  ', ' V', 'OL', 'UM', 'E ', '  ', '(T', 'IM', 'E)'/
      DATA symbol/'A ', 'B ', 'C ', 'D ', 'E ', 'F ', 'G ', 'H ', 'I ', 
     &     'J ', 'K ', 'L '/, initfl/1/
      DATA msg/'STEP SIZE IN PLOT SCALE ALGORITHM EXCEEDS MAXIMUM LIMIT'
     &     /
C
C---INITIALIZE PLOT CONTROL PARAMETERS
      IF (initfl.EQ.1) THEN
        initfl = 2
        IF (Stages) THEN
          IF (Ounit.EQ.Me) zunit(3) = Mt
        ELSE
          ztitle = qtitle
          DO 10 i = 1, 5
            zunit(i) = qunit(i)
   10     CONTINUE
          IF (Ounit.EQ.Me) zunit(2) = Mt
        ENDIF
        yr = Iyr
        mo = Imo
        da = Ida
        hr = Ihr
        mn = Imn
        Dypmo(2) = 28 + (4-MOD(yr,4))/4
        meplot = .FALSE.
        mid = 0
        id = 0
        dtm = 0.0
        zqm = 0.0
        lastm = 0
        md = 0
        IF (Iplopt.GT.2) THEN
          meplot = .TRUE.
          dtm = Mdt*60
          mid = 1
          id = (Inhr*60+Inmn)/Idtm
        ENDIF
      ENDIF
      mdfirst = md
C
C---PLOT FLOW RESULTS
      kt = M - lastm
      IF (meplot) THEN
        IF (Ketime.LT.Meitim .OR. Letime.GT.Mektim) GOTO 220
        midm1 = mid - 1
        idm = (Mihr*60+Mimn)/Idtm
        mbeg = idm - id + 1
        mend = (Khr*60+Kmn)/Idtm - id + 1
        ddt = Dt/dtm
      ENDIF
C
C---BEGIN BRANCH LOOP
      DO 210 i = 1, Nbch
        IF (meplot) THEN
          DO 20 k = 1, Ktmeas
            IF (Mbch(k).EQ.i) THEN
              IF (Mdata(k).EQ.0) GOTO 210
              mm = k
              md = mdfirst
              kk = IFIX(md*ddt+0.000001) + 1
              th = (md*Dt-(kk-1)*dtm)/dtm
              IF (kk.EQ.1) THEN
                zqm = Zqmeas(mid,mm)
              ELSE
                zqm = 0.5*th*(Zqmeas(kk+1,mm)-Zqmeas(kk-1,mm)
     &                +th*(Zqmeas(kk+1,mm)+Zqmeas(kk-1,mm)
     &                -2.0*Zqmeas(kk,mm))) + Zqmeas(kk,mm)
              ENDIF
              md = md + 1
              mnd = (Khr*60+Kmn)/Mdt - (idm-1)*Idtm/Mdt
              IF (mnd.GT.Mdata(mm)) THEN
                mnd = Mdata(mm)
                mend = mbeg + mnd*Mdt/Idtm - 1
              ENDIF
              Mdata(mm) = Mdata(mm) - mnd
              GOTO 30
            ENDIF
   20     CONTINUE
          GOTO 210
        ENDIF
        IF (Gplbch.EQ.1 .OR. (Gplbch.NE.2.AND.Ppltbh(i).NE.0)) GOTO 210
   30   ns = Nsec(i)
        ij = MAXS - Xskt(i)
C
C---BEGIN CROSS-SECTION LOOP
        jbeg = 1
        jend = 2
        nplots = (ns+1)/2
        IF (meplot) nplots = 1
        DO 200 iplot = 1, nplots
          IF (iplot.NE.1) THEN
            IF (jend.GT.ns) THEN
              jbeg = jend
              jend = jend + 1
            ELSE
              jbeg = jend + 1
              jend = jend + 2
              ij = ijp1
            ENDIF
          ENDIF
          ij = ij + 1
          ijp1 = ij + 1
          symbeg = symbol(jbeg)
          symend = symbol(jend)
C
C---DETERMINE FIELD-STATION NUMBER AT CROSS-SECTION LOCATION
          IF (meplot) THEN
C
C---DETERMINE DATA RANGE FOR COMPUTED VRS. MEASURED DATA PLOT
            ij = ij + Msec(mm) - 1
            zqmin = BIGPOS
            zqmax = BIGNEG
            DO 40 k = 1, kt
              zqijk = Zqcomp(k,ij)
              IF (zqijk.LT.zqmin) zqmin = zqijk
              IF (zqijk.GT.zqmax) zqmax = zqijk
   40       CONTINUE
            DO 50 k = mid, midm1 + mnd
              zqijk = Zqmeas(k,mm)
              IF (zqijk.LT.zqmin) zqmin = zqijk
              IF (zqijk.GT.zqmax) zqmax = zqijk
   50       CONTINUE
          ELSE
            IF (jbeg.EQ.1 .OR. jend.EQ.ns) THEN
              isec = 0
              DO 60 k = 1, Nbnd
                IF (Istatn(k)(15:16).NE.Iblk) THEN
                  IF (Ibjnc(k).EQ.Ijf(i)) THEN
                    isec = 1
                  ELSE
                    IF (Ibjnc(k).NE.Ijt(i)) GOTO 60
                    isec = ns
                  ENDIF
                  cstano = Istatn(k)
                  GOTO 70
                ENDIF
   60         CONTINUE
            ENDIF
C
C---DETERMINE DATA RANGE FOR PLOTTING COMPUTED RESULTS
   70       zqmin = Zqcomp(1,ij)
            zqmax = zqmin
            zqijk = Zqcomp(1,ijp1)
            IF (zqijk.LT.zqmin) zqmin = zqijk
            IF (zqijk.GT.zqmax) zqmax = zqijk
            IF (kt.EQ.1) THEN
              IF (ABS(zqmax-zqmin).LT.SMLVL) zqmax = zqmin + 
     &            ABS(zqmin*0.1)
            ELSE
              DO 90 ijk = ij, ijp1
                DO 80 k = 2, kt
                  zqijk = Zqcomp(k,ijk)
                  IF (zqijk.LT.zqmin) zqmin = zqijk
                  IF (zqijk.GT.zqmax) zqmax = zqijk
   80           CONTINUE
   90         CONTINUE
            ENDIF
          ENDIF
C
C---DETERMINE PLOT SCALE
C
          ipower = IFIX(ALOG10(ABS(zqmax-zqmin))) - 1
          IF (Stages) ipower = ipower - 1
  100     ystep = 10.0**ipower
          zqrem = AMOD(zqmin,ystep)
          yorgin = zqmin - zqrem
          IF (zqmin.LT.0.0 .AND. ABS(zqrem).GT.SMLVL) yorgin = yorgin - 
     &        ystep
          zqrem = AMOD(zqmax,ystep)
          yupper = zqmax - zqrem
          IF (ABS(zqrem).GT.SMLVL) yupper = yupper + ystep
          zqstep = (yupper-yorgin)*0.1
          fac = 1.0
          IF (zqstep.GT.ystep) fac = 2.0
          IF (zqstep.GT.ystep*fac) fac = 5.0
          ystep = ystep*fac
          IF (zqstep.GT.ystep) THEN
            ipower = ipower + 1
            IF (ipower.LT.6) GOTO 100
            CALL ERRPRT(msg)
            RETURN
          ENDIF
  110     zqrem = AMOD(zqmin,ystep)
          yorgin = zqmin - zqrem
          IF (zqmin.LT.0.0 .AND. ABS(zqrem).GT.SMLVL) yorgin = yorgin - 
     &        ystep
          yupper = 10.0*ystep + yorgin
          IF (zqmax.GT.yupper) THEN
            IF (fac.EQ.5.0) THEN
              ipower = ipower + 1
              IF (ipower.LT.6) GOTO 100
              CALL ERRPRT(msg)
              RETURN
            ELSEIF (fac.EQ.2.0) THEN
              fac = 5.0
              ystep = ystep*2.5
            ELSE
              fac = 2.0
              ystep = ystep*2.0
            ENDIF
            GOTO 110
          ENDIF
          DO 120 k = 1, 11
            sreal(k) = yorgin + (k-1)*ystep
  120     CONTINUE
          ystep = ystep*10.0
          hstep = 0.5*ystep
          ystepi = 1.0/ystep
          yorgin = yorgin*100.0
          npage = kt/pagesz + 1
          IF (MOD(kt,pagesz).EQ.0) npage = npage - 1
          kend = 0
C
C---BEGIN PAGE LOOP
          cfvol(1) = Zqcomp(1,ij)*Dt
          IF (idm.EQ.1) THEN
            mfvol(1) = zqm*Dt
          ELSE
            mfvol(1) = 0.0
          ENDIF
          ktcvol = 1
          ktmvol = 1
          cqlast = SIGN(1.0,Zqcomp(1,ij))
          zqlast = SIGN(1.0,zqm)
          devtot = 0.0
          devabt = 0.0
          devsum = 0.0
          devabs = 0.0
          ktdev = 0
          devsqe = 0.0
          devsqt = 0.0
          nwrt = 1
          DO 160 ipage = 1, npage
            kbeg = kend + 1
            kend = ipage*pagesz
            IF (ipage.EQ.npage) kend = kt
            WRITE (Printr,9005) Netnam
            IF (meplot) THEN
              WRITE (Printr,9045) ztitle, Brname(i), oh, astk, Mbch(mm), 
     &                            Msec(mm)
              WRITE (Printr,9030) zunit, zunit, yr, mo, da, hr, mn, Kyr, 
     &                            Kmo, Kda, Khr, Kmn
              WRITE (Printr,9025) sreal, astk, oh, (vbar,k=1,11)
            ELSE
              WRITE (Printr,9010) ztitle, Brname(i), i, symbeg, symend, 
     &                            jbeg, jend
              IF (isec.NE.jbeg .AND. isec.NE.jend) THEN
                WRITE (Printr,9030) zunit, zunit, yr, mo, da, hr, mn, 
     &                              Kyr, Kmo, Kda, Khr, Kmn
              ELSEIF (cstano(7:8).EQ.Iblk) THEN
                WRITE (Printr,9015) zunit, zunit, yr, mo, da, hr, mn, 
     &                              cstano(9:10), cstano(11:14), 
     &                              cstano(15:16), symbol(isec), Kyr, 
     &                              Kmo, Kda, Khr, Kmn
              ELSE
                WRITE (Printr,9020) zunit, zunit, yr, mo, da, hr, mn, 
     &                              cstano, symbol(isec), Kyr, Kmo, Kda, 
     &                              Khr, Kmn
              ENDIF
              WRITE (Printr,9025) sreal, symbeg, symend, (vbar,k=1,11)
            ENDIF
            IF (ipage.EQ.1) THEN
              nhour = hr
              nminit = mn
            ENDIF
            IF (.NOT.meplot) THEN
C
C---BEGIN LOOP FOR PLOTTING COMPUTED RESULTS
              DO 130 k = kbeg, kend
                loca = 1 + IFIX(((Zqcomp(k,ij)*100.0+hstep)-yorgin)
     &                 *ystepi)
                locb = 1 + IFIX(((Zqcomp(k,ijp1)*100.0+hstep)-yorgin)
     &                 *ystepi)
                IF (nminit.EQ.0 .OR. k.EQ.kbeg .OR. k.EQ.kend) THEN
                  chara = d(loca)
                  charb = d(locb)
                  d(loca) = symbeg
                  d(locb) = symend
                  WRITE (Printr,9035) nhour, nminit, Zqcomp(k,ij), 
     &                                Zqcomp(k,ijp1), d
                  d(loca) = chara
                  d(locb) = charb
                ELSE
                  chara = b(loca)
                  charb = b(locb)
                  b(loca) = symbeg
                  b(locb) = symend
                  WRITE (Printr,9035) nhour, nminit, Zqcomp(k,ij), 
     &                                Zqcomp(k,ijp1), b
                  b(loca) = chara
                  b(locb) = charb
                ENDIF
                nminit = nminit + Idtm
                IF (nminit.GE.60) THEN
                  nhour = nhour + nminit/60
                  nminit = MOD(nminit,60)
                  IF (nhour.GT.24 .OR. (nhour.EQ.24 .AND. nminit.NE.0))
     &                nhour = nhour - 24
                ENDIF
  130         CONTINUE
            ELSE
C
C---BEGIN LOOP FOR PLOTTING COMPUTED VRS. MEASURED DATA
              DO 150 k = kbeg, kend
                loca = 1 + IFIX(((Zqcomp(k,ij)*100.0+hstep)-yorgin)
     &                 *ystepi)
                IF (nminit.EQ.0 .OR. k.EQ.kbeg .OR. k.EQ.kend) THEN
                  chara = d(loca)
                  IF (k.LT.mbeg .OR. k.GT.mend) THEN
                    d(loca) = astk
                    WRITE (Printr,9040) nhour, nminit, Zqcomp(k,ij), d
                    d(loca) = chara
                  ELSE
                    locb = 1 + IFIX(((zqm*100.0+hstep)-yorgin)*ystepi)
                    charb = d(locb)
                    d(loca) = astk
                    d(locb) = oh
                    WRITE (Printr,9035) nhour, nminit, Zqcomp(k,ij), 
     &                                  zqm, d
                    d(loca) = chara
                    d(locb) = charb
                  ENDIF
                ELSE
                  chara = b(loca)
                  IF (k.LT.mbeg .OR. k.GT.mend) THEN
                    b(loca) = astk
                    WRITE (Printr,9040) nhour, nminit, Zqcomp(k,ij), b
                    b(loca) = chara
                  ELSE
                    locb = 1 + IFIX(((zqm*100.0+hstep)-yorgin)*ystepi)
                    charb = b(locb)
                    b(loca) = astk
                    b(locb) = oh
                    WRITE (Printr,9035) nhour, nminit, Zqcomp(k,ij), 
     &                                  zqm, b
                    b(loca) = chara
                    b(locb) = charb
                  ENDIF
                ENDIF
                IF (k.GE.mbeg .AND. k.LE.mend) THEN
                  dev = Zqcomp(k,ij) - zqm
                  devsum = devsum + dev
                  devabs = devabs + ABS(dev)
                  devsqe = devsqe + dev*dev
                  ktdev = ktdev + 1
                  IF (k.EQ.mend) THEN
                    nhrrev(nwrt) = nhour
                    nmnrev(nwrt) = nminit
                    IF (.NOT.(Stages .OR. lrevrs)) mtvol(ktmvol)
     &                  = nhour*100 + nminit
                  ENDIF
                ENDIF
                IF (k.NE.kt) THEN
                  IF (.NOT.(Stages .OR. lrevrs)) THEN
                    cqsign = SIGN(1.0,Zqcomp(k+1,ij))
                    IF (cqsign.NE.cqlast) THEN
                      dtzero = (-Zqcomp(k,ij)*Dt)
     &                         /(Zqcomp(k+1,ij)-Zqcomp(k,ij))
                      cfvol(ktcvol) = cfvol(ktcvol) + Zqcomp(k,ij)
     &                                *dtzero
                      ctvol(ktcvol) = nhour*100 + nminit + 
     &                                IFIX(dtzero/60.0+0.000001)
                      IF (ktcvol.EQ.MXFRPT) THEN
                        lrevrs = .TRUE.
                      ELSE
                        ktcvol = ktcvol + 1
                        cfvol(ktcvol) = Zqcomp(k+1,ij)*(Dt-dtzero)
                        cqlast = cqsign
                      ENDIF
                    ELSE
                      cfvol(ktcvol) = cfvol(ktcvol) + Zqcomp(k+1,ij)*Dt
                    ENDIF
                  ENDIF
                  IF (k.GE.mbeg .AND. k.LT.mend) THEN
                    IF (ktmvol.EQ.1 .AND. ktcvol.NE.1) THEN
                      DO 140 n = 1, ktcvol
                        mtvol(n) = 99999
                        mfvol(n) = 0.0
  140                 CONTINUE
                      ktmvol = ktcvol
                      IF (cqlast.NE.zqlast) ktmvol = ktmvol - 1
                    ENDIF
                    zqmp = zqm
                    kk = IFIX(md*ddt+0.000001) + 1
                    th = (md*Dt-(kk-1)*dtm)/dtm
                    IF (kk.EQ.1) THEN
                      kk = 2
                      th = th - 1.0
                    ENDIF
                    zqm = 0.5*th*(Zqmeas(kk+1,mm)-Zqmeas(kk-1,mm)
     &                    +th*(Zqmeas(kk+1,mm)+Zqmeas(kk-1,mm)
     &                    -2.0*Zqmeas(kk,mm))) + Zqmeas(kk,mm)
                    md = md + 1
                    zqsign = SIGN(1.0,zqm)
                    IF (.NOT.(Stages .OR. lrevrs)) THEN
                      IF (zqsign.NE.zqlast) THEN
                        dtzero = (-zqmp*Dt)/(zqm-zqmp)
                        mfvol(ktmvol) = mfvol(ktmvol) + zqmp*dtzero
                        mtvol(ktmvol) = nhour*100 + nminit + 
     &                                  IFIX(dtzero/60.0+.000001)
                        IF (ktmvol.EQ.MXFRPT) THEN
                          lrevrs = .TRUE.
                        ELSE
                          ktmvol = ktmvol + 1
                          mfvol(ktmvol) = zqm*(Dt-dtzero)
                        ENDIF
                      ELSE
                        mfvol(ktmvol) = mfvol(ktmvol) + zqm*Dt
                      ENDIF
                    ENDIF
                    IF (zqsign.NE.zqlast) THEN
                      IF (ktdev.EQ.0) ktdev = 1
                      devbar(nwrt) = devsum/ktdev
                      devabe(nwrt) = devabs/ktdev
                      devmse(nwrt) = devsqe/ktdev
                      devrms(nwrt) = SQRT(devmse(nwrt))
                      nhrrev(nwrt) = nhour
                      nmnrev(nwrt) = nminit
                      nwrt = nwrt + 1
                      devtot = devtot + devsum
                      devabt = devabt + devabs
                      devsqt = devsqt + devsqe
                      devsum = 0.0
                      devsqe = 0.0
                      devabs = 0.0
                      ktdev = 0
                      zqlast = zqsign
                    ENDIF
                  ENDIF
                  nminit = nminit + Idtm
                  IF (nminit.GE.60) THEN
                    nhour = nhour + nminit/60
                    nminit = MOD(nminit,60)
                    IF (nhour.GT.24 .OR. (nhour.EQ.24 .AND. nminit.NE.0)
     &                  ) nhour = nhour - 24
                  ENDIF
                ENDIF
  150         CONTINUE
            ENDIF
  160     CONTINUE
          IF (meplot) THEN
            WRITE (Printr,9050)
            devtot = devtot + devsum
            devabt = devabt + devabs
            devsqt = devsqt + devsqe
            ktdev = mend - mbeg + 1
            devbar(nwrt) = devtot/ktdev
            devabe(nwrt) = devabt/ktdev
            devmse(nwrt) = devsqt/ktdev
            devrms(nwrt) = SQRT(devmse(nwrt))
            DO 170 n = 1, nwrt
              WRITE (Printr,9055) nhrrev(n), nmnrev(n), devbar(n), 
     &                            devmse(n), devrms(n), devabe(n)
  170       CONTINUE
            IF (.NOT.Stages) THEN
              mfvsum = 0.0
              cfvsum = 0.0
              ctvol(ktcvol) = nhour*100 + nminit
              DO 180 n = 1, ktcvol
                cfvsum = cfvsum + cfvol(n)
  180         CONTINUE
              DO 190 n = 1, ktmvol
                IF (ABS(mfvol(n)).GT.SMLVL) THEN
                  fvdiff(n) = (cfvol(n)-mfvol(n))/mfvol(n)*100.0
                  IF (fvdiff(n).GT.100.0) fvdiff(n) = 999.9
                ELSE
                  fvdiff(n) = 999.9
                ENDIF
                mfvsum = mfvsum + mfvol(n)
  190         CONTINUE
              IF (lrevrs) WRITE (Printr,9060)
              WRITE (Printr,9065) (header,n=1,ktcvol)
              WRITE (Printr,9075) zunit(2), (zunit(2),n=1,ktcvol)
              WRITE (Printr,9070) cfvsum, (cfvol(n),ctvol(n),n=1,ktcvol)
              WRITE (Printr,9085) (fvdiff(n),n=1,ktmvol)
              WRITE (Printr,9080) mfvsum, (mfvol(n),mtvol(n),n=1,ktmvol)
            ENDIF
          ENDIF
  200   CONTINUE
  210 CONTINUE
C
C---SET PARAMETERS FOR NEXT PLOT
  220 id = 1
      yr = Kyr
      mo = Kmo
      da = Kda
      hr = Khr
      mn = Kmn
      mn = mn + Idtm
      IF (mn.GE.60) THEN
        hr = hr + mn/60
        mn = MOD(mn,60)
      ENDIF
      IF (.NOT.(hr.LT.24 .OR. (hr.EQ.24 .AND. mn.EQ.0))) THEN
        hr = hr - 24
        da = da + 1
      ENDIF
      IF (da.GT.Dypmo(mo)) THEN
        da = 1
        mo = mo + 1
      ENDIF
      IF (mo.GT.12) THEN
        mo = 1
        yr = yr + 1
        IF (yr.GT.99) yr = 0
        Dypmo(2) = 28 + (4-MOD(yr,4))/4
      ENDIF
      lastm = M
      IF (meplot) THEN
        Letime = Ketime + Idtm
        IF (Ketime.GE.Meitim) THEN
          Mihr = hr
          Mimn = mn
          mid = mid + mnd
        ENDIF
      ENDIF
      RETURN
C
C---OUTPUT FORMAT STATEMENTS
 9005 FORMAT ('1',A80,09X,'FLOW COMPUTED BY THE BRANCH-NETWORK MODEL'//
     &        ' ',T63,'# # # #'//,1X,6('='),'+',22('='),'+',99('='),'+')
 9010 FORMAT ('  TIME |',4X,A12,6X,'|',T33,A40,T95,'BRANCH',I3,2X,'(',
     &        A1,'-',A1,') CROSS SECTIONS ',I1,'-',I1,T131,'|')
 9015 FORMAT (' HR:MN |',5A2,1X,5A2,1X,'| START= ',I2,2('/',I2),I3,':',
     &        I2,T64,'FIELD-STATION NUMBER ',A2,'-',A4,'.',A2,' (',A1,
     &        ')',T111,'END= ',I2,2('/',I2),I3,':',I2,' |')
 9020 FORMAT (' HR:MN |',5A2,1X,5A2,1X,'| START= ',I2,2('/',I2),I3,':',
     &        I2,T64,'FIELD-STATION NUMBER ',A16,' (',A1,')',T111,
     &        'END= ',I2,2('/',I2),I3,':',I2,' |')
 9025 FORMAT (1X,6('='),'+',22('='),'+',99('='),'+'/' ',T24,11F10.2,/,
     &        T13,'(',A1,')',T24,'(',A1,')',T31,A1,10(9X,A1))
 9030 FORMAT (' HR:MN |',5A2,1X,5A2,1X,'| START= ',I2,2('/',I2),I3,':',
     &        I2,T111,'END= ',I2,2('/',I2),I3,':',I2,' |')
 9035 FORMAT (I3.2,':',I2.2,' |',F10.2,1X,F10.2,1X,101A1)
 9040 FORMAT (I3.2,':',I2.2,' |',F10.2,12X,101A1)
 9045 FORMAT ('  TIME |',4X,A12,6X,'|',T33,A40,T82,'(',A1,
     &        ') MEASURED (',A1,') COMPUTED AT BRANCH:SECTION ',I2,':',
     &        I1,T131,'|')
 9050 FORMAT (/
     &' TIME    MEAN DEVIATION  MEAN SQUARE ERROR  ROOT MEAN SQUARE ERRO
     &R  MEAN ABSOLUTE ERROR')
 9055 FORMAT (I3,':',I2,' | ',E13.6,E17.6,E21.6,E24.6)
 9060 FORMAT (
     &' *WARNING* EXCEEDED MAXIMUM NUMBER OF REVERSALS, COMPUTATION OF S
     &TATISTICS SUSPENDED')
 9065 FORMAT (/' FLOW    :     TOTAL   ',6(9A2))
 9070 FORMAT (' COMPUTED: ',E11.5,1X,8(6(E11.5,' (',I4,')'),/,23X))
 9075 FORMAT ('               ',A2,'**3',3X,6(3X,A2,'**3',10X))
 9080 FORMAT (' MEASURED: ',E11.5,1X,8(6(E11.5,' (',I4,')'),/,23X))
 9085 FORMAT (' ERROR   : ',5X,8(6(12X,F5.1,'%'),/,16X))
      END
C
C
C
      SUBROUTINE TDDOUT
C
C  THIS SUBROUTINE WRITES FLOW COMPUTATION RESULTS TO THE TIME-
C  DEPENDENT DATA BASE OF THE TIME-DEPENDENT DATA SYSTEM(TDDS).
C
      INTEGER jyr, jmo, jda, jhr, jmn, kyr, kmo, kda, khr, kmn
      INCLUDE 'dimens.cmn'
      INCLUDE 'zq.cmn'
      INCLUDE 'logics.cmn'
      INCLUDE 'units.cmn'
      INCLUDE 'dadcom.cmn'
      INCLUDE 'comcon.cmn'
      INCLUDE 'convt.cmn'
      INCLUDE 'lunums.cmn'
      INCLUDE 'dtypes.cmn'
      INCLUDE 'bctime.cmn'
      INCLUDE 'xsichr.cmn'
      INCLUDE 'branch.cmn'
C
C     MXOTDT IS USED TO DIMENSION THE DATA ARRAY.  THIS DIMENSION MUST
C     COINCIDE WITH ZQCOMP DIMENSION TO WHICH IT IS EQUIVALENCED.
C     EQUIVALENCE STATEMENT CAN BE REMOVED IF CORE IS NOT A PROBLEM.
C
      REAL R4data(MXOTDT,4)
      EQUIVALENCE (Zqcomp(1,1),R4data(1,1))
      INTEGER nend, nb, nd, ns, i, ij, j, nsm1, ketime, idmy, k, kk, n, 
     &        iret
      REAL qij, zij, aij, bij
      CHARACTER*2 stype
      LOGICAL moretd
      EXTERNAL DATCOD, DTCODE, DADI, ERRSTP, INCELT
C
      Irdpdy = 1440/Idtm
      Strip = -1
C---Output data as real values to TDDB
      stype = 'R4'
      IF (Nsteps.GT.MXOTDT) THEN
        moretd = .TRUE.
      ELSE
        moretd = .FALSE.
        jyr = Iyr
        jmo = Imo
        jda = Ida
        jhr = Ihr
        jmn = Imn
        kyr = Nyr
        kmo = Nmo
        kda = Nda
        khr = Nhr
        kmn = Nmn
        nend = Nsteps
        nb = 1
      ENDIF
      nd = MAXS - Xskt(Nbch) + Nsec(Nbch)
      DO 70 i = 1, Nbch
        ns = Nsec(i)
        ij = MAXS - Xskt(i)
        DO 60 j = 1, ns
          nsm1 = MAXS - Xskt(i) + j - 1
          ij = ij + 1
          IF (.NOT.((Xstatn(ij)(15:16).EQ.Iblk) .OR. (Itypeo(1,ij).EQ.
     &        Iblk .AND. Itypeo(2,ij).EQ.Iblk .AND. Itypeo(3,ij)
     &        .EQ.Iblk .AND. Itypeo(4,ij).EQ.Iblk))) THEN
            REWIND Luiflo
            IF (moretd) THEN
              nend = MXOTDT
              nb = 1
              jyr = Iyr
              jmo = Imo
              jda = Ida
              jhr = Ihr
              jmn = Imn
              ketime = Ietime + (MXOTDT-1)*Idtm
              kyr = Iyr
              CALL DATCOD(ketime,kyr,kmo,kda,khr,kmn)
              CALL DTCODE(kyr,kmo,kda,khr,kmn,idmy,ketime,iret)
              IF (iret.NE.0) GOTO 80
              IF (kyr.GT.Iyr) CALL INCELT(Iyr,kyr,ketime)
            ENDIF
   10       k = 0
            DO 40 kk = nb, nend
              k = k + 1
              DO 20 n = 1, nsm1
                READ (Luiflo)
   20         CONTINUE
              READ (Luiflo) qij, zij, aij, bij
              DO 30 n = nsm1 + 2, nd
                READ (Luiflo)
   30         CONTINUE
              R4data(k,1) = qij*Qconvt
              R4data(k,2) = zij*Zconvt
              R4data(k,3) = aij*Aconvt
              R4data(k,4) = bij*Zconvt
   40       CONTINUE
            DO 50 n = 1, 4
              Dtype = Itypeo(n,ij)
              IF (Dtype.EQ.Qtype) THEN
                CALL DADI(Xstatn(ij),Dtype,stype,jyr,jmo,jda,jhr,jmn,
     &                    kyr,kmo,kda,khr,kmn,Irdpdy,R4data(1,1),Strip,
     &                    Prtmsg,Rtcode)
              ELSEIF (Dtype.EQ.Ztype) THEN
                CALL DADI(Xstatn(ij),Dtype,stype,jyr,jmo,jda,jhr,jmn,
     &                    kyr,kmo,kda,khr,kmn,Irdpdy,R4data(1,2),Strip,
     &                    Prtmsg,Rtcode)
              ELSEIF (Dtype.EQ.Atype) THEN
                CALL DADI(Xstatn(ij),Dtype,stype,jyr,jmo,jda,jhr,jmn,
     &                    kyr,kmo,kda,khr,kmn,Irdpdy,R4data(1,3),Strip,
     &                    Prtmsg,Rtcode)
              ELSEIF (Dtype.EQ.Btype) THEN
                CALL DADI(Xstatn(ij),Dtype,stype,jyr,jmo,jda,jhr,jmn,
     &                    kyr,kmo,kda,khr,kmn,Irdpdy,R4data(1,4),Strip,
     &                    Prtmsg,Rtcode)
              ELSE
                GOTO 50
              ENDIF
              IF (Rtcode.EQ.0) WRITE (Printr,9005) Xstatn(ij), jyr, jmo, 
     &                                jda, jhr, jmn, kyr, kmo, kda, khr, 
     &                                kmn, Irdpdy, Dtype
   50       CONTINUE
            IF (nend.NE.Nsteps) THEN
              nb = nend + 1
              ketime = ketime + Idtm
              jyr = Iyr
              CALL DATCOD(ketime,jyr,jmo,jda,jhr,jmn)
              CALL DTCODE(jyr,jmo,jda,jhr,jmn,idmy,ketime,iret)
              IF (iret.NE.0) GOTO 80
              IF (jyr.GT.Iyr) CALL INCELT(Iyr,kyr,ketime)
              ketime = ketime + (MXOTDT-1)*Idtm
              kyr = Iyr
              CALL DATCOD(ketime,kyr,kmo,kda,khr,kmn)
              IF (ketime.GE.Netime .OR. kyr.GT.Nyr) THEN
                kyr = Nyr
                kmo = Nmo
                kda = Nda
                khr = Nhr
                kmn = Nmn
                nend = Nsteps
              ELSE
                nend = nend + MXOTDT
              ENDIF
              CALL DTCODE(kyr,kmo,kda,khr,kmn,idmy,ketime,iret)
              IF (iret.NE.0) GOTO 80
              IF (kyr.GT.Iyr) CALL INCELT(Iyr,kyr,ketime)
              GOTO 10
            ENDIF
          ENDIF
   60   CONTINUE
   70 CONTINUE
      RETURN
   80 CALL ERRSTP('INVALID DATE AND(OR) TIME IN TDDOUT ROUTINE')
 9005 FORMAT (/' DATA FOR STATION "',A16,'", FROM',I3.2,2('/',I2.2),
     &        I3.2,':',I2.2,' TO',I3.2,2('/',I2.2),I3.2,':',I2.2,
     &        '; VALUES PER DAY =',I3,'; AND DATA TYPE ',A2,' STORED'/)
      END
