      SUBROUTINE CDFOUT
C     LAST MODIFIED October 8, 1993 -- RSR
C     MODIFIED MARCH 11, 1992 -- RSR
      INCLUDE 'netcdf.inc'
      INCLUDE 'dimens.cmn'
      INCLUDE 'dtcomp.cmn'
      INCLUDE 'comcon.cmn'
      INCLUDE 'datime.cmn'
      INCLUDE 'xsichr.cmn'
      INCLUDE 'netwrk.cmn'
      INTEGER initfl
      INTEGER iret
C netCDF id
      INTEGER cdfid
C dimension ids
      INTEGER timedim, maxsdim, name_lendim
C variable ids
      INTEGER qid, zid, aid, bid, xstatnid
C variable shapes
      INTEGER dims(2)
C corners and edge lengths
C     integer corner(2), edges(2)
C data variables
C     real q(MAXS,1)
C     real z(MAXS,1)
C     real a(MAXS,1)
C     real b(MAXS,1)
C     character*16 xstatn(MAXS)
C attribute vectors
      DOUBLE PRECISION doubleval(1)
      INTEGER lenstr, rcode
      INTEGER start(2), count(2)
      CHARACTER*12 filnam
      SAVE start, count, initfl, cdfid, iret, timedim, maxsdim, dims, 
     &     name_lendim, qid, zid, aid, bid, xstatnid, doubleval, filnam, 
     &     rcode, lenstr
      DATA start/1, 1/, count/16, MAXS/, initfl/1/
C     write (*,*) ' time step = ',M
      IF (initfl.NE.0) THEN
        initfl = 0
C enter define mode
        filnam = 'br'//Rundat(1:2)//Rundat(4:5)//Rundat(7:8)//'.cdf'
        cdfid = NCCRE(filnam,NCCLOB,iret)
C define dimensions
        timedim = NCDDEF(cdfid,'time',NCUNLIM,iret)
        maxsdim = NCDDEF(cdfid,'maxs',MAXS,iret)
        name_lendim = NCDDEF(cdfid,'name_len',16,iret)
C define variables
        dims(2) = timedim
        dims(1) = maxsdim
        qid = NCVDEF(cdfid,'q',NCFLOAT,2,dims,iret)
        dims(2) = timedim
        dims(1) = maxsdim
        zid = NCVDEF(cdfid,'z',NCFLOAT,2,dims,iret)
        dims(2) = timedim
        dims(1) = maxsdim
        aid = NCVDEF(cdfid,'a',NCFLOAT,2,dims,iret)
        dims(2) = timedim
        dims(1) = maxsdim
        bid = NCVDEF(cdfid,'b',NCFLOAT,2,dims,iret)
        dims(1) = name_lendim
        dims(2) = maxsdim
        xstatnid = NCVDEF(cdfid,'xstatn',NCCHAR,2,dims,iret)
C assign attributes
        CALL NCAPTC(cdfid,qid,'long_name',NCCHAR,9,'Discharge',iret)
        CALL NCAPTC(cdfid,qid,'units',NCCHAR,3,'cfs',iret)
        CALL NCAPTC(cdfid,zid,'long_name',NCCHAR,5,'Stage',iret)
        CALL NCAPTC(cdfid,zid,'units',NCCHAR,4,'feet',iret)
        doubleval(1) = Zdatum
        CALL NCAPT(cdfid,zid,'add_offset',NCDOUBLE,1,doubleval,iret)
        CALL NCAPTC(cdfid,aid,'long_name',NCCHAR,20,
     &              'Cross-sectional Area',iret)
        CALL NCAPTC(cdfid,aid,'units',NCCHAR,11,'square feet',iret)
        CALL NCAPTC(cdfid,bid,'long_name',NCCHAR,21,
     &              'Cross-sectional Width',iret)
        CALL NCAPTC(cdfid,bid,'units',NCCHAR,4,'feet',iret)
        CALL NCAPTC(cdfid,NCGLOBAL,'source',NCCHAR,58,Brdate(1:58),iret)
        CALL NCAPTC(cdfid,NCGLOBAL,'run_datime',NCCHAR,14,Rundat,iret)
        CALL NCAPTC(cdfid,NCGLOBAL,'sim_datime',NCCHAR,17,Simdat,iret)
C leave define mode
        CALL NCENDF(cdfid,iret)
        lenstr = MAXS*16
        CALL NCVPTC(cdfid,xstatnid,start,count,Xstatn,lenstr,rcode)
        count(1) = MAXS
        count(2) = 1
      ENDIF
      start(2) = M
      CALL NCVPT(cdfid,qid,start,count,Q,rcode)
      CALL NCVPT(cdfid,zid,start,count,Z,rcode)
      CALL NCVPT(cdfid,aid,start,count,Ap,rcode)
      CALL NCVPT(cdfid,bid,start,count,Bp,rcode)
      IF (M.EQ.Nsteps) CALL NCCLOS(cdfid,iret)
      RETURN
      END
