      SUBROUTINE DTFILE
C
C     SUBROUTINE TO WRITE SELECTED FLOW RESULTS TO A FILE (*.out)
C     FOR POST-PROCESS PLOTTING
C
      INCLUDE 'dimens.cmn'
      INCLUDE 'branch.cmn'
      INCLUDE 'comcon.cmn'
      INCLUDE 'lunums.cmn'
      INCLUDE 'dtcomp.cmn'
      INCLUDE 'tdfiln.cmn'
      INCLUDE 'geom.cmn'
C
      INTEGER i, j, n, ij, ns, len, idts, itsec, initfl, idtout
      CHARACTER*48 blank, outnam
      REAL toff, FLOAT
      INTRINSIC FLOAT
      EXTERNAL FILPRE, OPNFIL
      SAVE initfl, idtout, toff, itsec, idts
      DATA initfl/0/, 
     &     blank/'                                                '/
C
      IF (initfl.EQ.0) THEN
        initfl = 1
C
C---GET LENGTH OF BASE NAME
        CALL FILPRE(Rdname,len)
C
C---BUILD FLOW-RESULTS OUTPUT FILE NAME
        outnam = blank
        outnam = Rdname(1:len)//'.out'
C
C---OPEN FILE FOR OUTPUT OF FORMATTED RESULTS FOR POST-PROCESS PLOTTING
        CALL OPNFIL(Luout,outnam)
C       OPEN (UNIT=21,FILE='tmsndq1.out')
C       OPEN (UNIT=22,FILE='tmsndz1.out')
C       OPEN (UNIT=23,FILE='tmsx4036.out')
C       OPEN (UNIT=23,FILE='nondim.out')
C       OPEN (UNIT=24,FILE='tmsndq3.out')
C       OPEN (UNIT=25,FILE='tmsndz3.out')
        idts = Idtm*60
        toff = Nsteps*Idtm
        idtout = Iprtdt*60
        IF (Idtsec.GT.0) THEN
          idts = Idtsec
          toff = FLOAT(Nsteps*Idtsec)/60.0
        ENDIF
        itsec = 0
      ENDIF
C
C     LOOP THROUGH BRANCH CROSS-SECTIONS TO FILE SELECTED RESULTS
C
      DO 20 i = 1, Nbch
        ns = Nsec(i)
        ij = MAXS - Xskt(i)
        DO 10 j = 1, ns
          ij = ij + 1
C Code to write high-gradient channel results to a file
C     IF (i.EQ.2 .AND. j.EQ.ns) THEN
C       z11 = Zp(MAXS-Xskt(1)+1) + Zdatum
C       q11 = Qp(MAXS-Xskt(1)+1)
C       z21 = Zp(MAXS-Xskt(i)+1) + Zdatum
C       q21 = Qp(MAXS-Xskt(i)+1)
C       WRITE (Luout,'(3(F6.1,2F8.3))') thr, z11, q11, toff, z21, q21,
C    &                                  thr+2.0*toff, Zp(ij) + Zdatum,
C    &                                  Qp(ij)
C       thr = thr + Idtm
C     ENDIF
C       WRITE (Luout,*) Zp(MAXS-Xskt(1)+1),Za(1,MAXS-Xskt(1)+1),Zdatum
C       itsec = itsec + idts
          IF (i.EQ.Nbch .AND. j.EQ.ns .AND. MOD(itsec,idtout).EQ.0)
     &        WRITE (Luout,'(11(F6.1,2F8.3))')
     &               (itsec/60.+(n-1)*toff,Zp(MAXS-Xskt(n)+1)
     &               -Za(1,MAXS-Xskt(n)+1)+0.01,Qp(MAXS-Xskt(n)+1),n=1,
     &               Nbch)
C
C Code to write Threemile Slough results at reach ends to a file
C     IF (j.EQ.ns) THEN
C       z11 = Zp(MAXS-Xskt(1)+1) + Zdatum
C       z11 = (z11+11.5)/23.0
C       q11 = Qp(MAXS-Xskt(1)+1)
C       q11 = q11/14387.0
C       z15 = (Zp(ij) + Zdatum + 11.5)/23.0
C       q15 = Qp(ij)/14387.0
C       WRITE (23,'(F5.2,4F9.3)') thr,z11,q11,z15,q15
C       thr = thr + Idtm/60.0
C     ENDIF
C
C Code to write Threemile Slough results at midreach to a file
C     IF (j.EQ.3) THEN
C ==> Begin create standard file n=0.0360
C       z036 = (Zp(ij) + Zdatum+11.5)/23.0
C       q036 = Qp(ij)/14387.0
C       WRITE (23,'(F5.2,2F7.3)') thr,z036,q036
C ==> End create standard file n=0.0360
C ==> Begin create files for n=0.0324
C       z1 = (Zp(ij) + Zdatum+11.5)/23.0
C       q1 = Qp(ij)/14387.0
C       WRITE (21,'(5X,F7.3)') q1
C       WRITE (22,'(5X,F7.3)') z1
C ==> End create files for n=0.0324
C ==> Begin create files for n=0.0324, 0.0360, and 0.0396
C       z13 = (Zp(ij) + Zdatum+11.5)/23.0
C       q13 = Qp(ij)/14387.0
C       READ (21,'(5X,F7.3)') q1
C       READ (22,'(5X,F7.3)') z1
C       READ (23,'(5X,2F7.3)') z036, q036
C       WRITE (24,'(F5.2,3F7.3)') thr, q1, q036, q13
C       WRITE (25,'(F5.2,3F7.3)') thr, z1, z036, z13
C ==> End create files for n=0.0324, 0.0360, and 0.0396
C       thr = thr + Idtm/60.0
C     ENDIF
C
   10   CONTINUE
   20 CONTINUE
      itsec = itsec + idts
      RETURN
      END
