      SUBROUTINE DTOUT(IENT,LASTN,Q,Z,A,B,BT)
C
C     PRINTS FLOW COMPUTATION RESULTS IN TABULAR FORM AT PRINTOUT
C     FREQUENCY (IDTRAT) EVERY TIME STEP (IPROPT = 0, 5, OR 7) OR EVERY
C     ITERATION (IPROPT = 1, 6, OR 8)
C
      INTEGER IENT, LASTN
      INCLUDE 'dimens.cmn'
      REAL Q(MAXS), Z(MAXS), A(MAXS), B(MAXS), BT(MAXS)
C
      INCLUDE 'branch.cmn'
      INCLUDE 'comcon.cmn'
      EXTERNAL DTBLTM, DTPOST
      CHARACTER*1 ideta(7)
      INTEGER initfl, i, nxsprt
      CHARACTER*4 prtyp
      SAVE initfl, nxsprt, prtyp
      DATA initfl/1/, nxsprt/0/
      DATA ideta/'0', 'T', 'D', 'Q', 'F', 'R', 'Z'/
C
C     INPUT-OUTPUT UNIT CONVERSION FACTORS
C
      IF (initfl.EQ.1) THEN
        initfl = 2
        DO 10 i = 1, Nbch
          IF (Gprbch.NE.1 .AND. (Gprbch.EQ.2.OR.Prtbch(i).EQ.0)) THEN
            nxsprt = nxsprt + Nsec(i)
            IF (Iprfmt.EQ.1) nxsprt = nxsprt - 1
          ENDIF
   10   CONTINUE
        IF (Typeta.EQ.1) THEN
          prtyp = '    '
        ELSE
          prtyp = 'n('//ideta(Typeta)//')'
        ENDIF
      ENDIF
C
      IF (Iprfmt.EQ.0) THEN
C
C---Write results in one cross section per record format for time step
        CALL DTNFMT(nxsprt,prtyp,IENT,LASTN,Q,Z,A,B,BT)
      ELSE
C
C---Write results in two cross sections per record format for time step
        CALL DTOFMT(nxsprt,IENT,LASTN,Q,Z,A,B,BT)
      ENDIF
C
C---Write BLTM output for time step
      IF (Otfile.EQ.2) CALL DTBLTM(Q,Z,A,B,BT)
C
C---Write selected flow results for time step
      IF (Otfile.EQ.5) CALL DTPOST(Q,Z,A,B,BT)
C
      RETURN
      END
C
C
C
      SUBROUTINE DTNFMT(NXSPRT,PRTYP,IENT,LASTN,Q,Z,A,B,BT)
C
C     PRINTS FLOW COMPUTATION RESULTS IN NEW TABULAR FORM AT PRINTOUT
C     FREQUENCY (IDTRAT) EVERY TIME STEP (IPROPT = 0, 5, OR 7) OR EVERY
C     ITERATION (IPROPT = 1, 6, OR 8)
C
      INTEGER IENT, LASTN, NXSPRT
      CHARACTER*4 PRTYP
      INCLUDE 'dimens.cmn'
      REAL Q(MAXS), Z(MAXS), A(MAXS), B(MAXS), BT(MAXS)
C
      REAL zij, qij, aij, bij, vij, dmy, dmy2, bsij, hydep, frnum, hrij
      INTEGER lastm, i, ibxs, ij, j, ktline, ns
      LOGICAL ifirst, prhead
      CHARACTER*8 ktime, blank8, itnum, lbl
      CHARACTER*5 alphrn
      INCLUDE 'datime.cmn'
      INCLUDE 'netwrk.cmn'
      INCLUDE 'units.cmn'
      INCLUDE 'branch.cmn'
      INCLUDE 'comcon.cmn'
      INCLUDE 'untmes.cmn'
      INCLUDE 'convt.cmn'
      INCLUDE 'zqstat.cmn'
      INCLUDE 'lunums.cmn'
      INCLUDE 'xsinit.cmn'
      INCLUDE 'geom.cmn'
      REAL SQRT, ABS
      INTRINSIC SQRT, ABS
      SAVE lastm, ifirst, ktline
      DATA lastm/0/, ifirst/.TRUE./, ktline/0/blank8/'        '/, 
     &     ktime/'    :   '/, itnum/'   ( )  '/
C
      IF (ktline+NXSPRT.GT.66) ifirst = .TRUE.
C
      IF (ifirst) THEN
        ifirst = .FALSE.
        ktline = 5
        WRITE (Printr,9005) Netnam(1:78)
        WRITE (Printr,9015)
        WRITE (Printr,9010) Kyr, Kmo, Kda, Unit, Unit, Unit, Unit, Unit, 
     &                      Unit, Unit, Unit, PRTYP
        WRITE (Printr,9015)
      ENDIF
C
      WRITE (ktime(3:4),'(I2.2)') Khr
      WRITE (ktime(6:7),'(I2.2)') Kmn
      WRITE (itnum(5:5),'(I1)') LASTN
      DO 20 i = 1, Nbch
        IF (Gprbch.NE.1 .AND. (Gprbch.EQ.2.OR.Prtbch(i).EQ.0)) THEN
          ibxs = 0
          ns = Nsec(i)
          ij = MAXS - Xskt(i)
          DO 10 j = 1, ns
            ij = ij + 1
C
            zij = Z(ij) + Zdatum
            qij = Q(ij)
            aij = A(ij)
            bij = B(ij)
            bsij = BT(ij) - B(ij)
            hrij = Hyrad(ij)
C
C---CONVERT FROM ENGLISH TO METRIC OR FROM METRIC TO ENGLISH
            IF (Iunit.NE.Ounit) THEN
              zij = zij*Zconvt
              qij = qij*Qconvt
              aij = aij*Aconvt
              bij = bij*Zconvt
              bsij = bsij*Zconvt
              hrij = bsij*Zconvt
            ENDIF
C
            IF (aij.NE.0.0) THEN
              vij = qij/aij
            ELSE
              vij = 0.0
            ENDIF
            IF (bij.NE.0.0) THEN
              hydep = aij/bij
            ELSE
              hydep = 0.0
            ENDIF
            IF (hydep.NE.0.0) THEN
              frnum = ABS(vij)/SQRT(G*hydep)
            ELSE
              frnum = 0.0
            ENDIF
            ibxs = ibxs + 1
            WRITE (alphrn,'(F5.4)') Rn4(ij)
            IF (j.EQ.ns) alphrn = blank8(1:5)
            lbl = blank8
            IF (i.EQ.1) THEN
              IF (j.EQ.1) lbl = ktime
              IF (j.EQ.2) lbl = itnum
            ENDIF
            WRITE (Printr,9035) lbl, i, ibxs, zij, vij, qij, aij,
     &                          bij, bsij, hydep, hrij, alphrn, frnum
   10     CONTINUE
        ENDIF
   20 CONTINUE
      ktline = ktline + NXSPRT
C
C---PRINT MINIMUM, MAXIMUM, AND MEAN DISCHARGE SUMMARY AT END OF DAY
C---AND AT END OF SIMULATION RUN
      IF ((Khr.EQ.24 .OR. M.EQ.Nsteps) .AND. IENT.EQ.0) THEN
        WRITE (Printr,9015)
        prhead = .TRUE.
        dmy2 = 1.0
        IF (Iunit.NE.Ounit) dmy2 = Qconvt
        dmy = dmy2/(M-lastm)
        DO 40 i = 1, Nbch
          IF (Gprbch.NE.1 .AND. (Gprbch.EQ.2.OR.Prtsum(i).EQ.0)) THEN
            IF (prhead) THEN
              WRITE (Printr,9020)
              prhead = .FALSE.
            ENDIF
            ns = Nsec(i)
            ij = MAXS - Xskt(i)
            DO 30 j = 1, ns
              ij = ij + 1
              WRITE (Printr,9025) Qmin(ij)*dmy2, Qsum(ij)*dmy, Qmax(ij)
     &                            *dmy2
              Qmin(ij) = BIGPOS
              Qmax(ij) = BIGNEG
              Qsum(ij) = 0.0
   30       CONTINUE
          ENDIF
   40   CONTINUE
        IF (.NOT.prhead) WRITE (Printr,9030)
        ifirst = .TRUE.
        lastm = M
      ENDIF
C
      RETURN
C
C---OUTPUT FORMAT STATEMENTS
 9005 FORMAT ('1',A78)
 9010 FORMAT (1X,2(I2.2,'/'),I2.2,
     &   '|BR #|Stage| Vel.| Disch. |  Area  | Width|StrWid|HyDep|HyRad'
     &   ,'| Eta |Fr#',/,'  (Iter) |XS #|  ',A2,' | ',A2,'/S| ',A2,
     &   '**3/S|  ',A2,'**2 |  ',A2,'  |  ',A2,'  |',2(2X,A2,' |'),A5,
     &   '|')
 9015 FORMAT (' --------+----+-----+-----+--------+--------+',
     &       2('------+'),3('-----+'),'---')
 9020 FORMAT (14X,'|',12X,'Discharge',15X,'|',/,14X,
     &        '|   Minimum      Mean      Maximum   |')
 9025 FORMAT (14X,'|',2F10.1,F13.1,'   |')
 9030 FORMAT (14X,'+',36('-'),'+')
 9035 FORMAT (A9,'|',2I2,2F6.2,2F9.1,2F7.1,2F6.2,A6,1X,F3.2)
      END
C
C
C
      SUBROUTINE DTOFMT(NXSPRT,IENT,LASTN,Q,Z,A,B,BT)
C
C     PRINTS FLOW COMPUTATION RESULTS IN OLD TABULAR FORM AT PRINTOUT
C     FREQUENCY (IDTRAT) EVERY TIME STEP (IPROPT = 0, 5, OR 7) OR EVERY
C     ITERATION (IPROPT = 1, 6, OR 8)
C
      INTEGER NXSPRT, IENT, LASTN
      INCLUDE 'dimens.cmn'
      REAL Q(MAXS), Z(MAXS), A(MAXS), B(MAXS), BT(MAXS)
C
      REAL zij, zijp1, qij, qijp1, aij, aijp1, bij, bijp1, vij, vijp1, 
     &     dmy, dmy2, bsij, bsijp1
      INTEGER lastm, i, ibxs, ij, j, ijp1, ktline, ns
      LOGICAL ifirst, prtday, prtime, prhead
      INCLUDE 'datime.cmn'
      INCLUDE 'netwrk.cmn'
      INCLUDE 'units.cmn'
      INCLUDE 'branch.cmn'
      INCLUDE 'comcon.cmn'
      INCLUDE 'untmes.cmn'
      INCLUDE 'convt.cmn'
      INCLUDE 'zqstat.cmn'
      INCLUDE 'lunums.cmn'
      INCLUDE 'logics.cmn'
      INCLUDE 'xsinit.cmn'
      SAVE lastm, ifirst, ktline
      DATA lastm/0/, ifirst/.TRUE./, ktline/0/
C
      IF (ktline+NXSPRT.GT.66) ifirst = .TRUE.
      prtday = (Kmn.EQ.0 .OR. M.EQ.Nsteps)
C
      IF (ifirst) THEN
        ifirst = .FALSE.
        ktline = 5
        prtday = .TRUE.
        WRITE (Printr,9005) Netnam
        WRITE (Printr,9015)
        WRITE (Printr,9010) Unit, Unit, Unit, Unit, Unit, Unit, Unit, 
     &                      Unit, Unit, Unit, Unit, Unit, Unit
        WRITE (Printr,9015)
      ENDIF
C
      prtime = .TRUE.
      DO 20 i = 1, Nbch
        IF (Gprbch.NE.1 .AND. (Gprbch.EQ.2.OR.Prtbch(i).EQ.0)) THEN
          ibxs = 0
          ns = Nsec(i) - 1
          ij = MAXS - Xskt(i)
          DO 10 j = 1, ns
            ij = ij + 1
            ijp1 = ij + 1
C
            zij = Z(ij) + Zdatum
            zijp1 = Z(ijp1) + Zdatum
            qij = Q(ij)
            qijp1 = Q(ijp1)
            aij = A(ij)
            aijp1 = A(ijp1)
            bij = B(ij)
            bijp1 = B(ijp1)
            bsij = BT(ij) - B(ij)
            bsijp1 = BT(ijp1) - B(ijp1)
            IF (Modflow) THEN
              IF (zij.LT.Zbot(ij)) THEN
                zij = Zbot(ij)
                aij = 0.0
                bij = 0.0
                bsij = 0.0
              ENDIF
              IF (zijp1.LT.Zbot(ijp1)) THEN
                zijp1 = Zbot(ijp1)
                aijp1 = 0.0
                bijp1 = 0.0
                bsijp1 = 0.0
              ENDIF
            ENDIF
C
C---CONVERT FROM ENGLISH TO METRIC OR FROM METRIC TO ENGLISH
            IF (Iunit.NE.Ounit) THEN
              zij = zij*Zconvt
              zijp1 = zijp1*Zconvt
              qij = qij*Qconvt
              qijp1 = qijp1*Qconvt
              aij = aij*Aconvt
              aijp1 = aijp1*Aconvt
              bij = bij*Zconvt
              bijp1 = bijp1*Zconvt
              bsij = bsij*Zconvt
              bsijp1 = bsijp1*Zconvt
            ENDIF
C
            IF (aij.NE.0.0) THEN
              vij = qij/aij
            ELSE
              vij = 0.0
            ENDIF
            IF (aijp1.NE.0.0) THEN
              vijp1 = qijp1/aijp1
            ELSE
              vijp1 = 0.0
            ENDIF
            ibxs = ibxs + 1
            IF (prtday) THEN
              WRITE (Printr,9025) Kyr, Kmo, Kda, Khr, Kmn, zij, vij, 
     &                            qij, aij, bij, bsij, zij-zijp1, i, 
     &                            LASTN, ibxs, ibxs+1, Rn4(ij), zijp1, 
     &                            vijp1, qijp1, aijp1, bijp1, bsijp1
              prtday = .FALSE.
              prtime = .FALSE.
            ELSEIF (prtime) THEN
              WRITE (Printr,9045) Khr, Kmn, zij, vij, qij, aij, bij, 
     &                            bsij, zij-zijp1, i, LASTN, ibxs, 
     &                            ibxs+1, Rn4(ij), zijp1, vijp1, 
     &                            qijp1, aijp1, bijp1, bsijp1
              prtime = .FALSE.
            ELSE
              WRITE (Printr,9020) zij, vij, qij, aij, bij, bsij, 
     &                            zij-zijp1, i, ibxs, ibxs+1, 
     &                            Rn4(ij), zijp1, vijp1, qijp1, aijp1, 
     &                            bijp1, bsijp1
            ENDIF
   10     CONTINUE
        ENDIF
   20 CONTINUE
      ktline = ktline + NXSPRT
C
C---PRINT MINIMUM, MAXIMUM, AND MEAN DISCHARGE SUMMARY AT END OF DAY
C---AND AT END OF SIMULATION RUN
      IF ((Khr.EQ.24 .OR. M.EQ.Nsteps) .AND. IENT.EQ.0) THEN
        WRITE (Printr,9015)
        prhead = .TRUE.
        dmy2 = 1.0
        IF (Iunit.NE.Ounit) dmy2 = Qconvt
        dmy = dmy2/(M-lastm)
        DO 40 i = 1, Nbch
          IF (Gprbch.NE.1 .AND. (Gprbch.EQ.2.OR.Prtsum(i).EQ.0)) THEN
            IF (prhead) THEN
              WRITE (Printr,9030)
              prhead = .FALSE.
            ENDIF
            ns = Nsec(i) - 1
            ij = MAXS - Xskt(i)
            DO 30 j = 1, ns
              ij = ij + 1
              ijp1 = ij + 1
              WRITE (Printr,9035) Qmin(ij)*dmy2, Qsum(ij)*dmy, Qmax(ij)
     &                            *dmy2, Qmin(ijp1)*dmy2, Qsum(ijp1)
     &                            *dmy, Qmax(ijp1)*dmy2
              Qmin(ij) = BIGPOS
              Qmax(ij) = BIGNEG
              Qsum(ij) = 0.0
   30       CONTINUE
            Qmin(ijp1) = BIGPOS
            Qmax(ijp1) = BIGNEG
            Qsum(ijp1) = 0.0
          ENDIF
   40   CONTINUE
        IF (.NOT.prhead) WRITE (Printr,9040)
        ifirst = .TRUE.
        lastm = M
      ENDIF
C
      RETURN
C
C---OUTPUT FORMAT STATEMENTS
 9005 FORMAT ('1',T34,'FLOW RESULTS FOR ',A80/)
 9010 FORMAT (3X,
     &'DATE    TIME| STAGE| VEL.|DISCHARGE|  AREA | WIDTH| STORE| FALL|B
     &RANCH X-S |  ETA | STAGE| VEL.|DISCHARGE|  AREA | WIDTH| STORE|',
     &/,1X,'YR/MO/DY HR:MN|  ',A2,'  | ',A2,'/S| ',A2,'**3/S | ',A2,
     &'**2 |',2X,2(A2,2X,'|',2X),A2,' |(ITERATION)|',6X,'|  ',A2,2X,
     &'| ',A2,'/S| ',A2,'**3/S | ',A2,'**2 |  ',A2,2X,'|  ',A2,'  |')
 9015 FORMAT (' --------------+-',2('-----+'),'---------+-',3('------+')
     &        ,'-----+-----',3('------+'),'-----+---------+-',
     &        3('------+'))
 9020 FORMAT (15X,'|',2(F6.2),2F9.1,2F7.1,'|',F5.2,I3,I6,':',I2,F7.4,
     &        '|',2(F6.2),2F9.1,2F7.1,'|')
 9025 FORMAT (I3.2,2('/',I2.2),I3.2,':',I2.2,'|',2(F6.2),2F9.1,2F7.1,
     &        '|',F5.2,I3,' (',I1,')',I2,':',I2,F7.4,'|',2(F6.2),2F9.1,
     &        2F7.1,'|')
 9030 FORMAT (15X,'|',18X,'DISCHARGE',17X,'|',24X,'|',18X,'DISCHARGE',
     &        17X,'|',/,15X,'|',5X,'MINIMUM',7X,'MEAN',9X,'MAXIMUM',5X,
     &        '|',24X,'|',5X,'MINIMUM',7X,'MEAN',9X,'MAXIMUM',5X,'|')
 9035 FORMAT (15X,'|',F12.1,F13.1,F14.1,5X,'|',24X,'|',F12.1,F13.1,
     &        F14.1,5X,'|')
 9040 FORMAT (15X,'+',44('-'),'+',24X,'+',44('-'),'+')
 9045 FORMAT (I12.2,':',I2.2,'|',2(F6.2),2F9.1,2F7.1,'|',F5.2,I3,' (',
     &        I1,')',I2,':',I2,F7.4,'|',2(F6.2),2F9.1,2F7.1,'|')
      END
C
C
C
      SUBROUTINE DTBLTM(Q,Z,A,B,BT)
C
C     PRINTS FLOW COMPUTATION RESULTS TO BLTM FLOW FILE
C
      INCLUDE 'dimens.cmn'
      REAL Q(MAXS), Z(MAXS), A(MAXS), B(MAXS), BT(MAXS)
C
C     q = discharge, a = conveyance area, b = conveyance width,
C     sa = storage area, bs = storage width
      REAL qij, aij, bij, saij, bsij
      INTEGER i, ibxs, ns, ij, j
      INCLUDE 'datime.cmn'
      INCLUDE 'branch.cmn'
      INCLUDE 'comcon.cmn'
      INCLUDE 'untmes.cmn'
      INCLUDE 'convt.cmn'
      INCLUDE 'lunums.cmn'
C
      EXTERNAL INTRPO
C
      DO 20 i = 1, Nbch
        ibxs = 0
        ns = Nsec(i)
        ij = MAXS - Xskt(i)
        DO 10 j = 1, ns
          ibxs = ibxs + 1
          ij = ij + 1
          qij = Q(ij)
          CALL INTRPO(Z(ij),Zdatum,i,j,ij,saij)
          aij = A(ij)
          bij = B(ij)
          bsij = BT(ij) - bij
C
C---CONVERT FROM ENGLISH TO METRIC OR FROM METRIC TO ENGLISH
          IF (Iunit.NE.Ounit) THEN
            qij = qij*Qconvt
            aij = aij*Aconvt
            bij = bij*Zconvt
            bsij = bsij*Zconvt
            saij = saij*Aconvt
          ENDIF
C
          WRITE (Lubltm,9005) M-1, i, ibxs, qij, aij, bij, 0.0, saij,
     &                        bsij
   10   CONTINUE
   20 CONTINUE
      RETURN
C
 9005 FORMAT (3I5,6E18.5)
      END
C
C
C
      SUBROUTINE INTRPO(Z,ZDATUM,I,J,IJ,SA)
C
C     Routine to interpolate percentage of the current stage, between
C     two points in the geometry table
C
      REAL Z, ZDATUM, SA, r0
      INTEGER IJ, I, J, k
      INCLUDE 'dimens.cmn'
      INCLUDE 'geom.cmn'
C
C---indxs must be initialized to 2 in bricxs routine
      k = Indxs(IJ)
      IF (Z.LT.Za(k-1,IJ) .OR. Z.GT.Za(k,IJ)) THEN
        IF (Z.LT.Za(1,IJ) .OR. Z.GT.Za(Ipt(IJ),IJ)) THEN
          WRITE (*,9005) Z+ZDATUM, Za(1,IJ)+ZDATUM,
     &                  Za(Ipt(IJ),IJ)+ZDATUM, I, J
          STOP
        ENDIF
C
C---LINEAR INTERPOLATE IF STAGE WITHIN DEFINED RANGE OF GEOMETRY TABLE
        IF (Z.GT.Za(k,IJ)) THEN
   10     k = k + 1
          IF (Z.GT.Za(k,IJ)) GOTO 10
        ELSE
   20     k = k - 1                                     
          IF (Z.LT.Za(k-1,IJ)) GOTO 20
        ENDIF
        Indxs(IJ) = k
      ENDIF
      r0 = (Za(k,IJ)-Z)/(Za(k,IJ)-Za(k-1,IJ))
      SA = Storar(k,ij) - r0*(Storar(k,ij)-Storar(k-1,ij))
      RETURN
 9005 FORMAT (/,' *ERROR* computed stage (',F7.2,
     &       ') out of geometry table (min=',F7.2,' max=',F7.2,')',/,9X,
     &       'for branch:',I3,' cross section:',I3,/,9X,
     &     'in routine INTRPO which computes storage area for BLTM.FLW')
      END
C
C
C
      SUBROUTINE DTPOST(Q,Z,A,B,BT)
C
C     STORES SELECTED FLOW COMPUTATION RESULTS IN A TEXT FILE AT
C     PRINTOUT FREQUENCY (IDTRAT) EVERY TIME STEP (IPROPT = 0, 5, OR 7)
C     OR EVERY ITERATION (IPROPT = 1, 6, OR 8)
C
      INCLUDE 'dimens.cmn'
      REAL Q(MAXS), Z(MAXS), A(MAXS), B(MAXS), BT(MAXS)
      INCLUDE 'datime.cmn'
      INCLUDE 'branch.cmn'
      INCLUDE 'comcon.cmn'
      INCLUDE 'untmes.cmn'
      INCLUDE 'convt.cmn'
      INCLUDE 'lunums.cmn'
      INCLUDE 'logics.cmn'
      INCLUDE 'xsinit.cmn'
      INCLUDE 'usrtbl.cmn'
      REAL zij, qij, aij, bij, dmy, bsij, result(NUMTBL)
      INTEGER i, nsm1, ij, j, iniflg, ii, num
C
      REAL FLOAT
      INTRINSIC FLOAT
      SAVE iniflg, num
      DATA iniflg/0/, num/0/
C
      IF (iniflg.EQ.0) THEN
        iniflg = 1
        WRITE (Lupst,9010)
        DO 10 i = 1, NUMTBL
          IF (Uttyp(i).NE.'  ') THEN
            WRITE (Lupst,9005) i+1, Utbch(i), Utsec(i), Uttyp(i)
            num = i
          ENDIF
   10   CONTINUE
      ENDIF
      DO 40 ii = 1, num
        DO 30 i = 1, Nbch
          IF (Utbch(ii).EQ.i) THEN
            nsm1 = Nsec(i) - 1
            ij = MAXS - Xskt(i)
            DO 20 j = 1, nsm1
              IF (Utsec(ii).EQ.j) THEN
                ij = ij + 1
                zij = Z(ij) + Zdatum
                qij = Q(ij)
                aij = A(ij)
                bij = B(ij)
                bsij = BT(ij) - B(ij)
                IF (Modflow .AND. zij.LT.Zbot(ij)) THEN
                  zij = Zbot(ij)
                  aij = 0.0
                  bij = 0.0
                  bsij = 0.0
                ENDIF
C
C---CONVERT FROM ENGLISH TO METRIC OR FROM METRIC TO ENGLISH
                IF (Iunit.NE.Ounit) THEN
                  zij = zij*Zconvt
                  qij = qij*Qconvt
                  aij = aij*Aconvt
                  bij = bij*Zconvt
                  bsij = bsij*Zconvt
                ENDIF
C
                IF (Uttyp(ii).EQ.' Q') THEN
                  result(ii) = qij
                ELSEIF (Uttyp(ii).EQ.' Z') THEN
                  result(ii) = zij
                ELSEIF (Uttyp(ii).EQ.' V') THEN
                  result(ii) = 0.0
                  IF (aij.NE.0.0) result(ii) = qij/aij
                ELSEIF (Uttyp(ii).EQ.' A') THEN
                  result(ii) = aij
                ELSEIF (Uttyp(ii).EQ.' B') THEN
                  result(ii) = bij
                ELSEIF (Uttyp(ii).EQ.'BS') THEN
                  result(ii) = bsij
                ENDIF
              ENDIF
   20       CONTINUE
          ENDIF
   30   CONTINUE
   40 CONTINUE
C
      dmy = FLOAT(Kda*1440+Khr*60+Kmn)
      WRITE (Lupst,9015) dmy, (result(i),i=1,num)
C
      RETURN
C
 9005 FORMAT ('Column',I2,': Branch:',I3,' Cross section:',I3,
     &        ' Data type:',A2)
 9010 FORMAT (
     &    'Column 1: elapsed time in minutes (from beginning of month)')
 9015 FORMAT (F18.1,8F13.5)
      END
