      SUBROUTINE DTPREP(KT)
C
      INTEGER KT
C
      INCLUDE 'dimens.cmn'
      INCLUDE 'dtcomp.cmn'
      INCLUDE 'branch.cmn'
      INCLUDE 'xsinit.cmn'
      INCLUDE 'zq.cmn'
      INCLUDE 'zqstat.cmn'
      INCLUDE 'comcon.cmn'
      INCLUDE 'volcom.cmn'
      INCLUDE 'lunums.cmn'
      INCLUDE 'logics.cmn'
      INCLUDE 'datime.cmn'
C
      INTEGER i, j, l, ij, ns
      REAL dtzero, ztemp, qtemp, zij, qij, tmp
      INTEGER IFIX
      REAL COS, ABS, SIGN
      INTRINSIC COS, ABS, SIGN, IFIX
C
C     PREPARATION FOR NEXT TIME STEP
C
      DO 30 i = 1, Nbch
        ns = Nsec(i)
        ij = MAXS - Xskt(i)
        DO 20 j = 1, ns
          ij = ij + 1
C
C     COMPUTE FLOW VOLUMES
          IF (Ipropt.EQ.4) THEN
            DO 10 l = 1, Nfvxs
              IF (ij.EQ.Ijvol(l)) THEN
                IF ((Q(ij).GT.0.0 .AND. Qp(ij).GT.0.0) .OR. 
     &              (Q(ij).LT.0.0 .AND. Qp(ij).LT.0.0) .OR. 
     &              (Q(ij).EQ.0.0 .AND. Qp(ij).EQ.0.0)) THEN
                  tmp = Q(ij)*Dt
                  Ifvol(Ijvkt(l),1,l) = Ifvol(Ijvkt(l),1,l) + 
     &                                  IFIX(tmp*0.01+SIGN(0.5,tmp))
                  Fvol(l) = Fvol(l) + tmp
                ELSE
                  dtzero = (-Q(ij)*Dt)/(Qp(ij)-Q(ij))
                  tmp = Q(ij)*dtzero
                  Ifvol(Ijvkt(l),1,l) = Ifvol(Ijvkt(l),1,l) +
     &                                  IFIX(tmp*0.01+SIGN(0.5,tmp))
                  Fvol(l) = Fvol(l) + tmp
                  Itvol(Ijvkt(l),1,l) = Khr*100 + Kmn
                  Ijvkt(l) = Ijvkt(l) + 1
                  tmp = Qp(ij)*(Dt-dtzero)
                  Ifvol(Ijvkt(l),1,l) = Ifvol(Ijvkt(l),1,l) +
     &                                  IFIX(tmp*0.01+SIGN(0.5,tmp))
                  Fvol(l) = Fvol(l) + tmp
                ENDIF
              ENDIF
   10       CONTINUE
          ENDIF
C
C     SAVE LAST VALUES COMPUTED BY ITERATION
          ztemp = Z(ij)
          qtemp = Q(ij)
          Z(ij) = Zp(ij)
          Q(ij) = Qp(ij)
          A(ij) = Ap(ij)
          B(ij) = Bp(ij)
          Bt(ij) = Btp(ij)
          R(ij) = Rp(ij)
          zij = Z(ij) + Zdatum
          qij = Q(ij)
          IF (Inwind.NE.0 .AND. j.NE.ns) Wangle(ij)
     &        = COS(.01745329*ABS(Wdirec-Orient(ij)))
          IF (.NOT.Modeta) THEN
            IF (Stages) THEN
              Zqcomp(KT,ij) = zij*Qzconv
            ELSE
              Zqcomp(KT,ij) = qij*Qzconv
            ENDIF
          ENDIF
          IF (Ottddb) WRITE (Luiflo) qij, zij, Ap(ij), Bp(ij)
          Qsum(ij) = Qsum(ij) + qij
          IF (qij.GT.Qmax(ij)) THEN
            Qmax(ij) = qij
            Zqmax(ij) = zij
            Aqmax(ij) = Ap(ij)
            Itqmax(ij) = Khr*100 + Kmn
          ENDIF
          IF (qij.LT.Qmin(ij)) THEN
            Qmin(ij) = qij
            Zqmin(ij) = zij
            Aqmin(ij) = Ap(ij)
            Itqmin(ij) = Khr*100 + Kmn
          ENDIF
C
C     (IEXOPT=0) USE CURRENT VALUES AS INITIAL VALUES FOR FUTURE UNKNOWNS
          IF (.NOT.Noextp) THEN
C     (IEXOPT=1) EXTRAPOLATE INITIAL VALUES FOR UNKNOWNS FROM CURRENT VALUES
            Zp(ij) = 2.*Zp(ij) - ztemp
            Qp(ij) = 2.*Qp(ij) - qtemp
          ENDIF
   20   CONTINUE
   30 CONTINUE
      IF (Ipropt.EQ.4) WRITE (Luivol) (Fvol(l),l=1,Nfvxs)
      RETURN
      END
C
C
      SUBROUTINE INTBC
C
      INCLUDE 'dimens.cmn'
      INCLUDE 'dtcomp.cmn'
      INCLUDE 'matrix.cmn'
      INCLUDE 'branch.cmn'
      INCLUDE 'bindex.cmn'
      INCLUDE 'comcon.cmn'
      INCLUDE 'nodal.cmn'
C
      REAL th
      INTEGER IAR, i, j, k, l, ij, ibch, mm, nnn, nbpj, m0, iabch
      INTEGER IABS, ISIGN, IFIX
      INTRINSIC IABS, ISIGN, IFIX
C
C     STATEMENT FUNCTION FOR LOCATING ELEMENTS IN COEFFICIENT MATRIX
      IAR(i,j,Ii) = i + Ii*(j-1)
C
C     INSERT BOUNDARY CONDITIONS FOR INTERNAL JUNCTIONS
      DO 30 j = 1, Njnc
        IF (Ict(j).NE.1) THEN
          nbpj = Ict(j)
C     INSERT DISCHARGE CONTINUITY EQUATION
          DO 10 i = 1, nbpj
            ibch = Idx(j,i)
            mm = IABS(ibch)*4 + (ISIGN(1,ibch)-1)
            nnn = IAR(Nn,mm,Ii)
            Am(nnn) = ISIGN(1,ibch)
   10     CONTINUE
          IF (Kttdnf.EQ.0 .OR. Nxtdnf(j).EQ.0) THEN
            Bmx(Nn) = -W(j)
          ELSE
            l = Nxtdnf(j)
            k = IFIX(Nnd*Dt/Dttn(l)+1.0001)
            th = (Nnd*Dt-(k-1)*Dttn(l))/Dttn(l)
            IF (k.EQ.1) THEN
              k = 2
              th = th - 1.0
            ENDIF
            Bmx(Nn) = -(0.5*th*(Wt(k+1,l)-Wt(k-1,l)+th*(Wt(k+1,l)+Wt(k-1
     &                ,l)-2.0*Wt(k,l)))+Wt(k,l))
          ENDIF
          Nn = Nn + 1
C     INSERT STAGE OR ENERGY COMPATIBILITY EQUATIONS
          ibch = Idx(j,1)
          m0 = IABS(ibch)*4 + (ISIGN(1,ibch)-1) - 1
          DO 20 i = 2, nbpj
            nnn = IAR(Nn,m0,Ii)
            Am(nnn) = 1.0
            IF (Ienibc.EQ.1) THEN
              ibch = Idx(j,1)
              iabch = IABS(ibch)
              IF ((Ijf(iabch).EQ.j .AND. Ijfen(iabch).EQ.0) .OR. 
     &            (Ijt(iabch).EQ.j .AND. Ijten(iabch).EQ.0)) THEN
                nnn = nnn + Ii
                ij = MAXS - Xskt(iabch) + 1
                IF (ibch.GT.0) ij = ij + Nsec(iabch) - 1
                Am(nnn) = Qp(ij)/(2.*G*Ap(ij)*Ap(ij))
              ENDIF
            ENDIF
            ibch = Idx(j,i)
            mm = IABS(ibch)*4 + (ISIGN(1,ibch)-1) - 1
            nnn = IAR(Nn,mm,Ii)
            Am(nnn) = -1.0
            IF (Ienibc.EQ.1) THEN
              iabch = IABS(ibch)
              IF ((Ijf(iabch).EQ.j .AND. Ijfen(iabch).EQ.0) .OR. 
     &            (Ijt(iabch).EQ.j .AND. Ijten(iabch).EQ.0)) THEN
                nnn = nnn + Ii
                ij = MAXS - Xskt(iabch) + 1
                IF (ibch.GT.0) ij = ij + Nsec(iabch) - 1
                Am(nnn) = -Qp(ij)/(2.*G*Ap(ij)*Ap(ij))
              ENDIF
            ENDIF
            Bmx(Nn) = 0.0
            Nn = Nn + 1
   20     CONTINUE
        ENDIF
   30 CONTINUE
      RETURN
      END
C
C
      SUBROUTINE EXTBC
C
C---INSERT BOUNDARY CONDITIONS FOR EXTERNAL JUNCTIONS
C
      INCLUDE 'dimens.cmn'
      INCLUDE 'dtcomp.cmn'
      INCLUDE 'matrix.cmn'
      INCLUDE 'branch.cmn'
      INCLUDE 'bindex.cmn'
      INCLUDE 'comcon.cmn'
      INCLUDE 'dtypes.cmn'
      INCLUDE 'boundy.cmn'
      INCLUDE 'bouchr.cmn'
      INCLUDE 'datime.cmn'
      INCLUDE 'nodal.cmn'
      INCLUDE 'partim.cmn'
      INCLUDE 'xsinit.cmn'
      INCLUDE 'geom.cmn'
Ctmp  INCLUDE 'lunums.cmn'
C
      REAL th, qcul, zqpij, zuscul, zdscul
      INTEGER posrt, negrt, wrnflg, fatflg, iculfl, IAR, k, l, ij, 
     &        intdbc, knd, ibch, mm, nnn, i, j
      EXTERNAL PARM3
      INTEGER IABS, IFIX
      INTRINSIC IABS, IFIX
      SAVE posrt, negrt
      DATA posrt/1/, negrt/1/
C
C     STATEMENT FUNCTION FOR LOCATING ELEMENTS IN COEFFICIENT MATRIX
      IAR(i,j,Ii) = i + Ii*(j-1)
C
      iculfl = 0
      intdbc = 0
      Intabc = 0
C
C---BEGIN LOOP TO INSERT BOUNDARY CONDITIONS FOR EXTERNAL JUNCTIONS
C
      DO 40 l = 1, Nbnd
        IF (Ibjnc(l).EQ.0) GOTO 40
        ibch = Idx(Ibjnc(l),1)
        ij = MAXS - Xskt(IABS(ibch)) + 1
        mm = 1 + (IABS(ibch)-1)*4
        IF (ibch.GT.0) THEN
          ij = ij + Nsec(ibch) - 1
          mm = mm + 2
        ENDIF
        IF (Itype(l).EQ.Qtype .OR. Itype(l).EQ.Qptype) mm = mm + 1
        nnn = IAR(Nn,mm,Ii)
        Am(nnn) = 1.0
C-----------------------------------------------------------------------
C---COMPUTE AND SET BOUNDARY CONDITION AT JUNCTION CONNECTED BY CULVERT
C-----------------------------------------------------------------------
        IF (ij.EQ.Ijdcul .OR. ij.EQ.Ijucul) THEN
          IF (iculfl.EQ.0) THEN
            iculfl = 1
            zuscul = Zp(Ijucul) + Zdatum
            zdscul = Zp(Ijdcul) + Zdatum
            CALL PARM3(Kyr,Kmo,Kda,Khr,Kmn,posrt,negrt,zuscul,zdscul,
     &                 qcul,wrnflg,fatflg)
          ENDIF
          Bmx(Nn) = qcul
C-----------------------------------------------------------------------
C---SET BOUNDARY CONDITION FROM INPUT EQUATION OR RATING TABLE
C-----------------------------------------------------------------------
        ELSEIF (Izqbve(l).NE.0) THEN
          IF (ibch.LT.0) THEN
            ij = MAXS - Xskt(IABS(ibch)) + 1
          ELSE
            ij = MAXS - Xskt(ibch) + Nsec(ibch)
          ENDIF
C-----------------------------------------------------------------------
C---SET BOUNDARY CONDITION FROM SPECIFIED STAGE (OR DISCHARGE)
C---BOUNDARY-CONDITION CONSTANT
C-----------------------------------------------------------------------
          IF (Izqbve(l).EQ.1) THEN
            Bmx(Nn) = Zqbvco(1,l)
C-----------------------------------------------------------------------
C---SET BOUNDARY CONDITION FROM SPECIFIED STAGE (OR DISCHARGE)
C---BOUNDARY-CONDITION EQUATION AND PREVIOUSLY COMPUTED DEPENDENT VARIABLE
C-----------------------------------------------------------------------
          ELSEIF (Izqbve(l).EQ.-1) THEN
            IF (Itype(l).EQ.Ztype) THEN
              zqpij = Q(ij)
            ELSE
              zqpij = Z(ij) + Zdatum
            ENDIF
            Bmx(Nn) = Zqbvco(1,l)
     &                + (Zqbvco(2,l)+(Zqbvco(3,l)+Zqbvco(4,l)*zqpij)
     &                *zqpij)*zqpij
C
          ELSEIF (Izqbve(l).EQ.3) THEN
C
C---Z(t) B.C. specified by SIN equation
C---Z(t) = Zd + Za*SIN((M*Dt/Zp)+Zo)
C----------Zd = Zqbvco(1,l) = mean elevation
C----------Za = Zqbvco(2,l) = amplitude
C----------Zo = Zqbvco(3,l) = phase
C----------Zp = Zqbvco(4,l) = offset
            Bmx(Nn) = Zqbvco(1,l) + (Zqbvco(2,l)*0.5)*SIN(.01745329*
     &                ((M*Dt/Zqbvco(3,l)*180.0)+Zqbvco(4,l)))
C            
C-----------------------------------------------------------------------
C---SET LINEAR STAGE (OR DISCHARGE) BOUNDARY-CONDITION
C---EQUATION FROM INPUT STAGE/DISCHARGE RATING TABLE
C-----------------------------------------------------------------------
          ELSE
C
C ==> Begin temporary code to specify Q(t) B.C. flood-wave hydrograph
C           tt = M*Dt
C           IF (tt.GT.240.0 .AND. tt.LE.1440.0) THEN
C             Bmx(Nn) = 18.0 + 0.03*(tt-240.0)
C           ELSEIF (tt.GT.1440.0 .AND. tt.LE.3840.0) THEN
C             Bmx(Nn) = 54.0 - 0.015*(tt-1440.0)
C           ELSE 
C             Bmx(Nn) = 18.0
C           ENDIF
C ==> End temporary code to specify Q(t) B.C. flood-wave hydrograph
            Intabc = Intabc + 1
            knd = Izqpt(Intabc) - 1
            mm = 1 + (IABS(ibch)-1)*4
            IF (Itype(l).EQ.Ztype) mm = mm + 1
            IF (ibch.GT.0) mm = mm + 2
            nnn = IAR(Nn,mm,Ii)
            IF (Itype(l).EQ.Qtype) THEN
C
C---STAGE BOUNDARY-CONDITION EQUATION
              DO 10 k = 1, knd
                IF (Z(ij).LT.Zt(k,Intabc) .OR. Z(ij).GT.Zt(k+1,Intabc))
     &              GOTO 10
                Am(nnn) = -((Zt(k+1,Intabc)-Zt(k,Intabc))/
     &                      (Qt(k+1,Intabc)-Qt(k,Intabc)))
                Bmx(Nn) = Zt(k,Intabc) + Am(nnn)*Qt(k,Intabc)
                GOTO 30
   10         CONTINUE
            ELSE
C
C---DISCHARGE BOUNDARY-CONDITION EQUATION
              DO 20 k = 1, knd
                IF (Q(ij).LT.Qt(k,Intabc) .OR. Q(ij).LE.Qt(k+1,Intabc))
     &              GOTO 20
                Am(nnn) = -((Qt(k+1,Intabc)-Qt(k,Intabc))/
     &                      (Zt(k+1,Intabc)-Zt(k,Intabc)))
                Bmx(Nn) = Qt(k,Intabc) + Am(nnn)*Zt(k,Intabc)
                GOTO 30
   20         CONTINUE
            ENDIF
          ENDIF
C-----------------------------------------------------------------------
C---SET BOUNDARY CONDITION FROM INPUT STAGE OR DISCHARGE DATA
C-----------------------------------------------------------------------
        ELSEIF (Itype(l).NE.Zptype .AND. Itype(l).NE.Qptype) THEN
          intdbc = intdbc + 1
          IF (Ndata(l).NE.0) THEN
            knd = M
          ELSE
            knd = Nd
          ENDIF
          k = IFIX(knd*Dt/Dtt(l)+1.0001)
          th = (knd*Dt-(k-1)*Dtt(l))/Dtt(l)
          IF (k.EQ.1) THEN
            k = 2
            th = th - 1.0
          ENDIF
C
C---PARABOLIC INTERPOLATION FROM BOUNDARY-VALUE DATA
          Bmx(Nn) = .5*th*(Zq(k+1,intdbc)-Zq(k-1,intdbc)+th*
     &              (Zq(k+1,intdbc)+Zq(k-1,intdbc)-2.0*Zq(k,intdbc)))
     &              + Zq(k,intdbc)
C-----------------------------------------------------------------------
C---SET STAGE BOUNDARY CONDITION TO PREVIOUSLY COMPUTED STAGE
C---OR MINIMUM VALUE SPECIFIED
C-----------------------------------------------------------------------
        ELSEIF (Itype(l).EQ.Zptype) THEN
          IF (Z(Ijzpbc).LT.Zqpmin(l)) THEN
            Bmx(Nn) = Zqpmin(l)
          ELSE
C           Bmx(Nn) = Z(Ijzpbc
C
C ==> Begin temporary code to specify self-setting gradient B.C.
            Bmx(Nn) = Z(Ijzpbc) - ((Z(Ijzpbc)-Za(1,Ijzpbc)+0.01)-
     &                (Z(Ijzpbc+1)-Za(1,Ijzpbc+1)+0.01))*0.5 -
     &                (Za(1,Ijzpbc)-Za(1,Ijzpbc+1))
C           WRITE (Printr,*) Bmx(Nn)+Zdatum, Z(Ijzpbc)+Zdatum,
C    &                     Z(Ijzpbc+1)+Zdatum, Za(1,Ijzpbc),
C    &                     Za(1,Ijzpbc+1)
C ==> End temporary code to specify self-setting gradient B.C.
C
          ENDIF
C-----------------------------------------------------------------------
C---SELF-SETTING DEPTH OF FLOW BOUNDARY CONDITION
C-----------------------------------------------------------------------
        ELSEIF (Itype(l).EQ.Dptype) THEN
          IF (Z(Ijzpbc).LT.Zqpmin(l)) THEN
            Bmx(Nn) = Zqpmin(l)
          ELSE
            Bmx(Nn) = Z(Ijzpbc) - Zbot(Ijzpbc) + Zbot(Ijzpbc+1)
          ENDIF
C-----------------------------------------------------------------------
C---SET DISCHARGE BOUNDARY CONDITION TO PREVIOUSLY COMPUTED DISCHARGE
C---OR MINIMUM VALUE SPECIFIED
C-----------------------------------------------------------------------
        ELSEIF (Itype(l).EQ.Qptype) THEN
          IF (Q(Ijqpbc).LT.Zqpmin(l)) THEN
            Bmx(Nn) = Zqpmin(l)
          ELSE
            Bmx(Nn) = Q(Ijzpbc)
          ENDIF
        ENDIF
   30   Nn = Nn + 1
   40 CONTINUE
C
C---END LOOP TO INSERT BOUNDARY CONDITIONS FOR EXTERNAL JUNCTIONS
C
      RETURN
      END
