      SUBROUTINE ERRREC(DTYPE,STATN,DT,ND,IRDPDY)
C
C     + + + PURPOSE + + +
C     THIS ROUTINE PRINTS OUT THE INFORMATION CONTAINED ON AN ERRANT
C     DATA DEFINITION RECORD.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER ND, IRDPDY
      REAL DT
      CHARACTER DTYPE*2, STATN*16
C
C     + + + ARGUMENT DEFINITIONS + + +
C     DTYPE  - DATA TYPE
C     STATN  - STATION NUMBER
C     DT     - RECORDING INTERVAL
C     ND     - NUMBER OF DATA INPUT
C     IRDPDY - NUMBER OF DATA RECORDED PER DAY
C
C     + + + LOCAL VARIABLES + + +
      INTEGER iyr, nyr, imo, nmo, ida, nda, ihr, nhr, imn, nmn, nopcrd, 
     &        ibjnc
      REAL datum
C
C     + + + INCLUDED COMMON BLOCKS + + +
      INCLUDE 'lunums.cmn'
      INCLUDE 'brnerr.cmn'
C
C     + + + EXTERNALS + + +
      EXTERNAL ERRMSG
C
C     + + + END SPECIFICATIONS + + +
C
      READ (Lstcrd,9005) ibjnc, iyr, imo, ida, ihr, imn, nyr, nmo, nda, 
     &                   nhr, nmn, nopcrd, datum
      IF (nopcrd.EQ.0) nopcrd = 1
      IF (DTYPE.EQ.'  ') DTYPE = ' Z'
      WRITE (Printr,9010) DTYPE, ibjnc, STATN, ND, iyr, imo, ida, ihr, 
     &                    imn, nopcrd, nyr, nmo, nda, nhr, nmn, IRDPDY, 
     &                    datum, DT/60.0
      WRITE (*,9010) DTYPE, ibjnc, STATN, ND, iyr, imo, ida, ihr, imn, 
     &               nopcrd, nyr, nmo, nda, nhr, nmn, IRDPDY, datum, 
     &               DT/60.0
      CALL ERRMSG
 9005 FORMAT (2X,I2,20X,5(I2,1X),5X,5(I2,1X),I1,5X,F7.3)
 9010 FORMAT (/,3X,
     &       'DATA-DEFINITION TABLE FOR TIME-VARYING DATA SPECIFICATION'
     &       ,/,1X,61('-'),/,' DATA TYPE',21X,A2,5X,'JUNCTION NUMBER',
     &       I9,/,' STATION NUMBER  ',A16,5X,'NO. OF DATA VALUES',I6,/,
     &       ' BEGINNING DATE',I6.2,2('/',I2.2),I3.2,':',I2.2,5X,
     &       'VALUES PER RECORD',I7,/,' ENDING DATE',I9.2,2('/',I2.2),
     &       I3.2,':',I2.2,5X,'READINGS PER DAY',I8,/,
     &       ' DATUM CORRECTION',F16.3,5X,'RECORDING INTERVAL',F6.1)
      END
C
      SUBROUTINE ERRMSG
C
      INCLUDE 'brnerr.cmn'
      CHARACTER*80 msg
      EXTERNAL ERRPRT, ERRCRD, ERRLIN
C
      IF (Ier.LT.0) THEN
        msg = 'DETECTED DURING MULTIPLE RETRIEVAL OF '//Errtyp//' DATA'
        CALL ERRPRT(msg)
      ELSE
        msg = 'DETECTED IN THE FOLLOWING '//Errtyp//' DATA RECORD'
        CALL ERRCRD(0,Lstcrd,msg)
      ENDIF
      IF (Ier.EQ.1 .OR. Ier.EQ.-1) THEN
        msg = 'INVALID RETRIEVAL FROM DATA BASE'
      ELSEIF (Ier.EQ.2 .OR. Ier.EQ.-2) THEN
        msg = 'INVALID DATE AND(OR) TIME'
      ELSEIF (Ier.EQ.4) THEN
        msg = 'END TIME FALLS BEFORE BEGIN TIME FOR RETRIEVAL REQUEST'
      ELSEIF (Ier.EQ.5) THEN
        msg = 
     &'INSUFFICIENT NUMBER OF DATA VALUES INPUT IN PROGRAM-CONTROL FILE'
      ELSEIF (Ier.EQ.6) THEN
        msg = 
     &'RECORDING INTERVAL AND READINGS PER DAY WERE INPUT AS ZERO OR ARE
     & IN CONFLICT'
      ELSEIF (Ier.EQ.7) THEN
        msg = 
     &'DATA/FORMAT ERROR, BE SURE PARAMETERS ARE CODED IN THE CORRECT CO
     &LUMN POSITIONS'
      ELSEIF (Ier.EQ.10) THEN
        msg = 
     &'COMPUTATION TIME INTERVAL AND RECORDING INTERVAL FOR FIRST BVD AR
     &E UNSPECIFIED'
      ELSEIF (Ier.EQ.11) THEN
        msg = 
     &'MEASURED DATA MUST BEGIN AT A MULTIPLE OF THE COMPUTATION TIME IN
     &TERVAL'
      ELSEIF (Ier.EQ.12) THEN
        msg = 'INVALID JUNCTION NUMBER SPECIFIED'
      ELSEIF (Ier.EQ.13) THEN
        msg = 'JUNCTION NUMBER ASSIGNED TO MORE THAN ONE '//Errtyp//
     &        ' LOCATION'
      ELSEIF (Ier.EQ.15) THEN
        msg = 
     &'DATA SPECIFIED TO BEGIN AT A TIME OTHER THAN THE SIMULATION BEGIN
     & TIME'
      ELSEIF (Ier.EQ.16) THEN
        msg = 
     &'DATA SPECIFIED TO END AT A TIME OTHER THAN THE SIMULATION END TIM
     &E'
      ELSEIF (Ier.EQ.17) THEN
        msg = 'STATION NUMBER NOT SPECIFIED'
      ELSEIF (Ier.EQ.19) THEN
        msg = 
     &'THE DATA SET RECORDED AT THE GREATEST FREQUENCY MUST BE THE FIRST
     & BVD RECORD'
        CALL ERRLIN(msg)
        msg = 
     &'REARRANGE THE BVD RECORDS (FREQUENCY OF "Q" DATA ARE MULTIPLIED B
     &Y 2'
      ELSEIF (Ier.EQ.20) THEN
        msg = 
     &'SELF-SETTING EXTERNAL B.C. CANNOT BE SPECIFIED AS THE FIRST BVD R
     &ECORD'
      ENDIF
      CALL ERRLIN(msg)
      STOP
      END
C
      SUBROUTINE ERRSCR(ISTOP,I,J,MSG)
      INTEGER I, J, ISTOP
      INCLUDE 'lunums.cmn'
      CHARACTER*(*) MSG
      EXTERNAL ERRPRT
C
      CALL ERRPRT(MSG)
      WRITE (*,9005) I, J
      WRITE (Printr,9005) I, J
      IF (ISTOP.EQ.1) STOP
      RETURN
 9005 FORMAT (11X,'FOR BRANCH:',I3,', CROSS SECTION:',I3)
      END
C
      SUBROUTINE ERRCRD(ISTOP,RECRD,MSG)
      INTEGER ISTOP
      CHARACTER*80 RECRD
      CHARACTER*(*) MSG
      INCLUDE 'lunums.cmn'
      INTEGER LENCHR, i
      EXTERNAL LENCHR, ERRPRT
C
      CALL ERRPRT(MSG)
      i = LENCHR(RECRD)
      IF (i.EQ.0) i = 1
      WRITE (*,9005) RECRD(:i)
      WRITE (Printr,9005) RECRD(:i)
      IF (ISTOP.EQ.1) STOP
      RETURN
 9005 FORMAT (' "',A,'"')
      END
C
      SUBROUTINE ERRPAR(ISTOP,IVAL,MIN,MAX,PARM,MSG)
      INTEGER ISTOP, IVAL, MIN, MAX
      CHARACTER*6 PARM
      CHARACTER*(*) MSG
      INCLUDE 'lunums.cmn'
      EXTERNAL ERRPRT
C
      CALL ERRPRT(MSG)
      WRITE (*,9005) IVAL, MIN, MAX, PARM
      WRITE (Printr,9005) IVAL, MIN, MAX, PARM
      IF (ISTOP.EQ.1) STOP
      RETURN
 9005 FORMAT (' VALUE FOUND:',I5,' MINIMUM ALLOWED:',I5,
     &        ' MAXIMUM ALLOWED:',I5,/,' CORRECT PARAMETER "',A6,
     &        '" IN DIMENS.CMN AND RECOMPILE AND LOAD')
      END
C
      SUBROUTINE ERRDIM(IVAL,MAXVL,MAXB,PARM,PARMB,MSG)
      INTEGER IVAL, MAXVL, MAXB
      CHARACTER*6 PARM, PARMB
      CHARACTER*(*) MSG
      INCLUDE 'lunums.cmn'
      EXTERNAL ERRPRT
C
      CALL ERRPRT(MSG)
      WRITE (*,9005) IVAL, MAXVL, PARMB, PARM
      WRITE (Printr,9005) IVAL, MAXVL, PARMB, MAXB, PARM
      RETURN
 9005 FORMAT (' VALUE SPECIFIED:',I5,' MUST BE:',I5,' BASED ON "',A6,
     &        '" =',I5,/,' CORRECT PARAMETER "',A6,
     &        '" IN DIMENS.CMN AND RECOMPILE AND LOAD')
      END
C
      SUBROUTINE ERRSTP(MSG)
      CHARACTER*(*) MSG
      EXTERNAL ERRPRT
C
      CALL ERRPRT(MSG)
      STOP
      END
C
      SUBROUTINE ERRPRT(MSG)
      CHARACTER*(*) MSG
      INCLUDE 'lunums.cmn'
      EXTERNAL ERRLIN
C
      WRITE (*,9005)
      WRITE (Printr,9005)
      CALL ERRLIN(MSG)
      RETURN
 9005 FORMAT (/,' **ERROR**')
      END
C
      SUBROUTINE ERRLIN(MSG)
      CHARACTER*(*) MSG
      INCLUDE 'lunums.cmn'
      INTEGER LENCHR, l
      EXTERNAL LENCHR
C
      l = LENCHR(MSG)
      WRITE (*,9005) MSG(:l)
      WRITE (Printr,9005) MSG(:l)
      RETURN
 9005 FORMAT (1X,A)
      END
