      SUBROUTINE LEAKVL(NCOL,NROW,NLAY,HNEW,HOLD,IBOUND,KKITER)
      INTEGER NCOL, NLAY, NROW
      DOUBLE PRECISION HNEW(NCOL,NROW,NLAY)
      REAL HOLD(NCOL,NROW,NLAY)
      INTEGER IBOUND(NCOL,NROW,NLAY)
      INTEGER itria1, itria2, itria3, KKITER
      INCLUDE 'dimens.cmn'
      INCLUDE 'branch.cmn'
      INCLUDE 'comcon.cmn'
      INCLUDE 'xsinit.cmn'
      INCLUDE 'dtcomp.cmn'
      INCLUDE 'modbrn.cmn'
      REAL onechi
      INTEGER i, j, nsm1, ij, ijfi, ijp1, ijti, mod1, mod2, mod3
      EXTERNAL AQFRHD, AQRHEAD, AQRDRY
      INTEGER MOD
      INTRINSIC MOD
C
      onechi = (1.0-Chi)*0.5
C
C14A--THE NEW AND OLD AQUIFER HEADS ARE USED TO INTERPOLATE THE
C     HEAD AT THE PRESENT BRANCH TIMESTEP (HAQ) FOR CALCULATING
C     THE TOTAL VOLUME OF LEAKAGE.
C
      DO 20 i = 1, Nbch
        nsm1 = Nsec(i) - 1
        ij = MAXS - Xskt(i)
        ijfi = MAXS + Ijf(i)
        ijp1 = ij + 1
        Qlsum(ijfi) = Qlsum(ijfi) - Qp(ijp1)/Ntsaq
        DO 10 j = 1, nsm1
          ij = ij + 1
          ijp1 = ij + 1
          IF (Istrm(3,ij).LT.0) GOTO 10
          CALL AQFRHD(ij,NCOL,NROW,NLAY,HNEW,HOLD,IBOUND)
          CALL AQRDRY(ij)
          Qlsum(ij) = Qlsum(ij)
     &                + (Chi*(Clkpp1*Bp(ijp1)*(Zp(ijp1)-Haqpp1)
     &                +Clkp*Bp(ij)*(Zp(ij)-Haqp))
     &                +onechi*(Clkp1*B(ijp1)*(Z(ijp1)-Haqp1)
     &                +Clkij*B(ij)*(Z(ij)-Haq)))*Dx(ij)/(2.*Ntsaq)
          IF (KKITER.LT.51) THEN
            CALL AQRHEAD(ij,NCOL,NROW,NLAY,HNEW,HOLD)
C
C     THE DRYNESS CONDITIONS ARE CHECKED TO SET VALUES OF ITRIAL
            itria1 = 0
            IF (Zp(ij).LT.Zbot(ij)-Zdatum) itria1 = itria1 + 10
            IF (Zp(ijp1).LT.Zbot(ijp1)-Zdatum) itria1 = itria1 + 20
            IF (Haqp.LT.Zbot(ij)) itria1 = itria1 + 1
Crsr should above be haqp1, since haqp=haqpp1
Crsr as used in next statement???
            IF (Haqpp1.LT.Zbot(ijp1)) itria1 = itria1 + 2
            itria2 = Itrial(Icount+1,ij)
            itria3 = Itrial(Icount,ij)
            mod1 = MOD(itria1,10)
            mod2 = MOD(itria2,10)
            mod3 = MOD(itria3,10)
            IF (itria3.GE.30) THEN
              IF (itria3.LT.80) THEN
                IF (itria1.GE.30) itria1 = mod1 + itria3 - mod3
              ELSEIF (itria1.GE.30) THEN
                itria1 = mod1 + itria3 - mod3 + 10
              ELSE
                itria1 = mod1 + itria3 - mod3 - 10
              ENDIF
            ENDIF
            IF (KKITER.LE.5 .OR. (itria1-mod1)/10.EQ.mod2 .OR. 
     &          itria1-mod1.LT.itria3-mod3) Itrial(Icount+1,ij) = itria1
            Itrial(Icount+1,ij) = Itrial(Icount+1,ij)
     &                            - MOD(Itrial(Icount+1,ij),10) + mod1
          ENDIF
   10   CONTINUE
        ijti = MAXS + Ijt(i)
        Qlsum(ijti) = Qlsum(ijti) + Qp(ijp1)/Ntsaq
   20 CONTINUE
      RETURN
      END
C
C
      SUBROUTINE AQFRHD(IJ,NCOL,NROW,NLAY,HNEW,HOLD,IBOUND)
C
C---THE NEW AND OLD AQUIFER HEADS ARE USED TO INTERPOLATE THE HEAD
C---AT THE PRESENT BRANCH TIMESTEP (HAQ).
C
      INTEGER IJ, NCOL, NROW, NLAY
      DOUBLE PRECISION HNEW(NCOL,NROW,NLAY)
      REAL HOLD(NCOL,NROW,NLAY)
      INTEGER IBOUND(NCOL,NROW,NLAY)
      INCLUDE 'dimens.cmn'
      INCLUDE 'xsinit.cmn'
      INCLUDE 'modbrn.cmn'
      INCLUDE 'comcon.cmn'
      EXTERNAL AQRHEAD
      REAL AMAX1
      INTRINSIC AMAX1
C
      Clkij = Clk(IJ)
      IF (IBOUND(Istrm(1,IJ),Istrm(2,IJ),Istrm(3,IJ)).LT.1) Clkij = 0.0
      Clkij = Clkij
      Clkp1 = Clkij
      Clkp = Clkij
      Clkpp1 = Clkij
C
      CALL AQRHEAD(IJ,NCOL,NROW,NLAY,HNEW,HOLD)
C
C---IF THE AQUIFER IS BELOW THE STREAMBED, HEAD IN STREAM IS USED
C---TO CALCULATE LEAKAGE.
      Haq = AMAX1(Haq,Zbot(IJ))
      Haqp = AMAX1(Haqp,Zbot(IJ))
      Haqp1 = AMAX1(Haqp1,Zbot(IJ+1))
      Haqpp1 = AMAX1(Haqpp1,Zbot(IJ+1))
      Haq = Haq - Zdatum
      Haqp = Haqp - Zdatum
      Haqp1 = Haqp1 - Zdatum
      Haqpp1 = Haqpp1 - Zdatum
C
      RETURN
      END
C
C
      SUBROUTINE AQRHEAD(IJ,NCOL,NROW,NLAY,HNEW,HOLD)
C
C---THE NEW AND OLD AQUIFER HEADS ARE USED TO INTERPOLATE THE HEAD
C---AT THE PRESENT BRANCH TIMESTEP (HAQ).
C
      INTEGER NCOL, NLAY, NROW, IJ
      DOUBLE PRECISION HNEW(NCOL,NROW,NLAY)
      REAL HOLD(NCOL,NROW,NLAY), hnew1, hold1
      INCLUDE 'dimens.cmn'
      INCLUDE 'xsinit.cmn'
      INCLUDE 'modbrn.cmn'
      REAL FLOAT
      INTRINSIC FLOAT
C
      hnew1 = HNEW(Istrm(1,IJ),Istrm(2,IJ),Istrm(3,IJ))
      hold1 = HOLD(Istrm(1,IJ),Istrm(2,IJ),Istrm(3,IJ))
      Haq = hold1 + FLOAT(Icount-1)*(hnew1-hold1)/FLOAT(Ntsaq)
      Haqp = hold1 + FLOAT(Icount)*(hnew1-hold1)/FLOAT(Ntsaq)
      Haqp1 = Haq
      Haqpp1 = Haqp
C
      RETURN
      END
C
C
C
      SUBROUTINE AQRDRY(IJ)
      INCLUDE 'dimens.cmn'
      INCLUDE 'modbrn.cmn'
      INTEGER it, IJ
C
      it = Itrial(Icount+1,IJ)
      IF (it.EQ.11) THEN
        Clkp = 0.0
      ELSEIF (it.EQ.22) THEN
        Clkpp1 = 0.0
      ELSEIF (it.GT.32) THEN
        Clkp = 0.0
        Clkpp1 = 0.0
      ENDIF
C
      it = Itrial(Icount,IJ)
      IF (it.EQ.11) THEN
        Clkij = 0.0
      ELSEIF (it.EQ.22) THEN
        Clkp1 = 0.0
      ELSEIF (it.GT.32) THEN
        Clkij = 0.0
        Clkp1 = 0.0
      ENDIF
C
      RETURN
      END
