      SUBROUTINE OPLOT
C     LAST MODIFIED November 19, 1996 -- RSR
C     MODIFIED October 8, 1993 -- RSR
C     MODIFIED APRIL 23, 1992 -- RSR
C
C # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
C #                         SUBROUTINE OPLOT                          #
C #   THIS FORTRAN AND CALCOMP CODED SUBROUTINE PREPARES A DAILY      #
C #   COMPUTED AND, OPTIONALLY, MEASURED DISCHARGE/STAGE HYDROGRAPH.  #
C # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
      REAL legend(4,2), xlen, size, ylen, hsiz, xorgin, xlcurv, Xspace, 
     &     xstep, xpos, ypos, zqmin, zqmax, zqnum, yorgin, yupper, 
     &     zqbase, yp, xp, ypos1, xpos1, hspace, r0, Yspace, siz15, fac
      INTEGER ktplot, i, k, kd, nochar, isec, ip, mid, mnd, i0, mnphr,
     &        mnpdy, irotat, mm, ns, ndm, in, nplot, kk, iplot, ins,
     &        jns, ij, ipen, ipwr, ipower, icon, l, cpp, iquad, id, idm,
     &        nd, ibnd, j, i1, initfl, im, ifct, lblclr
C     INITIALIZE CPP FOR THE NUMBER OF CURVES PER PLOT (MAXIMUM OF 5)
C     TO OVERRIDE PROGRAM DEFAULTS FOR LEGEND LOCATION, SET IQUAD TO
C     DESIRED QUADRANT.
      LOGICAL locleg, meplot, measfg, labsta, switch
      CHARACTER*19 cstan
      CHARACTER lbl*48, fmt*11, vartyp*14, varunt*23
      INTEGER typlen, untlen
      INCLUDE 'dimens.cmn'
      INCLUDE 'units.cmn'
      INCLUDE 'datime.cmn'
      INCLUDE 'logics.cmn'
      INCLUDE 'lunums.cmn'
      INCLUDE 'comcon.cmn'
      INCLUDE 'untmes.cmn'
      INCLUDE 'mdatas.cmn'
      INCLUDE 'zq.cmn'
      INCLUDE 'boundy.cmn'
      INCLUDE 'bouchr.cmn'
      INCLUDE 'branch.cmn'
      INCLUDE 'branam.cmn'
      INCLUDE 'netwrk.cmn'
      REAL Zqtime(MAXCZQ), Rmtime(MAXMZQ), zqijk, tmax, zqcmin, zqcmax
      REAL Xangle, Yangle, Delx, tcmax, ystep, ytest
      CHARACTER*6 csect
      COMMON /OPLTCM/ Zqtime, Rmtime, Yangle, Xangle, Delx, Yspace, 
     &                Xspace
      SAVE /OPLTCM/
      EXTERNAL PLOTS, FACTOR, NEWPEN, PLOT, SYMBOL, PLTBAX, PLTLAX,
     &         PLTDAT, PLTLIN, NXTPLT, ERRPRT
      INTEGER IFIX, MOD
      REAL ALOG10, AMOD
      INTRINSIC IFIX, ALOG10, AMOD, MOD, IABS
      SAVE idm, ndm, meplot, mnd, xstep, id, nd, initfl, siz15, ibnd
      SAVE vartyp, typlen, varunt, untlen
      DATA initfl/1/, xlen/7.8/, size/.12/, ylen/10./, hsiz/.10/, 
     &     xorgin/0.0/, xlcurv/1.00/, mnphr/60/, mnpdy/1440/, irotat/0/, 
     &     iquad/0/, cpp/5/, locleg/.FALSE./, ktplot/0/, mid/1/,
     &     r0/0.0/, i0/0/, i1/1/, lblclr/15/, ip/2/, fac/0.7/
C     DISSPLA CHARACTER WIDTH/HEIGHT RATIO IS 6/7 (CHARWH = 0.857)
C
C     INITIALIZE PLOT CONTROL PARAMETERS
      IF (initfl.EQ.1) THEN
        initfl = 2
        IF (Stages) THEN
          vartyp = 'STAGE, IN '
          typlen = 10
        ELSE
          vartyp = 'DISCHARGE, IN '
          typlen = 14
        ENDIF
        IF (Ounit.EQ.Me) THEN
          IF (Stages) THEN
            varunt = 'CENTIMETERS'
            untlen = 11
          ELSE
            varunt = 'CUBIC METERS PER SECOND'
            untlen = 23
          ENDIF
        ELSEIF (Stages) THEN
          varunt = 'FEET'
          untlen = 4
        ELSE
          varunt = 'CUBIC FEET PER SECOND'
          untlen = 21
        ENDIF
        siz15 = 1.5*size
        id = (Inhr*mnphr+Inmn)/Idtm
        nd = mnpdy/Idtm
        DO 10 k = 1, nd
          Zqtime(k) = Idtm*k
   10   CONTINUE
        DO 20 k = nd+1, MAXCZQ-nd
          Zqtime(k) = 0.0
   20   CONTINUE
C     12 INCREMENTS ON X-AXIS, 10 ON Y-AXIS, 1440 MINUTES IN A DAY
        xstep = 1440./xlen
C     DELX=1440.0/12.0/60.0+0.005
        Delx = 2.0
        Xspace = xlen/12.0
        Yspace = ylen*0.1
        CALL PLOTS(Ludplt,i1,i0)
        CALL FACTOR(fac)
        IF (Iplmsg.NE.0) Iplmsg = 1
        meplot = .FALSE.
        ibnd = 0
        idm = 0
        ndm = 96
        mnd = 0
        IF (Iplopt.GT.2) THEN
          cpp = 1
          meplot = .TRUE.
          idm = (Mihr*mnphr+Mimn)/Mdt
          ndm = mnpdy/Mdt
          DO 30 k = 1, ndm
            Rmtime(k) = Mdt*k
   30     CONTINUE
          DO 40 k = ndm+1, MAXCZQ-ndm
            Rmtime(k) = 0.0
   40     CONTINUE
        ENDIF
      ENDIF
C
C # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
C #   SECONDARY ENTRY POINT TO PRODUCE GRAPHICAL PLOTS                #
C # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
      IF (M.EQ.Nsteps) nd = (Khr*mnphr+Kmn)/Idtm
      kd = nd - id + 1
      IF (kd.NE.1) THEN
        IF (meplot) THEN
          IF (Ketime.LT.Meitim .OR. Letime.GT.Mektim) GOTO 190
          mnd = ndm - idm + 1 + mnd
        ENDIF
C
C     DETERMINE POSSIBLE COORDINATES FOR LOCATION OF LEGEND(P,Q)
C     P = DESIRED QUADRANT; Q = 1 STORES X-COORD.; Q = 2 STORES Y-COORD.
        xpos = xlen - (xlcurv+siz15+4.0*hsiz)
        ypos = ylen - (siz15+hsiz)
        legend(1,1) = xpos
        legend(1,2) = ypos
        legend(2,1) = siz15
        legend(2,2) = ypos
        IF (iquad.GT.2) THEN
          legend(3,1) = siz15
          legend(3,2) = siz15
          legend(4,1) = xpos
          legend(4,2) = siz15
        ENDIF
C
C     BEGIN BRANCH CURVE PLOTTING LOOP
        DO 180 i = 1, Nbch
          IF (meplot) THEN
            DO 50 j = 1, Ktmeas
              IF (Mbch(j).EQ.i) THEN
                mm = j
                IF (mnd.GT.Mdata(mm)) mnd = Mdata(mm)
                GOTO 60
              ENDIF
   50       CONTINUE
            GOTO 180
          ENDIF
          IF (Gplbch.EQ.1.OR.(Gplbch.NE.2.AND.Pltbch(i).NE.0)) GOTO 180
   60     ibnd = 1
          ns = Nsec(i)
          in = MAXS - Xskt(i)
          IF (ns.GT.cpp) THEN
            nplot = ns/cpp
            kk = nplot*cpp
            IF (kk.NE.ns) nplot = nplot + 1
          ELSE
            nplot = 1
            kk = 1
          ENDIF
C
C     BEGIN LOOP CONTROLLING NUMBER OF PLOTS
          DO 170 iplot = 1, nplot
            IF (meplot) THEN
C  CHECK TO SEE IF MORE THAN ONE MEASURED LOCATION PER BRANCH
C  PLOT ONLY CROSS SECTIONS WITH MEASURED DATA.
              DO 70 im = mm, Ktmeas
                IF (Mbch(im).EQ.i .AND. Msec(im).EQ.iplot) GOTO 80
   70         CONTINUE
              GOTO 170
            ENDIF
C
   80       measfg = .FALSE.
            ktplot = ktplot + 1
            DO 90 j = 40, i1, -i1
              IF (Brname(i)(j:j).EQ.' ') THEN
                nochar = j
                GOTO 100
              ENDIF
   90       CONTINUE
            nochar = 0
  100       xpos = (xlen-nochar*siz15)*0.5
            ypos = ylen + 3.0*size
            CALL NEWPEN(lblclr)
            IF (irotat.EQ.0) THEN
              switch = .FALSE.
              Xangle = 0.0
              Yangle = 90.0
              CALL PLOT(1.3,1.3,-3)
              CALL SYMBOL(xpos,ypos,siz15,Brname(i),Xangle,nochar)
            ELSE
              switch = .TRUE.
              Yangle = 180.0
              Xangle = 90.0
              CALL PLOT(ylen+1.,1.5,-3)
              CALL SYMBOL(-ypos,xpos,siz15,Brname(i),Xangle,nochar)
            ENDIF
C
C     DETERMINE MINIMUM AND MAXIMUM DISCHARGE/STAGE FOR PLOT SCALING
            zqmin = BIGPOS
            zqmax = BIGNEG
            ins = (iplot-1)*cpp + 1
            jns = ns
            IF (iplot.NE.nplot) jns = iplot*cpp
            ij = in + ins - 1
            DO 120 j = ins, jns
              ij = ij + 1
              DO 110 k = id, nd
                zqijk = Zqcomp(k,ij)
                IF (zqijk.LT.zqmin) zqmin = zqijk
                IF (zqijk.GT.zqmax) THEN
                  zqmax = zqijk
                  tmax = Zqtime(k)
                ENDIF
  110         CONTINUE
  120       CONTINUE
            IF (meplot) THEN
              zqcmin = zqmin
              zqcmax = zqmax
              tcmax = tmax
              measfg = .TRUE.
              DO 130 k = mid, mnd
                zqijk = Zqmeas(k,mm)
                IF (zqijk.LT.zqmin) zqmin = zqijk
                IF (zqijk.GT.zqmax) THEN
                  zqmax = zqijk
                  tmax = Rmtime(k)
                ENDIF
  130         CONTINUE
              IF (zqcmin.LT.zqmin) zqmin = zqcmin
              IF (zqcmax.GT.zqmax) zqmax = zqcmax
            ENDIF
C
C     ESTABLISH PLOT ORIGIN AND SCALE
            ipower = IFIX(ALOG10(zqmax-zqmin)) - 2
            ystep = 10.0**ipower
            ifct = 0
C
  140       zqnum = AMOD(zqmin,ystep)
            yorgin = zqmin - zqnum
            IF (zqmin.LT.0.0 .AND. ABS(zqnum).GT.SMLVL) yorgin = yorgin 
     &          - ystep
            zqnum = AMOD(zqmax,ystep)
            yupper = zqmax - zqnum
            IF (ABS(zqnum).GT.SMLVL) yupper = yupper + ystep
            IF (ifct.EQ.0) THEN
              ytest = ystep*2.0
            ELSEIF (ifct.EQ.1) THEN
              ytest = ystep*2.5
            ELSE
              ipower = ipower + 1
              IF (ipower.GT.5) THEN
                CALL ERRPRT(
     &        'STEP SIZE IN PLOT SCALE ALGORITHM EXCEEDS MAXIMUM LIMIT')
                RETURN
              ENDIF
              ytest = 10.0**ipower
              ifct = -1
            ENDIF
            IF (ystep*ylen+yorgin.LT.yupper) THEN
              ifct = ifct + 1
              ystep = ytest
              GOTO 140
            ENDIF
            zqbase = 1.0
            IF (ipower.GT.2) zqbase = 10.0**ipower
C
C     DRAW TIME AXIS
            xpos = 0.0
            ypos = ylen + size
            IF (switch) THEN
              CALL PLTBAX(-ylen,r0,xlen,Xangle,Xspace,-size,i1)
              CALL PLTBAX(r0,xlen,ylen,Yangle,Yspace,size,i1)
              xp = -ypos
              ypos = xpos
              xpos = xp
            ELSE
              CALL PLTBAX(r0,ylen,xlen,Xangle,Xspace,-size,i1)
              CALL PLTBAX(xlen,r0,ylen,Yangle,Yspace,size,i1)
            ENDIF
            CALL PLTLAX(r0,r0,'TIME, IN HOURS',14,xlen,Xangle,xorgin,
     &                  Delx,size,i0,-i1,Xspace,size,i1)
C
C     DRAW DISCHARGE/STAGE AXIS
            zqnum = yorgin/zqbase
            nochar = IABS(ipower) + 1
            WRITE (fmt,9005) nochar
C
            ipwr = 10**ipower
            IF (ipwr.LE.100) THEN
              nochar = typlen + untlen
              WRITE (lbl,'(A)') vartyp(1:typlen)//varunt(1:untlen)
            ELSE
              nochar = nochar + typlen + untlen + 1
              WRITE (lbl,fmt) vartyp(1:typlen), ipwr, varunt(1:untlen)
            ENDIF
            j = 1
            IF (ipower.LT.-1) j = IABS(ipower)
            IF (ipower.EQ.2) j = 0
            CALL PLTLAX(r0,r0,lbl,nochar,ylen,Yangle,zqnum,
     &                  ystep/Yspace/zqbase,size,j,i1,Yspace,-size,i1)
            CALL SYMBOL(xpos,ypos,size,Brdate(1:48),Xangle,48)
C
C     LABEL PLOT AND AXES
            IF (switch) THEN
              CALL SYMBOL(xpos,ylen-16.0*size,size,Simdat,Xangle,17)
            ELSE
              CALL SYMBOL(xlen-16.0*size,ypos,size,Simdat,Xangle,17)
            ENDIF
C
            xpos = xlen - 8.0*size
            ypos = -3.5*size
            IF (switch) THEN
              CALL PLTDAT(-ypos,xpos,size,Xangle,Kyr,Kmo,Kda)
            ELSE
              CALL PLTDAT(xpos,ypos,size,Xangle,Kyr,Kmo,Kda)
            ENDIF
C
C     DETERMINE LOCATION OF LEGEND
            IF (.NOT.(iquad.NE.0.AND.locleg)) THEN
              locleg = .FALSE.
              icon = MOD(ns,cpp)
              IF (icon.EQ.0 .AND. cpp.LT.6) icon = cpp
              IF ((cpp.GT.5.AND.nplot.GT.1) .OR. icon.GT.5) icon = 5
              IF (measfg) icon = icon + 1
              yp = (zqnum-(icon*(size+hsiz)+0.20)*(zqnum-yorgin/zqbase)
     &             /ylen)*10.0**ipower
              IF ((zqmax.GE.yp.AND.tmax.LT.540.0) .OR. 
     &            (zqcmax.GE.yp.AND.tcmax.LT.540.0)) THEN
                iquad = 1
              ELSE
                iquad = 2
              ENDIF
            ENDIF
C
C     INITIALIZE LOCATION OF LEGEND
            xpos = legend(iquad,1)
            ypos = legend(iquad,2) + .5*hsiz
            xpos1 = xpos + xlcurv + hsiz
            ypos1 = ypos - .5*hsiz
            IF (i.GT.9) THEN
              xp = xpos1
            ELSE
              xp = xpos1 + hsiz
            ENDIF
            hspace = hsiz + size
            jns = cpp
            IF (.NOT.meplot) THEN
              IF (ns.GT.cpp) THEN
                IF (iplot.EQ.nplot) jns = ns - (iplot-1)*cpp
              ELSE
                jns = ns
              ENDIF
            ENDIF
C
C     BEGIN CURVE PLOTTING LOOP
            DO 150 j = 1, jns
              ipen = j + 1
              CALL NEWPEN(ipen)
              isec = j + (iplot-1)*cpp
              IF (j.NE.1) THEN
                IF (iquad.GT.2) THEN
                  ypos1 = ypos1 + hspace
                  ypos = ypos + hspace
                ELSE
                  ypos1 = ypos1 - hspace
                  ypos = ypos - hspace
                ENDIF
              ENDIF
              WRITE (csect,'(I2,A1,I2)') i, '-', isec
              IF (switch) THEN
                CALL PLOT(-ypos,xpos,3)
                CALL PLOT(-ypos,xpos+xlcurv,ip)
                CALL NEWPEN(lblclr)
                CALL SYMBOL(-ypos1,xpos1,hsiz,csect,Xangle,5)
              ELSE
                CALL PLOT(xpos,ypos,3)
                CALL PLOT(xpos+xlcurv,ypos,ip)
                CALL NEWPEN(lblclr)
                CALL SYMBOL(xpos1,ypos1,hsiz,csect,Xangle,5)
              ENDIF
              CALL NEWPEN(ipen)
C
C     PLOT DISCHARGE/STAGE DATA CURVES
              IF (switch) THEN
                CALL PLTLIN(Zqcomp(id,in+isec),Zqtime(id),kd,i1,i0,ip,
     &                      i0,yorgin,xorgin,-ystep,xstep)
              ELSE
                CALL PLTLIN(Zqtime(id),Zqcomp(id,in+isec),kd,i1,i0,ip,
     &                      i0,xorgin,yorgin,xstep,ystep)
              ENDIF
              IF (measfg) THEN
                CALL NEWPEN(ipen+1)
                IF (iquad.LT.3) THEN
                  ypos = ypos - hspace
                ELSE
                  ypos = ypos + hspace
                ENDIF
                IF (switch) THEN
                  CALL PLOT(-ypos,xpos,3)
                  CALL PLOT(-ypos,xpos+xlcurv,ip)
                  CALL PLTLIN(Zqmeas(mid,mm),Rmtime(idm),mnd-mid+1,i1,
     &                        i0,ip,i0,yorgin,xorgin,-ystep,xstep)
                ELSE
                  CALL PLOT(xpos,ypos,3)
                  CALL PLOT(xpos+xlcurv,ypos,ip)
                  CALL PLTLIN(Rmtime(idm),Zqmeas(mid,mm),mnd-mid+1,i1,
     &                        i0,ip,i0,xorgin,yorgin,xstep,ystep)
                ENDIF
              ENDIF
  150       CONTINUE
            CALL NEWPEN(lblclr)
C
C     PLOT FIELD STATION NUMBERS
            labsta = .FALSE.
            IF (iquad.EQ.2 .OR. iquad.EQ.3) THEN
              xpos = xpos + xlcurv + 18.0*hsiz
              xpos1 = xpos
            ELSE
              xpos = legend(iquad,1) - 14.0*hsiz
              xpos1 = legend(iquad,1) - 20.0*hsiz
            ENDIF
            yp = legend(iquad,2)
            DO 160 j = ibnd, Nbnd
              IF (Istatn(j)(13:16).EQ.'    ') GOTO 160
              l = j
              IF (Ibjnc(l).NE.Ijf(i)) THEN
                IF (Ibjnc(l).NE.Ijt(i)) GOTO 160
                isec = 1
                IF (Ijt(i).GT.Ijf(i)) isec = Nsec(i)
              ELSE
                isec = 1
                IF (Ijf(i).GT.Ijt(i)) isec = Nsec(i)
              ENDIF
              IF (isec.GT.cpp*iplot) GOTO 160
              icon = MOD(isec,cpp)
              IF (icon.LT.6) THEN
                IF (icon.EQ.0 .AND. cpp.LT.6) icon = cpp
                labsta = .TRUE.
                IF (iquad.GT.2) THEN
                  ypos = yp + (icon-1)*hspace
                ELSE
                  ypos = yp - (icon-1)*hspace
                ENDIF
                cstan = ' ('//Istatn(l)//')'
                IF (switch) THEN
                  CALL SYMBOL(-ypos,xpos1,hsiz,cstan,Xangle,19)
                ELSE
                  CALL SYMBOL(xpos1,ypos,hsiz,cstan,Xangle,19)
                ENDIF
                IF (measfg) THEN
                  IF (iquad.LT.3) THEN
                    ypos = ypos - hspace
                  ELSE
                    ypos = ypos + hspace
                  ENDIF
                  IF (switch) THEN
                    CALL SYMBOL(-ypos,xpos,hsiz,' ( MEASURED )',Xangle,
     &                          13)
                  ELSE
                    CALL SYMBOL(xpos,ypos,hsiz,' ( MEASURED )',Xangle,
     &                          13)
                  ENDIF
                  measfg = .FALSE.
                ENDIF
              ENDIF
  160       CONTINUE
            IF (measfg .AND. .NOT.labsta) THEN
              IF (iquad.GT.2) THEN
                ypos = yp + hspace
                ypos1 = ypos + hspace
              ELSE
                ypos = yp
                ypos1 = ypos - hspace
              ENDIF
              IF (switch) THEN
                CALL SYMBOL(-ypos,xpos,hsiz,' ( COMPUTED )',Xangle,13)
                CALL SYMBOL(-ypos1,xpos,hsiz,' ( MEASURED )',Xangle,13)
              ELSE
                CALL SYMBOL(xpos,ypos,hsiz,' ( COMPUTED )',Xangle,13)
                CALL SYMBOL(xpos,ypos1,hsiz,' ( MEASURED )',Xangle,13)
              ENDIF
            ENDIF
            ibnd = l
            CALL NXTPLT()
            CALL FACTOR(fac)
  170     CONTINUE
  180   CONTINUE
      ENDIF
C
C     TERMINATE PLOT AND CLOSE OUT PLOT FILE
  190 IF (M.EQ.Nsteps) CALL PLOT(r0,r0,999)
      id = 1
      Letime = Ketime + Idtm
      IF (meplot .AND. Ketime.GE.Meitim) THEN
        idm = 1
        mid = mnd + 1
      ENDIF
      RETURN
C
 9005 FORMAT ('(A,I',I1,',1X,A)')
      END
