      SUBROUTINE RDRAT(UNO)
C
C  READS THE TA,T1,T2,T3,T4,AND TD RECORDS NECESSARY
C  FOR 2 AND 3-PARM RATING LOOKUPS:
C
C  FATAL ERROR FLAGS:
C    1 = ERROR IN OPENING FILE
C    2 = ERROR IN READING FILE
C    3 = ERROR IN CLOSING FILE
C    4 = ERROR BECAUSE OF TRYING TO TAKE LOG OF A
C        NUMBER LESS THAN OR EQUAL TO ZERO
C
C  JJ,I,J - COUNTERS
C  UNO    - UNIT NO OF FILE HOLDING RATING DATA
C  DUM,X  - DUMMY NUMBERS
C  FILEN  - FILE NAME
C  CD     - INPUT RECORD
C  TYPE   - TYPE OF INPUT RECORD
C
      INTEGER Jj, i, j, UNO
      REAL dum, x
      CHARACTER filen*48, type*2
C
C  THE FOLLOWING ARE DECLARATIONS FOR ITEMS INCLUDED IN COMMON BLOCKS
C    TO BE TRANSFERRED TO THE CULVERT SUBROUTINE:
C
      INTEGER NORATS, RTPTS, NORTDT
      PARAMETER (NORATS=1,RTPTS=100,NORTDT=50)
      INTEGER Noparm(NORATS), ratcnt, Dtcnt(NORATS), Ratyp(NORATS), 
     &        Rtptsx, ratnum, Rtpts3(NORATS), Rtpts2(NORATS), idmy, 
     &        idm2, Rtpts1(NORATS), Rtptsu(NORATS), Rdtpos(NORATS), 
     &        fatflg
      REAL Offset(NORATS), Ghdiff(NORATS), Datum, Posk4(NORATS), 
     &     Negk4(NORATS), Typ4gh(NORATS), Twmin(NORATS), Hwmax(NORATS), 
     &     Mult(NORTDT,NORATS), Multx(NORATS), Tw3(RTPTS,NORATS), 
     &     Hw3(RTPTS,NORATS), Q3(RTPTS,NORATS), Hw2(RTPTS,NORATS), 
     &     Tw2(RTPTS,NORATS), Q2(RTPTS,NORATS), H1(RTPTS,NORATS), 
     &     T1(RTPTS,NORATS)
      REAL Hu(RTPTS,NORATS), Tu(RTPTS,NORATS), Qu(RTPTS,NORATS), 
     &     tur(RTPTS), hur(RTPTS), qur(RTPTS)
      CHARACTER Rdate(NORTDT,NORATS)*6, Rtime(NORTDT,NORATS)*4, 
     &          Exist3(NORATS)*1, Exist4(NORATS)*1, Exist2(NORATS)*1, 
     &          Existu(NORATS)*1, Mulxst(NORATS)*1
      COMMON /IN    / Noparm, Rtpts3, Rtpts2, Rtpts1, Rtptsu, Rdtpos, 
     &                Dtcnt, Ratyp
      COMMON /RL    / Offset, Ghdiff, Typ4gh, Twmin, Hwmax, Mult, Tw3, 
     &                Hw3, Q3, Hw2, Tw2, Q2, H1, T1, Hu, Tu, Qu, Multx, 
     &                Posk4, Negk4, Datum
      COMMON /CH    / Rdate, Rtime, Exist3, Exist4, Exist2, Mulxst, 
     &                Existu
      COMMON /C1    / Jj, Rtptsx
      INTEGER scrunt
      LOGICAL okflag
      CHARACTER msg*40, cd*80, date*6
      EXTERNAL OPNRDF, OPNSCR, CKPTS, LOGX
      REAL LOG10
      INTRINSIC LOG10
      SAVE /IN    / , scrunt
      SAVE /RL    / 
      SAVE /CH    / 
      SAVE /C1    / 
C  NORATS - NO OF RATINGS
C  RTPTS  - NO OF POINTS PER RATING
C  NORTDT - NO OF MULT DATES
C  NOPARM(NORATS) - 2=PARM, 3 = 3-PARM RATING
C  RATCNT - COUNT OF NO OF RATINGS FOUND
C  DTCNT(NORATS)  - NO OF DATES FOUND
C  RATYP(NORATS)  - 0 = ARITH, 1 = LOG INTERP
C  RTPTSX - TEMP RTPTS
C  RATNUM - RATING NO
C  RTPTS3(NORATS) - COUNT OF TYPE3 RTPTS
C  RTPTS2(NORATS) - COUNT OF TYPE2 RTPTS
C  RTPTS1(NORATS) - COUNT OF TYPE 1-3 JCT PTS
C  RTPTSU(NORATS) - COUNT OF TYPE3-INDEFZONE
C  RDTPOS(NORATS) - COUNT OF WHICH DATE WAS LAST
C  FATFLG - FATAL FLAG
C  OFFSET(NORATS) - LOG OFFSET
C  GHDIFF(NORATS) - GH DIFF TO OPEN GATE
C  DATUM  - DATUM CORRECTION ADDED TO INPUT HW, TW
C  POSK4(NORATS)  - POSITIVE TYPE 4 K
C  NEGK4(NORATS)  - NEGATIVE TYPE 4 K
C  TYP4GH(NORATS) - TOP OF CULV FOR TYPE 4
C  TWMIN(NORATS)  - USE LIMIT Q BELOW THIS
C  HWMAX(NORATS)  - USE LIMITING Q ABOVE THIS
C  MULT(NORTDT,NORATS) - MULT FACTOR * Q
C  MULTX(NORATS)  - CURRENT MULT FACTOR
C  TW3(RTPTS,NORATS) - TYPE 3 TW
C  HW3(RTPTS,NORATS) - TYPE3 HW
C  Q3(RTPTS,NORATS)  - TYPE 3 Q
C  HW2(RTPTS,NORATS) - LIMITING Q HW
C  TW2(RTPTS,NORATS) - LIMITING Q
C  Q2(RTPTS,NORATS)  - LIMITING Q
C  H1(RTPTS,NORATS)  - WHERE TYPE 1 AND 3 JOIN
C  T1(RTPTS,NORATS)  - D. O.
C  HU(RTPTS,NORATS)  -   WHERE TYPE 3 AND H1-Z/D=1.2
C  TU(RTPTS,NORATS)  -
C  QU(RTPTS,NORATS)  -
C  TUR(RTPTS) - TEMP TU TO REVERSE ORDER
C  HUR(RTPTS) - TEMP HU TO REVERSE ORDER
C  QUR(RTPTS) - TEMP QUR TO REVERSE ORDER
C  RDATE(NORTDT,NORATS) - YYMMDD
C  RTIME(NORTDT,NORATS) - HHMM
C  EXIST3(NORATS) - TYPE 3 RAT EXISTS
C  EXIST4(NORATS) - TYPE 4 K EXISTS
C  EXIST2(NORATS) - LIMITING FLOW RAT EXISTS
C  EXIST1(NORATS) - HW-TW RATING AT TYPE 1 & 3 FLOWJCT
C  EXISTU(NORATS) - TW-Q RATING AT H1-Z/D=1.2
C  MULXST(NORATS) - DATE-MULTIPLIER TABLE EXISTS
C
      DATA scrunt/52/
C
      okflag = .FALSE.
      filen = 'BRANCH.CUL  '
      msg = 'ENTER INPUT CULVERT-RATING FILE NAME.'
      CALL OPNRDF(msg,UNO,filen,okflag)
      CALL OPNSCR(scrunt)
C
C   INITIALIZE VARIABLES:
C
      Rtptsx = RTPTS
      DO 10 i = 1, NORATS
        Rtpts3(i) = 0
        Rtpts2(i) = 0
        Rtpts1(i) = 0
        Rtptsu(i) = 0
        Existu(i) = 'N'
        Exist2(i) = 'N'
        Exist3(i) = 'N'
        Exist4(i) = 'N'
        Dtcnt(i) = 0
        Mulxst(i) = 'N'
        Multx(i) = 1.00
        Tu(1,i) = 999999.
        Rdtpos(i) = 1
        Twmin(i) = -999999.
        Hwmax(i) = 999999.
   10 CONTINUE
      ratcnt = 0
C
C    READ IN DATA:
C
      fatflg = 0
   20 READ (UNO,'(A80)',END=30,ERR=80) cd
      WRITE (scrunt,'(A78)') cd(3:80)
      BACKSPACE scrunt
      type = cd(:2)
      IF (type.EQ.'TA') THEN
        ratcnt = ratcnt + 1
        IF (ratcnt.GT.NORATS) THEN
          fatflg = 9
          WRITE (*,*) 'NUMBER OF RATINGS INPUT GREATER THAN ', NORATS
          GOTO 90
        ENDIF
        READ (cd,'(2X,I3)',ERR=80) ratnum
        READ (scrunt,*,ERR=80) idmy, Ratyp(ratnum), Offset(ratnum), 
     &                         Noparm(ratnum), Posk4(ratnum), 
     &                         Negk4(ratnum), Typ4gh(ratnum), 
     &                         Twmin(ratnum), Hwmax(ratnum), 
     &                         Ghdiff(ratnum), Datum
        IF (Ratyp(ratnum).EQ.1) THEN
          x = Twmin(ratnum) - Offset(ratnum)
          IF (x.LE.0.0) THEN
            fatflg = 4
            WRITE (*,*) 'ATTEMPT AT LOG OF NEGATIVE NUMBER IN RDRAT'
            GOTO 90
          ELSE
            Twmin(ratnum) = LOG10(x)
          ENDIF
          x = Hwmax(ratnum) - Offset(ratnum)
          IF (x.LE.0.0) THEN
            fatflg = 4
            WRITE (*,*) 'ATTEMPT AT LOG OF NEGATIVE NUMBER IN RDRAT'
            GOTO 90
          ELSE
            Hwmax(ratnum) = LOG10(x)
          ENDIF
        ENDIF
        IF (Posk4(ratnum).GT.0.0 .OR. Negk4(ratnum).GT.0.0)
     &      Exist4(ratnum) = 'Y'
      ELSEIF (type.EQ.'TD') THEN
        Mulxst(ratnum) = 'Y'
        Dtcnt(ratnum) = Dtcnt(ratnum) + 1
        Jj = Dtcnt(ratnum)
        CALL CKPTS(fatflg)
        READ (scrunt,*,ERR=80) idmy, idm2, Mult(Jj,ratnum)
        WRITE (date,'(I6.6)') idmy
        Rdate(Jj,ratnum) = date
        WRITE (date,'(I4.4)') idm2
        Rtime(Jj,ratnum) = date(:4)
      ELSE
        IF (type.EQ.'T1' .OR. type.EQ.'T2') THEN
          Exist2(ratnum) = 'Y'
          Rtpts2(ratnum) = Rtpts2(ratnum) + 1
          Jj = Rtpts2(ratnum)
          CALL CKPTS(fatflg)
          IF (type.EQ.'T2') THEN
            READ (scrunt,*,ERR=80) Q2(Jj,ratnum), Hw2(Jj,ratnum), 
     &                             Tw2(Jj,ratnum)
            BACKSPACE scrunt
          ELSE
            READ (scrunt,*,ERR=80) Q2(Jj,ratnum), Hw2(Jj,ratnum)
            Tw2(Jj,ratnum) = 999999.0
          ENDIF
          IF (Ratyp(ratnum).EQ.1)
     &        CALL LOGX(Offset(ratnum),Q2(Jj,ratnum),Hw2(Jj,ratnum),
     &        Tw2(Jj,ratnum),fatflg)
        ENDIF
        IF (type.EQ.'T3' .OR. type.EQ.'T2' .OR. type.EQ.'T4') THEN
          Exist3(ratnum) = 'Y'
          Rtpts3(ratnum) = Rtpts3(ratnum) + 1
          Jj = Rtpts3(ratnum)
          CALL CKPTS(fatflg)
          READ (scrunt,*,ERR=80) Q3(Jj,ratnum), Hw3(Jj,ratnum), 
     &                           Tw3(Jj,ratnum)
          IF (Ratyp(ratnum).EQ.1)
     &        CALL LOGX(Offset(ratnum),Q3(Jj,ratnum),Hw3(Jj,ratnum),
     &        Tw3(Jj,ratnum),fatflg)
          IF (type.EQ.'T2') THEN
            Rtpts1(ratnum) = Rtpts1(ratnum) + 1
            Jj = Rtpts1(ratnum)
            CALL CKPTS(fatflg)
            dum = Q3(Jj,ratnum)
            H1(Jj,ratnum) = Hw3(Jj,ratnum)
            T1(Jj,ratnum) = Tw3(Jj,ratnum)
            IF (Ratyp(ratnum).EQ.1)
     &          CALL LOGX(Offset(ratnum),dum,H1(Jj,ratnum),T1(Jj,ratnum)
     &          ,fatflg)
          ELSEIF (type.EQ.'T4') THEN
            Rtptsu(ratnum) = Rtptsu(ratnum) + 1
            Jj = Rtptsu(ratnum)
            CALL CKPTS(fatflg)
            Existu(ratnum) = 'Y'
            Qu(Jj,ratnum) = Q3(Jj,ratnum)
            Hu(Jj,ratnum) = Hw3(Jj,ratnum)
            Tu(Jj,ratnum) = Tw3(Jj,ratnum)
            IF (Ratyp(ratnum).EQ.1)
     &          CALL LOGX(Offset(ratnum),Qu(Jj,ratnum),Hu(Jj,ratnum),
     &          Tu(Jj,ratnum),fatflg)
          ENDIF
        ENDIF
      ENDIF
      GOTO 20
C
C  NEED AT LEAST TWO POINTS FOR A RATING:
C
   30 DO 40 i = 1, ratcnt
        IF (Rtptsu(i).LT.2) Existu(i) = 'N'
        IF (Rtpts2(i).LT.2) Exist2(i) = 'N'
        IF (Rtpts3(i).LT.2) Exist3(i) = 'N'
   40 CONTINUE
C
C  NOW, HAVE TO REVERSE THE ORDER OF THE TU,HU, AND QU DATA SO THAT
C    THE PARM2 RATING LOOKUP WILL WORK, BECAUSE IT LOOKS FOR
C    ASCENDING ORDER, NOT DESCENDING.
C
      DO 70 i = 1, ratcnt
        IF (Existu(i).EQ.'Y') THEN
          DO 50 j = 1, Rtptsu(i)
            tur(j) = Tu(Rtptsu(i)-j+1,i)
            hur(j) = Hu(Rtptsu(i)-j+1,i)
            qur(j) = Qu(Rtptsu(i)-j+1,i)
   50     CONTINUE
          DO 60 j = 1, Rtptsu(i)
            Hu(j,i) = hur(j)
            Tu(j,i) = tur(j)
            Qu(j,i) = qur(j)
   60     CONTINUE
        ENDIF
   70 CONTINUE
      CLOSE (UNO)
      CLOSE (scrunt,STATUS='DELETE')
      RETURN
   80 fatflg = 2
      WRITE (*,*) 'ERROR IN READING CULVERT-RATING FILE!'
C
   90 STOP
      END
C
      SUBROUTINE CKPTS(FATFLG)
C
C  CHECKS TO SEE IF MORE RATING POINTS HAVE BEEN
C  ENTERED THAN WERE DIMENSIONED FOR.
C
      INTEGER Rtptsx, Jj, FATFLG
      COMMON /C1    / Jj, Rtptsx
      IF (Jj.GT.Rtptsx) THEN
        FATFLG = 8
        WRITE (*,*) 'NUMBER OF RATING POINTS GREATER THAN ', Rtptsx
        STOP
      ENDIF
      RETURN
      END
C
      SUBROUTINE LOGX(OFFST,Q,HW,TW,FATFLG)
C
C  TAKES LOG OF Q,HW,AND TW, ADJUSTING FOR OFFSET
C
      REAL OFFST, Q, HW, TW, x
      INTEGER FATFLG
      REAL LOG10
      INTRINSIC LOG10
C
      Q = LOG10(Q)
      x = HW - OFFST
      IF (x.GT.0) THEN
        HW = LOG10(x)
        x = TW - OFFST
        IF (x.GT.0) THEN
          TW = LOG10(x)
          RETURN
        ENDIF
      ENDIF
      FATFLG = 4
C     TRYING TO TAKE LOG OF LE 0 NO
      WRITE (*,*) 'ATTEMPT AT LOG OF NEGATIVE NUMBER IN LOGX'
      STOP
      END
C
      SUBROUTINE PARM3(YR,MON,DAY,HR,MIN,POSRT,NEGRT,HW,TW,Q,WRNFLG,
     &                 FATFLG)
C
C   SUBROUTINE PARM3 DOES THE 2 AND 3-PARM LOOKUP.
C
C   FATAL FLAGS ARE:
C    4 = ERROR BECAUSE OF TRYING TO TAKE LOG OF A
C           NUMBER LESS THAN OR EQUAL TO ZERO
C    5 = ERROR BECAUSE MORE DATES WERE READ IN THAN ARE
C         DIMENSIONED FOR THE DATE-TIME-MULTIPLIER ARRAY
C    6 = ERROR BECAUSE A RATING TABLE WAS EXCEEDED
C    7 = ERROR BECAUSE THE SUBROUTINE WAS UNABLE TO ARRIVE
C          AT A DISCHARGE SOLUTION, PROBABLY BECAUSE OF
C          A PROGRAMMING ERROR FROM NOT PROPERLY IDENTIFYING
C          ALL SOLUTION CASES.
C    8 = ERROR BECAUSE MORE RATING POINTS WERE FOUND THAN WERE
C          DIMENSIONED FOR
C    9 = ERROR BECAUSE MORE RATINGS WERE FOUND THAN WERE
C    10 = TRIED TO DIVIDE BY ZERO IN RATING LOOKUP. TWO
C           INPUT VALUES WERE EQUAL, WHICH IS ILLEGAL.
C           DIMENSIONED FOR
C
C   RNO    - RATING NUMBER
C   NOWDT  - CURRENT YYMMDD
C   NOWTIM - CURRENT HHMM
C   IDATE  - DATE OF CHANGE OF GATE OPENING
C   ITIME  - TIME OF CHANGE OF GATE OPENING
C   I      - COUNTERS
C   HW     - HEADWATER
C   TW     - TAILWATER
C   HWUSE  - SWITCHED FOR NEG FLOW
C   TWUSE  - SWITCHED FOR NEG FLOW
C   HWIN   - INPUT HW
C   TWIN   - INPUT TW
C   QLAST  - LAST Q FOUND IN SEARCH
C   HWLAST - LAST HW FOUND IN SEARCH
C   HWTEST - CURRENT HW BEING COMPARED TO HWIN
C   H13    - HW WHERE TYPE 1 AND 3 FLOW JOIN
C   Q13    - Q AT H1-Z/D = 1.2
C   FALL   - HW - TW
C   QMAX   - Q AT HWMAX
C   X      - TEMPORARY NUMBER
C   FIRST  - FLAG FOR FIRST
      INTEGER rno, nowdt, nowtim, iyr, imon, iday, ihr, imin, idate, 
     &        itime, i
      REAL HW, TW, hwuse, twuse, hwin, twin, qlast, hwlast, hwtest, h13, 
     &     q13, fall, qmax, x
      CHARACTER first*1
C
C  THE FOLLOWING ARE DECLARATIONS FOR ITEMS INCLUDED IN COMMON BLOCKS
C    TO BE TRANSFERRED TO THE CULVERT SUBROUTINE:
C
      CHARACTER neg*1
      INTEGER NORATS, RTPTS, NORTDT
      PARAMETER (NORATS=1,RTPTS=100,NORTDT=50)
      INTEGER POSRT, NEGRT, Noparm(NORATS), Dtcnt(NORATS), xcd, 
     &        Ratyp(NORATS), Rtpts3(NORATS), Rtpts2(NORATS), 
     &        Rtpts1(NORATS), Rtptsu(NORATS), Rdtpos(NORATS), YR, MON, 
     &        DAY, HR, MIN, WRNFLG, FATFLG
      REAL Q, k4, Offset(NORATS), Ghdiff(NORATS), Datum, Posk4(NORATS), 
     &     Negk4(NORATS), Typ4gh(NORATS), Twmin(NORATS), Hwmax(NORATS), 
     &     Mult(NORTDT,NORATS), Multx(NORATS), Tw3(RTPTS,NORATS), 
     &     Hw3(RTPTS,NORATS), Q3(RTPTS,NORATS), Hw2(RTPTS,NORATS), 
     &     Tw2(RTPTS,NORATS), Q2(RTPTS,NORATS), H1(RTPTS,NORATS), 
     &     T1(RTPTS,NORATS)
      REAL Hu(RTPTS,NORATS), Tu(RTPTS,NORATS), Qu(RTPTS,NORATS)
      CHARACTER Rdate(NORTDT,NORATS)*6, Rtime(NORTDT,NORATS)*4, 
     &          Exist3(NORATS)*1, Exist4(NORATS)*1, Exist2(NORATS)*1, 
     &          Existu(NORATS)*1, Mulxst(NORATS)*1
      COMMON /IN    / Noparm, Rtpts3, Rtpts2, Rtpts1, Rtptsu, Rdtpos, 
     &                Dtcnt, Ratyp
      COMMON /RL    / Offset, Ghdiff, Typ4gh, Twmin, Hwmax, Mult, Tw3, 
     &                Hw3, Q3, Hw2, Tw2, Q2, H1, T1, Hu, Tu, Qu, Multx, 
     &                Posk4, Negk4, Datum
      COMMON /CH    / Rdate, Rtime, Exist3, Exist4, Exist2, Mulxst, 
     &                Existu
      REAL LOG10
      INTRINSIC LOG10
      EXTERNAL PARM2
      SAVE /IN    / 
      SAVE /RL    / 
      SAVE /CH    / 
C   NEG    - Y = NEG FLOW, N = POS FLOW
C   NORATS - NO OF RATINGS
C   RTPTS  - NO OF POINTS PER RATING
C   NORTDT - NO OF MULT DATES
C   POSRT  - RATING RT FOR POS FLOW
C   NEGRT  - RATING RT FOR NEG FLOW
C   NOPARM(NORATS) - 2=PARM, 3 = 3-PARM RATING
C   DTCNT(NORATS)  - NO OF DATES FOUND
C   XCD            - 0=OK, 1 = RATING EXCEEDED
C   RATYP(NORATS)  - 0 = ARITH, 1 = LOG INTERP
C   RTPTS3(NORATS) - COUNT OF TYPE3 RTPTS
C   RTPTS2(NORATS) - COUNT OF TYPE2 RTPTS
C   RTPTS1(NORATS) - COUNT OF TYPE 1-3 JCT PTS
C   RTPTSU(NORATS) - COUNT OF TYPE3-INDEFZONE
C   RDTPOS(NORATS) - COUNT OF WHICH DATE WAS LAST
C   WRNFLG - WARNING FLAG
C   FATFLG - FATAL FLAG
C   Q      - OUTPUT Q
C   OFFSET(NORATS) - LOG OFFSET
C   GHDIFF(NORATS) - GH DIFF TO OPEN GATE
C   DATUM  - DATUM CORRECTION ADDED TO INPUT HW,TW
C   K4     - K4 TO USE
C   POSK4(NORATS)  - POSITIVE TYPE 4 K
C   NEGK4(NORATS)  - NEGATIVE TYPE 4 K
C   TYP4GH(NORATS) - TOP OF CULV FOR TYPE 4
C   TWMIN(NORATS)  - USE LIMIT Q BELOW THIS
C   HWMAX(NORATS)  - USE LIMITING Q ABOVE THIS
C   MULT(NORTDT,NORATS) - MULT FACTOR * Q
C   MULTX(NORATS)  - CURRENT MULT FACTOR
C   TW3(RTPTS,NORATS)   - TYPE 3 TW
C   HW3(RTPTS,NORATS)   - TYPE3 HW
C   Q3(RTPTS,NORATS)    - TYPE 3 Q
C   HW2(RTPTS,NORATS)   - LIMITING Q HW
C   TW2(RTPTS,NORATS)   - LIMITING Q
C   Q2(RTPTS,NORATS)    - LIMITING Q
C   H1(RTPTS,NORATS)    - WHERE TYPE 1 AND 3 JOIN
C   T1(RTPTS,NORATS)    - D. O.
C   HU(RTPTS,NORATS)    - WHERE TYPE 3 AND H1-Z/D=1.2
C   TU(RTPTS,NORATS)    -
C   QU(RTPTS,NORATS)    -
C   RDATE(NORTDT,NORATS) - YYMMDD
C   RTIME(NORTDT,NORATS) - HHMM
C   EXIST3(NORATS) - TYPE 3 RAT EXISTS
C   EXIST4(NORATS) - TYPE 4 K EXISTS
C   EXIST2(NORATS) - LIMITING FLOW RAT EXISTS
C   EXIST1(NORATS) - HW-TW RATING AT TYPE 1 & 3 FLOWJCT
C   EXISTU(NORATS) - TW-Q RATING AT H1-Z/D=1.2
C   MULXST(NORATS) - DATE-MULTIPLIER TABLE EXISTS
C
      WRNFLG = 0
      FATFLG = 0
      fall = HW - TW
      IF (fall.NE.0.0) THEN
        IF (fall.LT.0.0) THEN
          hwuse = TW + Datum
          twuse = HW + Datum
          hwin = twuse
          twin = hwuse
          rno = NEGRT
          neg = 'Y'
        ELSE
          hwuse = HW + Datum
          twuse = TW + Datum
          hwin = hwuse
          twin = twuse
          rno = POSRT
          neg = 'N'
        ENDIF
        IF (Ratyp(rno).EQ.1) THEN
          x = hwin - Offset(rno)
          IF (x.LE.0.0) GOTO 20
          hwin = LOG10(x)
          x = twin - Offset(rno)
          IF (x.LE.0.0) GOTO 20
          twin = LOG10(x)
        ENDIF
C
C   CHECK FOR TIDE GATE AND SET Q = 0 FOR NEG FLOW:
C
        IF (Ghdiff(rno).GT.-999998.0 .AND. fall.LT.Ghdiff(rno)) GOTO 30
C
C   CHECK FOR MULTIPLIER, BASED ON DATE AND TIME:
C
        IF (Mulxst(rno).EQ.'Y') THEN
          i = Rdtpos(rno)
          nowdt = YR*10000 + MON*100 + DAY
          nowtim = HR*100 + MIN
          READ (Rdate(i,rno),'(3I2)') iyr, imon, iday
          idate = iyr*10000 + imon*100 + iday
          READ (Rtime(i,rno),'(2I2)') ihr, imin
          itime = ihr*100 + imin
          IF (nowdt.LT.idate) THEN
C             USE OLD VALUE:
          ELSEIF (nowdt.GT.idate) THEN
            Multx(rno) = Mult(i,rno)
            IF (Rdtpos(rno).LT.Dtcnt(rno)) Rdtpos(rno) = Rdtpos(rno) + 1
            IF (Rdtpos(rno).GT.NORTDT) THEN
              FATFLG = 5
              WRITE (*,*) ' NUMBER OF DATES INPUT GREATER THAN ', 
     &                    NORTDT, 'AT POINT 1'
C  ABOVE, 5 = TOO MANY DATES IN DATETIME - MULTIPLIER TABLE.
              GOTO 30
            ENDIF
          ELSEIF (nowtim.GE.itime .OR. nowdt.NE.idate) THEN
C                USE OLD VALUE:
            Multx(rno) = Mult(i,rno)
            IF (Rdtpos(rno).LT.Dtcnt(rno)) Rdtpos(rno) = Rdtpos(rno) + 1
            IF (Rdtpos(rno).GT.NORTDT) THEN
              FATFLG = 5
              WRITE (*,*) ' NUMBER OF DATES INPUT GREATER THAN ', 
     &                    NORTDT, 'AT POINT 2'
              GOTO 30
            ENDIF
          ENDIF
        ENDIF
C
C   CHECK FOR AND COMPUTE TYPE 4 FLOW IF APPLICABLE:
C
        IF (Exist4(rno).EQ.'Y' .AND. twuse.GE.Typ4gh(rno) .AND. 
     &      hwuse.GE.Typ4gh(rno)) THEN
          IF (neg.EQ.'Y') THEN
            k4 = Negk4(rno)
          ELSE
            k4 = Posk4(rno)
          ENDIF
          Q = k4*(hwuse-twuse)**0.5
          GOTO 40
        ENDIF
C
C  CHECK AND COMPUTE IF HW BETWEEN H1-Z/D = 1.2 AND 1.5:
C
        IF (Existu(rno).EQ.'Y' .AND. hwin.LE.Hwmax(rno)) THEN
          CALL PARM2(rno,Rtptsu(rno),Tu,Hu,twin,hwlast,xcd,FATFLG)
          IF (hwin.GE.hwlast) THEN
C        HWIN IS BETWEEN H1-Z/D = 1.2 AND 1.5
            CALL PARM2(rno,Rtptsu(rno),Tu,Qu,twin,qlast,xcd,FATFLG)
C        NOTE: ALLOW INTERPOLATION PAST LIMITS OF TABLE.
            CALL PARM2(rno,Rtpts2(rno),Hw2,Q2,Hwmax(rno),qmax,xcd,
     &                 FATFLG)
            IF (xcd.EQ.1) THEN
              FATFLG = 6
              WRITE (*,*) 
     &             'RATING TABLE DIMENSION EXCEEDED IN PARM3 AT POINT 3'
              GOTO 30
            ENDIF
            Q = qlast + (hwin-hwlast)*(qmax-qlast)/(Hwmax(rno)-hwlast)
            IF (Ratyp(rno).EQ.1) Q = 10.0**Q
            GOTO 40
          ENDIF
        ENDIF
C
C  CHECK TO SEE IF FLOW IS LIMITING FLOW Q:
C
        IF (Exist2(rno).EQ.'Y' .AND. Exist3(rno).EQ.'Y') THEN
          CALL PARM2(rno,Rtpts1(rno),T1,H1,twin,h13,xcd,FATFLG)
C         NOTE: ALLOW ABOVE TO EXCEED RATING.
        ELSE
          h13 = 999999.
        ENDIF
        IF (Noparm(rno).EQ.2 .OR. twin.LE.Twmin(rno) .OR. 
     &      hwin.GE.Hwmax(rno)) THEN
          CALL PARM2(rno,Rtpts2(rno),Hw2,Q2,hwin,Q,xcd,FATFLG)
          IF (xcd.EQ.1) THEN
            FATFLG = 6
            WRITE (*,*) 
     &             'RATING TABLE DIMENSION EXCEEDED IN PARM3 AT POINT 4'
            GOTO 30
          ENDIF
          IF (Ratyp(rno).EQ.1) Q = 10.0**Q
          GOTO 40
        ENDIF
C
C    ELSE DO A 3-PARM LOOKUP:
C
C   SEARCH FOR ZONE A:
C
        first = 'Y'
        DO 10 i = 2, Rtpts3(rno)
          IF (twin.LE.Tw3(i,rno) .AND. twin.GT.Tw3(i-1,rno)) THEN
C   FOUND IT:
            hwtest = Hw3(i-1,rno) + (Hw3(i,rno)-Hw3(i-1,rno))
     &               *(twin-Tw3(i-1,rno))/(Tw3(i,rno)-Tw3(i-1,rno))
C   BRACKED:
            IF (first.EQ.'Y') THEN
              first = 'N'
              hwlast = hwtest
              qlast = Q3(i,rno)
            ELSEIF (hwin.LT.hwtest) THEN
C   IN ZONE A:
              Q = qlast + (Q3(i,rno)-qlast)*(hwin-hwlast)
     &            /(hwtest-hwlast)
              IF (Ratyp(rno).EQ.1) Q = 10.0**Q
              GOTO 40
            ELSE
              hwlast = hwtest
              qlast = Q3(i,rno)
            ENDIF
          ENDIF
   10   CONTINUE
C
C   ELSE, IN ZONE B:
C
        IF (twin.LT.Tu(1,rno)) THEN
          CALL PARM2(rno,Rtpts2(rno),Hw2,Q2,h13,q13,xcd,FATFLG)
        ELSEIF (twin.GE.Tu(1,rno)) THEN
          CALL PARM2(rno,Rtptsu(rno),Tu,Qu,twin,q13,xcd,FATFLG)
          CALL PARM2(rno,Rtptsu(rno),Tu,Hu,twin,h13,xcd,FATFLG)
        ENDIF
        IF (xcd.EQ.1) THEN
          FATFLG = 6
          WRITE (*,*) 
     &             'RATING TABLE DIMENSION EXCEEDED IN PARM3 AT POINT 5'
          GOTO 30
        ELSE
          Q = qlast + (q13-qlast)*(hwin-hwlast)/(h13-hwlast)
          IF (Ratyp(rno).EQ.1) Q = 10.0**Q
          GOTO 40
        ENDIF
   20   FATFLG = 4
        WRITE (*,*) 'ATTEMPT AT LOG OF NEGATIVE NUMBER IN PARM3'
      ENDIF
   30 Q = 0.0
      GOTO 50
   40 Q = Multx(rno)*Q
      IF (neg.EQ.'Y') Q = -1.0*Q
   50 RETURN
      END
C
      SUBROUTINE PARM2(RATNO,NOVALS,RATIN,RATOUT,IN,OUTVAL,XCD,FATFLG)
C
C  DO RATING TABLE LOOK UP. DOES ONLY ARITHMETIC LOOKUP. IF LOG,
C  ASSUMES THAT OFFSETS AND LOG TRANSFORMS ARE ALREADY DONE.
C  ARGUMENTS:
C   4 - I*2 NOVALS = NO OF VALUES IN RATING, MAX = 100
C   5 - REAL RATIN(100,NORATS = INPUT DATA POINTS
C   6 - REAL RATOUT(100,RATNO) = OUTPUT DATA POINTS
C   7 - REAL IN = INPUT VALUE
C   8 - REAL OUTVAL = COMPUTED OUTPUT VALUE. WILL BE EXTRAPOLATED
C   9 - I*2 XCD  = 0 = NOT EXCEEDED, 1 = RATING WAS EXCEEDED
C
      INTEGER NORATS, FATFLG, RTPTS
      PARAMETER (NORATS=1,RTPTS=100)
      INTEGER NOVALS(NORATS), j, RATNO, XCD
      REAL RATIN(RTPTS,NORATS), RATOUT(RTPTS,NORATS), inval, OUTVAL, IN
      EXTERNAL INTERP
C
      inval = IN
C  CHECK TO SEE IF RATING IS EXCEEDED LOW.
      IF (IN.LT.RATIN(1,RATNO)) THEN
        CALL INTERP(inval,OUTVAL,RATIN(1,RATNO),RATIN(2,RATNO),
     &              RATOUT(1,RATNO),RATOUT(2,RATNO),FATFLG)
        XCD = 1
C  CHECK TO SEE IF RATING IS EXCEEDED HIGH.
      ELSEIF (IN.GT.RATIN(NOVALS(RATNO),RATNO)) THEN
        CALL INTERP(inval,OUTVAL,RATIN(NOVALS(RATNO)-1,RATNO),
     &              RATIN(NOVALS(RATNO),RATNO),
     &              RATOUT(NOVALS(RATNO)-1,RATNO),
     &              RATOUT(NOVALS(RATNO),RATNO),FATFLG)
        XCD = 1
      ELSE
        XCD = 0
C  NO EXCEEDS AT THIS POINT. GO AHEAD AND LOOK UP OUTVALUE.
        DO 10 j = 2, NOVALS(RATNO)
          IF (IN.LE.RATIN(j,RATNO)) THEN
            CALL INTERP(inval,OUTVAL,RATIN(j-1,RATNO),RATIN(j,RATNO),
     &                  RATOUT(j-1,RATNO),RATOUT(j,RATNO),FATFLG)
            GOTO 20
          ENDIF
   10   CONTINUE
      ENDIF
   20 RETURN
      END
C
      SUBROUTINE INTERP(IN,OUT,IN1,IN2,OUT1,OUT2,FATFLG)
C
C SUBROUTINE INTERPOLATES VALUES. DOES LOG CONVERSIONS, ALSO.
C
      REAL IN, OUT, IN1, OUT1, IN2, OUT2
      INTEGER FATFLG
      IF ((IN2-IN1).EQ.0.0) THEN
C   TRIED TO DIVIDE BY ZERO
        FATFLG = 10
        WRITE (*,*) 'ATTEMPT AT DIVIDE BY ZERO IN INTERP'
        STOP
C       RETURN
      ENDIF
      OUT = OUT1 + (IN-IN1)*(OUT2-OUT1)/(IN2-IN1)
      RETURN
      END
