      SUBROUTINE RDTRK
C
C  RDTRK Version Date = February 26, 1996
C
C  THIS SUBROUTINE TRACKS THE MOVEMENT OF INJECTED INDEX PARTICLES
C  REPRESENTING CONSERVATIVE CONSTITUENTS (OR INJECTED DYE)
C  THROUGH THE MAIN CHANNEL AND ADDITIONAL IDENTIFIED CHANNELS
C  OF A NETWORK OF OPEN-CHANNEL BRANCHES.
C
      CHARACTER errm*4
      INCLUDE 'dimens.cmn'
      INCLUDE 'lunums.cmn'
      INCLUDE 'tracer.cmn'
      INCLUDE 'comcon.cmn'
      INTEGER j, k, ibchus, ibchds
      CHARACTER lstcrd*80, msg*40
      EXTERNAL ERRCRD
C
C---READ PARTICLE TRACKING RECORDS
      WRITE (*,*) 'Read particle tracking records!'
      errm = '1ST '
C
C---READ BOUNDARY-CONDITION TYPES FOR FIRST PATH
      READ (Reader,9005,ERR=50) lstcrd, Itbcus, ibchus, Itbcds, ibchds, 
     &                          Ktpath
      Ktptbr(1) = ibchds - ibchus + 1
      DO 10 j = 1, Ktptbr(1)
        Ibrpt(j,1) = j + ibchus - 1
   10 CONTINUE
      errm = '2ND '
C
C---READ PARTICLE LOCATIONS FOR FIRST PATH
      READ (Reader,9010,ERR=50) lstcrd, (Xpart(j,1),j=1,10)
      IF (Ktcons.NE.0) READ (Reader,9010,ERR=50) lstcrd, 
     &                       (C(j,1),j=1,MXPART)
      IF (Ktpath.EQ.0) Ktpath = 1
C
C---READ PATH DEFINITIONS AND PARTICLE LOCATIONS FOR PATHS 2 THRU KTPATH
      DO 20 k = 2, Ktpath
        READ (Reader,*) Ktptbr(k)
        READ (Reader,*) (Ibrpt(j,k),j=1,Ktptbr(k))
        READ (Reader,9010,ERR=50) lstcrd, (Xpart(j,k),j=1,10)
        IF (Ktcons.NE.0) READ (Reader,9010,ERR=50) lstcrd, 
     &                         (C(j,k),j=1,MXPART)
   20 CONTINUE
      DO 40 k = 1, Ktpath
        Ktpart(k) = 10
        DO 30 j = 2, 10
          IF (Xpart(j,k).LE.0.0) Ktpart(k) = Ktpart(k) - 1
   30   CONTINUE
   40 CONTINUE
      RETURN
   50 msg = 'READING THE '//errm//'PARTICLE-TRACKING RECORD'
      CALL ERRCRD(1,lstcrd,msg)
      STOP
C
 9005 FORMAT (A80,T1,2(A2,3X,I2,4X),1X,I2)
 9010 FORMAT (A80,T1,10F8.2)
      END
C
      SUBROUTINE TRACK
C
C  TRACK Version Date = February 26, 1996
C
C  THIS SUBROUTINE TRACKS THE MOVEMENT OF INJECTED INDEX PARTICLES
C  REPRESENTING CONSERVATIVE CONSTITUENTS (OR INJECTED DYE)
C  THROUGH THE MAIN CHANNEL AND ADDITIONAL IDENTIFIED CHANNELS
C  OF A NETWORK OF OPEN-CHANNEL BRANCHES.
C
      CHARACTER*2 chrr, lb, km, mi
      CHARACTER dash*7
      INCLUDE 'dimens.cmn'
      INCLUDE 'lunums.cmn'
      INCLUDE 'logics.cmn'
      INCLUDE 'xsinit.cmn'
      INCLUDE 'dtcomp.cmn'
      INCLUDE 'branch.cmn'
      INCLUDE 'branam.cmn'
      INCLUDE 'netwrk.cmn'
      INCLUDE 'comcon.cmn'
      INCLUDE 'untmes.cmn'
      INCLUDE 'dtypes.cmn'
      INCLUDE 'units.cmn'
      INCLUDE 'bctime.cmn'
      INCLUDE 'datime.cmn'
      INCLUDE 'tracer.cmn'
      INCLUDE 'nodal.cmn'
      REAL Apart(10,5), Aopart(10,5)
      COMMON /TRAREA/ Apart, Aopart
      REAL rmconv, dxtot, xloc, xoff, xold, xnew, xdis, dxij, vij, 
     &     vijp1, vloc
      INTEGER i, j, k, l, ij, nsm1, ibch, ijindx, lbch, initfg
Ctmp  INTEGER iwrite
      LOGICAL prtday
      CHARACTER msg*62, unt*2
      EXTERNAL ERRSTP
      REAL ABS
      INTRINSIC ABS
C
      SAVE initfg
C
      DATA rmconv/1./
Ctmp  DATA iwrite/0/
      DATA dash/'------+'/, lb/' #'/, chrr/'R '/, km/'KM'/, initfg/0/, 
     &     mi/'M '/
      prtday = Kmn.EQ.0 .OR. M.EQ.1 .OR. M.EQ.Nsteps
C
C---INITIALIZE INDICES, LOCATIONS, VARIABLES, PRINTOUT, AND OUTPUT
      IF (initfg.EQ.0) THEN
        initfg = 1
        lbch = 1
C
C---ASSIGN IJ INDICES (IJPATH) AND COUNT OF INDICES (KTPTIJ)
C---OF PATHES OF TRAVEL
        DO 30 k = 1, Ktpath
C     write (*,*)
C     write (*,*) 'Ktpath    = ',k
C     write (*,*) 'Ktptbr(k) = ',Ktptbr(k)
C     write (*,*) 'Ibrpt(i,Ktpath) = '
C     write (*,*) (Ibrpt(i,k),i=1,Ktptbr(k))
          l = 0
          DO 20 i = 1, Ktptbr(k)
            ibch = Ibrpt(i,k)
            IF (i.GT.1 .AND. Ijf(ibch).NE.Ijt(lbch) .AND. 
     &          ABS(W(Ijf(ibch))+88888.88).GT.SMLVL .AND. 
     &          ABS(W(Ijt(lbch))+88888.88).GT.SMLVL) THEN
              WRITE (msg,9040) k, ibch, lbch
              CALL ERRSTP(msg)
            ENDIF
            lbch = ibch
            nsm1 = Nsec(ibch) - 1
            ij = MAXS - Xskt(ibch) + 1
            l = l + 1
            Ijpath(l,k) = ij
            DO 10 j = 1, nsm1
              l = l + 1
              ij = ij + 1
              Ijpath(l,k) = ij
   10       CONTINUE
   20     CONTINUE
          Ktptij(k) = l
C     write (*,*) 'Ijpath(j,Ktpath) = '
C     write (*,*) (Ijpath(j,k),j=1,Ktptij(k))
   30   CONTINUE
C
C---ASSIGN PATH LENGTHS (XLEN) AND DETERMINE STARTING SEGMENT
C---LOCATION (XNODE) OF ALL PARTICLES (KTPART) IN EVERY PATH (KTPATH)
        DO 70 k = 1, Ktpath
C     write (*,*)
C     write (*,*) 'Ktpath = ',k
          dxtot = 0.0
          DO 40 i = 1, Ktptij(k)
            dxtot = dxtot + Dx(Ijpath(i,k))
   40     CONTINUE
          Xlen(k) = dxtot
C     write (*,*) 'Xlen(Ktpath) = ',Xlen(k)
          ij = Ijpath(1,k)
          DO 60 i = 1, Ktpart(k)
            Outus(i,k) = .FALSE.
            Outds(i,k) = .FALSE.
            Xnode(i,k) = 0.0
C           IF (ABS(Xpart(i,k)).GT.SMLVL) THEN
            IF (Xpart(i,k).EQ.0.0) GOTO 51
              DO 50 j = 1, Ktptij(k)
                ij = Ijpath(j,k)
                Xnode(i,k) = Xnode(i,k) + Dx(ij)
C               IF (ABS(Xnode(i,k)-Xpart(i,k)).LT.SMLVL) GOTO 60
C               IF (Xnode(i,k).GT.Xpart(i,k)) THEN
C                 Xnode(i,k) = Xnode(i,k) - Dx(ij)
C                 GOTO 60
C               ENDIF
                IF (Xnode(i,k).LT.Xpart(i,k)) GOTO 50
                IF (Xnode(i,k).EQ.Xpart(i,k)) GOTO 51
                  Xnode(i,k) = Xnode(i,k) - Dx(ij)
                  GOTO 51
   50         CONTINUE
C           ENDIF
   51       CONTINUE
            Apart(i,k)=(A(ij+1)-A(ij))*((Xpart(i,k)-Xnode(i,k))
     &                 /Dx(ij))+A(ij)
C     write (*,*) 
C     write (*,*) 'ij = ',ij
C     write (*,*) 'Xnode = ',Xnode(i,k),'  Dx(ij) = ',Dx(ij),' Xpart = '
C    &            ,Xpart(i,k)
C     write (*,*) 'A(ij) = ',A(ij),' A(ij+1) = ',A(ij+1),' Apart = '
C    &            ,Apart(i,k)
   60     CONTINUE
   70   CONTINUE
C
C---INITIALIZE UNITS CONVERSION VARIABLE
        dxtot = Xlen(1)
        IF (Ounit.EQ.En) THEN
          IF (Iunit.EQ.Ounit) THEN
            rmconv = 1.0/5280.0
          ELSE
            rmconv = 3.281/5280.0
            dxtot = dxtot*3.281
          ENDIF
        ELSEIF (Iunit.EQ.Ounit) THEN
          rmconv = 1.0/1000.0
        ELSE
          rmconv = 0.3048/1000.0
          dxtot = dxtot*0.3048
        ENDIF
C
C---THE COUNT OF CONSTITUENTS VARIABLE (KTCONS) WILL SIGNAL TRANSPORT
C---SIMULATION, IF KTCONS = 0 THEN PARTICLE TRACKING ONLY
        IF (.NOT.Trnsprt) THEN
C
C---WRITE IDENTIFICATION INFORMATION TO PARTICLE-TRACK OUTPUT FILE
          WRITE (Luptrk) Netnam
          WRITE (Luptrk) Iyr, Imo, Ida, Ihr, Imn, Nyr, Nmo, Nda, Nhr, 
     &                   Nmn, Ktpath
          WRITE (Luptrk) Ktpart(1), Nsteps, Idtm, dxtot, Itbcus, Itbcds, 
     &                   Iunit, Ounit, Brname(Ibrpt(1,1)), 
     &                   Brname(Ibrpt(Ktptbr(1),1))
          DO 80 k = 2, Ktpath
            dxtot = Xlen(k)
            IF (Ounit.EQ.En .AND. Iunit.NE.Ounit) dxtot = dxtot*3.281
            IF (Ounit.NE.En .AND. Iunit.NE.Ounit) dxtot = dxtot*0.3048
            WRITE (Luptrk) Ktpart(k), dxtot, Brname(Ibrpt(1,k)), 
     &                     Brname(Ibrpt(Ktptbr(k),k))
   80     CONTINUE
C
C---PRINT TABLE HEADINGS FOR PARTICLE-TRACK PRINTOUT
          WRITE (Printr,9005) Netnam
          WRITE (Printr,9010) (dash,k=1,Ktpart(1))
          WRITE (Printr,9015) (lb,k,k=1,Ktpart(1))
          unt = mi
          IF (Ounit.NE.En) unt = km
          WRITE (Printr,9020) (chrr,unt,k=1,Ktpart(1))
          WRITE (Printr,9010) (dash,k=1,Ktpart(1))
          DO 100 k = 1, Ktpath
            DO 90 i = 1, Ktpart(k)
              Rm(i,k) = Xpart(i,k)*rmconv
   90       CONTINUE
            WRITE (Printr,9045) k, (Rm(i,k),i=1,Ktpart(k))
  100     CONTINUE
          WRITE (Printr,9010) (dash,k=1,Ktpart(1))
        ELSE
C
C---INITIALIZE ADVECTION-DISPERSION TRANSPORT SOLUTION
          CALL ADVDIS
        ENDIF
      ENDIF
C
C---DETERMINE NEW LOCATIONS OF ALL PARTICLES IN EVERY PATH
Ctmp  IF (Kda.EQ.26 .AND. Khr.EQ.20) iwrite = 1
Ctmp  IF (Kda.EQ.27 .AND. Khr.EQ.5) STOP
      DO 170 k = 1, Ktpath
        DO 160 i = 1, Ktpart(k)
          IF (.NOT.(Outus(i,k) .OR. Outds(i,k))) THEN
            xloc = Xpart(i,k)
            xoff = Xnode(i,k)
            xold = xloc
Ctmp        IF (iwrite.EQ.1)
Ctmp &          WRITE (Printr,*) xloc, xoff, xold, xdis, xnew
            DO 140 j = 1, Ktptij(k)
              ijindx = j
              ij = Ijpath(j,k)
              xold = xold - Dx(ij)
              IF (xold.GT.-SMLVL) GOTO 140
              dxij = Dx(ij)
              vij = Q(ij)/A(ij)
              vijp1 = Q(ij+1)/A(ij+1)
              xold = xold + dxij
Ctmp          IF (iwrite.EQ.1) THEN
Ctmp            WRITE (Printr,*) i, j, ij, ijindx
Ctmp            WRITE (Printr,*) xloc, xoff, xold, xdis, xnew
Ctmp            WRITE (Printr,*) vij, vijp1, vloc, dxij
Ctmp          ENDIF
C
C---INTEGRATE PARTICLE MOVEMENT OVER THE (IDTM) TIME STEP
              DO 130 l = 1, Idtm
                vloc = (vijp1-vij)*(xold/dxij) + vij
                xdis = vloc*60.0
                xnew = xold + xdis
Ctmp            IF (iwrite.EQ.1) THEN
Ctmp              WRITE (Printr,*) i, j, ij, ijindx, l
Ctmp              WRITE (Printr,*) xloc, xoff, xold, xdis, xnew
Ctmp              WRITE (Printr,*) vij, vijp1, vloc, dxij
Ctmp            ENDIF
                IF (xnew.LT.0.0) THEN
                  xloc = xoff - xold
  110             ijindx = ijindx - 1
                  IF (ijindx.GT.0) THEN
                    ij = Ijpath(ijindx,k)
                    IF (Dx(ij).LT.SMLVL) GOTO 110
                    xold = Dx(ij) + xnew
                    xoff = xoff - Dx(ij)
                  ELSE
C
C---PARTICLE OUT AT UPSTREAM END OF PATH
                    Outus(i,k) = .TRUE.
                    xloc = 0.0
                    GOTO 150
                  ENDIF
                ELSEIF (xnew.GT.dxij) THEN
                  xloc = xoff + dxij
                  xoff = xloc
  120             ijindx = ijindx + 1
                  IF (ijindx.LE.Ktptij(k)) THEN
                    ij = Ijpath(ijindx,k)
Ctmp                IF (iwrite.EQ.1) 
Ctmp &                  WRITE (Printr,*) i, j, ij, ijindx, l, Ktptij(k)
                    IF (Dx(ij).LT.SMLVL) GOTO 120
                    xold = xnew - dxij
                  ELSE
C
C---PARTICLE OUT AT DOWNSTREAM END OF PATH
                    Outds(i,k) = .TRUE.
                    xloc = Xlen(k)
                    GOTO 150
                  ENDIF
                ELSE
                  xold = xold + xdis
                  GOTO 130
                ENDIF
                dxij = Dx(ij)
                vij = Q(ij)/A(ij)
                vijp1 = Q(ij+1)/A(ij+1)
  130         CONTINUE
              xloc = xoff + xold
              GOTO 150
  140       CONTINUE
            xloc = Xlen(k)
  150       Rm(i,k) = xloc*rmconv
            Xpart(i,k) = xloc
            Xnode(i,k) = xoff
            Aopart(i,k) = Apart(i,k)
            Apart(i,k) = (A(ij+1)-A(ij))*((Xopart(i,k)-Xonode(i,k))
     &                   /dxij) + A(ij)
          ENDIF
  160   CONTINUE
  170 CONTINUE
      IF (.NOT.Trnsprt) THEN
C
C---WRITE COMPUTED PARTICLE LOCATIONS AND BOUNDARY CONDITIONS TO
C---PARTICLE-TRACK OUTPUT FILE
        IF (Itbcus.EQ.Qtype) THEN
          IF (Itbcds.EQ.Ztype) THEN
            DO 180 k = 1, Ktpath
              WRITE (Luptrk) Q(Ijpath(1,k)), Z(Ijpath(Ktptij(k),k)), 
     &                       (Rm(i,k),i=1,Ktpart(k))
  180       CONTINUE
          ELSEIF (Itbcds.EQ.Qtype) THEN
            DO 190 k = 1, Ktpath
              WRITE (Luptrk) Q(Ijpath(1,k)), Q(Ijpath(Ktptij(k),k)), 
     &                       (Rm(i,k),i=1,Ktpart(k))
  190       CONTINUE
          ENDIF
        ELSEIF (Itbcus.EQ.Ztype) THEN
          IF (Itbcds.EQ.Ztype) THEN
            DO 200 k = 1, Ktpath
              WRITE (Luptrk) Z(Ijpath(1,k)), Z(Ijpath(Ktptij(k),k)), 
     &                       (Rm(i,k),i=1,Ktpart(k))
  200       CONTINUE
          ELSEIF (Itbcds.EQ.Qtype) THEN
            DO 210 k = 1, Ktpath
              WRITE (Luptrk) Z(Ijpath(1,k)), Q(Ijpath(Ktptij(k),k)), 
     &                       (Rm(i,k),i=1,Ktpart(k))
  210       CONTINUE
          ENDIF
        ENDIF
C
C---PRINT COMPUTED PARTICLE LOCATIONS TO PARTICLE-TRACK TABLE
        IF (prtday) THEN
          WRITE (Printr,9030) Kyr, Kmo, Kda, Khr, Kmn, 
     &                        (Rm(i,1),i=1,Ktpart(1))
        ELSE
          WRITE (Printr,9025) Khr, Kmn, (Rm(i,1),i=1,Ktpart(1))
        ENDIF
        IF (Ktpath.GT.1) THEN
          DO 220 k = 2, Ktpath
            WRITE (Printr,9035) (Rm(i,k),i=1,Ktpart(k))
  220     CONTINUE
          WRITE (Printr,*)
        ENDIF
        IF (prtday) prtday = .FALSE.
        IF (M.EQ.Nsteps) WRITE (Printr,9010) (dash,i=1,Ktpart(1))
      ELSE
C
C---CALL ROUTINE TO SOLVE TRANSPORT EQUATION
        CALL ADVDIS
      ENDIF
      RETURN
C
C---OUTPUT FORMATS
 9005 FORMAT (
     &  '1CONSTITUENT PARTICLE TRACKING THROUGH AN OPEN-CHANNEL NETWORK'
     &  ,//,1X,80('='),/,1X,A80,/,1X,80('='))
 9010 FORMAT (' +',14('-'),'+',10A7)
 9015 FORMAT (' |  DATE    TIME| ',10(A2,I2,' | '))
 9020 FORMAT (' |YR/MO/DY HR:MN| ',10(1X,2A2,'| '))
 9025 FORMAT (' |',9X,I2,':',I2,'|',10(F6.2,'|'))
 9030 FORMAT (' |',I2,2('/',I2),I3,':',I2,'|',10(F6.2,'|'))
 9035 FORMAT (' |',14X,'|',10(F6.2,'|'))
 9040 FORMAT ('PARTICLE PATH',I3,' NOT CONNECTED BETWEEN BRANCH',I3,
     &        ' AND BRANCH',I3)
 9045 FORMAT (' |START PATH #',I2,'|',10(F6.2,'|'))
      END
C
      SUBROUTINE ADVDIS
C
C  ADVDIS Version Date = February 26, 1996
C
C  THIS SUBROUTINE SOLVES THE 1-D ADVECTION-DISPERSION TRANSPORT
C  EQUATION TO COMPUTE CONSTITUENT CONCENTRATIONS THROUGHOUT A
C  NETWORK OF OPEN CHANNELS.  THE SOLUTION METHOD IS AN EXTENSION
C  OF THE LAGRANGIAN PARTICLE-TRACKING FEATURE OF BRANCH.  IN THIS
C  EULERIAN-LAGRANGIAN APPROACH ADVECTIVE TRANSPORT IS COMPUTED
C  BY TRACKING INDEX PARTICLES AND INTERPOLATING THEIR ADVECTED
C  CONCENTRATION PROFILE TO A LAGRANGIAN GRID BY CUBIC SPLINES.
C  A CRANK-NICHOLSON EXPLICIT SPACE-CENTERED FINITE-DIFFERENCE
C  SCHEME IS THEN USED TO COMPUTE THE DISPERSIVE TRANSPORT.
C
      CHARACTER*2 chrr, lb, km, mi
      CHARACTER dash*7
      INCLUDE 'dimens.cmn'
      INCLUDE 'lunums.cmn'
      INCLUDE 'dtcomp.cmn'
      INCLUDE 'netwrk.cmn'
      INCLUDE 'comcon.cmn'
      INCLUDE 'untmes.cmn'
      INCLUDE 'units.cmn'
      INCLUDE 'datime.cmn'
      INCLUDE 'tracer.cmn'
      REAL Apart(10,5), Aopart(10,5)
      COMMON /TRAREA/ Apart, Aopart
      REAL brk(12), csc(4,12), xloc(12), cval(12)
      REAL amdx, apdx, am2dx, ap2dx
C     REAL vone, vten
      INTEGER i, k, initfg, nfirst, nintv, npart
      LOGICAL prtday
      CHARACTER*2 unt
      REAL CSVAL
      EXTERNAL CSAKM, CSVAL
C
      SAVE initfg
C
      DATA dash/'------+'/, lb/' #'/, chrr/'pp'/, km/'t '/, initfg/0/, 
     &     mi/'t '/
      prtday = Kmn.EQ.0 .OR. M.EQ.1 .OR. M.EQ.Nsteps
C
C---INITIALIZE INDICES, LOCATIONS, VARIABLES, PRINTOUT, AND OUTPUT
      IF (initfg.EQ.0) THEN
        initfg = 1
C
C---PRINT TABLE HEADINGS FOR CONSTITUENT CONCENTRATION OUTPUT
        WRITE (Printr,9005) Netnam
        WRITE (Printr,9010) (dash,k=1,Ktpart(1))
        WRITE (Printr,9015) (lb,k,k=1,Ktpart(1))
        unt = mi
        IF (Ounit.NE.En) unt = km
        WRITE (Printr,9020) (chrr,unt,k=1,Ktpart(1))
        WRITE (Printr,9010) (dash,k=1,Ktpart(1))
        DO 20 k = 1, Ktpath
          DO 10 i = 1, Ktpart(k)
            Xopart(i,k) = Xpart(i,k)
            Xonode(i,k) = Xnode(i,k)
C
C ==> Begin temporary code to assign initial conditions
C           C(i,k) = 10.15 + i*0.05
C           C(i,k) = 16.0+0.1*i
C ==> End temporary code to assign initial conditions
C
   10     CONTINUE
C     WRITE (Printr,'(/17H Xopart(i,k) =   ,10F7.1/)')
C    &   (Xopart(i,k),i=1,Ktpart(k))
          D(k) = Dsprsn
          WRITE (Printr,9040) k, D(k), (C(i,k),i=1,Ktpart(k))
          D(k) = D(k)*(Idtm*60.0)/(Xopart(2,k)-Xopart(1,k))**2
   20   CONTINUE
        WRITE (Printr,9010) (dash,k=1,Ktpart(1))
        RETURN
      ENDIF
C
C ==> Begin temporary code to assign boundary conditions
C     DO 30 k = 1, Ktpath
C       vone = Q(Ijpath(1,k))/A(Ijpath(1,k))
C       vten = Q(Ijpath(Ktptij(k),k))/A(Ijpath(Ktptij(k),k))
C       Xpart(1,k) = Xopart(1,k)
C       Xpart(Ktpart(k),k) = Xopart(Ktpart(k),k)
C       Cp(1,k) = 10.0 - vone/4.338*2.5
C       Cp(Ktpart(k),k) = 10.0 - vten/4.628*2.5
C     Cp(1,k) = (Z(Ijpath(1,k))+Zdatum-9.89)/3.61*5.+15.
C     Cp(Ktpart(k),k) = (Z(Ijpath(Ktptij(k),k))+Zdatum-9.35)/4.36*5.+15.
C     WRITE (Printr,*) Z(Ijpath(1,k)),Cp(1,k),Z(Ijpath(Ktptij(k),k)),
C    &                 Cp(Ktpart(k),k),vone,vten
C  30 CONTINUE
C ==> End temporary code to assign boundary conditions
C
C
C---SOLVE ADVECTION-DISPERSION EQUATION
      DO 50 k = 1, Ktpath
C     WRITE (Printr,'(/17H Xpart(i,k) =    ,10F7.1/)')
C    &   (Xpart(i,k),i=1,Ktpart(k))
        nfirst = 1
        npart = Ktpart(k)
        IF (Outus(2,k)) THEN
          nfirst = 2
          npart = npart - 1
          Cp(2,k) = Cp(1,k)
          IF (Outus(3,k)) THEN
            WRITE (Printr,'(/17H Xpart(i,k) =    ,10F7.1/)')
     &             (Xpart(i,k),i=1,Ktpart(k))
            WRITE (Printr,9045) k, 'UPSTREAM'
          ENDIF
        ENDIF
        IF (Outds(Ktpart(k)-1,k)) THEN
          npart = npart - 1
          Cp(Ktpart(k)-1,k) = Cp(Ktpart(k),k)
          IF (Outds(Ktpart(k)-2,k)) THEN
            WRITE (Printr,'(/17H Xpart(i,k) =    ,10F7.1/)')
     &             (Xpart(i,k),i=1,Ktpart(k))
            WRITE (Printr,9045) k, 'DOWNSTREAM'
          ENDIF
        ENDIF
C
C ==> Begin temporary code to assign boundary conditions
      DO 39 i = nfirst, npart
        xloc(i+1) = Xpart(i,k)
        cval(i+1) = C(i,k)
   39 CONTINUE
      xloc(1) = 2*Xopart(1,1) - Xopart(2,1)
      xloc(12) = 2*Xopart(npart,1) - Xopart(npart-1,1)
      IF (k.EQ.1) THEN
        cval(1) = 0.0
        cval(11) = 17.7+Z(Ijpath(Ktptij(k),k))-FLOAT(M)/Nsteps*6.
        cval(12) = cval(11)
      ENDIF
      IF (k.EQ.2) THEN
        cval(2) = 0.0
        cval(1) = cval(2)
        cval(12) = C(npart,2)
      ENDIF
C ==> End temporary code to assign boundary conditions
C
C       CALL CSAKM(npart,Xpart(nfirst,k),C(nfirst,k),Break,Cscoef)
C       nintv = npart - 1
C       DO 40 i = nfirst+1, npart-1
C  40     Cp(i,k) = CSVAL(Xopart(i,k),nintv,Break,Cscoef)
        CALL CSAKM(npart+2,xloc(1),cval(1),brk,csc)
        nintv = npart + 1
        DO 40 i = nfirst, npart
          Cp(i,k) = CSVAL(Xopart(i,k),nintv,brk,csc)
          IF (Cp(i,k).LT.0.0) Cp(i,k) = 0.0
   40   CONTINUE
C LOCAL CHANGE DUE TO dA/dt
        DO 42 i = nfirst, npart
         Cp(i,k) = Cp(i,k)+C(i,k)*(Apart(i,k)-Aopart(i,k))/Dt/Apart(i,k)
   42   CONTINUE
   50 CONTINUE
      DO 70 k = 1, Ktpath
        Cpt(1,k) = Cp(1,k)
        Cpt(Ktpart(k),k) = Cp(Ktpart(k),k)
        IF (Outus(2,k)) THEN
          Cpt(2,k) = Cp(1,k)
C Next assignment is to identify out-of-path particle in printout
          Cpt(1,k) = -Cp(1,k)
        ENDIF
        IF (Outds(Ktpart(k)-1,k)) THEN
          Cpt(Ktpart(k)-1,k) = Cp(Ktpart(k),k)
C Next assignment is to identify out-of-path particle in printout
          Cpt(Ktpart(k),k) = -Cp(Ktpart(k),k)
        ENDIF
C       DO 60 i = nfirst + 1, npart - 1
C         Cpt(i,k) = Cp(i,k) + D(k)*(Cp(i-1,k)-2.0*Cp(i,k)+Cp(i+1,k))
C  60   CONTINUE
        apdx = 0.5*(Apart(1,k)+Apart(2,k))
        ap2dx = 0.5*(Apart(2,k)+Apart(3,k))
        Cpt(1,k) = Cp(1,k) + D(k)*
     &    (Cp(1,k)*apdx-Cp(2,k)*apdx-Cp(2,k)*ap2dx+Cp(3,k)*ap2dx)/
     &    Apart(2,k)
        i = Ktpart(k)
        amdx = 0.5*(Apart(i,k)+Apart(i-1,k))
        am2dx = 0.5*(Apart(i-1,k)+Apart(i-2,k))
        Cpt(i,k) = Cp(i,k) + D(k)*
     &    (Cp(i-2,k)*am2dx-Cp(i-1,k)*am2dx-Cp(i-1,k)*amdx+Cp(i,k)*amdx)/
     &    Apart(i-1,k)
        DO 60 i = 2, Ktpart(k)-1
          apdx = 0.5*(Apart(i,k)+Apart(i+1,k))
          amdx = 0.5*(Apart(i,k)+Apart(i-1,k))
          Cpt(i,k) = Cp(i,k) + D(k)*
     &      (Cp(i-1,k)*amdx-Cp(i,k)*amdx-Cp(i,k)*apdx+Cp(i+1,k)*apdx)/
     &      Apart(i,k)
   60   CONTINUE
   70 CONTINUE
C
C---EXCHANGE CONCENTRATION ARRAYS (C = Cp) AND RETURN PARTICLES TO
C---ORIGINAL LOCATIONS (Xpart = Xopart) IN PREPARATION FOR NEXT TIME STEP
      DO 90 k = 1, Ktpath
        DO 80 i = 1, Ktpart(k)
          Outds(i,k) = .FALSE.
          Outus(i,k) = .FALSE.
          Xpart(i,k) = Xopart(i,k)
          Xnode(i,k) = Xonode(i,k)
          Cp(i,k) = Cpt(i,k)
          C(i,k) = Cp(i,k)
   80   CONTINUE
   90 CONTINUE
C
C---PRINT COMPUTED CONSTITUENT CONCENTRATIONS IN OUTPUT TABLE
      IF (prtday) THEN
        WRITE (Printr,9030) Kyr, Kmo, Kda, Khr, Kmn, 
     &                      (Cp(i,1),i=1,Ktpart(1))
      ELSE
        WRITE (Printr,9025) Khr, Kmn, (Cp(i,1),i=1,Ktpart(1))
      ENDIF
      IF (Ktpath.GT.1) THEN
        DO 100 k = 2, Ktpath
          WRITE (Printr,9035) (Cp(i,k),i=1,Ktpart(k))
  100   CONTINUE
        WRITE (Printr,*)
      ENDIF
      IF (prtday) prtday = .FALSE.
      IF (M.EQ.Nsteps) WRITE (Printr,9010) (dash,i=1,Ktpart(1))
C     IF (Khr.eq.16) stop
      RETURN
C
C---OUTPUT FORMATS
 9005 FORMAT ('1',17X,
     &        'CONSTITUENT TRANSPORT THROUGH AN OPEN-CHANNEL NETWORK',
     &        //,1X,86('='),/,4X,A80,/,1X,86('='))
 9010 FORMAT (' +',14('-'),'+',10A7)
 9015 FORMAT (' |  DATE    TIME| ',10(A2,I2,' | '))
 9020 FORMAT (' |YR/MO/DY HR:MN| ',10(1X,2A2,'| '))
 9025 FORMAT (' |',9X,I2.2,':',I2.2,'|',10(F6.1,'|'))
 9030 FORMAT (' |',I2.2,2('/',I2.2),I3.2,':',I2.2,'|',10(F6.1,'|'))
 9035 FORMAT (' |',14X,'|',10(F6.1,'|'))
 9040 FORMAT (' PATH',I3,'(',F7.2,')',10(F6.1,'|'))
 9045 FORMAT (' ** ERROR ** PARTICLE ADVECTED OUT OF BRANCH',I3,' AT ',
     &        A,' END, REDUCE TIME STEP OR INCREASE PARTICLE SPACING!')
      END
