      SUBROUTINE DADIO(PRINTR,MESFL,WDMFL,LIST,DSNAME,TDDBNM,RTCODE)
C
C     + + + PURPOSE + + +
C     This subroutine has been written to allow insertion into any
C     program currently using the TDDS database to convert to the
C     WDMS database.This subroutine opens the WDM and message files
C     and performs initalization on the WDM file.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER PRINTR, MESFL, WDMFL, LIST, RTCODE
      CHARACTER*48 TDDBNM, DSNAME
C
C     + + + ARGUMENT DEFINITIONS + + +
C     PRINTR - Unit number of device for output
C              of errors.
C     MESFL  - Unit number for the message file.
C     WDMFL  - The unit number the WDMS is opened on.
C     LIST   - An variable to signal a list of data base index.
C     TDDBNM - Filename of wdm file
C     DSNAME - Filename of DSR file (not used with wdm)
C     RTCODE - An variable to pass any error code generated
C              within the routine.
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'dimens.cmn'
      INCLUDE 'wdadio.cmn'
C
C     + + + SAVES + + +
      INTEGER again
      SAVE again
C
C     + + + EXTERNAL + + +
C     local
      EXTERNAL DADSUM, OPENWDM
C
C     + + + DATA INITIALIZATION + + +
      DATA again/0/
C
C     + + + END SPECIFICATIONS + + +
C
      RTCODE = 0
      IF (again.EQ.0) THEN
C---first time DADIO called, open files
        again = 1
        Messfl = MESFL
        Wdmsfl = WDMFL
        Prtfl = PRINTR
        CALL OPENWDM(Wdmsfl,Messfl,Prtfl,TDDBNM,RTCODE)
      ENDIF
      IF (LIST.NE.0) CALL DADSUM(LIST,RTCODE)
      RETURN
      END
C
      SUBROUTINE DADSUM(LIST,RTCODE)
C
C     + + + PURPOSE + + +
C     This routine prints a summary of the WDM data sets.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER LIST, RTCODE
C
C     + + + ARGUMENT DEFINITIONS + + +
C     LIST   - An variable to signal a list of data base index.
C     RTCODE - An variable to pass any error code generated
C              within the routine.
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'dimens.cmn'
      INCLUDE 'wdadio.cmn'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER iyr, imo, ida, buflen, knt, dsncnt, i, idmy, saind(12), 
     &        satyp(12), salng(12), sawid(12), sapnt(12), sgfd(12), 
     &        dpla(12), dsnbuf(300)
      CHARACTER head(5)*132, versn*64
C
C     + + + EXTERNAL + + +
C     annielib
      INTEGER WDCKDT
      EXTERNAL WDCKDT
C     local
      EXTERNAL TBABAT, SYSDATE
C
C     + + + DATA INITIALIZATION + + +
      DATA buflen/132/, knt/12/, sgfd/8*0, 8, 0, 7, 7/, dpla/8*0, 2, 0, 
     &     1, 1/
      DATA saind/2, 1, 33, 17, 84, 85, 27, 83, 32, 34, 12, 13/
      DATA satyp/3, 3, 6*1, 2, 1, 2, 2/, salng/16, 4, 10*1/
      DATA sawid/16, 4, 4, 1, 1, 1, 4, 1, 10, 1, 8, 8/
      DATA sapnt/38, 56, 62, 71, 77, 84, 89, 97, 100, 114, 116, 124/
C
C     + + + END SPECIFICATIONS + + +
C
      versn = '@(#) wdadio - Storage/retrieval routines to access a WDM'
      versn = '@(#) wdadio - Contact: R. Steven Regan, rsregan@usgs.gov'
      versn = '@(#) wdadio - Version: 6.0 1997/03/14'
      head(1) = 
     & '$Id: wdadio.f,v 6.0 1997/03/14 20:28:09 rsregan Exp rsregan $'
C     this string (characters 5-40) is used for labeling printouts.
      versn = 'Version: '//head(1)(17:30)
C
      CALL SYSDATE(iyr,imo,ida)
      RTCODE = 0
      IF (LIST.NE.0) THEN
        head(1) = 
     &' ================================================================
     &==================================================================
     &='
        head(5) = head(1)
        head(2) = 
     &'  DATA       PERIOD OF RECORD             STATION     DATA   TIME
     &   TIME  DATA   VAR.   BASE  COM-    FILLER  GROUP MINIMUM MAXIMUM
     &'
        head(3) = 
     &'   SET   BEGINNING        ENDING      IDENTIFICATION  TYPE   STEP
     &  UNITS  FORM  T-STEP  YEAR  PRESS   VALUE    UNIT  VALUE   VALUE'
        head(4) = 
     &'    NO   DATE/TIME      DATE/TIME          STAID     TSTYPE TSSTE
     &P TCODE TSFORM VBTIME TSBYR COMPFG   TSFILL  TGROUP MINVAL  MAXVAL
     &'
        WRITE (Prtfl,9005) versn(1:23), iyr, imo, ida
        dsncnt = 0
        dsnbuf(1) = 1
        DO 10 i = 1, 32000
          idmy = WDCKDT(Wdmsfl,i)
          IF (idmy.NE.0) THEN
            dsncnt = dsncnt + 1
            dsnbuf(dsncnt) = i
            IF (dsncnt.EQ.300) GOTO 20
          ENDIF
   10   CONTINUE
   20   CALL TBABAT(Wdmsfl,Prtfl,buflen,head,knt,dsncnt,dsnbuf,saind,
     &              satyp,salng,sawid,sapnt,sgfd,dpla)
        WRITE (Prtfl,'(A132)') head(1)(:132)
      ENDIF
      RETURN
 9005 FORMAT ('1',//,T51,'Directory of Data Sets in the WDM File',//,
     &        T38,'Processed using WDADIO Routines: ',A,//,T63,
     &        '# # # #',//,T55,'Processing Date',I3.2,2('/',I2.2),/)
      END
C
      SUBROUTINE DADO(STATN,TYPE,STYP,BY,BMO,BD,BH,BMN,EY,EMO,ED,EH,EMN,
     &                RDPDY,DATA,DUMMY,PRTMSG,RTCODE)
C
C     + + + PURPOSE + + +
C     This subroutine is used to replace the TDDS DADI subroutine
C     which retreives data from the TDDB. This routine will
C     retrieve data from the WDMS and return the data in the
C     buffer DATA.
C
C     + + + DUMMY ARGUMENTS + + +
      CHARACTER STATN*16
      INTEGER BY, BMO, BD, BH, BMN, EY, EMO, ED, EH, EMN, RDPDY, DUMMY, 
     &        RTCODE
      INTEGER*2 DATA(*)
      CHARACTER*2 TYPE, STYP
      LOGICAL PRTMSG
C
C     + + + ARGUMENT DEFINITIONS + + +
C     STATN  - Station ID number
C     TYPE   - Data type as C*2
C     STYP   - Storage type for data (I2, I4, R4, or R8)
C     BY     - Beginning year.
C     BMO    -    "      month.
C     BD     -    "      day.
C     BH     -    "      hour.
C     BMN    -    "      minute.
C     EY     - Ending year.
C     EMO    -   "    month.
C     ED     -   "    day.
C     EH     -   "    hour.
C     EMN    -   "    minute.
C     RDPDY  - Readings per day.
C     DATA   - Buffer for data transfer to calling program.
C     DUMMY  - Dummy variable to allow the padding of parameter list.
C     PRTMSG - Flag to indicate whether or not to print error messages.
C     RTCODE - Variable to pass error condition back to calling prog.
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'dimens.cmn'
      INCLUDE 'wdadio.cmn'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER bdate(6), edate(6), idate(6), ndate(6), btime, etime, 
     &        itime, ntime, idmy, delt, nval, tunits, dsno(10), dtran, 
     &        quaflg, i, retc, dstype, dsnum, gpflg, retcd, nstp
      CHARACTER type4*4
C
C     + + + INTRINSICS + + +
      INTEGER IFIX
      REAL SIGN
      DOUBLE PRECISION DBLE
      INTRINSIC IFIX, SIGN, DBLE
C
C     + + + EXTERNALS + + +
C     annielib
      EXTERNAL WDTGET
C     local
      EXTERNAL FNDDSN, WDTCOD
C
C     + + + DATA INITIALIZATION + + +
      DATA tunits, dtran, quaflg, dstype, gpflg/2, 0, 0, 1, 1/
C
C     + + + END SPECIFICATIONS + + +
C
      RTCODE = 0
      retc = 0
      dsno(1) = 1
      nval = 1
C
C---compute time step
      delt = 1440/RDPDY
C
C---set TYPE2 eq to TYPE
      type4 = TYPE//'  '
C
C---load date/time into arrays.
C---get number of values for period of request
      CALL BACKDT(BY,BMO,BD,BH,BMN,EY,EMO,ED,EH,EMN,delt,bdate,edate,
     &            nval,RTCODE)
      IF (RTCODE.NE.0) GOTO 80
C
C---find data set number
      CALL FNDDSN(Wdmsfl,dstype,STATN,type4,tunits,delt,dsno,retc)
      IF (retc.EQ.1 .AND. TYPE.EQ.' Q') THEN
        type4 = 'FLOW'
        CALL FNDDSN(Wdmsfl,dstype,STATN,type4,tunits,delt,dsno,retc)
      ENDIF
      IF (retc.EQ.1) THEN
C
C---found no dataset
        RTCODE = 7
        GOTO 80
      ELSEIF (retc.LT.0) THEN
C
C---more than 1 dataset
        CALL WDTCOD(bdate,btime)
        CALL WDTCOD(edate,etime)
        DO 10 i = 1, -retc
          CALL WTFNDT(Wdmsfl,dsno(i),gpflg,idmy,idate,ndate,retcd)
          IF (retcd.NE.0) THEN
            RTCODE = 14
            GOTO 80
          ENDIF
          CALL WDTCOD(idate,itime)
          CALL WDTCOD(ndate,ntime)
          IF (btime.GE.itime .AND. btime.LT.ntime .AND. 
     &        etime.GE.itime .AND. etime.LE.ntime) THEN
            dsnum = dsno(i)
            GOTO 20
          ENDIF
   10   CONTINUE
        RTCODE = 14
        GOTO 80
      ENDIF
      dsnum = dsno(1)
C
C---retrieve data from WDM file
   20 CALL WDTGET(Wdmsfl,dsnum,delt,bdate,nval,dtran,quaflg,tunits,
     &            Rdata,retc)
      IF (retc.EQ.-10) THEN
C
C---set RTCODE to 7 for no data in file
        RTCODE = 7
        GOTO 80
      ENDIF
C
C---Put data in equivalenced data buffer
      IF (STYP.EQ.'I2') THEN
C---data values needed are integer*2
        DO 30 i = 1, nval
          Datai2(i) = IFIX(Rdata(i)*100.0+SIGN(0.5,Rdata(i)))
   30   CONTINUE
      ELSEIF (STYP.EQ.'I4') THEN
C---data values needed are integer*4
        DO 40 i = 1, nval
          Datai4(i) = IFIX(Rdata(i)*100.0+SIGN(0.5,Rdata(i)))
   40   CONTINUE
      ELSEIF (STYP.EQ.'R4') THEN
C---data values are Real*4
        DO 50 i = 1, nval
          Datar4(i) = Rdata(i)
   50   CONTINUE
      ELSEIF (STYP.EQ.'R8') THEN
C---data values needed are Double precision
        DO 60 i = 1, nval
          Datar8(i) = DBLE(Rdata(i))
   60   CONTINUE
      ELSE
        RTCODE = 5
        GOTO 80
      ENDIF
C
      nstp = 1
      IF (STYP(2:2).EQ.'4') nstp = 2
      IF (STYP(2:2).EQ.'8') nstp = 4
      DO 70 i = 1, nval*nstp
        DATA(i) = Datai2(i)
   70 CONTINUE
C
   80 IF (RTCODE.NE.0 .AND. PRTMSG) THEN
        IF (RTCODE.EQ.3) WRITE (Prtfl,9005)
        IF (RTCODE.EQ.14) WRITE (Prtfl,9010) -retc
        IF (RTCODE.EQ.7) WRITE (Prtfl,9015)
        WRITE (Prtfl,9020) STATN, BY, BMO, BD, BH, BMN, EY, EMO, ED, EH, 
     &                     EMN, RDPDY, TYPE
      ENDIF
      RETURN
 9005 FORMAT (' $$$ DATE AND(OR) TIME IS ERRANT $$$')
 9010 FORMAT (' $$$',I3,
     &        ' DATA SETS FOUND IN WDM MATCHING SEARCH ATTRIBUTES $$$')
 9015 FORMAT (' $$$ NO DATA AVAILABLE FOR TIME SPAN OF REQUEST $$$')
 9020 FORMAT (/5X,'(STATION NUMBER "',A16,'" ; TIME SPAN =',I3.2,
     &        2('/',I2.2),I3.2,':',I2.2,' TO',I3.2,2('/',I2.2),I3.2,':',
     &        I2.2,'; VALUES PER DAY =',I4,'; DATA TYPE = ',A2,')'/)
      END
C
      SUBROUTINE DADI(STATN,TYPE,STYP,BY,BMO,BD,BH,BMN,EY,EMO,ED,EH,EMN,
     &                RDPDY,DATA,DUMMY,PRTMSG,RTCODE)
C
C     + + + PURPOSE + + +
C     This subroutine is used to replace the TDDS DADO subroutine
C     which places data in the TDDB. This routine will
C     retrieve data through the buffer DATA and store the data
C     into the WDMS.
C
C     + + + DUMMY ARGUMENTS + + +
      CHARACTER*16 STATN
      INTEGER BY, BMO, BD, BH, BMN, EY, EMO, ED, EH, EMN, RDPDY, DUMMY, 
     &        RTCODE
      INTEGER*2 DATA(*)
      CHARACTER*2 TYPE, STYP
      LOGICAL PRTMSG
C
C     + + + ARGUMENT DEFINITIONS + + +
C     STATN  - Station ID number
C     TYPE   - Data type as C*2
C     BY     - Beginning year.
C     BMO    -    "      month.
C     BD     -    "      day.
C     BH     -    "      hour.
C     BMN    -    "      minute.
C     EY     - Ending year.
C     EMO    -   "    month.
C     ED     -   "    day.
C     EH     -   "    hour.
C     EMN    -   "    minute.
C     RDPDY  - Readings per day.
C     DATA   - Buffer for data transfer to WDM file.
C     DUMMY  - Dummy variable to allow the padding of parameter list.
C     PRTMSG - Flag to indicate whether or not to printer error messages.
C     RTCODE - Variable to pass error condition back to calling prog.
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'dimens.cmn'
      INCLUDE 'wdadio.cmn'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER bdate(6), edate(6), sdat(6), edat(6), one, ise, iee, ieb, 
     &        isb, tsbyr, numr, dsn, delt, nval, tunits, dsno(10), zero, 
     &        i, idmy, dstype, retc, tsform, dsnum, nstp
      REAL miss, minval, maxval
      CHARACTER stnam*48, type4*4
C
C     + + + FUNCTIONS + + +
      INTEGER WDCKDT
C
C      + + + INTRINSIC + + +
      REAL FLOAT, SNGL
      INTRINSIC FLOAT, SNGL
C
C     + + + EXTERNALS + + +
C     annielib
      EXTERNAL WDTPUT, WDCKDT, WTFNDT, CKDATE, WTDDEL
C     local
      EXTERNAL FNDDSN, WCRDSN
C
C     + + + DATA INITIALIZATION + + +
      DATA zero, one, dsn/0, 1, 0/
C
C     + + + END SPECIFICATIONS + + +
      type4 = TYPE//'  '
      RTCODE = 0
      dstype = 1
      tunits = 2
C
C---compute time step
      delt = 1440/RDPDY
C
C---load date/time into arrays.
      CALL BACKDT(BY,BMO,BD,BH,BMN,EY,EMO,ED,EH,EMN,delt,bdate,edate,
     &            nval,RTCODE)
      IF (RTCODE.NE.0) GOTO 90
      dsno(1) = 0
      stnam = 'BRANCH COMPUTED DATA SET'
      miss = -999999.0
      tsform = 3
      tsbyr = bdate(1)
C
C---find data set number
      CALL FNDDSN(Wdmsfl,dstype,STATN,type4,tunits,delt,dsno,retc)
      IF (retc.LT.1) THEN
        dsnum = dsno(1)
        i = 2
        numr = -retc
C
C---IF RETC IS LESS THAN 0, THEN MORE THAN ONE DATA SET FOUND, USE
C---CONSECUTIVE DS # TO SEE IF ANOTHER SHOULD BE CREATED.
C---found dataset, check existence of data
   10   CALL WTFNDT(Wdmsfl,dsnum,one,idmy,sdat,edat,retc)
        IF (retc.EQ.0) THEN
C
C---data exists, check end date
          CALL CKDATE(sdat,bdate,isb)
          CALL CKDATE(edat,edate,iee)
          IF (isb.EQ.-1 .AND. iee.EQ.1) THEN
C
C---DATA SET TIME PERIOD IS SUBSET OF DATA SET, SDAT<BDATE & EDAT>EDATE
            RTCODE = 8
            GOTO 90
          ENDIF
          CALL CKDATE(edat,bdate,ieb)
          CALL CKDATE(sdat,edate,ise)
          IF (ieb.EQ.-1 .OR. ise.EQ.1) THEN
C
C---STORAGE TIME PERIOD IS NOT IN DATA SET, EDAT<BDATE OR SDAT>EDATE
            IF (i.LE.numr) THEN
C
C---SEQUENCE THROUGH OTHER DATA SET FOUND THAT MATCH SEARCH ATTRIBUTES
              dsnum = dsno(i)
              i = i + 1
              GOTO 10
            ELSE
C
C---FIND NEXT CONSECUTIVE DATA SET NUMBER THAT DOESN'T EXIST AND
C---AND ADD NEW DATA SET TO WDM
   20         dsnum = dsnum + 1
              idmy = WDCKDT(Wdmsfl,dsnum)
              IF (idmy.NE.0) GOTO 20
              CALL WCRDSN(Messfl,Wdmsfl,Prtfl,dstype,one,STATN,tunits,
     &                    delt,type4,stnam,miss,tsform,tsbyr,dsn,dsnum, 
     &                    retc)
              dsn = dsnum
            ENDIF
          ELSEIF ((isb.EQ.0 .AND. iee.EQ.0) .OR. 
     &            (ieb.EQ.1 .AND. iee.LT.1)) THEN
C
C---Delete data from BDATE to end of file
C---EITHER DATA SET COMPLETLY OVERLAPS IN TIME AN EXISTING DATA SET,
C---SDAT=BDATE AND EDAT=EDATE, OR THE NEW DATA SET CAN BE APPENDED
C---TO AN EXISTING DATA SET, POSSIBLY OVERWRITING PART OF THE EXISTING
C---DATA SET, EDAT>BDATE AND EDAT<=EDATE
            CALL WTDDEL(Wdmsfl,dsnum,bdate,one,retc)
          ENDIF
        ENDIF
      ELSE
C
C---No dataset # found therefore create one
        CALL WCRDSN(Messfl,Wdmsfl,Prtfl,dstype,zero,STATN,tunits,delt,
     &              type4,stnam,miss,tsform,tsbyr,dsn,dsnum,retc)
        dsn = dsnum
      ENDIF
C
C---Put data in equivalenced data buffer
      nstp = 1
      IF (STYP(2:2).EQ.'4') nstp = 2
      IF (STYP(2:2).EQ.'8') nstp = 4
      DO 30 i = 1, nval*nstp
        Datai2(i) = DATA(i)
   30 CONTINUE
      IF (STYP.EQ.'I2') THEN
C---data values are integer*2
        DO 40 i = 1, nval
          Rdata(i) = FLOAT(Datai2(i))*0.01
   40   CONTINUE
      ELSEIF (STYP.EQ.'I4') THEN
C---data values are integer*4
        DO 50 i = 1, nval
          Rdata(i) = FLOAT(Datai4(i))*0.01
   50   CONTINUE
      ELSEIF (STYP.EQ.'R4') THEN
C---data values are Real*4
        DO 60 i = 1, nval
          Rdata(i) = Datar4(i)
   60   CONTINUE
      ELSEIF (STYP.EQ.'R8') THEN
C---data values are Double precision
        DO 70 i = 1, nval
          Rdata(i) = SNGL(Datar8(i))
   70   CONTINUE
      ELSE
        RTCODE = 5
        GOTO 90
      ENDIF
C
C---ADD MINIMUM AND MAXIMUM VALUES (ALSO UPDATE IF THERE)
      CALL WDBSGR(Wdmsfl,dsnum,12,1,minval,retc)
      IF (retc.NE.0) minval = 999999.0
      CALL WDBSGR(Wdmsfl,dsnum,13,1,maxval,retc)
      IF (retc.NE.0) maxval = -99999.0
      DO 80 i = 1, nval
        IF (Rdata(i).GT.maxval) maxval = Rdata(i)
        IF (Rdata(i).LT.minval) minval = Rdata(i)
   80 CONTINUE
      CALL WDBSAR(Wdmsfl,dsnum,Messfl,12,1,minval,retc)
      CALL WDBSAR(Wdmsfl,dsnum,Messfl,13,1,maxval,retc)
C
C---store data into WDM file
      CALL WDTPUT(Wdmsfl,dsnum,delt,bdate,nval,zero,zero,tunits,Rdata,
     &            retc)
C
C---set RTCODE = 8 if data previously stored
      IF (retc.EQ.-9) RTCODE = 8
   90 IF (RTCODE.NE.0 .AND. PRTMSG) THEN
        IF (RTCODE.EQ.3) WRITE (Prtfl,9005)
        IF (RTCODE.EQ.8) WRITE (Prtfl,9010)
        WRITE (Prtfl,9015) STATN, BY, BMO, BD, BH, BMN, EY, EMO, ED, EH, 
     &                     EMN, RDPDY, TYPE
      ENDIF
      RETURN
 9005 FORMAT (' $$$ DATE AND(OR) TIME IS ERRANT $$$')
 9010 FORMAT (' $$$ DATA PREVIOUSLY STORED FOR TIME SPAN $$$')
 9015 FORMAT (/5X,'(STATION NUMBER "',A16,'" ; TIME SPAN =',I3.2,
     &        2('/',I2.2),I3.2,':',I2.2,' TO',I3.2,2('/',I2.2),I3.2,':',
     &        I2.2,'; VALUES PER DAY =',I4,'; DATA TYPE = ',A2,')'/)
      END
C
      SUBROUTINE OPENWDM(WDMFL,MESFL,PRINTR,TDDBNM,RTCODE)
C
C     + + + PURPOSE + + +
C     This subroutine has been written to allow insertion into any
C     program currently using the TDDS database to convert to the
C     WDMS database.This subroutine opens the WDM and message files.
C
C     + + + DUMMY ARGUMENTS + + +
      CHARACTER TDDBNM*48
      INTEGER PRINTR, MESFL, WDMFL, RTCODE
C
C     + + + ARGUMENT DEFINITIONS + + +
C     PRINTR - Unit number of device for output
C              of errors.
C     MESFL  - Unit number for the message file.
C     WDMFL  - The unit number the WDMS is opened on.
C     TDDBNM - File name of the time-dependent data base.
C     RTCODE - An variable to pass any error code generated within the
C              routine.
C
C     + + + LOCAL VARIABLES + + +
      INTEGER retc, iflg
      LOGICAL exist
      CHARACTER*48 msgnm
C
C     + + + EXTERNALS + + +
C     annielib
      EXTERNAL WDBOPN
C
C     + + + END SPECIFICATIONS + + +
C
C     open WDM file
      INQUIRE (FILE=TDDBNM,EXIST=exist)
      IF (.NOT.exist) THEN
        iflg = 2
        CALL WDBOPN(WDMFL,TDDBNM,iflg,retc)
      ELSE
        iflg = 0
        CALL WDBOPN(WDMFL,TDDBNM,iflg,retc)
      ENDIF
      IF (retc.EQ.0) THEN
C
C---OPEN MESSAGE FILE
        INCLUDE 'msgfil.inc'
        iflg = 1
        CALL WDBOPN(MESFL,msgnm,iflg,retc)
        IF (retc.NE.0) THEN
          RTCODE = -4
          WRITE (PRINTR,9010)
        ENDIF
      ELSE
        WRITE (PRINTR,9005)
C
C---SET RTCODE TO REFLECT ERROR IN OPENING WDM FILE
        RTCODE = -9
      ENDIF
      RETURN
 9005 FORMAT (/,
     &' $$$ AN ERROR WAS ENCOUNTERD IN OPENING WDM FILE, CHECK FOR CORRE
     &CT FILE NAME $$$')
 9010 FORMAT (/,
     &' $$$ AN ERROR WAS ENCOUNTERED OPENING THE MESSAGE FILE, CONTACT S
     &UPPORT PERSONNEL $$$')
      END
C
      SUBROUTINE TBABAT(WDMSFL,FUNIT,BUFLEN,HEAD,KNT,DSNCNT,DSNBUF,
     &                  SAIND,SATYP,SALNG,SAWID,SAPNT,SGFD,DPLA)
C
C     LAST MODIFIED APRIL 13, 1992 -- RSR
C
C     + + + PURPOSE + + +
C     This routine outputs in table format a list of given attributes
C     for the datasets found in ARRAY DSNBUF.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER WDMSFL, FUNIT, BUFLEN, lines, KNT, DSNCNT
      INTEGER SAIND(KNT), SATYP(KNT), SALNG(KNT), SAWID(KNT), SAPNT(KNT)
     &        , SGFD(KNT), DPLA(KNT), DSNBUF(DSNCNT)
      CHARACTER HEAD(5)*132, buf(132)*1, buff*132
      EQUIVALENCE (buf(1),buff)
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - Fortran unit number of WDM file
C     FUNIT  - Fortran unit number of output table
C     BUFLEN - width of output table
C     LINES  - number of lines per screen/page for output
C     HEAD   - output buffer containing the title and table headings
C     KNT    - number of attributes to be output to the table
C     DSNCNT - number of datasets in DSN buffer
C     DSNBUF - array of datasets in buffer
C     SAIND  - search attribute index numbers
C     SATYP  - search attribute types
C              1 - integer
C              2 - real
C              3 - character
C     SALNG  - search attribute length, in words
C     SAWID  - width allowed for search attribute in output table
C     SAPNT  - starting position pointer in output buffer for table
C     SGFD   - number of significant digits for real search attribute
C     DPLA   - number of decimal places for real search attributes
C
C     + + + LOCAL VARIABLES + + +
      INTEGER savali(1), strt(6), fnsh(6), retc, kount, jr, gpflg, idmy, 
     &        i, k, j, n
      REAL savalr
      CHARACTER savalc*80
      CHARACTER*14 date
C
C     + + + EXTERNALS + + +
C     annielib
      EXTERNAL WTFNDT, WDBSGI, WDBSGR, INTCHR, DECCHX, WDBSGC
C
C     + + + DATA INITIALIZATIONS + + +
      DATA jr, gpflg, lines/0, 1, 62/
C
C     + + + END SPECIFICATIONS + + +
C
C     write out title and table headings
      retc = 0
      kount = 13
      DO 10 k = 1, 5
        WRITE (FUNIT,9005) HEAD(k)(1:BUFLEN)
   10 CONTINUE
C
      DO 40 i = 1, DSNCNT
C
C---put dataset number in output buffer
        buff = '        '
        WRITE (buff,'(I6)') DSNBUF(i)
C
C---try to get begin and end dates
        CALL WTFNDT(WDMSFL,DSNBUF(i),gpflg,idmy,strt,fnsh,retc)
        IF (retc.EQ.0) THEN
C
C---add dates to output buffer
          strt(1) = strt(1) - strt(1)/100*100
          fnsh(1) = fnsh(1) - fnsh(1)/100*100
          WRITE (date,9015) (strt(j),j=1,5)
          buff(8:21) = date
          WRITE (date,9015) (fnsh(j),j=1,5)
          buff(23:36) = date
        ENDIF
C
        DO 20 k = 1, KNT
C
C---get search attribute values
          IF (SATYP(k).EQ.1) THEN
C
C---integer attribute
            CALL WDBSGI(WDMSFL,DSNBUF(i),SAIND(k),SALNG(k),savali,retc)
            IF (retc.EQ.0) CALL INTCHR(savali(1),SAWID(k),jr,idmy,
     &                                 buf(SAPNT(k)))
          ELSEIF (SATYP(k).EQ.2) THEN
C
C---real attribute
            CALL WDBSGR(WDMSFL,DSNBUF(i),SAIND(k),SALNG(k),savalr,retc)
            IF (retc.EQ.0) CALL DECCHX(savalr,SAWID(k),SGFD(k),DPLA(k),
     &                                 buf(SAPNT(k)))
          ELSEIF (SATYP(k).EQ.3) THEN
C
C---character attribute
            CALL WDBSGC(WDMSFL,DSNBUF(i),SAIND(k),SALNG(k),savalc,retc)
            IF (retc.EQ.0) THEN
              j = SAPNT(k)
              n = j + SALNG(k) - 1
              buff(j:n) = savalc(:SALNG(k))
            ENDIF
          ENDIF
   20   CONTINUE
        WRITE (FUNIT,'(132A1)') (buf(j),j=1,BUFLEN)
        kount = kount + 1
        IF (kount.GE.lines) THEN
C
C---start new screen/page
          WRITE (FUNIT,9010)
C
C---write out title and table headings
          DO 30 k = 1, 5
            WRITE (FUNIT,9005) HEAD(k)(1:BUFLEN)
   30     CONTINUE
          kount = 8
        ENDIF
C
   40 CONTINUE
C
      RETURN
C
C     + + + OUTPUT FORMATS + + +
 9005 FORMAT (A132)
 9010 FORMAT ('1',//)
 9015 FORMAT (I2,2('/',I2),1X,I2,':',I2)
      END
C
      SUBROUTINE BACKDT(BYR,BMO,BDA,BHR,BMN,EYR,EMO,EDA,EHR,EMN,DT,
     &                  BDATE,EDATE,NVAL,RTCODE)
C
C     LAST MODIFIED October 8, 1993 -- RSR
C
C     + + + PURPOSE + + +
C     This subroutine is used to subtract one time interval from a
C     time period request so that the correct number of values
C     will be retrieved from a WDM.  Needed because of a conflict
C     in time conventions between BRANCH and WDMS, BRANCH needs
C     instaneous values, WDM provides time interval averaged.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER DT, BDATE(6), EDATE(6), NVAL, RTCODE, BYR, BMO, BDA, BHR, 
     &        BMN, EYR, EMO, EDA, EHR, EMN
C
C     + + + ARGUMENT DEFINITIONS + + +
C     BYR    - Beginning year.
C     BMO    -    "      month.
C     BDA    -    "      day.
C     BHR    -    "      hour.
C     BMN    -    "      minute.
C     EYR    - Ending year.
C     EMO    -   "    month.
C     EDA    -   "    day.
C     EHR    -   "    hour.
C     EMN    -   "    minute.
C     DT     - Time interval (delta T).
C     BDATE  - WDM beginning date array.
C     EDATE  - WDM ending date array.
C     NVAL   - Number of values for time period at DT.
C     RTCODE - Variable to pass error condition back to calling prog.
C     . . .
C
      INTEGER yr, mo, da, hr, mn, idmy, belt, eelt, i, iret
C
      CALL DTCODE(BYR,BMO,BDA,BHR,BMN,idmy,belt,iret)
      IF (iret.EQ.0) THEN
        belt = belt - DT
        yr = BYR
        CALL DATCOD(belt,yr,mo,da,hr,mn)
        IF (belt.EQ.0) belt = 525600 + (4-(yr-yr/4*4))/4*1440
        CALL DTCODE(EYR,EMO,EDA,EHR,EMN,idmy,eelt,iret)
        IF (iret.EQ.0) THEN
          IF (yr.LE.EYR) THEN
            idmy = yr
            DO 10 i = 1, EYR - yr
              eelt = eelt + 525600 + (4-(idmy-idmy/4*4))/4*1440
              idmy = idmy + 1
   10       CONTINUE
            NVAL = (eelt-belt)/DT
            BDATE(1) = yr + 1900
            BDATE(2) = mo
            BDATE(3) = da
            BDATE(4) = hr
            BDATE(5) = mn
            BDATE(6) = 0
            EDATE(1) = EYR + 1900
            EDATE(2) = EMO
            EDATE(3) = EDA
            EDATE(4) = EHR
            EDATE(5) = EMN
            EDATE(6) = 0
            GOTO 20
          ENDIF
        ENDIF
      ENDIF
      RTCODE = 3
   20 RETURN
      END
C
      SUBROUTINE FNDDSN(WDMSFL,DSTYPE,STA,TSTYPE,TUNITS,TSSTEP,DSNO,
     &                  RETC)
C
C     LAST MODIFIED APRIL 13, 1992 -- RSR
C
C     + + + PURPOSE + + +
C     This routine searches for a single data set with the
C     specified attributes.  The dataset type and station
C     number are required, the rest of the attributes are
C     optional.
C
C     + + + KEYWORDS + + +
C     message file, WDM file, search attributes
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER WDMSFL, DSTYPE, TUNITS, TSSTEP, DSNO(10), RETC
      CHARACTER STA*16, TSTYPE*4
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - Fortran unit number of WDM file
C     DSTYPE - dataset type (required)
C              1 - timeseries
C              2 - table
C     STA    - station number (required)
C     TSTYPE  - type of data in dataset
C              (blank if not used)
C     TUNITS - time units code
C              0 - no time unit    4 - days
C              1 - seconds         5 - months
C              2 - minutes         6 - years
C              3 - hours
C     TSSTEP - timestep, in TUNITS units
C              0 if no timestep
C     DSNO   - datset numbers found
C     RETC   - return code
C                1 - found no datasets
C                0 - found 1 dataset
C              <-1 - found more than 1 dataset
C
C     + + + LOCAL VARIABLES + + +
      INTEGER len4, ipt, i, dsnmin, dsnmax, maxdsn, sacnt, saind(4), 
     &        satyp(4), sabeg(4), salen(4), dsbful, saimin(4), saimax(4)
     &        , sacond(4), saor(4), dsncnt, saval(30)
      REAL sarmin(4), sarmax(4)
      CHARACTER*20 code
C
C     + + + EXTERNALS + + +
C     syssubs
      EXTERNAL MOVEI0
C     annielib
      EXTERNAL WDFNDS
C
C     + + + DATA INITIALITATIONS + + +
      DATA len4, sacond, sarmin, sarmax/4, 4*1, 4*0.0, 4*0.0/
C
C     + + + END SPECIFICATIONS + + +
C
      CALL MOVEI0(saor,len4)
      CALL MOVEI0(saimin,len4)
      CALL MOVEI0(saimax,len4)
C
      code = STA//TSTYPE
C
C---character station STAID
      saind(1) = 2
      satyp(1) = 3
      salen(1) = 16
      sabeg(1) = 1
      READ (code,9005) (saval(i),i=1,4)
C
C---timeseries type TSTYPE
      saind(2) = 1
      satyp(2) = 3
      salen(2) = 4
      sabeg(2) = 5
      READ (code(17:20),9005) saval(5)
      ipt = 3
C
C---check time attributes
      IF (TUNITS.GT.0 .AND. TUNITS.LE.6) THEN
C
C---valid time unit TUNITS
        saind(ipt) = 17
        satyp(ipt) = 1
        salen(ipt) = 1
        sabeg(ipt) = 6
        saimin(ipt) = TUNITS
        saimax(ipt) = TUNITS
        ipt = ipt + 1
      ENDIF
      IF (TSSTEP.GT.0 .AND. TSSTEP.LE.1440) THEN
C
C---valid timestep TSSTEP
        saind(ipt) = 33
        satyp(ipt) = 1
        salen(ipt) = 1
        sabeg(ipt) = 7
        saimin(ipt) = TSSTEP
        saimax(ipt) = TSSTEP
        ipt = ipt + 1
      ENDIF
C
      sacnt = ipt - 1
      saor(1) = sacnt
C
C---search for matching dataset
      maxdsn = 10
      dsnmin = 1
      dsnmax = 32000
      dsncnt = 0
      dsbful = 0
      DO 10 i = 1, 10
        DSNO(i) = 0
   10 CONTINUE
      CALL WDFNDS(WDMSFL,DSTYPE,sacnt,saind,satyp,sabeg,saval,salen,
     &            saimin,saimax,sarmin,sarmax,sacond,saor,maxdsn,dsnmin,
     &            dsnmax,DSNO,dsncnt,dsbful)
      IF (dsncnt.EQ.0) THEN
        RETC = 1
      ELSEIF (dsncnt.EQ.1) THEN
        RETC = 0
      ELSE
        RETC = -dsncnt
      ENDIF
C
      RETURN
C
C     + + + INPUT FORMATS + + +
 9005 FORMAT (20A4)
      END
C
      SUBROUTINE WDTCOD(CDATE,ITIME)
C
C     LAST MODIFIED October 8, 1993 -- RSR
C
C     + + + PURPOSE + + +
C     This subroutine takes a 4-byte integer array containing a date
C     and uses the DTCODE routine to verify the date and time which
C     requires two-byte integer arguments, returns elapsed minutes in year.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER CDATE(6), ITIME
C
C     + + + ARGUMENT DEFINITIONS + + +
C     CDATE  - Array containing date and time, YR,MO,DA,HR,MN,SEC.
C     ITIME  - Output variable that holds elapsed time in minutes since
C              beginning of year.
C
C     + + + LOCAL VARIABLES + + +
      INTEGER idmy, iy, im, id, ih, imn, iret
C
C     + + + EXTERNALS + + +
C     syssubs
      EXTERNAL DTCODE
C
C     + + + END SPECIFICATIONS + + +
C
      iy = CDATE(1) - CDATE(1)/100*100
      im = CDATE(2)
      id = CDATE(3)
      ih = CDATE(4)
      imn = CDATE(5)
      CALL DTCODE(iy,im,id,ih,imn,ITIME,idmy,iret)
      IF (iret.EQ.0) RETURN
      STOP '*ERROR* IN WDTCOD, INVALID DATE'
      END
C
      SUBROUTINE WCRDSN(MESSFL,WDMSFL,OUTSFL,DSTYPE,SPACE,STANO,TUNITS,
     &                  TSSTEP,TYPE,STANAM,MISS,TSFORM,TSBYR,DSNL,DSN,
     &                  RETC)
C
C     LAST MODIFIED APRIL 10, 1992 -- RSR
C
C     + + + PURPOSE + + +
C     Add a new dataset, with attributes to WDM file
C
C     + + + KEYWORDS + + +
C     Message file, WDM file
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER MESSFL, WDMSFL, OUTSFL, DSTYPE, SPACE, TUNITS, TSSTEP, 
     &        DSNL, DSN, RETC, TSFORM, TSBYR
      REAL MISS
      CHARACTER STANO*16, TYPE*4, STANAM*48
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MESSFL - Fortran unit number of message file
C     WDMSFL - Fortran unit number of WDM file
C     OUTSFL - Fortran unit number for summary output
C              0 -no summary output file
C     DSTYPE - Dataset type
C              1 - timeseries
C              2 - table
C     SPACE  - indicator flag for space allocation
C              1 - default space
C              2 - increased space fo attributes and
C                  reduced space for group pointers
C     STANO  - station number
C     TUNITS - time units code
C                1 - seconds      4 - days
C                2 - minutes      5 - months
C                3 - hours        6 - years
C     TSSTEP - time step in TUNITS units
C     TYPE   - type of data in dataset
C     STANAM - station identification name
C     MISS   - filler for missing values
C     TSFORM - form of data
C              1 - mean over time step (default)
C              2 - total over time step
C              3 - instantaneous at time step (end of time step)
C              4 - minimum over time step
C              5 - maximum over time step
C     TSBYR - base year of data set
C     DSNL   - last dataset number written
C     DSN    - input as requested dataset,
C              output as actual dataset added
C     RETC   - return code
C
C     + + + LOCAL VARIABLES + + +
      INTEGER sta, len, len16, vbtime, compfg, nret, ret(13), kount, i, 
     &        tgroup, badi, len48
      LOGICAL file
C
C     + + + FUNCITONS + + +
      INTEGER LENSTR, CRINTE
C
C     + + + INTRINSICS + + +
      INTRINSIC ABS
C
C     + + + EXTERNALS + + +
C     syssubs
      EXTERNAL MOVEI0
C     annielib
      EXTERNAL LENSTR, CRINTE, WDBSAI, WDBSAC, WDBSAR
C     local
      EXTERNAL WDSNAD
C
C     + + + DATA INITIALIZATIONS + + +
      DATA len16, len48, tgroup, compfg/16, 48, 5, 1/
      DATA nret, badi, vbtime/13, -99, 1/
C
C     + + + END SPECIFICATIONS + + +
C
      file = .FALSE.
      IF (OUTSFL.NE.0) file = .TRUE.
C
      RETC = 0
      CALL MOVEI0(ret,nret)
C
C---set up record and pointer for dataset
      CALL WDSNAD(WDMSFL,DSTYPE,SPACE,DSNL,DSN,ret(1))
C
C---station number
      len = LENSTR(len16,STANO)
      sta = CRINTE(badi,len,STANO)
      IF (sta.NE.badi) CALL WDBSAI(WDMSFL,DSN,MESSFL,51,1,sta,ret(2))
C
C---character staion id
      CALL WDBSAC(WDMSFL,DSN,MESSFL,2,16,STANO,ret(3))
C
C---time series type
      IF (TYPE.NE.'    ') CALL WDBSAC(WDMSFL,DSN,MESSFL,1,4,TYPE,ret(4))
C
C---time indicators
      IF (TUNITS.GT.0 .AND. TUNITS.LT.7)
     &    CALL WDBSAI(WDMSFL,DSN,MESSFL,17,1,TUNITS,ret(5))
      IF (TSSTEP.GT.0 .AND. TSSTEP.LT.1441)
     &    CALL WDBSAI(WDMSFL,DSN,MESSFL,33,1,TSSTEP,ret(6))
C
C---missing value indicator
      CALL WDBSAR(WDMSFL,DSN,MESSFL,32,1,MISS,ret(7))
C
C---station name
      len = LENSTR(len48,STANAM)
      IF (len.GT.0) CALL WDBSAC(WDMSFL,DSN,MESSFL,45,48,STANAM,ret(8))
C
C---FORM OF DATA
      IF (TSFORM.GT.0 .AND. TSFORM.LT.6)
     &    CALL WDBSAI(WDMSFL,DSN,MESSFL,84,1,TSFORM,ret(9))
C
C---VARIABLE TIME-STEP OPTION, SET TO ONE SO THAT ALL DATA MUST BE OF
C---SAME TIME STEP FOR EACH DATA SET.
      IF (vbtime.GT.0 .AND. vbtime.LT.4)
     &    CALL WDBSAI(WDMSFL,DSN,MESSFL,85,1,vbtime,ret(10))
C
C---UNIT FOR GROUP POINTERS, TGROUP=5 IS OPTIMAL FOR 5, 15, AND 60 MINUTE
C---TIME STEPS.
      IF (tgroup.GT.2 .AND. tgroup.LT.8)
     &    CALL WDBSAI(WDMSFL,DSN,MESSFL,34,1,tgroup,ret(11))
C
C---COMPRESSION FLAG 2 MEANS DATA ARE NOT COMPRESSED
      IF (compfg.GT.0 .AND. compfg.LT.3)
     &    CALL WDBSAI(WDMSFL,DSN,MESSFL,83,1,compfg,ret(12))
C
C---BASE-YEAR FOR TIME-SERIES DATA
      CALL WDBSAI(WDMSFL,DSN,MESSFL,27,1,TSBYR,ret(13))
C
C---check for errors in writing attributes
      kount = 0
      DO 10 i = 1, nret
        kount = kount + ABS(ret(i))
   10 CONTINUE
      IF (kount.NE.0) THEN
C
C---error in creating dataset
        RETC = kount
        WRITE (*,9005) DSN, RETC
        IF (file) WRITE (OUTSFL,9005) DSN, RETC
        WRITE (*,9010) TYPE, STANO
        IF (file) WRITE (OUTSFL,9010) TYPE, STANO
        IF (TSSTEP.GT.0) THEN
          WRITE (*,9015) TUNITS, TSSTEP
          IF (file) WRITE (OUTSFL,9015) TUNITS, TSSTEP
        ENDIF
      ENDIF
C
      RETURN
 9005 FORMAT (/,' *** warning:  when creating DSN',I4,':',/,15X,
     &        'return code =',I3)
 9010 FORMAT (/,' TSTYPE =',A4,5X,'STANO  =',A16)
 9015 FORMAT (/,' TUNITS =',I3,5X,'TSSTEP =',I5)
      END
C
      SUBROUTINE WDSNAD(WDMSFL,DSTYPE,SPACE,DSNL,DSN,RETC)
C
C     + + + PURPOSE + + +
C     This routine adds a dataset to a WDM file.  If the requested
C     dataset DSN already exists, the first available dataset after
C     DSNL is added.
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER WDMSFL, DSTYPE, SPACE, DSNL, DSN, RETC
C
C     + + + ARGUMENT DEFINITIONS + + +
C     WDMSFL - Fortran unit number of the WDM file
C     DSTYPE - data-set type to be added
C              1 - time series
C              2 - table
C     SPACE  - indicator flag for space allocation
C              1 - default space
C              2 - increased space for attributes and reduced
C                  space for group pointers.  Allows for 100
C                  search attributes with space of 130 and
C                  pointers for 7 data groups.
C     DSNL   - input - dataset number to start at if the input
C              DSN already exists
C              output - remains unchanged if DSN is available,
C              otherwise, the dataset that was added
C     DSN    - input - requested dataset number
C              output - dataset added
C     RETC   - return code
C              0 - successful
C              /=0 - unsuccessful
C
C     + + + LOCAL VARIABLES + + +
      INTEGER exist, ndn, nup, nsa, nsasp, ndp, psa
C
C     + + + FUNCTIONS + + +
      INTEGER WDCKDT
C
C     + + + EXTERNALS + + +
C     annielib
      EXTERNAL WDCKDT, WDBCRL, WDLBAX
C
C     + + + DATA INITIALIZATIONS + + +
      DATA ndn, nup, nsa, nsasp, ndp/1, 1, 100, 130, 7/
C
C     NDN    - number of down pointers
C     NUP    - number of up pointers
C     NSA    - nusdmber of search attributes
C     NSASP  - space for search attributes
C     NDP    - number of group pointers
C
C     + + + END SPECIFICATIONS + + +
C
      RETC = 0
      IF (DSN.GT.0 .AND. DSN.LE.32000) THEN
C
C---check to see if DSN exists
        exist = WDCKDT(WDMSFL,DSN)
C
C---DSN already exists, find new one
        IF (exist.NE.0) DSN = 0
      ENDIF
C
      IF (DSN.LE.0 .OR. DSN.GT.32000) THEN
C
C---find an unused DSN
        DSNL = DSNL - 1
        IF (DSNL.LT.0 .OR. DSNL.GT.31999) DSNL = 0
   10   DSNL = DSNL + 1
        exist = WDCKDT(WDMSFL,DSNL)
        IF (exist.NE.0) GOTO 10
        DSN = DSNL
      ENDIF
C
      IF (SPACE.EQ.2) THEN
C
C---increase space for attributes, reduce space for group pointers
        CALL WDLBAX(WDMSFL,DSN,DSTYPE,ndn,nup,nsa,nsasp,ndp,psa)
      ELSE
C
C---use default space allocation
        CALL WDBCRL(WDMSFL,DSN,DSTYPE,RETC)
      ENDIF
C
      RETURN
      END
