      SUBROUTINE GEMXP
C
C  THIS SUBROUTINE SOLVES A SYSTEM OF EQUATIONS BY GAUSSIAN
C  ELIMINATION USING MAXIMUM COLUMN PIVOT STRATEGY.
C
      INCLUDE 'dimens.cmn'
      INCLUDE 'matrix.cmn'
      REAL tol, abbiga, aval, rebiga
      INTEGER jj, jrow, k, k1, mrow, nbeg, nend, kr, kb, ia, kxj, jcol, 
     &        imax
      REAL ABS
      INTRINSIC ABS
      EXTERNAL ERRSTP
      SAVE tol
      DATA tol/0.1E-35/
C
C---FORWARD SOLUTION
      jj = -Ii
      DO 50 jrow = 1, Ii
        jj = jj + Ii
        abbiga = tol
        imax = 0
C
C---SEARCH FOR MAXIMUM COEFFICIENT IN COLUMN
        DO 10 jcol = jrow, Ii
          aval = ABS(Am(Row(jcol)+jj))
          IF (aval.GT.abbiga) THEN
            abbiga = aval
            imax = jcol
          ENDIF
   10   CONTINUE
C
C---TEST FOR PIVOT LESS THAN TOLERANCE (SINGULAR MATRIX)
        IF (imax.EQ.0) CALL ERRSTP('MATRIX IS SINGULAR')
C
C---SWAP ROW POINTERS
        mrow = Row(imax)
        Row(imax) = Row(jrow)
        Row(jrow) = mrow
C
C---DIVIDE EQUATION BY LEADING COEFFICIENT
        nbeg = jj + mrow
        rebiga = 1.0/Am(nbeg)
        nend = nbeg + Ii*(Ii-jrow)
        DO 20 k = nbeg, nend, Ii
          IF (Am(k).NE.0.0) Am(k) = Am(k)*rebiga
   20   CONTINUE
        Bmx(mrow) = Bmx(mrow)*rebiga
C
C---ELIMINATE THE ITH COLUMN BELOW THE DIAGONAL
        IF (jrow.EQ.Ii) GOTO 60
        nbeg = nbeg + Ii
        DO 40 k1 = jrow + 1, Ii
          kr = Row(k1)
          kxj = jj + kr
          aval = Am(kxj)
          IF (aval.NE.0.0) THEN
            DO 30 k = nbeg, nend, Ii
              kxj = kxj + Ii
              IF (Am(k).NE.0.0) Am(kxj) = Am(kxj) - aval*Am(k)
   30       CONTINUE
            Bmx(kr) = Bmx(kr) - aval*Bmx(mrow)
          ENDIF
   40   CONTINUE
   50 CONTINUE
C
C---BACK SUBSTITUTE, PLACING THE SOLUTION IN AN UNOCCUPIED COLUMN OF A
   60 Am(Ii) = Bmx(mrow)
      DO 80 k1 = 1, Iim1
        kb = Ii - k1
        kr = Row(kb)
        Am(kb) = Bmx(kr)
        ia = Iim1ii + kr
        DO 70 k = Ii, kb + 1, -1
          IF (Am(ia).NE.0.0) Am(kb) = Am(kb) - Am(ia)*Am(k)
          ia = ia - Ii
   70   CONTINUE
   80 CONTINUE
C
C---RESTORE THE SOLUTION TO THE B VECTOR
      DO 90 k = 1, Ii
        Bmx(k) = Am(k)
   90 CONTINUE
      DO 100 k = 1, Iisq
        Am(k) = 0.0
  100 CONTINUE
      RETURN
      END
