      SUBROUTINE GETBVD
C
      INCLUDE 'dimens.cmn'
      INCLUDE 'comcon.cmn'
      INCLUDE 'dtypes.cmn'
      INCLUDE 'boundy.cmn'
      INCLUDE 'bouchr.cmn'
      INCLUDE 'dadcom.cmn'
      INCLUDE 'databk.cmn'
      INCLUDE 'logics.cmn'
      INCLUDE 'bctime.cmn'
      INCLUDE 'brnerr.cmn'
      INCLUDE 'partim.cmn'
      INTEGER myr, mmo, mda, mhr, mmn, jjyr, l, intdbc, inter, metime, 
     &        jjtime, idmy, iret
      EXTERNAL DATCOD, DTCODE, DADO, ERRMSG, LDARRY, INCELT
      INTEGER IFIX
      INTRINSIC IFIX
C
C     RETRIEVE MORE BOUNDARY-VALUE DATA FROM DIRECT-ACCESS STORAGE
C
      Errtyp = ' BVD '
      Ier = -2
      intdbc = 0
      DO 10 l = 1, Nbnd
        IF (Ndata(l).GT.1) THEN
          intdbc = intdbc + 1
          GOTO 10
        ENDIF
        Dtype = Itype(l)
        IF (Dtype.NE.Zptype .AND. Dtype.NE.Qptype .AND. Ibjnc(l)
     &      .NE.0 .AND. Ndata(l).EQ.0) THEN
          intdbc = intdbc + 1
          inter = IFIX(Dtt(l)/60.0+0.0001)
          Irdpdy = 1440/inter
          IF (l.EQ.1) THEN
C  NDPART IS THE NUMBER OF DATA RETRIEVED LAST TIME -1.
C  THE LAST VALUE RETRIEVED LAST TIME WILL ALSO BE RETRIEVED THIS TIME.
            Ndpart = Ndleft
            IF (Ndleft+Dtmax/Dtt(1).LE.Maxbd) Morebd = .FALSE.
C  SET BEGINNING OF RETRIEVAL TO CURRENT TIME MINU THE LARGEST RECORDING
C  FREQUENCY FOR EACH BVD SO THAT PARABOLIC INTERPOLATION WILL WORK
            jjtime = Jetime - IFIX((Dtmax/60.0)+0.0001)
            jjyr = Iyr
            CALL DATCOD(jjtime,jjyr,Jmo,Jda,Jhr,Jmn)
            CALL DTCODE(jjyr,Jmo,Jda,Jhr,Jmn,idmy,jjtime,iret)
            IF (iret.NE.0) GOTO 20
            IF (jjyr.GT.Iyr) CALL INCELT(Iyr,jjyr,jjtime)
          ENDIF
          IF (Morebd) THEN
            IF (l.EQ.1) THEN
              metime = jjtime + (Maxbd-1)*inter
C  SET ENDING TIME OF RETRIEVAL TO BE ON AN HOUR
              metime = (metime/60)*60
              myr = Iyr
              CALL DATCOD(metime,myr,mmo,mda,mhr,mmn)
              CALL DTCODE(myr,mmo,mda,mhr,mmn,idmy,metime,iret)
              IF (iret.NE.0) GOTO 20
              IF (myr.GT.Iyr) CALL INCELT(Iyr,myr,metime)
              Ndpart = (metime-jjtime)/inter
              Ndleft = Ndleft - Ndpart + IFIX(Dtmax/Dt+0.000001)
            ENDIF
            CALL DADO(Istatn(l),Dtype,Stype(l),jjyr,Jmo,Jda,Jhr,Jmn,myr,
     &                mmo,mda,mhr,mmn,Irdpdy,Datai2,Strip,Prtmsg,Rtcode)
            Nd = (metime-jjtime)/inter + 1
          ELSE
            CALL DADO(Istatn(l),Dtype,Stype(l),jjyr,Jmo,Jda,Jhr,Jmn,Nyr,
     &                Nmo,Nda,Nhr,Nmn,Irdpdy,Datai2,Strip,Prtmsg,Rtcode)
            Nd = (Netime-jjtime)/inter + 1
          ENDIF
          IF (Rtcode.NE.0 .AND. (Rtcode.NE.4 .OR. Strip.GT.-1) .AND. 
     &        (Rtcode.NE.10 .OR. Strip.GT.-1)) THEN
            Ier = -1
            GOTO 20
          ENDIF
          CALL LDARRY(Dtype,Stype(l),Zq(1,intdbc),Nd,Datum(l),Zdatum)
        ENDIF
   10 CONTINUE
      Jetime = metime
      Jyr = myr
      Jmo = mmo
      Jda = mda
      Jhr = mhr
      Jmn = mmn
      RETURN
   20 CALL ERRMSG
      END
C
      SUBROUTINE GETNDF(DT,PRTMSG)
C
C     RETRIEVE MORE NODAL FLOW DATA FROM DIRECT-ACCESS STORAGE
C
      INCLUDE 'dimens.cmn'
      INCLUDE 'nodal.cmn'
      INCLUDE 'dadcom.cmn'
      INCLUDE 'databk.cmn'
      INCLUDE 'bctime.cmn'
      INCLUDE 'brnerr.cmn'
      INTEGER myr, mmo, mda, mhr, mmn, jjyr, l, intdnf, inter, metime, 
     &        jjtime, idmy, iret
      REAL DT
      LOGICAL PRTMSG
      EXTERNAL DATCOD, DTCODE, DADO, ERRMSG, LDARRY, INCELT
      INTEGER IFIX
      INTRINSIC IFIX
C
      Errtyp = 'NODAL'
      Ier = -2
      intdnf = 0
      DO 10 l = 1, Kttdnf
        IF (Injnc(l).NE.0 .AND. Nndat(l).EQ.0) THEN
          intdnf = intdnf + 1
          inter = IFIX(Dttn(l)/60.0+0.0001)
          Irdpdy = 1440/inter
          IF (l.EQ.1) THEN
C---NNPART IS THE NUMBER OF DATA RETRIEVED LAST TIME -1.
C---THE LAST VALUE RETRIEVED LAST TIME WILL ALSO BE RETRIEVED THIS TIME.
            Nnpart = Nnleft
            IF (Nnleft+Dtmxnf/Dttn(1).LE.Maxndf) Morenf = .FALSE.
C---SET BEGINNING OF RETRIEVAL TO CURRENT TIME MINUS THE LARGEST RECORDING
C---FREQUENCY FOR EACH NDF SO THAT PARABOLIC INTERPOLATION WILL WORK
            jjtime = Nftime - IFIX((Dtmxnf/60.0)+0.0001)
            jjyr = Iyr
            CALL DATCOD(jjtime,jjyr,Nfmo,Nfda,Nfhr,Nfmn)
            CALL DTCODE(jjyr,Nfmo,Nfda,Nfhr,Nfmn,idmy,jjtime,iret)
            IF (iret.NE.0) GOTO 20
            IF (jjyr.GT.Iyr) CALL INCELT(Iyr,jjyr,jjtime)
          ENDIF
          IF (Morenf) THEN
            IF (l.EQ.1) THEN
              metime = jjtime + (Maxndf-1)*inter
C  SET ENDING TIME OF RETRIEVAL TO BE ON AN HOUR
              metime = metime/60*60
              myr = Iyr
              CALL DATCOD(metime,myr,mmo,mda,mhr,mmn)
              CALL DTCODE(myr,mmo,mda,mhr,mmn,idmy,metime,iret)
              IF (iret.NE.0) GOTO 20
              IF (myr.GT.Iyr) CALL INCELT(Iyr,myr,metime)
              Nnpart = (metime-jjtime)/inter
              Nnleft = Nnleft - Nnpart + IFIX(Dtmxnf/DT+0.0001)
            ENDIF
            CALL DADO(Nstatn(l),Nftype,Nfstyp(l),jjyr,Nfmo,Nfda,Nfhr,
     &                Nfmn,myr,mmo,mda,mhr,mmn,Irdpdy,Datai2,Strip,
     &                PRTMSG,Rtcode)
            Nnd = (metime-jjtime)/inter + 1
          ELSE
            CALL DADO(Nstatn(l),Nftype,Nfstyp(l),jjyr,Nfmo,Nfda,Nfhr,
     &                Nfmn,Nyr,Nmo,Nda,Nhr,Nmn,Irdpdy,Datai2,Strip,
     &                PRTMSG,Rtcode)
            Nnd = (Netime-jjtime)/inter + 1
          ENDIF
          IF (Rtcode.NE.0 .AND. (Rtcode.NE.4 .OR. Strip.GT.-1) .AND. 
     &        (Rtcode.NE.10 .OR. Strip.GT.-1)) THEN
            Ier = -1
            GOTO 20
          ENDIF
          CALL LDARRY(Nftype,Nfstyp(l),Wt(1,intdnf),Nnd,Datmnf(l),0.0)
        ENDIF
   10 CONTINUE
      Nftime = metime
      Nfyr = myr
      Nfmo = mmo
      Nfda = mda
      Nfhr = mhr
      Nfmn = mmn
      RETURN
   20 CALL ERRMSG
      END
C
      SUBROUTINE GETWND(PRTMSG)
C
C     RETRIEVE MORE WIND DATA FROM DIRECT-ACCESS STORAGE
C
      INCLUDE 'dimens.cmn'
      INCLUDE 'wind.cmn'
      INCLUDE 'dadcom.cmn'
      INCLUDE 'databk.cmn'
      INCLUDE 'bctime.cmn'
      INCLUDE 'brnerr.cmn'
      INTEGER syr, smo, sda, shr, smn, inter, setime, idmy, iret
      LOGICAL PRTMSG
      EXTERNAL DATCOD, DTCODE, DADO, ERRMSG, LDARRY, INCELT
      INTEGER IFIX
      INTRINSIC IFIX
C
      Errtyp = ' WIND'
      Ier = -1
      inter = IFIX(Wdtt/60.+0.000001)
      Irdpdy = 1440/inter
      Nwd = Nwfirt - Nwpart
      Nwfirt = Nwd
      IF (Nwd.GT.Maxwnd) THEN
        setime = Jwtime + (Maxwnd-1)*inter
        syr = Iyr
        CALL DATCOD(setime,syr,smo,sda,shr,smn)
        Ier = -2
        CALL DTCODE(syr,smo,sda,shr,smn,idmy,setime,iret)
        IF (iret.NE.0) GOTO 10
        Ier = -1
        IF (syr.GT.Iyr) CALL INCELT(Iyr,syr,setime)
C
C---SET NWPART TO THE NUMBER OF WIND DATA LESS 1, SO THAT THE IF
C---STATEMENT TO DETERMINE WHETHER TO RETRIEVE DATA CAN BE A SIMPLE .GT.
        Nwpart = (setime-Jwtime)/inter
        Nwd = Nwpart + 1
        CALL DADO(Iwstan,'WS',Wstype,Wyr,Wmo,Wda,Whr,Wmn,syr,smo,sda,
     &            shr,smn,Irdpdy,Datai2,Strip,PRTMSG,Rtcode)
        IF (Rtcode.NE.0 .AND. (Rtcode.NE.4 .OR. Strip.GT.-1) .AND. 
     &      (Rtcode.NE.10 .OR. Strip.GT.-1)) GOTO 10
        CALL LDARRY('WS',Wstype,Windsp,Nwd,Wcdatm,0.0)
        CALL DADO(Iwstan,'WD',Wstype,Wyr,Wmo,Wda,Whr,Wmn,syr,smo,sda,
     &            shr,smn,Irdpdy,Datai2,Strip,PRTMSG,Rtcode)
        IF (Rtcode.NE.0 .AND. (Rtcode.NE.4 .OR. Strip.GT.-1) .AND. 
     &      (Rtcode.NE.10 .OR. Strip.GT.-1)) GOTO 10
        CALL LDARRY('WD',Wstype,Winddr,Nwd,Wcdatm,0.0)
        Jwtime = setime
        Wyr = syr
        Wmo = smo
        Wda = sda
        Whr = shr
        Wmn = smn
      ELSE
        Morewd = .FALSE.
        Nwd = (Netime-Jwtime)/inter + 1
        Nwpart = Nwd
        CALL DADO(Iwstan,'WS',Wstype,Wyr,Wmo,Wda,Whr,Wmn,Nyr,Nmo,Nda,
     &            Nhr,Nmn,Irdpdy,Datai2,Strip,PRTMSG,Rtcode)
        IF (Rtcode.NE.0 .AND. (Rtcode.NE.4 .OR. Strip.GT.-1) .AND. 
     &      (Rtcode.NE.10 .OR. Strip.GT.-1)) GOTO 10
        CALL LDARRY('WS',Wstype,Windsp,Nwd,Wcdatm,0.0)
        CALL DADO(Iwstan,'WD',Wstype,Wyr,Wmo,Wda,Whr,Wmn,Nyr,Nmo,Nda,
     &            Nhr,Nmn,Irdpdy,Datai2,Strip,PRTMSG,Rtcode)
        IF (Rtcode.NE.0 .AND. (Rtcode.NE.4 .OR. Strip.GT.-1) .AND. 
     &      (Rtcode.NE.10 .OR. Strip.GT.-1)) GOTO 10
        CALL LDARRY('WD',Wstype,Winddr,Nwd,Wcdatm,0.0)
      ENDIF
      Nwd = 1
      RETURN
   10 CALL ERRMSG
      END
