      SUBROUTINE PRTBXS
C
      INCLUDE 'dimens.cmn'
      INCLUDE 'dtcomp.cmn'
      INCLUDE 'xsinit.cmn'
      INCLUDE 'xsichr.cmn'
      INCLUDE 'geom.cmn'
      INCLUDE 'ceta.cmn'
      INCLUDE 'comcon.cmn'
      INCLUDE 'untmes.cmn'
      INCLUDE 'branch.cmn'
      INCLUDE 'branam.cmn'
      INCLUDE 'units.cmn'
      INCLUDE 'boundy.cmn'
      INCLUDE 'bouchr.cmn'
      INCLUDE 'lunums.cmn'
      INCLUDE 'logics.cmn'
      INCLUDE 'bctime.cmn'
      INCLUDE 'dtypes.cmn'
      INCLUDE 'netwrk.cmn'
      INCLUDE 'mdatas.cmn'
      INCLUDE 'nodal.cmn'
      INCLUDE 'wind.cmn'
      INCLUDE 'limits.cmn'
      CHARACTER*1 ideta(7), prtyp
      LOGICAL skip
      INTEGER i, ij, ns, l, nxs, nmxpt, nd, j, k, icrbr, icr, jcr, nxset
      REAL crmax, crbrmx, brdx, rijm1, ri1, rij, rin, cr, crbrdx, dxcr
      CHARACTER*62 msg
      INTEGER IFIX
      REAL SQRT, COS, ABS
      INTRINSIC IFIX, SQRT, COS, ABS
      EXTERNAL ERRPAR, ERRSCR
      DATA ideta/'0', 'T', 'D', 'Q', 'F', 'R', 'Z'/
C
C---PRINT COMPUTATIONAL CONTROL HEADER, NETWORK NAME, AND USER COMMENT
      WRITE (*,*) 'Begin control record and geometry printout!'
      IF (Intabc.GT.MXZQRT) CALL ERRPAR(1,Intabc,0,MXZQRT,'MXZQRT',
     &         'THE NUMBER OF B.C. RATING TABLES INPUT EXCEEDS MAXIMUM')
C
      IF (Iardem.EQ.1) THEN
        WRITE (Printr,9005)
        nmxpt = -99
        nxs = MAXS - Xskt(Nbch) + Nsec(Nbch)
        DO 10 i = 1, nxs
          IF (Ipt(i).GT.nmxpt) nmxpt = Ipt(i)
          IF (Eta(1,i).GT.SMLVL) nxset = i
   10   CONTINUE
        WRITE (Printr,9010) MXBH, Nbch, MXJN, Njnc, MXFV, Nfvxs
        WRITE (Printr,9015) MAXS, nxs, MXTFXS, nxset, MXPT, nmxpt
        WRITE (Printr,9020) MXMD, Ktmeas, MAXMZQ, Mdata(1), MAXCZQ, 
     &                      1440/Idtm, MXTDBC, Kttdbc, MAX2BY, Ndz, 
     &                      MXZQRT, Intabc, MXZQRE, Maxrat
        WRITE (Printr,9025) MAX4BY, Ndq, MXWIND, Nwfirt, MXTDNF, Kttdnf, 
     &                      MXNODL, Nnd, MAXDFR, MXOTDT, MXPART, MXPATH
      ENDIF
      WRITE (Printr,9115) Iyr, Imo, Ida, Ihr, Imn, Nyr, Nmo, Nda, Nhr, 
     &                    Nmn
C
C---PRINT OUT COMPUTATION CONTROL CARD INFORMATION
      WRITE (Printr,9030) Iunit, MXBH, Nbch, MXJN, Njnc, MXJN, Nbnd, 
     &                    Nsteps, Ounit, Irdgeo, Imodfw, Nit, Ipropt,
     &                    Iplopt, Ipldev
      WRITE (Printr,9035) Iprmsg, Iplmsg, Iexopt, Typeta, Inhr, Inmn, 
     &                    Idtm, Theta
      WRITE (Printr,9040) Qqtol, Zztol, Wspeed, Wsdrag, H2oden, Chi, 
     &                    Iwrtic, Ienibc, Irdic, Numcom
      WRITE (Printr,9045) Wdirec, Inwind, Otfile, Iwmopt, Iardem,
     &                    Iprfmt, Ktcons, Irdnxt
      WRITE (Printr,9050) Glbeta, Gleta, Etamin, Etamax, Tolerr, Iprtdt
      WRITE (Printr,9055) Glicq, Glicz, Dcfm, Airden, H2osal, H2otmp,
     &                    Dsprsn, Gprbch, Gplbch, Gprtxs
      WRITE (Printr,9057) Zdatum
C
C---PRINT OUT TIME SERIES BOUNDARY CONDITIONS INFO
      WRITE (Printr,9060)
      DO 20 l = 1, Nbnd
        IF (Ibjnc(l).NE.0) THEN
          IF (Izqbve(l).EQ.0) THEN
            WRITE (Printr,9065) Istatn(l), Itype(l), Ibjnc(l), Ndata(l), 
     &                          IFIX(Dtt(l))/60, Datum(l)
          ELSEIF (Izqbve(l).EQ.2) THEN
C---Z(t) B.C. specified by stage/discharge rating
            WRITE (Printr,9105) Istatn(l), Itype(l), Ibjnc(l), Ndata(l), 
     &                          IFIX(Dtt(l))/60, Datum(l), Itype(l)
          ELSEIF (Izqbve(l).EQ.1) THEN
C---B.C. specified by constant
            IF (Itype(l).EQ.Ztype) THEN
              WRITE (Printr,9095) Istatn(l), Itype(l), Ibjnc(l),
     &                            Ndata(l), IFIX(Dtt(l))/60, Datum(l),
     &                            Itype(l), Zqbvco(1,l)+Zdatum
            ELSE
              WRITE (Printr,9095) Istatn(l), Itype(l), Ibjnc(l),
     &                            Ndata(l), IFIX(Dtt(l))/60, Datum(l),
     &                            Itype(l), Zqbvco(1,l)
            ENDIF
          ELSE
            WRITE (Printr,9110) Istatn(l), Itype(l), Ibjnc(l), Ndata(l),
     &                          IFIX(Dtt(l))/60, Datum(l)
            IF (Izqbve(l).EQ.-1) THEN
C---B.C. specified by an up to three order equation
              IF (Itype(l).EQ.Ztype) THEN
                prtyp = 'Z'
                WRITE (Printr,9111) Itype(l), prtyp, Zqbvco(1,l)+Zdatum,
     &                              Zqbvco(2,l), prtyp, Zqbvco(3,l),
     &                              prtyp, Zqbvco(4,l), prtyp
              ELSE
                prtyp = 'Q'
                WRITE (Printr,9111) Itype(l), prtyp, Zqbvco(1,l),
     &                              Zqbvco(2,l), prtyp, Zqbvco(3,l),
     &                              prtyp, Zqbvco(4,l), prtyp
              ENDIF
            ELSE
C---Z(t) B.C. specified by SIN equation
C---where Zqbvco(1,l) = wave datum; Zqbvco(2,l) = wave amplitude;
C---Zqbvco(4,l) = wave origin; and Zqbvco(3,l) = wave period
              WRITE (Printr,9112) Zqbvco(1,l)+Zdatum, Zqbvco(2,l)*0.5, 
     &                            Zqbvco(3,l), Zqbvco(4,l)
            ENDIF
          ENDIF
        ENDIF
   20 CONTINUE
C
C---PRINT OUT NODAL FLOW INFORMATION
      IF (Kttdnf.NE.0) THEN
        WRITE (Printr,9070)
        DO 30 l = 1, Kttdnf
          WRITE (Printr,9065) Nstatn(l), Qtype, Injnc(l), Nndat(l), 
     &                        IFIX(Dttn(l))/60, Datmnf(l)
   30   CONTINUE
      ENDIF
      DO 40 l = 1, Njnc
        IF (ABS(W(l)+88888.88).LT.0.0005 .OR. ABS(W(l)-88888.88)
     &      .LT.0.0005) THEN
          WRITE (Printr,9080) l
        ELSEIF (ABS(W(l)).GT.SMLVL .AND. ABS(W(l)+99999.99).GT.0.0005)
     &          THEN
          IF (Iunit.EQ.Me) THEN
            WRITE (Printr,9075) l, W(l), Mt
          ELSE
            WRITE (Printr,9075) l, W(l), Unit
          ENDIF
        ENDIF
   40 CONTINUE
C
C---PRINT OUT WIND DATA INPUT INFO
      IF (Inwind.EQ.1) WRITE (Printr,9085) IFIX(Wdtt)/60, Iwstan
C
C---PRINT OUT MEASURE DATA INPUT INFO
      DO 50 l = 1, Ktmeas
        WRITE (Printr,9090) Mbch(l), Msec(l)
   50 CONTINUE
      WRITE (Printr,9100)
C
C---CHECK SEGMENT LENGTHS, COMPUTE COURANT, AND PRINT WARNING MESSAGES
      crmax = 0.0
      crbrmx = 0.0
      DO 70 i = 1, Nbch
        brdx = 0.0
        ns = Nsec(i)
        ij = MAXS - Xskt(i)
C       rijm1 = Rp(ij+1)
        rijm1 = Ap(ij+1)/Bp(ij+1)
        ri1 = rijm1
        DO 60 j = 1, ns
          ij = ij + 1
          IF (j.NE.ns) THEN
            brdx = brdx + Dx(ij)
            IF (Iwmopt.LT.2.AND.(Dx(ij).LT.Dxmin .OR. Dx(ij).GT.Dxmax))
     &          WRITE (Printr,9235) i, j, Dx(ij), Dxmin, Dxmax
            IF (Typeta.EQ.1 .AND. ABS(Gleta).LT.SMLVL .AND. 
     &          (Rn(1,ij).LT.0.01 .OR. Rn(1,ij).GT.0.05))
     &          WRITE (Printr,9240) i, j, Rn(1,ij)
          ENDIF
          IF (j.NE.1) THEN
C           rij = Rp(ij)
            rij = Ap(ij)/Bp(ij)
            IF (j.EQ.ns) THEN
              rin = (ri1+rij)*0.5
              cr = Dt/brdx*SQRT(G*rin)
              IF (cr.GT.crbrmx) THEN
                icrbr = i
                crbrdx = brdx
                crbrmx = cr
              ENDIF
            ENDIF
            rijm1 = (rij+rijm1)*0.5
            cr = Dt/Dx(ij-1)*SQRT(G*rijm1)
            rijm1 = rij
            IF (cr.GT.crmax) THEN
              icr = i
              jcr = j
              crmax = cr
              dxcr = Dx(ij-1)
            ENDIF
          ENDIF
   60   CONTINUE
   70 CONTINUE
      WRITE (Printr,9245) Idtm, icr, jcr, dxcr, crmax
      WRITE (Printr,9250) Idtm, icrbr, crbrdx, crbrmx
C
C---PRINT OUT CROSS-SECTION DATA
      DO 90 i = 1, Nbch
        ns = Nsec(i)
        ij = MAXS - Xskt(i)
        IF (Gprtxs.NE.1 .AND. (Gprtxs.EQ.2.OR.Prtxsg(i).EQ.0))
     &      WRITE (Printr,9120) Netnam, i, Ijf(i), Ijt(i), Brname(i)
        DO 80 j = 1, ns
          ij = ij + 1
          IF (Gprtxs.NE.1 .AND. (Gprtxs.EQ.2.OR.Prtxsg(i).EQ.0)) THEN
            skip = j.EQ.ns .OR. .NOT.Tabeta .OR. Eta(1,ij).LT.SMLVL
            nd = Ipt(ij)
            WRITE (Printr,9125) j
            IF (.NOT.skip) THEN
              WRITE (Printr,9130)
              IF (Typeta.GT.3 .AND. Typeta.LT.7) THEN
                WRITE (Printr,9135)
              ELSEIF (Typeta.EQ.2 .OR. Typeta.EQ.6) THEN
                WRITE (Printr,9140)
              ENDIF
            ENDIF
            WRITE (Printr,9145) Gdatum(ij), Unit, Unit, Unit, Unit,
     &                          Unit, Unit
            IF (.NOT.skip) THEN
              IF (Typeta.GT.3 .AND. Typeta.LT.7) THEN
                WRITE (Printr,9150) Unit
              ELSEIF (Typeta.EQ.2 .OR. Typeta.EQ.6) THEN
                IF (Unit.EQ.Mt) THEN
                  WRITE (Printr,9155)
                ELSE
                  WRITE (Printr,9160)
                ENDIF
              ENDIF
            ENDIF
            IF (Xstatn(ij)(15:16).NE.Iblk) WRITE (Printr,9165)
     &          Xstatn(ij), (Itypeo(k,ij),k=1,4)
            IF (skip) THEN
              WRITE (Printr,9170) (Za(k,ij),Aa(k,ij),Bb(k,ij),Bs(k,ij),
     &                            Storar(k,ij),Wp(k,ij),k=1,nd)
            ELSEIF (Typeta.EQ.1 .OR. Typeta.EQ.7 .OR. Typeta.EQ.3) THEN
              WRITE (Printr,9190) (Za(k,ij),Aa(k,ij),Bb(k,ij),Bs(k,ij),
     &                            Storar(k,ij),Wp(k,ij),Eta(k,ij),k=1,
     &                            nd)
            ELSEIF (Typeta.EQ.4 .OR. Typeta.EQ.5) THEN
              WRITE (Printr,9185) (Za(k,ij),Aa(k,ij),Bb(k,ij),Bs(k,ij),
     &                            Storar(k,ij),Wp(k,ij),Eta(k,ij),
     &                            Qa(k,ij),k=1,nd)
            ELSEIF (Typeta.EQ.6) THEN
              WRITE (Printr,9175) (Za(k,ij),Aa(k,ij),Bb(k,ij),Bs(k,ij),
     &                            Storar(k,ij),Wp(k,ij),Eta(k,ij),
     &                            Qa(k,ij),Ta(k,ij),k=1,nd)
            ELSE
              WRITE (Printr,9180) (Za(k,ij),Aa(k,ij),Bb(k,ij),Bs(k,ij),
     &                            Storar(k,ij),Wp(k,ij),Eta(k,ij),
     &                            Ta(k,ij),k=1,nd)
            ENDIF
            WRITE (Printr,9195) Z(ij), Q(ij), Rho(ij), Betvel(ij)
            IF (Z(ij).GT.Za(nd,ij) .OR. Z(ij).LT.Za(1,ij)) THEN
              Error = .TRUE.
              WRITE (msg,9230) Z(ij)
              CALL ERRSCR(0,i,j,msg)
            ENDIF
            WRITE (Printr,9200)
            IF (j.NE.ns) WRITE (Printr,9205) Dx(ij), Unit, T(ij), Tunit,
     &                                    Orient(ij), Qlat(ij), Ulat(ij)
            IF (Imodfw.NE.0) THEN
              WRITE (Printr,9255) Istrm(1,ij), Istrm(2,ij), Istrm(3,ij),
     &                            Clk(ij), Zbot(ij)
              IF (j.EQ.ns) WRITE (Printr,9200)
            ENDIF
            IF (j.EQ.ns) GOTO 80
            IF (Tabeta .AND. ABS(Eta(1,ij)).GT.SMLVL) THEN
              WRITE (Printr,9225) ideta(Typeta)
            ELSEIF (Typeta.EQ.1 .AND. ABS(Gleta).GT.SMLVL) THEN
              WRITE (Printr,9210) Gleta
            ELSE
              WRITE (Printr,9210) Rn(1,ij)
              IF (ABS(Rn(3,ij)).GT.SMLVL) THEN
                WRITE (Printr,9220) Rn(2,ij), ideta(Typeta), Rn(3,ij), 
     &                              ideta(Typeta)
              ELSE
                IF (ABS(Rn(2,ij)).GT.SMLVL) WRITE (Printr,9215) Rn(2,ij)
     &              , ideta(Typeta)
              ENDIF
            ENDIF
            WRITE (Printr,9200)
          ENDIF
          IF (j.NE.ns) Wangle(ij)= COS(.01745329*ABS(Wdirec-Orient(ij)))
   80   CONTINUE
   90 CONTINUE
C
C---CLOSEOUT
      IF (Error) STOP
      RETURN
 9005 FORMAT (
     &' THE TABLE BELOW IDENTIFIES PROGRAM PARAMETERS THAT SET MAXIMUM D
     &IMENSIONS OF',/,
     &' ARRAYS IN BRANCH.  CURRENT MAXIMUM DIMENSIONS REQUIRED BY THIS P
     &ARTICULAR',/,
     & ' APPLICATION ARE ALSO IDENTIFIED.  ASSOCIATED ARRAYS, AND COMMON
     & BLOCK(S) (OR',/,
     &' ROUTINE) IN WHICH THEY RESIDE, ARE ALSO GIVEN.  MAXIMUM DIMENSIO
     &N PARAMETERS',/,
     &' ARE INITIALIZED IN THE ''DIMENS.CMN'' INCLUDE FILE.  TO CHANGE A
     &RRAY DIMENSIONS'/,
     &' MODIFY THE PARAMETER VALUES IN THE DIMENS.CMN FILE AND RECOMPILE
     &.  SHARED',/,
     &' COMMON BLOCKS ARE CONTAINED IN INCLUDE FILES NAMED ''/COMMON-BLO
     &CK NAME/.CMN''.',//,1X,79('='),/)
 9010 FORMAT (' PARAMETER  MAXIMUM NUMBER OF:  ASSIGNED USED  LOCATION',
     &        8X,'ARRAYS',/,1X,79('-'),/,' MXBH    BRANCHES IN NETWORK',
     &        I12,I5,'  /BRANCH/ PLTBCH,PRTXSG,PRTBCH,'/,56X,
     &        'PRTSUM,PPLTBH,NSEC,'/,56X,'XSKT,IJF,IJT,IBROBC,',/,56X,
     &        'IJFEN,IJTEN',/,47X,'/TRACER/ IBRPT',/,47X,'/BINDEX/ IDX',
     &        /,47X,'/BRANAM/ BRNAME',/,47X,'/MATRIX/ AM,BMX,ROW',/,47X,
     &        '(SOLVER) BU,BUU',/,' MXJN    JUNCTIONS IN NETWORK',
     &        I11,I5,'  /BOUNDY/ IBJNC,NDATA,IZQBVE,DTT,',/,56X,
     &        'DATUM,ZQBVCO,ZQPMIN',/,47X,'/BOUCHR/ ITYPE,STYPE,ISTATN',
     &        /,47X,'/BINDEX/ IDX,ICT',/,47X,'/NODAL/  W,NXTDNF',/,47X,
     &        '/MODBRN/ QLSUM',/,' MXFV    FLOW VOLUME LOCATIONS',I10,
     &        I5,'  /VOLCOM/ ITVOL,IJVOL,IFVOL,FVOL,',/,56X,'IJVKT',/,
     &        47X,'/VOLCHR/ ISTAPR',/,47X,'(DAILY)  FVSTAT, ISTAPR')
 9015 FORMAT (' MAXS    CROSS SECTIONS IN NETWORK',I6,I5,
     & '  /ARBLOG/ LARBPR,ZHIGH,ZLOW,LINPRT',/,47X,
     & '/DTCOMP/ A,B,BT,Q,R,Z,AP,BP,BTP,',/,56X,'QP,RP,ZP,APZPIJ',/,47X,
     & '/GEOM/   AA,BB,BS,WP,ZA,IPT,',/,56X,'HYRAD,INDXS,RRFLG,STORAR',/
     & ,47X,'/MODBRN/ QLSUM,ITRAIL',/,47X,'/STRUCT/ STRMGT',/,47X,
     & '/TRACER/ IJPATH',/,47X,'/XSICHR/ ITYPEO,XSTATN',/,47X,
     & '/XSINIT/ BETVEL,DX,GDATUM,RN,T,',/,56X,
     &      'ORIENT,WANGLE,SUMETA,',/,56X,'QLAT,ULAT,QLATM,CLK,',/,56X,
     &      'ZBOT,RN4,DPDX,HYRAD,',/,56X,'RHO,SUMCZQ,SCZQSQ,',/,56X,
     &      'SZQETA,DZDT,DQDT,DQDXC,',/,56X,'DQDXM,DADX,DQADX,DZDX,',/,
     &      56X,'FRIC,WIND',/,47X,
     & '/ZQ/     ZQCOMP',/,47X,'/ZQSTAT/ QMIN,AQMIN,AQMAX,ZQMIN,',/,56X,
     & 'ZQMAX,QMAX,QSUM,ITQMIN,',/,56X,'ITQMAX',/,47X,'(SOLVER) U,UU',/,
     & ' MXTFXS  TABULAR ETA CROSS SECTIONS',2I5,
     & '  /CETA/   QA,TA,ETA,FUNETA',/,
     & ' MXPT    DATA PER CROSS SECTION',I9,I5,
     & '  /CETA/   QA,TA,ETA,FUNETA',/,47X,
     & '/GEOM/   AA,BB,BS,WP,ZA,STORAR')
 9020 FORMAT (' MXMD    MEASURED DATA LOCATIONS',I8,I5,
     &        '  /MDATAS/ MSEC,MDATA,MBCH,ZQMEAS',/,
     &        ' MAXMZQ  MEASURED DATA PER LOCATION',2I5,
     &        '  /MDATAS/ ZQMEAS,RNOPT,ZQOPT',/,47X,'/OPLTCM/ RMTIME',/,
     &        ' MAXCZQ  TIME STEPS PER DAY',I13,I5,'  /ZQ/     ZQCOMP',
     &        /,47X,'/OPLTCM/ ZQTIME',/,
     &        ' MXTDBC  TIME-VARYING BVD LOCATIONS',2I5,'  /BOUNDY/ ZQ',
     &        /,' MAX2BY  TWO-BYTE BVD PER LOCATION ',2I5,
     &        '  /BOUNDY/ ZQ',/,47X,'/DATABK/ DATAI2',/,
     &        ' MXZQRT  INPUT B.C. RATING TABLES',I7,I5,
     &        '  /BOUNDY/ ZT,QT,IZQPT',/,
     &  ' MXZQRE  Z/Q VALUES PER RATING TABLE',I4,I5,'  /BOUNDY/ ZT,QT')
 9025 FORMAT (' MAX4BY  FOUR-BYTE BVD PER LOCATION',2I5,
     &        '  /DATABK/ DATAR4,DATAR8,DATAI4',/,
     &        ' MXWIND  TIME-VARYING WIND DATA',I9,I5,
     &        '  /WIND/   WINDSP,WINDDR',/,
     &        ' MXTDNF  TIME-VARYING NODAL FLOW LOC.',I3,I5,
     &        '  /NODAL/  WT,DTTN,NNDAT,INJNC,',/,56X,'DATMNF',/,
     &        47X,'/NDLCHR/ NSTATN,NFSTYP',/,
     &        ' MXNODL  NODAL FLOW DATA PER LOC.',I7,I5,'  /NODAL/  WT',
     &        /,' MAXDFR  FLOW REVERSALS PER DAY',I9,4X,
     &        '?  /VOLCOM/ IFVOL,ITVOL',/,47X,'(DAILY)  IDTHR,IDTMN',/,
     &        ' MXOTDT  DATA OUTPUT TO DATA BASE',I7,4X,
     &        '?  /WDMS/   DATAI4',/,47X,'(TDDOUT) DATAI4',/,
     &        ' MXPART  NO. OF PARTICLES PER PATH',I6,4X,
     &        '?  /TRACER/ OUTDS,OUTUS,XPART,RM,',/,56X,
     &        'XNODE,C,XOPART,XONODE,',/,56X,'CP,CPT,BREAK,CSCOEF',/,
     &        ' MXPATH  NO. OF PATHS FOR TRACKING',I6,4X,
     &        '?  /TRACER/ OUTDS,OUTUS,XPART,RM,',/,56X,
     &        'XNODE,C,XOPART,XONODE,',/,56X,'CP,CPT,D,BREAK,CSCOEF',/,
     &        1X,79('='),/)
 9030 FORMAT (1X,79('=')//,5X,'VARIABLE',10X,'DEFINITION',12X,
     &        'POSITION FORMAT VALUES  ASSIGNED'/,1X,79('_'),//,5X,
     &        'IUNIT     UNITS OF INPUT',19X,'1-2     A2    EN/ME',8X,
     &        A2,/,5X,'NBCH      NUMBER OF BRANCHES',15X,
     &        '3-4     I2   0<N<=',I2,I9,/,5X,
     &        'NJNC      NUMBER OF JUNCTIONS',14X,'5-6     I2   1<N<=',
     &        I2,I9,/,5X,
     &   'NBND      NUMBER OF EXTERNAL BOUNDARIES    7-8     I2   1<N<='
     &   ,I2,I9,/,5X,'NSTEPS    NUMBER OF TIME STEPS',13X,
     &   '9-12    I4   -------',I9,/,5X,'OUNIT     UNITS OF OUTPUT',17X,
     &   '13-14    A2    EN/ME',8X,A2,/,5X,
     &   'IRDGEO    READ GEOMETRY FILE',16X,'15     I1     0/1',I11,/,
     &   5X,
     & 'IMODFW    MODFLOW/BRANCH SIMULATION OPTION  16     I1     0/1',
     & I11,/,5X,
     & 'NIT       MAXIMUM ITERATIONS ALLOWED      17-18    I2   -------'
     & ,I9,/,5X,'IPROPT    PRINTOUT OPTION',19X,'19     I1   0<=N<=9',
     & I9,/,5X,'IPLOPT    PLOT OPTION',23X,'20     I1   0<=N<=4',I9,/,
     & 5X,'IPLDEV    PLOTTER DEVICE TYPE',15X,'21     I1   0<=N<=9',I9)
 9035 FORMAT (5X,
     &   'IPRMSG    TDDS MESSAGE PRINTOUT OPTION      22     I1     0/1'
     &   ,I11,/,5X,
     &   'IPLMSG    DISSPLA MESSAGE PRINTOUT OPTION   23     I1     0/1'
     &   ,I11,/,5X,'IEXOPT    EXTRAPOLATION OPTION',14X,
     &   '24     I1     0/1',I11,/,5X,
     &   'TYPETA    FRICTION RESISTANCE TYPE',10X,'25     I1   1<=N<=7',
     &   I9,/,5X,'INHR      INITIAL-VALUE DATA HOUR',9X,
     &   '26-27    I2   0<=N<25',I9,/,5X,
     & 'INMN      INITIAL-VALUE DATA MINUTE       28-29    I2   0<=N<60'
     & ,I9,/,5X,'IDTM      TIME STEP',23X,'30-33    I4   -------',I9,/,
     & 5X,'THETA     THETA WEIGHTING FACTOR',9X,
     & ' 34-36   F3.2  0<=N<=1',F9.2)
 9040 FORMAT (5X,'QQTOL     DISCHARGE CONVERGENCE',11X,
     &        '37-41   F5.1  -------',F9.1,/,5X,
     &        'ZZTOL     STAGE CONVERGENCE',15X,'42-46   F5.3  -------',
     &        F9.3,/,5X,'WSPEED    CONSTANT WIND SPEED',13X,
     &        '47-51   F5.2  -------',F9.2,/,5X,
     &        'WSDRAG    SURFACE DRAG COEFFICIENT',8X,
     &        '52-56   F5.4  -------',F9.4,/,5X,
     &        'H2ODEN    WATER DENSITY',19X,'57-61   F5.4  -------',
     &        F9.4,/,5X,'CHI       CHI WEIGHTING FACTOR',11X,
     &        ' 62-64   F3.2  0<=N<=1',F9.2,/,5X,
     &        'IWRTIC    WRITE INITIAL-VALUE FILE',10X,
     &        '65     I1     0/1',I11,/,5X,'IENIBC',4X,
     &        'ENERGY CONSERVATION B.C OPTION    66     I1     0/1',I11,
     &        /,5X,'IRDIC     READ INITIAL-VALUE FILE',11X,
     &        '67     I1     0/1',I11,/,5X,
     & 'NUMCOM    NUMBER OF COMMENT RECORDS INPUT   68     I1   0<=N<10'
     & ,I9)
 9045 FORMAT (5X,'WDIREC    CONSTANT WIND DIRECTION',9X,
     &        '69-73   F5.1  -------',F9.1,/,5X,
     &  'INWIND    TIME-VARYING WIND INPUT OPTION    74     I1     0/1',
     &  I11,/,5X,
     &  'OTFILE    OUTPUT RESULTS TO A FILE OPTION   75     I1   0<=N<6'
     &  ,I10,/,5X,
     &  'IWMOPT    WARNING MESSAGE PRINTOUT OPTION   76     I1   0<=N<4'
     &  ,I10,/,5X,
     &  'IARDEM    ARRAY DIMENSION PRINTOUT OPTION   77     I1     0/1',
     &  I11,/,5X,
     &  'IPRFMT    NARROW/WIDE PRINT FORMAT OPTION   78     I1     0/1',
     &  I11,/,5X,
     &  'KTCONS    SALINITY TRANSPORT OPTION         79     I1     0/1',
     &  I11,/,5X,
     &  'IRDNXT    READ SECOND COMP-CONTROL RECORD   80     I1     0/1',
     &  I11)
 9050 FORMAT (5X,
     &   'GLBETA    GLOBAL DEFAULT BETA COEFFICIENT  1-4    F4.2   N>=1'
     &   ,F11.3,/,5X,
     &   'GLETA     GLOBAL DEFAULT ETA COEFFICIENT   5-9    F5.4    N>0'
     &   ,F11.4,/,5X,
     &   'ETAMIN    MINIMUM ETA FOR OPTIMIZATION    10-14   F5.3    N>0'
     &   ,F11.4,/,5X,
     &   'ETAMAX    MAXIMUM ETA FOR OPTIMIZATION    15-19   F5.3    N<1'
     &   ,F11.4,/,5X,
     &  'TOLERR    OPTIMIZATION ERROR TOLERENCE    20-23   F4.2   0<N<1'
     &  ,F10.3,/,5X,
     & 'IPRTDT    TABULAR PRINTOUT TIME STEP      24-27    I4   -------'
     & ,I9)
 9055 FORMAT (5X,
     & 'GLICQ     GLOBAL INITIAL DISCHARGE        30-37   F8.1  -------'
     & ,F9.1,/,5X,
     & 'GLICZ     GLOBAL INITIAL STAGE            38-43   F6.2  -------'
     & ,F9.2,/,5X,
     & 'DCFM      FRICTION MULTIPLIER DRY CHANNEL 44-49   F6.2  -------'
     & ,F9.2,/,5X,
     & 'AIRDEN    AIR DENSITY',21X,'50-57   F8.6  -------',F9.6,/,5X,
     & 'H2OSAL    WATER SALINITY',18X,'58-63   F6.3  -------',F9.3,/,5X,
     & 'H2OTMP    WATER TEMPERATURE',15X,'64-69   F6.3  -------',F9.3,/,
     & 5X,
     & 'DSPRSN    DEFAULT DISPERSION COEFFICIENT  70-76   F7.1  -------'
     & ,F9.1,/,5X,
     & 'GPRBCH    BRANCH RESULTS PRINT OVERRIDE     77     I1    0/1/2',
     & I10,/,5X,
     & 'GPLBCH    BRANCH RESULTS PLOT OVERRIDE      78     I1    0/1/2',
     & I10,/,5X,
     & 'GPRTXS    INPUT GEOMETRY PRINT OVERRIDE     79     I1    0/1/2',
     & I10)
 9057 FORMAT (//,1X,79('='),//,5X,'STAGE COMPUTATION DATUM',30X,F9.3,//,
     &        1X,79('='),/)
 9060 FORMAT (/,15X,'BOUNDARY-VALUE DATA DEFINITION',//,7X,
     &        'STATION NUMBER  TYPE  JUNCTION  NDATA  DTT  DATUM')
 9065 FORMAT (5X,A16,3X,A2,2I8,I7,F7.3)
 9070 FORMAT (/,5X,'TIME-VARYING NODAL-FLOW DATA DEFINITION',//,7X,
     &        'STATION NUMBER  TYPE  JUNCTION  NDATA  DTT  DATUM')
 9075 FORMAT (/5X,'CONSTANT NODAL-FLOW INPUT AT JUNCTION',I3,' =',F10.2,
     &        1X,A2,'**3/SEC')
 9080 FORMAT (/,5X,'CULVERT NODAL-FLOW DEFINED AT JUNCTION',I3)
 9085 FORMAT (/,5X,'TIME-VARYING WIND INPUT AT',I5,
     &        ' MINUTE INTERVAL FROM STATION',1X,A16)
 9090 FORMAT (/,5X,'MEASURED DATA INPUT AT BRANCH (',I2,
     &        ') CROSS SECTION (',I2,')')
 9095 FORMAT (5X,A16,3X,A2,2I8,I7,F7.3,2X,A2,'(t) =',F11.3)
 9100 FORMAT (/,1X,79('='),/)
 9105 FORMAT (5X,A16,3X,A2,2I8,I7,F7.3,2X,A2,'(t) =  RATING TABLE')
 9110 FORMAT (5X,A16,3X,A2,2I8,I7,F7.3)
 9111 FORMAT (4X,A2,'(',A1,') =',E11.4,' +',E12.4,'*',A1,' +',E12.4,'*',
     &        A1,'**2 +',E12.4,'*',A1,'**3')
 9112 FORMAT (5X,'Z(t) =',F7.2,' +',F5.2,' * SIN( (t/',F6.0,'*180.)+',
     &        F4.0,'deg )')
 9115 FORMAT (' BRANCH MODEL RUN FOR FLOW CONDITIONS OF',I3,2('/',I2.2),
     &        I3.2,':',I2.2,' TO',I3,2('/',I2.2),I3.2,':',I2.2,/)
 9120 FORMAT ('1CHANNEL GEOMETRY FOR ',A80,//,' BRANCH',I3,
     &        ' FROM JUNCTION',I3,' TO',I3,' :',1X,A40)
 9125 FORMAT (/,'  CROSS SECTION',I3,' :   STAGE',7X,'AREA',6X,
     &        'WIDTH   STO_WID  STO_AREA WET_PERMTR')
 9130 FORMAT ('+',T86,'ETA')
 9135 FORMAT ('+',T92,'DISCHARGE')
 9140 FORMAT ('+',T104,'TEMPERATURE')
 9145 FORMAT ('  DATUM =',F8.3,7X,'(',A2,')     (',A2,'**2)      (',A2,
     &        ')      (',A2,')   (',A2,'**2)      (',A2,')')
 9150 FORMAT ('+',T92,'(',A2,'**3/S)')
 9155 FORMAT ('+',T107,'(DEG C)')
 9160 FORMAT ('+',T107,'(DEG F)')
 9165 FORMAT (1X,A16,' (',3(A2,'/'),A2,')')
 9170 FORMAT ((F28.2,F12.1,4F10.1))
 9175 FORMAT ((F28.2,F12.1,4F10.1,F10.4,F10.1,F12.1))
 9180 FORMAT ((F28.2,F12.1,4F10.1,F10.4,F22.1))
 9185 FORMAT ((F28.2,F12.1,4F10.1,F10.4,F10.1))
 9190 FORMAT ((F28.2,F12.1,4F10.1,F10.4))
 9195 FORMAT (/'  INIT. VALUE: STAGE=',F6.2,'; DISC.=',F9.1,'; RHO=',
     &        F10.4,'; BETA=',F6.3)
 9200 FORMAT (2X,71('-'))
 9205 FORMAT ('  LENGTH=',F8.1,1X,A2,';',7X,'TEMP=',F5.1,' DEG',A2,';',
     &        6X,'ORIENTATION=',F6.1,' DEG',/,'  q=',F10.5,';',13X,'u=',
     &        F10.5)
 9210 FORMAT ('  ETA=',E13.6,/)
 9215 FORMAT ('+',19X,'+ (',E13.6,')*',A1)
 9220 FORMAT ('+',18X,2(' + (',E13.6,')*',A1),'**2')
 9225 FORMAT (/,'  ETA = F(',A1,')')
 9230 FORMAT ('INITIAL STAGE',F7.2,
     &        ' OUT OF DEFINED RANGE OF CHANNEL GEOMETRY')
 9235 FORMAT (' *WARNING* SEGMENT LENGTH DX(',I2,',',I2,') =',F8.1,
     &        ' IS OUT OF RANGE',F7.1,'<DX<',F7.1)
 9240 FORMAT (' *WARNING* FRICTION FACTOR RN(',I2,',',I2,') =',F8.5,
     &        ' IS OUT OF RANGE   0.01<RN<0.05')
 9245 FORMAT (/,I5,' MINUTE TIME STEP AND DX(',I2,',',I2,')  =',F9.1,
     &        ' YIELDS COURANT NUMBER OF',F6.1)
 9250 FORMAT (I5,' MINUTE TIME STEP AND BRANCH',I3,'  =',F9.1,
     &        ' YIELDS COURANT NUMBER OF',F6.1/)
 9255 FORMAT ('  ISTRM=',3I10,';  CLK=',F10.5,';  ZBOT=',F10.5)
      END
