      SUBROUTINE RDCOMP
C
C     Read in program control parameters and assign defaults
C     Note, routine must be modified to run in a non-interacteve mode
C
      INCLUDE 'dimens.cmn'
      INCLUDE 'zqstat.cmn'
      INCLUDE 'comcon.cmn'
      INCLUDE 'untmes.cmn'
      INCLUDE 'convt.cmn'
      INCLUDE 'units.cmn'
      INCLUDE 'lunums.cmn'
      INCLUDE 'logics.cmn'
      INCLUDE 'netwrk.cmn'
      CHARACTER errm*4, msg*56
      INTEGER i
      CHARACTER*80 Coment(9)
      COMMON /CMMNT / Coment
      EXTERNAL IOFILE, COMCTL, CHKCOM, ERRSTP
C
C---Open reader and printr files
      CALL IOFILE
C
C---Assign defaults
      DO 10 i = 1, MAXS
        Qmax(i) = BIGNEG
        Qmin(i) = BIGPOS
        Qsum(i) = 0.0
   10 CONTINUE
      Gleta = 0.0
      Glbeta = 1.0
      Glicq = 0.0
      Glicz = 0.0
      Dcfm = 0.0
      Airden = 0.0
      H2osal = 0.0
      H2otmp = 0.0
      Etamin = 0.0
      Etamax = 0.0
      Tolerr = 0.0
      Iprtdt = 0
      Modflow = .FALSE.
      Trnsprt = .FALSE.
C
C---Read in first computational-control record
      errm = '1ST '
      READ (Reader,9005,END=30) Netnam
      READ (Reader,9010,ERR=60,END=40) Iunit, Nbch, Njnc, Nbnd, Nsteps, 
     &                         Ounit, Irdgeo, Imodfw, Nit, Ipropt, 
     &                         Iplopt, Ipldev, Iprmsg, Iplmsg, Iexopt,
     &                         Typeta, Inhr, Inmn, Idtm, Theta, Qqtol,
     &                         Zztol, Wspeed, Wsdrag, H2oden, Chi,
     &                         Iwrtic, Ienibc, Irdic, Numcom, Wdirec, 
     &                         Inwind, Otfile, Iwmopt, Iardem, Iprfmt,
     &                         Ktcons, Irdnxt
C
C---Read in second computational-control record, if needed
      IF (Irdnxt.NE.0) THEN
        errm = '2ND '
        READ (Reader,9015,ERR=60,END=40) Glbeta, Gleta, Etamin, Etamax, 
     &        Tolerr, Iprtdt, Glicq, Glicz, Dcfm, Airden, H2osal,
     &        H2otmp, Dsprsn, Gprbch, Gplbch, Gprtxs
      ENDIF
C
C---Read in comment records if input
      DO 20 i = 1, Numcom
        READ (Reader,9005,END=50) Coment(i)
   20 CONTINUE
C
C---Display computational control parameters and allow update
      CALL COMCTL
C
C---Set logical variables that control printing and plots
      Daysum = Ipropt.EQ.2 .OR. Ipropt.EQ.4
      Noprit = Ipropt.NE.1 .AND. Ipropt.NE.6 .AND. Ipropt.NE.8
      Dtprt = Ipropt.LT.2 .OR. (Ipropt.GT.4 .AND. Ipropt.LT.9)
      Ptplt = Ipropt.EQ.3 .AND. Iplopt.NE.0 .AND. Ipldev.EQ.0 .AND.
     &        Gplbch.NE.1
      Oplots = Iplopt.NE.0 .AND. Ipldev.NE.0 .AND. Gplbch.NE.1
      Stages = Iplopt.EQ.2 .OR. Iplopt.EQ.4
      Prtmsg = Iprmsg.NE.0
      Noextp = Iexopt.EQ.0
      Ottddb = Otfile.EQ.1
C
C---Set conversion factors
      IF (Iunit.NE.Ounit) THEN
        Noconv = .FALSE.
C---Conversion from English (input) to Metric (output) required
        IF (Iunit.EQ.En) THEN
          Qconvt = 0.02832
          Zconvt = 0.3048
          Aconvt = 0.0929
        ELSE
C---Conversion from Metric (input) to English (output) required
          Qconvt = 35.31
          Zconvt = 3.281
          Aconvt = 10.76
        ENDIF
        Qzconv = Qconvt
        IF (Stages) Qzconv = Zconvt
      ELSE
C---No conversion required if Iunit equal Ounit
        Qzconv = 1.0
        Qconvt = 1.0
        Zconvt = 1.0
        Aconvt = 1.0
      ENDIF
C
C---Open remainder of files
      CALL IOFILE
C
C---Print out computational-control variables
      CALL CHKCOM
C
      WRITE (*,'(A/)') ' Control record read and initialization end!'
      RETURN
   30 msg = 'COMPUTATION-CONTROL FILE IS EMPTY'
      GOTO 70
   40 msg = 'END-OF-FILE READING '//errm//'COMPUTATION-CONTROL RECORD'
      GOTO 70
   50 msg = 'END-OF-FILE READING COMMENT RECORDS'
      GOTO 70
   60 msg = 'READING '//errm//'COMPUTATION-CONTROL RECORD'
   70 CALL ERRSTP(msg)
C
C---INPUT FORMAT STATEMENTS
 9005 FORMAT (A80)
 9010 FORMAT (A2,3I2,I4,A2,2I1,I2,7I1,2I2,I4,F3.2,F5.1,F5.3,F5.2,
     &        2F5.4,F3.2,4I1,F5.1,7I1)
 9015 FORMAT (F4.2,F5.4,2F5.3,F4.2,I4,2X,F8.1,2F6.2,F8.6,2F6.3,F7.1,3I1)
      END
C
      SUBROUTINE COMCTL
C
      INTEGER NUMCTL
      PARAMETER (NUMCTL=54)
      CHARACTER*6 fmt(NUMCTL)
C---measured data record extends past column 80
      CHARACTER*1 Ans(24), Record(88)
      CHARACTER mesg1*64, recrd*88, answ*24
      CHARACTER*80 Coment(9)
      EQUIVALENCE (Record(1),recrd)
      EQUIVALENCE (Ans(1),answ)
      COMMON /CMMNT / Coment
      INCLUDE 'dimens.cmn'
      INCLUDE 'comcon.cmn'
      INCLUDE 'untmes.cmn'
      INCLUDE 'netwrk.cmn'
      INCLUDE 'lunums.cmn'
      CHARACTER*6 Var(NUMCTL)
      CHARACTER*62 Msg(NUMCTL)
      COMMON /CMCTL / Msg, Var, Record, Ans
      INTEGER i, k, j, ih2odn, ichi, itheta, iqqtol, LENCHR
      LOGICAL update
      EXTERNAL GETCHR, UPCASE, GETCVL, GETIVL, GETOPT, GETRVL, OPNSCR, 
     &         CMPDEF, LENCHR
      INTEGER IFIX, MAX0
      INTRINSIC IFIX, MAX0
C
      update = .FALSE.
      Var(1) = 'IUNIT'
      Var(2) = 'NBCH'
      Var(3) = 'NJNC'
      Var(4) = 'NBND'
      Var(5) = 'NSTEPS'
      Var(6) = 'OUNIT'
      Var(7) = 'IRDGEO'
      Var(8) = 'IMODFW'
      Var(9) = 'NIT'
      Var(10) = 'IPROPT'
      Var(11) = 'IPLOPT'
      Var(12) = 'IPLDEV'
      Var(13) = 'IPRMSG'
      Var(14) = 'IPLMSG'
      Var(15) = 'IEXOPT'
      Var(16) = 'TYPETA'
      Var(17) = 'INHR'
      Var(18) = 'INMN'
      Var(19) = 'IDTM'
      Var(20) = 'THETA'
      Var(21) = 'QQTOL'
      Var(22) = 'ZZTOL'
      Var(23) = 'WSPEED'
      Var(24) = 'WSDRAG'
      Var(25) = 'H2ODEN'
      Var(26) = 'CHI'
      Var(27) = 'IWRTIC'
      Var(28) = 'IENIBC'
      Var(29) = 'IRDIC '
      Var(30) = 'NUMCOM'
      Var(31) = 'WDIREC'
      Var(32) = 'INWIND'
      Var(33) = 'OTFILE'
      Var(34) = 'IWMOPT'
      Var(35) = 'IARDEM'
      Var(36) = 'IPRFMT'
      Var(37) = 'KTCONS'
      Var(38) = 'IRDNXT'
      Var(39) = 'GLBETA'
      Var(40) = 'GLETA '
      Var(41) = 'ETAMIN'
      Var(42) = 'ETAMAX'
      Var(43) = 'TOLERR'
      Var(44) = 'IPRTDT'
      Var(45) = 'GLICQ '
      Var(46) = 'GLICZ '
      Var(47) = 'DCFM  '
      Var(48) = 'AIRDEN'
      Var(49) = 'H2OSAL'
      Var(50) = 'H2OTMP'
      Var(51) = 'DSPRSN'
      Var(52) = 'GPRBCH'
      Var(53) = 'GPLBCH'
      Var(54) = 'GPRTXS'
      fmt(1) = ' (A2)'
      fmt(2) = ' (I2)'
      fmt(3) = ' (I2)'
      fmt(4) = ' (I2)'
      fmt(5) = ' (I4)'
      fmt(6) = ' (A2)'
      DO 10 i = 7, 38
        fmt(i) = ' (I1)'
   10 CONTINUE
      fmt(9) = ' (I2)'
      fmt(17) = ' (I2)'
      fmt(18) = ' (I2)'
      fmt(19) = ' (I4)'
      fmt(20) = '(F3.2)'
      fmt(21) = '(F5.1)'
      fmt(22) = '(F5.3)'
      fmt(23) = '(F5.2)'
      fmt(24) = '(F5.4)'
      fmt(25) = '(F5.4)'
      fmt(26) = '(F3.2)'
      fmt(31) = '(F5.1)'
      fmt(39) = '(F4.2)'
      fmt(40) = '(F5.4)'
      fmt(41) = '(F5.3)'
      fmt(42) = '(F5.3)'
      fmt(43) = '(F4.2)'
      fmt(44) = ' (I4)'
      fmt(45) = '(F8.1)'
      fmt(46) = '(F6.2)'
      fmt(47) = '(F6.2)'
      fmt(48) = '(F8.6)'
      fmt(49) = '(F6.3)'
      fmt(50) = '(F6.3)'
      fmt(51) = '(F7.1)'
      fmt(52) = '(I1)'
      fmt(53) = '(I1)'
      fmt(54) = '(I1)'
      Msg(1) = 'Units of input (EN=english, ME=metric)'
      Msg(2) = 'Number of branches in the network'
      Msg(3) = 'Number of junctions (internal plus external) in network'
      Msg(4) = 'Number of junctions for boundary-condition definition'
      Msg(5) = 'Number of time steps to be computed'
      Msg(6) = 'Units of results (EN=english, ME=metric)'
      Msg(7) = 'Read geometry from separate file (0=no, 1=yes)'
      Msg(8) =
     &       'Coupled MODFLOW/BRANCH simulation (0=no, 1=yes, 2=ignore)'
      Msg(9) = 'Maximum number of iterations/time step (default=5)'
      Msg(10) = 'Printout options'
      Msg(11) = 'Plot options'
      Msg(12) = 'Plot device options'
      Msg(13) = 'Print messages from the TDDS (0=no, 1=yes)'
      Msg(14) = 'Print DISSPLA software messages (0=no, 1=yes)'
      Msg(15) = 'Extrapolate initial values (0=no, 1=yes)'
      Msg(16) = 'Bottom-friction relationship options'
      Msg(17) = 'Hour of initial-value data'
      Msg(18) = 'Minute of initial-value data'
      Msg(19) = 'Simulation time increment (>0=minutes, <0=seconds)'
      Msg(20) =
     &     'Time weighting factor for spatial derivatives (default=1.0)'
      Msg(21) = 'Discharge convergence criterion in ft**3/s or cm**3/ss'
      Msg(22) = 'Stage convergence criterion in feet or meters'
      Msg(23) = 'Wind speed in miles/hour or km/hour (default=0.0)'
      Msg(24) = 'Water-surface drag coefficient (default=0.0026)'
      Msg(25) = 'Water density in slugs/ft**3 OR gm/cm**3'
      Msg(26) =
     &  'Time weighting factor for geometric quantities (default=THETA)'
      Msg(27) = 'Store last conditions in .ico file (0=no, 1=yes)'
      Msg(28) = 'Conservation of energy as boundary condition option'
      Msg(29) = 'Read initial conditions from .ici file (0=no, 1=yes)'
      Msg(30) = 'Number of comment records input (maximum=9)'
      Msg(31) = 'Wind direction clockwise from north (default=0.0)'
      Msg(32) = 'Time-varying wind data input (0=no, 1=yes)'
      Msg(33) = 'Output file options'
      Msg(34) =
     &         'Suppress warnings (0=no, 1=iteration, 2=length, 3=both)'
      Msg(35) = 'Print model array dimensions (0=no, 1=yes)'
      Msg(36) = 'Print format option (0=narrow, 1=wide)'
      Msg(37) = 'Number of constitutents (presently salinity only)'
      Msg(38) = 'Read computation-control record 2 (0=no, 1=yes)'
      Msg(39) = 'Global default BETA coefficient'
      Msg(40) = 'Global default ETA coefficient'
      Msg(41) = 'Minimum ETA value for optimization'
      Msg(42) = 'Maximum ETA value for optimization'
      Msg(43) = 'Error tolerance for optimization'
      Msg(44) = 'Tabular printout time increment in minutes'
      Msg(45) = 'Global default initial-condition discharge'
      Msg(46) = 'Global default initial-condition stage'
      Msg(47) = 'Multiplier for friction term when channel is dry'
      Msg(48) = 'Air density in slugs/ft**3 OR gm/cm**3'
      Msg(49) = 'Global default water salinity in ppt or mg/l'
      Msg(50) = 'Global default water temperature in degrees F or C'
      Msg(51) = 'Global default longitudinal dispersion coefficient'
      Msg(52) =
     &   'Print flag for results (0=use PRTBCH & PRTSUM, 1=none, 2=all)'
      Msg(53) =
     &    'Plot flag for results (0=use PPLTBH & PLTBCH, 1=none, 2=all)'
      Msg(54) =
     &     'Print flag for input geometry (0=use PRTXSG, 1=none, 2=all)'
C
C---ASSIGN DEFAULT VALUES FOR VARIABLES ON COMPUTATION CONTROL RECORD.
      CALL CMPDEF
C
C---BEGINNING OF LOOP TO REQUEST CHANGE COMMANDS.
C
      WRITE (*,9085)
      answ = 'T'
      k = 0
   20 k = k + 1
      IF (k.EQ.25) THEN
        mesg1 = 
     & 'ENTER UP TO 10 CODES, N, T, #, H#, C, F, ?, OR <CR> TO CONTINUE'
        CALL GETCHR(mesg1,answ)
        CALL UPCASE(answ)
        IF (Ans(1).EQ.' ') Ans(1) = 'F'
        k = 1
      ENDIF
      IF (Ans(k).EQ.' ' .OR. Ans(k).EQ.',') GOTO 20
      IF (Ans(k).EQ.'F') GOTO 60
C
C---STOP IF THE COMMAND "Q" OR "q" IS FOUND.
      IF (Ans(k).EQ.'Q') STOP 'Quit requested'
C
C---DISPLAY TABLE SHOWING VARIABLE NUMBERS, FORMATS, AND VALUES.
      IF (Ans(k).EQ.'T') THEN
        WRITE (*,9020) Var(1), fmt(1), Iunit, Var(19), fmt(19), Idtm, 
     &                 Var(37), fmt(37), Ktcons, Var(2), fmt(2), Nbch, 
     &                 Var(20), fmt(20), Theta, Var(38), fmt(38), Irdnxt
     &                 , Var(3), fmt(3), Njnc, Var(21), fmt(21), Qqtol, 
     &                 Var(39), fmt(39), Glbeta, Var(4), fmt(4), Nbnd, 
     &                 Var(22), fmt(22), Zztol, Var(40), fmt(40), Gleta
        WRITE (*,9025) Var(5), fmt(5), Nsteps, Var(23), fmt(23), Wspeed,
     &                 Var(41), fmt(41), Etamin, Var(6), fmt(6), Ounit, 
     &                 Var(24), fmt(24), Wsdrag, Var(42), fmt(42), 
     &                 Etamax, Var(7), fmt(7), Irdgeo, Var(25), fmt(25), 
     &                 H2oden, Var(43), fmt(43), Tolerr, Var(8), fmt(8), 
     &                 Imodfw, Var(26), fmt(26), Chi, Var(44), fmt(44),
     &                 Iprtdt
        WRITE (*,9030) Var(9), fmt(9), Nit, Var(27), fmt(27), Iwrtic,
     &                 Var(45), fmt(45), Glicq, Var(10), fmt(10), Ipropt
     &                 , Var(28), fmt(28), Ienibc, Var(46), fmt(46),
     &                 Glicz, Var(11), fmt(11), Iplopt, Var(29), fmt(29)
     &                 , Irdic, Var(47), fmt(47), Dcfm, Var(12), fmt(12)
     &                 , Ipldev, Var(30), fmt(30), Numcom, Var(48),
     &                 fmt(48), Airden
        WRITE (*,9035) Var(13), fmt(13), Iprmsg, Var(31), fmt(31), 
     &                 Wdirec, Var(49), fmt(49), H2osal, Var(14),
     &                 fmt(14), Iplmsg, Var(32), fmt(32), Inwind,
     &                 Var(50), fmt(50), H2otmp, Var(15), fmt(15),
     &                 Iexopt, Var(33), fmt(33), Otfile, Var(51),
     &                 fmt(51), Dsprsn, Var(16), fmt(16), Typeta,
     &                 Var(34), fmt(34), Iwmopt, Var(52), fmt(52),
     &                 Gprbch
        WRITE (*,9040) Var(17), fmt(17), Inhr, Var(35), fmt(35), Iardem, 
     &                 Var(53), fmt(53), Gplbch, Var(18), fmt(18), Inmn,
     &                 Var(36), fmt(36), Iprfmt, Var(54), fmt(54),
     &                 Gprtxs
C
C---UPDATE NETWORK NAME RECORD.
C---IF A SINGLE "Q" OR "QUIT" IS ENTERED THE PROGRAM WILL TERMINATE.
C---IF A <CR> IS ENTERED THE OLD VALUE IS RETAINED.
      ELSEIF (Ans(k).EQ.'N') THEN
        mesg1 = 'NETWORK NAME'
        CALL GETCVL(mesg1,Netnam)
        update = .TRUE.
C
C---BEGIN THE VARIABLE HELP SECTION.
      ELSEIF (Ans(k).EQ.'H') THEN
        j = k
   30   j = j + 1
        IF (j.GT.24) THEN
          WRITE (*,*) 
     &          '*WARNING* a number must follow the "H" to receive help'
        ELSE
          IF (Ans(j).EQ.' ') GOTO 30
          k = j
          IF (Ans(j+1).NE.' ' .AND. Ans(j+1).NE.',') THEN
            j = j + 1
            IF (Ans(j).GT.'9') j = j - 1
          ENDIF
          IF (Ans(k).GT.'9') THEN
            i = 99
          ELSE
            READ (Ans(k),'(I1)',ERR=50) i
            IF (k.NE.j) THEN
              k = j
              READ (Ans(k),'(I1)',ERR=50) j
              i = i*10 + j
            ENDIF
          ENDIF
          IF (i.GT.NUMCTL .OR. i.LT.1) THEN
            WRITE (*,9065)
          ELSE
            WRITE (*,9070) i, Msg(i)
            IF (i.EQ.10) WRITE (*,9045)
            IF (i.EQ.11) WRITE (*,9050)
            IF (i.EQ.12) WRITE (*,9055)
            IF (i.EQ.16) WRITE (*,9060)
            IF (i.EQ.33) WRITE (*,9090)
          ENDIF
        ENDIF
      ELSEIF (Ans(k).EQ.'?') THEN
        WRITE (*,9005)
      ELSE
        IF (Ans(k).EQ.'C') THEN
          i = 30
        ELSE
          IF (Ans(k).GT.'9') THEN
            WRITE (*,*) '*WARNING* invalid response -- ', Ans(k)
            GOTO 20
          ENDIF
          READ (Ans(k),'(I1)',ERR=50) i
          IF (Ans(k+1).GE.'0' .AND. Ans(k+1).LE.'9') THEN
            k = k + 1
            READ (Ans(k),'(I1)',ERR=50) j
            i = i*10 + j
          ENDIF
        ENDIF
        IF (i.GT.NUMCTL .OR. i.LT.1) THEN
          WRITE (*,*) '*WARNING* invalid value, enter a number from 1-', 
     &                NUMCTL
        ELSE
          update = .TRUE.
C
C---SECTION TO UPDATE COMMENT RECORD(S).
C---IF A "C" WAS ENTERED AS A COMMAND, I IS SET TO 28 ABOVE. THE NUMCOM
C---VARIABLE IS FIRST UPDATED, <CR> RETAINS OLD VALUE.  THE OLD COMMENT
C---RECORD IS DISPLAYED AND A PROMPT ISSUED FOR THE NEW VALUE.  A <CR>
C---RETAINS OLD VALUE, AND A "Q" WILL TERMINATE EXECUTION.
          WRITE (mesg1,9075) i, Var(i)
          IF (i.GT.35) Irdnxt = 1
          IF (i.EQ.30) THEN
            CALL GETIVL(mesg1,0,9,Numcom)
            mesg1 = 'ENTER NEW COMMENT RECORD'
            DO 40 j = 1, Numcom
              CALL GETCVL(mesg1,Coment(j))
   40       CONTINUE
C
C---THIS BLOCK IF SECTION IS THE UPDATE PROCEDURE FOR EACH VARIABLE
C---THE SUBROUTINE GETVAL IS CALLED, PASSING THE APPROPRIATE VARIABLE.
          ELSEIF (i.EQ.1) THEN
            CALL GETCVL(mesg1,Iunit)
            CALL UPCASE(Iunit)
          ELSEIF (i.EQ.2) THEN
            CALL GETIVL(mesg1,1,MXBH,Nbch)
          ELSEIF (i.EQ.3) THEN
            CALL GETIVL(mesg1,2,MXJN,Njnc)
          ELSEIF (i.EQ.4) THEN
            CALL GETIVL(mesg1,2,MXJN,Nbnd)
          ELSEIF (i.EQ.5) THEN
            CALL GETIVL(mesg1,0,9999,Nsteps)
          ELSEIF (i.EQ.6) THEN
            CALL GETCVL(mesg1,Ounit)
            CALL UPCASE(Ounit)
          ELSEIF (i.EQ.7) THEN
            CALL GETOPT(mesg1,Irdgeo)
          ELSEIF (i.EQ.8) THEN
            CALL GETIVL(mesg1,0,2,Imodfw)
          ELSEIF (i.EQ.9) THEN
            CALL GETIVL(mesg1,0,20,Nit)
          ELSEIF (i.EQ.10) THEN
            CALL GETIVL(mesg1,0,9,Ipropt)
          ELSEIF (i.EQ.11) THEN
            CALL GETIVL(mesg1,0,4,Iplopt)
          ELSEIF (i.EQ.12) THEN
            CALL GETIVL(mesg1,0,9,Ipldev)
          ELSEIF (i.EQ.13) THEN
            CALL GETOPT(mesg1,Iprmsg)
          ELSEIF (i.EQ.14) THEN
            CALL GETOPT(mesg1,Iplmsg)
          ELSEIF (i.EQ.15) THEN
            CALL GETOPT(mesg1,Iexopt)
          ELSEIF (i.EQ.16) THEN
            CALL GETIVL(mesg1,0,7,Typeta)
          ELSEIF (i.EQ.17) THEN
            CALL GETIVL(mesg1,0,24,Inhr)
          ELSEIF (i.EQ.18) THEN
            CALL GETIVL(mesg1,0,60,Inmn)
          ELSEIF (i.EQ.19) THEN
            CALL GETIVL(mesg1,-999,9999,Idtm)
          ELSEIF (i.EQ.20) THEN
            CALL GETRVL(mesg1,2,0.0,1.0,Theta)
          ELSEIF (i.EQ.21) THEN
            CALL GETRVL(mesg1,1,0.0,1000.0,Qqtol)
          ELSEIF (i.EQ.22) THEN
            CALL GETRVL(mesg1,3,0.0,10.0,Zztol)
          ELSEIF (i.EQ.23) THEN
            CALL GETRVL(mesg1,2,0.0,100.0,Wspeed)
          ELSEIF (i.EQ.24) THEN
            CALL GETRVL(mesg1,4,0.0,1.0,Wsdrag)
          ELSEIF (i.EQ.25) THEN
            CALL GETRVL(mesg1,4,0.0,2.0,H2oden)
          ELSEIF (i.EQ.26) THEN
            CALL GETRVL(mesg1,2,0.0,1.0,Chi)
          ELSEIF (i.EQ.27) THEN
            CALL GETOPT(mesg1,Iwrtic)
          ELSEIF (i.EQ.28) THEN
            CALL GETOPT(mesg1,Ienibc)
          ELSEIF (i.EQ.29) THEN
            CALL GETOPT(mesg1,Irdic)
          ELSEIF (i.EQ.31) THEN
            CALL GETRVL(mesg1,1,0.0,360.0,Wdirec)
          ELSEIF (i.EQ.32) THEN
            CALL GETOPT(mesg1,Inwind)
          ELSEIF (i.EQ.33) THEN
            CALL GETIVL(mesg1,0,5,Otfile)
          ELSEIF (i.EQ.34) THEN
            CALL GETIVL(mesg1,0,3,Iwmopt)
          ELSEIF (i.EQ.35) THEN
            CALL GETOPT(mesg1,Iardem)
          ELSEIF (i.EQ.36) THEN
            CALL GETOPT(mesg1,Iprfmt)
          ELSEIF (i.EQ.37) THEN
            CALL GETIVL(mesg1,0,10,Ktcons)
          ELSEIF (i.EQ.38) THEN
            CALL GETOPT(mesg1,Irdnxt)
          ELSEIF (i.EQ.39) THEN
            CALL GETRVL(mesg1,2,0.0,10.0,Glbeta)
          ELSEIF (i.EQ.40) THEN
            CALL GETRVL(mesg1,4,0.0,10.0,Gleta)
          ELSEIF (i.EQ.41) THEN
            CALL GETRVL(mesg1,3,0.0,10.0,Etamin)
          ELSEIF (i.EQ.42) THEN
            CALL GETRVL(mesg1,3,0.0,10.0,Etamax)
          ELSEIF (i.EQ.43) THEN
            CALL GETRVL(mesg1,2,0.0,10.0,Tolerr)
          ELSEIF (i.EQ.44) THEN
            CALL GETIVL(mesg1,0,9999,Iprtdt)
          ELSEIF (i.EQ.45) THEN
            CALL GETRVL(mesg1,1,0.0,BIGPOS,Glicq)
          ELSEIF (i.EQ.46) THEN
            CALL GETRVL(mesg1,2,0.0,10000.0,Glicz)
          ELSEIF (i.EQ.47) THEN
            CALL GETRVL(mesg1,2,0.0,10000.0,Dcfm)
          ELSEIF (i.EQ.48) THEN
            CALL GETRVL(mesg1,2,0.0,1.0,Airden)
          ELSEIF (i.EQ.49) THEN
            CALL GETRVL(mesg1,2,0.0,45.0,H2osal)
          ELSEIF (i.EQ.50) THEN
            CALL GETRVL(mesg1,2,-20.0,100.0,H2otmp)
          ELSEIF (i.EQ.51) THEN
            CALL GETRVL(mesg1,2,-9999.9,99999.9,Dsprsn)
          ELSEIF (i.EQ.52) THEN
            CALL GETIVL(mesg1,0,2,Gprbch)
          ELSEIF (i.EQ.53) THEN
            CALL GETIVL(mesg1,0,2,Gplbch)
          ELSEIF (i.EQ.54) THEN
            CALL GETIVL(mesg1,0,2,Gprtxs)
          ENDIF
        ENDIF
      ENDIF
      GOTO 20
   50 IF (i.GT.NUMCTL .OR. i.LT.1) THEN
        WRITE (*,9065)
        GOTO 20
      ENDIF
C
C---THIS SECTION WRITES THE UPDATED DATA TO A SCRATCH FILE (OPEN
C---ON UNIT 51), READS IN THE REMAINDER OF THE COMPUTATION
C---CONTROL FILE (OPEN ON UNIT READER, USUALLY 5), AND WRITES
C---THIS DATA ALSO TO THE SCRATCH FILE.
   60 IF (.NOT.update) GOTO 130
C
C---Assign defaults after update
      CALL CMPDEF
      CALL OPNSCR(Luscr)
      iqqtol = IFIX(Qqtol*10.0+0.5)
      ih2odn = IFIX(H2oden*10000.0+0.5)
      ichi = IFIX(Chi*100.0+0.5)
      itheta = IFIX(Theta*100.0+0.5)
      WRITE (*,*)
      WRITE (Luscr,9080) Netnam
      WRITE (Luscr,9010) Iunit, Nbch, Njnc, Nbnd, Nsteps, Ounit, Irdgeo, 
     &                   Imodfw, Nit, Ipropt, Iplopt, Ipldev, Iprmsg,
     &                   Iplmsg, Iexopt, Typeta, Inhr, Inmn, Idtm,
     &                   itheta, iqqtol, Zztol, Wspeed, Wsdrag, ih2odn,
     &                   ichi, Iwrtic, Ienibc, Irdic, Numcom, Wdirec,
     &                   Inwind, Otfile, Iwmopt, Iardem, Iprfmt, Ktcons,
     &                   Irdnxt
C
C---THE SECOND COMP. CONTROL RECORD IS WRITTEN TO THE SCRATCH FILE
C---DEPENDENT ON THE CURRENT VALUE OF IRDNXT.
      IF (Irdnxt.NE.0) WRITE (Luscr,9015) Glbeta, Gleta, Etamin, Etamax, 
     &                        Tolerr, Iprtdt, Glicq, Glicz, Dcfm, Airden
     &                        , H2osal, H2otmp, Dsprsn, Gprbch, Gplbch,
     &                        Gprtxs
      DO 70 i = 1, Numcom
        WRITE (Luscr,9080) Coment(i)
   70 CONTINUE
   80 READ (Reader,9080,END=90) recrd
      WRITE (Luscr,9080) recrd
      GOTO 80
C
C---THE READER AND SCRATCH FILE ARE REWOUND. THE CONTENTS OF THE SCRATCH
C---FILE ARE WRITTEN TO THE READER FILE AND THE READER FILE IS TRUNCATED
C---TO AVOID ANY EXTRANEOUS DATA AT THE END OF THE FILE. 
   90 REWIND Reader
      REWIND Luscr
  100 READ (Luscr,9080,END=110) recrd
      i = LENCHR(recrd)
      i = MAX0(1,i)
      WRITE (Reader,9080) recrd(1:i)
      GOTO 100
  110 ENDFILE Reader
      REWIND Reader
      READ (Reader,9080) recrd
      READ (Reader,9080) recrd
      IF (Irdnxt.NE.0) READ (Reader,9080) recrd
      DO 120 i = 1, Numcom
        READ (Reader,9080) recrd
  120 CONTINUE
      CLOSE (Luscr,STATUS='DELETE')
  130 RETURN
C
 9005 FORMAT (/,
     &' You may modify the first three record types of the computation-c
     &ontrol file',/,
     &' using the following options.  You may enter up to six of these o
     &ptions per',/,
     &' response separated by a blank or comma, for example "H10 10 5,H1
     &1,T,C"',//,5X,'Code',T35,'Function',/,6X,
     &'N  --  To change the NETWORK-NAME record.',/,6X,
     &'T  --  To display a table identifying the values assigned to',/,
     &13X,'variables of the COMPUTATION-CONTROL records.',/,6X,
     &'#  --  To change the value of a variable, enter its NUMBER (as',
     &/,13X,'shown in the table) and the new VALUE when requested.',/,
     &6X,'H# --  To display a HELP message for a variable.',/,6X,
     &'C  --  To change the COMMENT records.',/,6X,
     &'F  --  When FINISHED (saves changes and begins simulation, defaul
     &t)',/,6X,'?  --  To redisplay this message.')
 9010 FORMAT (A2,3I2,I4,A2,2I1,I2,7I1,2I2,I4,I3,I5,F5.3,F5.2,F5.4,I5,I3,
     &        4I1,F5.1,7I1)
 9015 FORMAT (F4.2,F5.4,2F5.3,F4.2,I4,2X,F8.1,2F6.2,F8.6,2F6.3,F7.1,3I1)
 9020 FORMAT (/,
     &' NO VARIABLE FORMAT VALUE   NO VARIABLE FORMAT VALUE   NO VARIABL
     &E FORMAT VALUE',/,1X,78('-'),/,'  1',2A7,6X,A2,' | 19',2A7,I8,
     &' | 37',2A7,I8,/,'  2',2A7,I8,' | 20',2A7,F8.2,' | 38',2A7,I8,/,
     &'  3',2A7,I8,' | 21',2A7,F8.1,' | 39',2A7,F8.2,/,'  4',2A7,I8,
     &' | 22',2A7,F8.3,' | 40',2A7,F8.4)
 9025 FORMAT ('  5',2A7,I8,' | 23',2A7,F8.2,' | 41',2A7,F8.3,/,'  6',2A7
     &        ,6X,A2,' | 24',2A7,F8.4,' | 42',2A7,F8.3,/,'  7',2A7,I8,
     &        ' | 25',2A7,F8.4,' | 43',2A7,F8.2,/,'  8',2A7,I8,' | 26',
     &        2A7,F8.2,' | 44',2A7,I8)
 9030 FORMAT ('  9',2A7,I8,' | 27',2A7,I8,' | 45',2A7,F8.1,/,' 10',2A7
     &        ,I8,' | 28',2A7,I8,' | 46',2A7,F8.2,/,' 11',2A7,I8,' | 29'
     &        ,2A7,I8,' | 47',2A7,F8.2,/,' 12',2A7,I8,' | 30',2A7,I8,
     &        ' | 48',2A7,F8.6)
 9035 FORMAT (' 13',2A7,I8,' | 31',2A7,F8.1,' | 49',2A7,F8.3,/,' 14',2A7
     &        ,I8,' | 32',2A7,I8,' | 50',2A7,F8.3,/,' 15',2A7,I8,
     &        ' | 33',2A7,I8,' | 51',2A7,F8.1,/,' 16',2A7,I8,' | 34',
     &        2A7,I8,' | 52',2A7,I8)
 9040 FORMAT (' 17',2A7,I8,' | 35',2A7,I8,' | 53',2A7,I8,/,' 18',2A7,I8,
     &        ' | 36',2A7,I8,' | 54',2A7,I8)
 9045 FORMAT (7X,
     &  '0 = Results at every time step;  5 = Terms at every time step;'
     &  ,/,7X,
     &  '1 = Results at every iteration;  6 = Terms at every iteration;'
     &  ,/,7X,
     &  '2 = Daily summary of results;    7 = Debug at every time step;'
     &  ,/,7X,
     &  '3 = No tabular printout;         8 = Debug at every iteration;'
     &  ,/,7X,'4 = Monthly flow-volume summary; 9 = Particle locations')
 9050 FORMAT (7X,
     & '0 = No plots produced;  3 = Measured versus computed discharge;'
     & ,/,7X,
     & '1 = Computed discharge; 4 = Measured versus computed stage',/,
     & 7X,'2 = Computed stage;',/,7X,
     & '(Only cross sections with measured data are plotted for 3 & 4)')
 9055 FORMAT (7X,'0 = Line printer;            5 = TAB 132/15-G;',/,7X,
     &        '1 = DISSPLA post-processing; 6 = Tektronix 4014;',/,7X,
     &        '2 = CALCOMP;                 7 = Teltronix 4105;',/,7X,
     &        '3 = FR80;                    8 = Graphon;',/,7X,
     &        '4 = Hewlett-Packard 7475;    9 = Postscript file;',/,7X,
     &        '(For digital plots on PC''s or DG''s use any number 1-9)'
     &        ,/,7X,
     &        '(If IPLDEV is set to 0, then IPROPT must be set to 3)')
 9060 FORMAT (7X,'1 = Constant;    5 = Froude number;',/,7X,
     &        '2 = Temperature; 6 = Reynolds number;',/,7X,
     &        '3 = Depth;       7 = Water-surface elevation',/,7X,
     &        '4 = Discharge;')
 9065 FORMAT (' *WARNING* invalid help request -- ignored')
 9070 FORMAT (/,' Variable',I3,':  ',A)
 9075 FORMAT ('VARIABLE',I3,1X,A)
 9080 FORMAT (A)
 9085 FORMAT (/,
     &' This table shows the current values assigned to computational-va
     &riables based',/,' on values read in and program defaults.')
 9090 FORMAT (7X,'0 = no filed output; 3 = map file;',/,7X,
     &           '1 = TDDB;            4 = NetCDF file;',/,7X,
     &           '2 = BLTM flow file;  5 = User-table file')
      END
C
      SUBROUTINE CHKCOM
C
C     PRINT COMPUTATIONAL CONTROL HEADER, NETWORK NAME, AND USER COMMENT
C
      INCLUDE 'dimens.cmn'
      INCLUDE 'comcon.cmn'
      INCLUDE 'netwrk.cmn'
      INCLUDE 'lunums.cmn'
      CHARACTER*80 Coment(9)
      COMMON /CMMNT / Coment
C
      CHARACTER*76 msg
      INTEGER yr, mo, da, hr, mn, sec, i, iflg
      EXTERNAL SYSDATE, SYSTIME, ERRDIM, ERRPAR, ERRPRT, ERRLIN
C
C---Determine time of execution (system time)
      CALL SYSDATE(yr,mo,da)
      CALL SYSTIME(hr,mn,sec)
C
C---Print header of BRANCH simulation
      WRITE (Simdat,9045) yr, mo, da, hr, mn, sec
      WRITE (Printr,9030) Brdate(1:59), Simdat
      WRITE (*,9030) Brdate(1:59), Simdat
      WRITE (Printr,9035) Netnam
      WRITE (*,9035) Netnam
C
      DO 10 i = 1, Numcom
        WRITE (Printr,'(1X,A80)') Coment(i)
        WRITE (*,'(1X,A80)') Coment(i)
   10 CONTINUE
      IF (Numcom.NE.0) WRITE (Printr,9040)
C
      WRITE (*,*) 'Begin computation-control file verification!'
C
C---Determine if parameters in DIMENS.CMN are consistent
      iflg = 0
      IF (MAXS2.NE.MAXS*2) THEN
        CALL ERRDIM(MAXS2,MAXS*2,MAXS,'MAXS2 ',' MAXS ',
     &              'MAXS2 DOES NOT EQUAL MAXS*2')
        iflg = 1
      ENDIF
      IF (MAXS4.NE.MAXS*4) THEN
        CALL ERRDIM(MAXS4,MAXS*4,MAXS,'MAXS4 ',' MAXS ',
     &              'MAXS4 DOES NOT EQUAL MAXS*4')
        iflg = 1
      ENDIF
C
      IF (MXBH2.NE.MXBH*2) THEN
        CALL ERRDIM(MXBH2,MXBH*2,MXBH,'MXBH2 ',' MXBH ',
     &              'MXBH2 DOES NOT EQUAL MXBH*2')
        iflg = 1
      ENDIF
      IF (MXBH4.NE.MXBH*4) THEN
        CALL ERRDIM(MXBH4,MXBH*4,MXBH,'MXBH4 ',' MXBH ',
     &              'MXBH4 DOES NOT EQUAL MXBH*4')
        iflg = 1
      ENDIF
C
      IF (MXBH42.NE.(MXBH*4)**2) THEN
        CALL ERRDIM(MXBH42,(MXBH*4)**2,MXBH,'MXBH42',' MXBH ',
     &              'MXBH42 DOES NOT EQUAL (MXBH*4)**2')
        iflg = 1
      ENDIF
      IF (MXOTDT.NE.(MAXCZQ*MAXS/4)) THEN
        CALL ERRDIM(MXOTDT,MAXCZQ*MAXS/4,MAXCZQ,'MXOTDT','MAXCZQ',
     &              'MXOTDT DOES NOT EQUAL MAXCZQ*MAXS/4')
        iflg = 1
      ENDIF
C
      IF (Nbch.LT.1 .OR. Nbch.GT.MXBH) THEN
        CALL ERRPAR(0,Nbch,1,MXBH,'MXBH',
     &              'IMPROPER NUMBER OF BRANCHES SPECIFIED')
        iflg = 1
      ENDIF
      IF (Njnc.LT.1 .OR. Njnc.GT.MXJN) THEN
        CALL ERRPAR(0,Njnc,1,MXJN,'MXJN',
     &              'IMPROPER NUMBER OF JUNCTIONS SPECIFIED')
        iflg = 1
      ENDIF
      IF (Nbnd.LT.1 .OR. Nbnd.GT.MXJN) THEN
        CALL ERRPAR(0,Nbnd,1,MXJN,'MXJN',
     &              'IMPROPER NUMBER OF EXTERNAL BOUNDARIES SPECIFIED')
        iflg = 1
      ENDIF
C
      IF (Iplopt.GT.4) THEN
        WRITE (msg,9005) Iplopt
        CALL ERRPRT(msg)
        iflg = 2
      ENDIF
      IF (Ipropt.NE.3 .AND. Iplopt.NE.0 .AND. Ipldev.EQ.0) THEN
        WRITE (msg,9010)
        CALL ERRPRT(msg)
        WRITE (msg,9015) Ipropt, Iplopt
        CALL ERRLIN(msg)
C
        iflg = 2
      ENDIF
      IF (Iplopt.EQ.0 .AND. Ipldev.NE.0) WRITE (Printr,9020) Ipldev
      IF (Inhr.LT.0 .OR. Inhr.GT.24 .OR. Inmn.LT.0 .OR. Inmn.GT.59) THEN
        WRITE (msg,9025) Inhr, Inmn
        CALL ERRPRT(msg)
        iflg = 2
      ENDIF
C
C---CLOSEOUT
      IF (iflg.NE.0) STOP
      RETURN
C
 9005 FORMAT ('REQUESTED PLOT OPTION (IPLOPT =',I2,') IS INVALID')
 9010 FORMAT (
     &'INCONSISTENT COMBINATION OF PRINTED OUTPUT OPTIONS, BOTH TABULAR 
     &AND')
 9015 FORMAT ('PRINTER PLOT REQUESTED, IPROPT =',I2,', IPLOPT =',I2,
     &        ', AND IPLDEV = 0')
 9020 FORMAT (
     &' *WARNING* PLOTTER DEVICE SPECIFIED YET NO PLOTS REQUESTED, IPLDE
     &V =',I2,', IPLOPT = 0, PLOTTER DEVICE IGNORED')
 9025 FORMAT ('SPECIFIED TIME OF INITIAL-VALUE DATA IS INVALID, INHR =',
     &        I3,', INMN =',I3)
 9030 FORMAT (//,6X,A,/,8X,
     &        'Unsteady flow computation in a network of open channels',
     &        /,12X,'A four-point, implicit, finite-difference scheme',
     &        /,12X,'with linear matrix solution by gauss elimination',
     &        /,10X,
     &        'using maximum pivot strategy with optional iteration',//,
     &        13X,'Date and time of execution (',A,')',//,1X,79('='),/)
 9035 FORMAT (1X,A80,//,1X,79('='),/)
 9040 FORMAT (/,1X,79('='),/)
 9045 FORMAT (2(I2.2,'/'),I2.2,I3.2,2(':',I2.2))
      END
C
      SUBROUTINE CMPDEF
C
C     ASSIGN DEFAULT VALUES FOR VARIABLES ON COMPUTATION CONTROL RECORD.
C
      INCLUDE 'dimens.cmn'
      INCLUDE 'comcon.cmn'
      INCLUDE 'logics.cmn'
      INCLUDE 'limits.cmn'
      INCLUDE 'units.cmn'
      INCLUDE 'untmes.cmn'
C
      REAL ABS
      INTRINSIC ABS
C
      IF (Iunit.NE.Me) Iunit = En
      IF (Ounit.NE.Me) Ounit = En
      IF (Iunit.NE.En) THEN
        Unit = Mt
        Tunit = Dc
        Dxmin = 2000
        Dxmax = 8000
        IF (Zztol.LT.SMLVL .OR. Zztol.EQ.0.011) Zztol = 0.003
C Pure water density in gm/cm**3 at  0 deg C = 0.99987
C Pure water density in gm/cm**3 at  4 deg C = 1.00000
C Pure water density in gm/cm**3 at 10 deg C = 0.99973
C Pure water density in gm/cm**3 at 15 deg C = 0.99913
C Pure water density in gm/cm**3 at 20 deg C = 0.99823
C Pure water density in gm/cm**3 at 25 deg C = 0.99708
C Salt water density in gm/cm**3 at 20 deg C and S of 35 ppt = 1.02478
C To convert from gm/cm**3 to slug/ft**3 multiply by 1.94032
        IF (H2oden.LT.SMLVL .OR. H2oden.EQ.1.9617) H2oden = 1.011
C Air density in gm/cm**3 at  0 deg C = 0.001293
C Air density in gm/cm**3 at 10 deg C = 0.001247
C Air density in gm/cm**3 at 20 deg C = 0.001205
C       IF (Airden.LT.SMLVL) Airden = 0.001293
        IF (Airden.LT.SMLVL .OR. Airden.EQ.0.002338) Airden = 0.001205
        IF (ABS(H2otmp).LT.SMLVL .OR. H2otmp.EQ.68.0) H2otmp = 20.0
        G = 9.806
      ELSE
        IF (Zztol.LT.SMLVL .OR. Zztol.EQ.0.003) Zztol = 0.011
C Pure water density in slug/ft**3 at 32 deg F = 1.940
C Pure water density in slug/ft**3 at 39 deg F = 1.940
C Pure water density in slug/ft**3 at 50 deg F = 1.9398
C Pure water density in slug/ft**3 at 59 deg F = 1.9386
C Pure water density in slug/ft**3 at 68 deg F = 1.9369
C Pure water density in slug/ft**3 at 77 deg F = 1.9347
C Salt water density in slug/ft**3 at 68 deg F and S of 35 ppt = 1.9884
        IF (H2oden.LT.SMLVL .OR. H2oden.EQ.1.011) H2oden = 1.9617
C Air density in slugs/ft**3 at 32 deg F = 0.002509
C Air density in slugs/ft**3 at 50 deg F = 0.002420
C Air density in slugs/ft**3 at 68 deg F = 0.002338
C       IF (Airden.LT.SMLVL) Airden = 0.002509
        IF (Airden.LT.SMLVL .OR. Airden.EQ.0.001205) Airden = 0.002338
        IF (ABS(H2otmp).LT.SMLVL .OR. H2otmp.EQ.20.0) H2otmp = 68.0
        G = 32.174
      ENDIF
      IF (Nit.LT.1) Nit = 5
      IF (Typeta.EQ.0 .OR. Typeta.GT.7) Typeta = 1
      IF (Theta.LT.SMLVL .OR. Theta.GT.1.0) Theta = 1.0
      IF (Chi.LT.SMLVL .OR. Chi.GT.1.0) Chi = Theta
      IF (Wsdrag.LT.SMLVL) Wsdrag = 0.0026
      IF (Glbeta.LT.1.0) Glbeta = 1.0
      IF (Gleta.LT.0.0) Gleta = 0.0
      Modflow = .FALSE.
      IF (Imodfw.EQ.1) Modflow = .TRUE.
      Trnsprt = .FALSE.
      IF (Ktcons.GT.0) Trnsprt = .TRUE.
      RETURN
      END
