      SUBROUTINE STRUC(IJ,ZPIJ,ZPIJP1,QPIJ,QPIJP1,ZIJ,ZIJP1,QIJ,QIJP1,
     &                 ZDATUM,G,IBRPRN,KKPER,NCOL,NROW,NLAY,HOLD,Z,
     &                 RN3IJ,EPSLON,ZETA,OMEGA,GAMMA,ALPHA,DELTA,DET)
C
C # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
C #   THIS SUBROUTINE SETS UP THE EQUATIONS FOR HYDRAULIC STRUCTURES  #
C # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
C
      INCLUDE 'dimens.cmn'
      INCLUDE 'struct.cmn'
      INCLUDE 'xsinit.cmn'
C
      INTEGER IJ, IBRPRN, KKPER, NCOL, NROW, NLAY
      REAL ZPIJ, ZPIJP1, QPIJ, QPIJP1, Z(MAXS), ZIJ, ZIJP1, QIJ, QIJP1, 
     &     ZDATUM, G, HOLD(NCOL,NROW,NLAY), RN3IJ, EPSLON, ZETA, OMEGA,
     &     GAMMA, ALPHA, DELTA, DET
C
      REAL ag, azm, bar, cgs, coef, cus, diff, diffmx, hp, hpm, hpmax, 
     &     hpo, pi, power, qtemp, wlcrit, zb, zdc, zdo, aa, bb, cc, dd, 
     &     ee, twog, zec, zeo, zhigh, zi, zloc, zlow, zm, zmid, zp, zph,
     &     zetal
      INTEGER ic, icm, iflg, ioper, ioper1, nqflag, istype, ifac1, ifac2
C
      REAL FLOAT, ABS, SQRT
      INTRINSIC FLOAT, ABS, SQRT
C
C---Set structure coefficients and properties from values read on XS
C---records
      aa = Dx(IJ)
      bb = T(IJ)
      cc = Orient(IJ)
      dd = Betvel(IJ)
      ee = Clk(IJ)
      istype = Istrm(3,IJ)
      ifac1 = Istrm(2,IJ)
      ifac2 = Istrm(1,IJ)
C
      twog = 2.0*G
      zetal = 10.0
C
C---IF EXTENDED STRUCTURE RULES EXIST, THEY ARE USED TO EVALUATE THE
C---OPERATING RULES
C
      ioper = 2
      ioper1 = 0
      IF (istype.LT.-10) THEN
        istype = istype/10
        icm = Strmgt(1,1)
        ic = 1
        iflg = 0
   10   ic = ic + 1
        IF (ic.LE.icm+1) THEN
          zeo = 1000000.0
          zec = 1000000.0
          zdo = -1000000.0
          zdc = -1000000.0
          IF (Strmgt(1,ic).EQ.IJ .AND. KKPER.GE.Strmgt(4,ic) .AND. 
     &        KKPER.LE.Strmgt(5,ic)) THEN
            IF (ioper.EQ.2) ioper = 0
            wlcrit = FLOAT(Strmgt(9,ic))/100.0
            IF (Strmgt(6,ic).LT.1) THEN
              zloc = Z(Strmgt(8,ic)) + ZDATUM
            ELSE
              zloc = HOLD(Strmgt(8,ic),Strmgt(7,ic),Strmgt(6,ic))
            ENDIF
            IF (Strmgt(3,ic).EQ.1) THEN
              IF (Strmgt(2,ic).EQ.1) THEN
                zeo = wlcrit
              ELSE
                zec = wlcrit
              ENDIF
            ELSEIF (Strmgt(2,ic).EQ.1) THEN
              zdo = wlcrit
            ELSE
              zdc = wlcrit
            ENDIF
            IF (Strmgt(10,ic).NE.1) THEN
              ioper1 = ioper
              iflg = 0
              IF (zloc.LT.zdo .OR. zloc.GT.zeo) THEN
                ioper = 1
                iflg = 1
              ENDIF
              IF (zloc.LT.zdc .OR. zloc.GT.zec) THEN
                ioper = -1
                iflg = 1
              ENDIF
            ELSEIF (iflg.EQ.1) THEN
              iflg = 0
              IF (zloc.LT.zdo .OR. zloc.GT.zeo) THEN
                ioper = 1
                iflg = 1
              ENDIF
              IF (zloc.LT.zdc .OR. zloc.GT.zec) THEN
                ioper = -1
                iflg = 1
              ENDIF
              IF (iflg.EQ.0) ioper = ioper1
            ENDIF
          ENDIF
          GOTO 10
        ENDIF
      ENDIF
C
C---PUMPS ARE SIMULATED. THE DATA IS; aa=ZMAX, bb=ZMIN, cc=GRAVITY
C---DESIGN FLOW, dd=PUMP DESIGN FLOW,
C---ee= HEAD DIFFERENCE FOR DESIGN FLOWS.
C---IF ifac1=1, PUMP HAS INFINITE CAPACITY.
      IF (istype.EQ.-1) THEN
        zhigh = aa - ZDATUM
        IF (ioper.EQ.1) zhigh = zhigh + 0.1
        zlow = bb - ZDATUM
        nqflag = 1
        IF (QIJ.LT.0.5) nqflag = -1
        qtemp = ABS(QPIJP1)
        IF (qtemp.LT.10.0) qtemp = 10.0
        IF (ZPIJ-zhigh.GT.-20.0) THEN
          power = SQRT(dd/qtemp)
          diff = ((20.0+ZPIJ-zhigh)/20.0)**power
          diffmx = SQRT(1.0+LOG10(dd/qtemp))
          IF (diff.GT.diffmx) diff = diffmx
        ELSE
          diff = 0.0
        ENDIF
        coef = cc**2/ABS(ee)
        hpm = dd**2/coef + ABS(ee)
        hpmax = ZPIJP1 - ZPIJ + dd
        hpo = QIJP1**2/coef - (ZIJ-ZIJP1)
        hp = ZPIJP1 - ZPIJ + ABS(QIJP1)
        IF (ifac2.EQ.2 .AND. IBRPRN.EQ.0) ifac2 = 1
        IF ((ZIJ.GT.zhigh .OR. ZPIJ.GT.zhigh .OR. QIJ.GT.10.0) .AND. 
     &      ioper.EQ.2) THEN
          IF (IBRPRN.GT.0 .AND. ifac2.NE.1) ifac2 = 2
          IF (ifac2.EQ.1) hp = ZPIJP1 - ZPIJ + qtemp*diff
          IF (ifac2.EQ.1) nqflag = 1
        ENDIF
        IF (ifac1.NE.1 .AND. ifac2.EQ.1 .AND. hp.GT.hpmax) hp = hpmax
        IF (ZIJ.LT.zlow .AND. ifac2.EQ.1 .AND. ioper.EQ.2) nqflag = -1
        IF (ioper.EQ.1) THEN
          hp = ZPIJP1 - ZPIJ + qtemp*diff
          IF (hp.GT.hpmax) hp = hpmax
          nqflag = 1
        ENDIF
        IF (ioper.EQ.-1) nqflag = -1
        IF (hp.LT.ZPIJP1-ZPIJ) nqflag = -1
        EPSLON = hp
        ZETA = 1.0
        QPIJP1 = ABS(hp+ZPIJ-ZPIJP1)
        QPIJ = ABS(hp+ZPIJ-ZPIJP1)
        OMEGA = 0.0
        IF (nqflag.LT.0) THEN
          ZETA = zetal
          OMEGA = zetal
          QPIJP1 = 0.001
          QPIJ = 0.001
          EPSLON = ZPIJP1-ZPIJ
          hp = 0.
        ENDIF
        RN3IJ = QPIJP1**2/(coef*(ZPIJ-ZPIJP1+hpm))
        IF (RN3IJ.GT.9.9999) RN3IJ = 9.9999
        GAMMA = 0.0
        ALPHA = 0.0
        DELTA = 0.0
        DET = 1.0
C
C---AUTOMATIC GATES ARE SIMULATED. THE DATA IS; aa=ZHIGH, bb=ZMID,
C---cc=ZLOW, dd=SILL WIDTH, ee=SUBMERGED WEIR COEFFICIENT.
      ELSEIF (istype.EQ.-2) THEN
        cus = ee
        cgs = 0.75
        EPSLON = 0.0
        OMEGA = 0.0
        zhigh = aa - ZDATUM
        zmid = bb - ZDATUM
        zlow = cc - ZDATUM
        zp = ZPIJ - ZPIJP1
        zph = zp
        zm = zmid - ZIJP1
        zi = ZIJ - ZIJP1
        azm = ABS(zm)
        zb = ZIJ - Zbot(IJ)
        coef = QIJ**2/ABS(ZIJ-ZIJP1)
        IF (ZIJ.GT.zhigh .AND. ioper.EQ.2) THEN
          IF (zm*zi.GT.0.) THEN
            coef = (QPIJP1**2+1.0)/azm
          ELSE
            coef = (cus*dd*SQRT(twog)*zb)**2
          ENDIF
        ENDIF
        IF (ZIJ.LT.zlow .AND. ioper.EQ.2) THEN
          IF (zm*zi.GT.0.) THEN
            coef = (QPIJP1**2+1.0)/azm
          ELSE
            coef = -1.0
          ENDIF
        ENDIF
        IF (ioper.EQ.1) coef = (QPIJP1**2+1.0)/azm
        IF (ioper.EQ.-1) coef = -1.0
        RN3IJ = coef/(cgs*dd*SQRT(twog))**2
        IF (coef.GT.(cus*dd*SQRT(twog)*zb)**2) THEN
          coef = (cus*dd*SQRT(twog)*zb)**2
          RN3IJ = -.9999
        ENDIF
        ZETA = ABS(QPIJP1)/coef
        IF (coef.LT.0.1/ABS(zph) .OR. zp.LT.0.) THEN
          ZETA = zetal
          OMEGA = zetal
          QPIJP1 = 0.001
          QPIJ = 0.001
          EPSLON = ZPIJP1-ZPIJ
          RN3IJ = 0.0
        ENDIF
        IF (RN3IJ.GT.9.9999) RN3IJ = 9.9999
        GAMMA = 0.0
        ALPHA = 0.0
        DELTA = 0.0
        DET = 1.0
C
C---SUBMERGED PIPE CULVERTS ARE SIMULATED. THE DATA IS: dd=COEFFICIENT
C---FOR H=DV**2/2G, ifac2 IS THE NUMBER OF BARRELS, ee=CROSS-SECTIONAL
C---AREA OF SINGLE CULVERT
      ELSEIF (istype.EQ.-4) THEN
        ZETA = dd*ABS(QPIJP1)/((ee*FLOAT(ifac2))**2*twog)
        OMEGA = 0.0
        EPSLON = 0.0
        GAMMA = 1.0
        ALPHA = 1.0
        DELTA = ZPIJP1 + ZPIJ
        DET = 1.0/(1.0-ZETA)
C
C---AUTOMATIC GATED PIPE CULVERTS ARE SIMULATED, DATA IS: aa=ZHIGH,
C---bb=ZMID, cc=ZLOW, dd=COEFFICIENT FOR H=DV**2/2G, IF ifac1=0 IT IS
C---A CIRCULAR CULVERT, IF ifac1=1 IT IS A BOX CULVERT.
C---ifac2 IS THE NUMBER OF BARRELS
C---ee=CROSS-SECTIONAL AREA OF A SINGLE CULVERT.
C---CGS IS THE ORIFICE COEFFICIENT FOR THE GATE.
      ELSEIF (istype.EQ.-5) THEN
        pi = ACOS(-1.0)
        cgs = 0.75
        bar = FLOAT(ifac2)
        OMEGA = 0.0
        EPSLON = 0.0
        zhigh = aa - ZDATUM
        zmid = bb - ZDATUM
        zlow = cc - ZDATUM
        zm = zmid - ZIJP1
        azm = ABS(zm)
        zi = ZIJ - ZIJP1
        zp = ZPIJ - ZPIJP1
        zph = zp
        coef = QIJ**2/ABS(ZIJ-ZIJP1)
        IF (ZIJ.GT.zhigh .AND. ioper.EQ.2) THEN
          IF (zm*zi.GT.0.) THEN
            coef = (QPIJP1**2+1.0)/azm
          ELSE
            coef = (bar*ee*SQRT(twog))**2/dd
          ENDIF
        ENDIF
        IF (ZIJ.LT.zlow .AND. ioper.EQ.2) THEN
          IF (zm*zi.GT.0.) THEN
            coef = (QPIJP1**2+1.0)/azm
          ELSE
            coef = -1.0
          ENDIF
        ENDIF
        IF (ioper.EQ.1) coef = (QPIJP1**2+1.0)/azm
        IF (ioper.EQ.-1) coef = -1.
        ag = SQRT(1.0/(cgs**2*ABS(1.0/coef-dd/(twog*bar**2*ee**2))))
        RN3IJ = ag/(bar*ee)
        IF (coef.GT.(bar*ee*SQRT(twog))**2/dd) THEN
          coef = (bar*ee*SQRT(twog))**2/dd
          IF (ifac1.EQ.0) THEN
            RN3IJ = 2*SQRT(ee/pi)
          ELSE
            RN3IJ = SQRT(ee)
          ENDIF
        ENDIF
        ZETA = ABS(QPIJP1)/coef
        IF (coef.LT.0.1/ABS(zph) .OR. ZPIJ-ZPIJP1.LT.0.) THEN
          ZETA = zetal
          OMEGA = zetal
          QPIJP1 = 0.001
          QPIJ = 0.001
          EPSLON = ZPIJP1 - ZPIJ
          RN3IJ = 0.0
        ENDIF
        IF (RN3IJ.GT.9.9999) RN3IJ = 9.9999
        GAMMA = 0.0
        ALPHA = 0.0
        DELTA = 0.0
        DET = 1.0
      ENDIF
      RETURN
      END
