      SUBROUTINE WRTERM(I,J,IJ)
C
C     SUBROUTINE TO WRITE VALUES FOR EQUATION TERMS TO A FILE (*.trm)
C     FOR POST-PROCESS PLOTTING
C
      INCLUDE 'dimens.cmn'
      INCLUDE 'comcon.cmn'
      INCLUDE 'lunums.cmn'
      INCLUDE 'xsinit.cmn'
      INCLUDE 'datime.cmn'
      INCLUDE 'tdfiln.cmn'
C
C---VARIABLES FOR STORAGE OF EQUATION TERMS
      REAL dzdts, dqdxsc, qlatsc, totc, dqdts, dqdxsm, dadxs, 
     &     dqaxs, dzdxs, frics, winds, dpdxs, qlatsm, totm, eqthr
      REAL adzdt, adqdx, aqlatc, atotc, adqdt, adqadx, adzdx, 
     &     afric, awind, adpdx, aqlatm, atotm, dxij
C
      INTEGER I, J, ii, jj, IJ, len, initfl
      CHARACTER*48 blank, trmnam
      REAL factc, factcr, factm, factmr, offc, offm, brlen
c     DOUBLE PRECISION factc, factcr, factm, factmr, offc, offm, brlen
      EXTERNAL FILPRE, OPNFIL
      SAVE adzdt, adqdx, aqlatc, atotc, adqdt, adqadx, adzdx, 
     &  afric, awind, adpdx, aqlatm, atotm
      SAVE factc, factcr, factm, factmr, offc, offm, brlen
      SAVE ii, jj, initfl
      DATA initfl/0/, 
     &     blank/'                                                '/
C
      IF (initfl.EQ.0) THEN
        initfl = 1
C
C---GET LENGTH OF BASE NAME
        CALL FILPRE(Rdname,len)
C
C---BUILD EQUATION-TERM OUTPUT FILE NAME
        trmnam = blank
        trmnam = Rdname(1:len)//'.trm'
C
C---OPEN FILE FOR OUTPUT OF EQUATION TERMS FOR POST-PROCESS PLOTTING
        CALL OPNFIL(Luterm,trmnam)
C       WRITE (*,9010)
        WRITE (Luterm,9010)
C
CC    SCALE FACTORS FOR PHEASANT BRANCH & HIGH-GRADIENT CHANNEL
        factc = 1000.
        offc = 10.
        factcr = 1000.
        factm = 1000.
        offm = 10.
        factmr = 1000.
        jj = 1
        ii = 3
        IF (trmnam(1:2).EQ.'PH'.OR.trmnam(1:2).EQ.'ph') ii = 1
C
CC    SCALE FACTORS FOR THREEMILE SLOUGH
        IF (trmnam(1:2).EQ.'TM'.OR.trmnam(1:2).EQ.'tm') THEN
          factc = 10.
          offc = 2.5
          factcr = 10.
          factm = 100000.
          offm = 10.
          factmr = 100.
        ENDIF
      ENDIF
C
C ==> BEGIN CODE TO FILE SCALED EQUATION TERMS FOR POST-PROCESS PLOTTING
C
      IF (I.NE.ii) RETURN
      eqthr = M*Idtm/60.
      dxij = Dx(IJ)
      dzdts = Dzdt(IJ)*dxij
      dqdxsc = Dqdxc(IJ)*dxij
      qlatsc = -Qlat(IJ)*dxij
      totc = dzdts + dqdxsc + qlatsc
      dqdts = Dqdt(IJ)*dxij
      dqdxsm = Dqdxm(IJ)*dxij
      dadxs = Dadx(IJ)*dxij
      dqaxs = Dqadx(IJ)*dxij
      dzdxs = Dzdx(IJ)*dxij
      frics = Fric(IJ)*dxij
      winds = Wind(IJ)*dxij
      dpdxs = Dpdx(IJ)*dxij
      qlatsm = Qlatm(IJ)*dxij
      totm = dqdts + dqdxsm + dadxs + dzdxs + frics + winds + 
     &       dpdxs + qlatsm
      IF (J.EQ.1) THEN
        brlen = 0.0
        adzdt = 0.0
        adqdx = 0.0
        aqlatc = 0.0
        atotc = 0.0
        adqdt = 0.0
        adqadx = 0.0
        adzdx = 0.0
        afric = 0.0
        awind = 0.0
        adpdx = 0.0
        aqlatm = 0.0
        atotm = 0.0
      ENDIF
      brlen = brlen + dxij
      adzdt = adzdt + dzdts
      adqdx = adqdx + dqdxsc
      aqlatc = aqlatc + qlatsc
      atotc = atotc + totc
      adqdt = adqdt + dqdts
      adqadx = adqadx + dqaxs
      adzdx = adzdx + dzdxs
      afric = afric + frics
      awind = awind + winds
      adpdx = adpdx + dpdxs
      aqlatm = aqlatm + qlatsm
      atotm = atotm + totm
      IF (J.EQ.jj) THEN
        adzdt = adzdt/brlen*factc
        adqdx = adqdx/brlen*factc
        aqlatc = aqlatc/brlen*factc
        atotc = atotc/brlen*factcr + offc
        adqdt = adqdt/brlen*factm
        adqadx = adqadx/brlen*factm
        adzdx = adzdx/brlen*factm
        afric = afric/brlen*factm
        awind = awind/brlen*factm
        adpdx = adpdx/brlen*factm
        aqlatm = aqlatm/brlen*factm
        atotm = atotm/brlen*factmr + offm
C       WRITE (*,9005) eqthr, adzdt, adqdx, aqlatc, atotc,
C    &                 adqdt, adqadx, adzdx, afric, awind, adpdx,
C    &                 aqlatm, atotm
        WRITE (Luterm,9005) eqthr, adzdt, adqdx, aqlatc, atotc, adqdt, 
     &                      adqadx, adzdx, afric, awind, adpdx, aqlatm, 
     &                      atotm
      ENDIF
CC    IF ( I.EQ.2 .AND. J.EQ.1 ) WRITE (*,9005)
CC    IF ( I.EQ.2 .AND. J.EQ.1 ) WRITE (Luterm,9005) eqthr, dzdts,
CC   &  dqdxsc, qlatsc, totc, dqdts, dqaxs, dzdxs, frics, winds, dpdxs,
CC   &  qlatsm, totm
      RETURN
C
C ==> END CODE TO FILE SCALED EQUATION TERMS FOR POST-PROCESS PLOTTING
C
 9005 FORMAT (F7.3,2F7.3,F4.1,5F7.3,3F4.1,F7.3)
 9010 FORMAT ('   Hour   dZdt   dQdx   q   Mass   dQdt',
     & '  dQudx   dZdx     Sf Sw dpdx  qu   Mom.')
      END
